from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Command(_message.Message):
    __slots__ = ["args", "exec_root", "execution_timeout", "identifiers", "input", "output", "platform", "remote_working_directory", "working_directory"]
    class PlatformEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ARGS_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    EXEC_ROOT_FIELD_NUMBER: _ClassVar[int]
    IDENTIFIERS_FIELD_NUMBER: _ClassVar[int]
    INPUT_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_FIELD_NUMBER: _ClassVar[int]
    PLATFORM_FIELD_NUMBER: _ClassVar[int]
    REMOTE_WORKING_DIRECTORY_FIELD_NUMBER: _ClassVar[int]
    WORKING_DIRECTORY_FIELD_NUMBER: _ClassVar[int]
    args: _containers.RepeatedScalarFieldContainer[str]
    exec_root: str
    execution_timeout: int
    identifiers: Identifiers
    input: InputSpec
    output: OutputSpec
    platform: _containers.ScalarMap[str, str]
    remote_working_directory: str
    working_directory: str
    def __init__(self, identifiers: _Optional[_Union[Identifiers, _Mapping]] = ..., exec_root: _Optional[str] = ..., input: _Optional[_Union[InputSpec, _Mapping]] = ..., output: _Optional[_Union[OutputSpec, _Mapping]] = ..., args: _Optional[_Iterable[str]] = ..., execution_timeout: _Optional[int] = ..., working_directory: _Optional[str] = ..., platform: _Optional[_Mapping[str, str]] = ..., remote_working_directory: _Optional[str] = ...) -> None: ...

class CommandResult(_message.Message):
    __slots__ = ["exit_code", "msg", "status"]
    EXIT_CODE_FIELD_NUMBER: _ClassVar[int]
    MSG_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    exit_code: int
    msg: str
    status: CommandResultStatus.Value
    def __init__(self, status: _Optional[_Union[CommandResultStatus.Value, str]] = ..., exit_code: _Optional[int] = ..., msg: _Optional[str] = ...) -> None: ...

class CommandResultStatus(_message.Message):
    __slots__ = []
    class Value(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    CACHE_HIT: CommandResultStatus.Value
    INTERRUPTED: CommandResultStatus.Value
    LOCAL_ERROR: CommandResultStatus.Value
    NON_ZERO_EXIT: CommandResultStatus.Value
    REMOTE_ERROR: CommandResultStatus.Value
    SUCCESS: CommandResultStatus.Value
    TIMEOUT: CommandResultStatus.Value
    UNKNOWN: CommandResultStatus.Value
    def __init__(self) -> None: ...

class ExcludeInput(_message.Message):
    __slots__ = ["regex", "type"]
    REGEX_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    regex: str
    type: InputType.Value
    def __init__(self, regex: _Optional[str] = ..., type: _Optional[_Union[InputType.Value, str]] = ...) -> None: ...

class Identifiers(_message.Message):
    __slots__ = ["command_id", "correlated_invocations_id", "execution_id", "invocation_id", "tool_name", "tool_version"]
    COMMAND_ID_FIELD_NUMBER: _ClassVar[int]
    CORRELATED_INVOCATIONS_ID_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_ID_FIELD_NUMBER: _ClassVar[int]
    INVOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    TOOL_NAME_FIELD_NUMBER: _ClassVar[int]
    TOOL_VERSION_FIELD_NUMBER: _ClassVar[int]
    command_id: str
    correlated_invocations_id: str
    execution_id: str
    invocation_id: str
    tool_name: str
    tool_version: str
    def __init__(self, command_id: _Optional[str] = ..., invocation_id: _Optional[str] = ..., correlated_invocations_id: _Optional[str] = ..., tool_name: _Optional[str] = ..., tool_version: _Optional[str] = ..., execution_id: _Optional[str] = ...) -> None: ...

class InputSpec(_message.Message):
    __slots__ = ["environment_variables", "exclude_inputs", "inputs", "symlink_behavior", "virtual_inputs"]
    class EnvironmentVariablesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ENVIRONMENT_VARIABLES_FIELD_NUMBER: _ClassVar[int]
    EXCLUDE_INPUTS_FIELD_NUMBER: _ClassVar[int]
    INPUTS_FIELD_NUMBER: _ClassVar[int]
    SYMLINK_BEHAVIOR_FIELD_NUMBER: _ClassVar[int]
    VIRTUAL_INPUTS_FIELD_NUMBER: _ClassVar[int]
    environment_variables: _containers.ScalarMap[str, str]
    exclude_inputs: _containers.RepeatedCompositeFieldContainer[ExcludeInput]
    inputs: _containers.RepeatedScalarFieldContainer[str]
    symlink_behavior: SymlinkBehaviorType.Value
    virtual_inputs: _containers.RepeatedCompositeFieldContainer[VirtualInput]
    def __init__(self, inputs: _Optional[_Iterable[str]] = ..., virtual_inputs: _Optional[_Iterable[_Union[VirtualInput, _Mapping]]] = ..., exclude_inputs: _Optional[_Iterable[_Union[ExcludeInput, _Mapping]]] = ..., environment_variables: _Optional[_Mapping[str, str]] = ..., symlink_behavior: _Optional[_Union[SymlinkBehaviorType.Value, str]] = ...) -> None: ...

class InputType(_message.Message):
    __slots__ = []
    class Value(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    DIRECTORY: InputType.Value
    FILE: InputType.Value
    UNSPECIFIED: InputType.Value
    def __init__(self) -> None: ...

class OutputSpec(_message.Message):
    __slots__ = ["output_directories", "output_files"]
    OUTPUT_DIRECTORIES_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_FILES_FIELD_NUMBER: _ClassVar[int]
    output_directories: _containers.RepeatedScalarFieldContainer[str]
    output_files: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, output_files: _Optional[_Iterable[str]] = ..., output_directories: _Optional[_Iterable[str]] = ...) -> None: ...

class SymlinkBehaviorType(_message.Message):
    __slots__ = []
    class Value(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    PRESERVE: SymlinkBehaviorType.Value
    RESOLVE: SymlinkBehaviorType.Value
    UNSPECIFIED: SymlinkBehaviorType.Value
    def __init__(self) -> None: ...

class TimeInterval(_message.Message):
    __slots__ = ["to"]
    FROM_FIELD_NUMBER: _ClassVar[int]
    TO_FIELD_NUMBER: _ClassVar[int]
    to: _timestamp_pb2.Timestamp
    def __init__(self, to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., **kwargs) -> None: ...

class VirtualInput(_message.Message):
    __slots__ = ["contents", "is_empty_directory", "is_executable", "path"]
    CONTENTS_FIELD_NUMBER: _ClassVar[int]
    IS_EMPTY_DIRECTORY_FIELD_NUMBER: _ClassVar[int]
    IS_EXECUTABLE_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    contents: bytes
    is_empty_directory: bool
    is_executable: bool
    path: str
    def __init__(self, path: _Optional[str] = ..., contents: _Optional[bytes] = ..., is_executable: bool = ..., is_empty_directory: bool = ...) -> None: ...
