from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import sources as _sources_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import failure_reason as _failure_reason_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ClusteredFailureRow(_message.Message):
    __slots__ = ["bug_tracking_component", "build_critical", "build_gardener_rotations", "build_status", "chunk_id", "chunk_index", "cluster_algorithm", "cluster_id", "duration", "exonerations", "failure_reason", "ingested_invocation_id", "ingested_invocation_result_count", "ingested_invocation_result_index", "is_included", "is_included_with_high_priority", "is_ingested_invocation_blocked", "is_test_run_blocked", "last_updated", "partition_time", "presubmit_run_id", "presubmit_run_mode", "presubmit_run_owner", "presubmit_run_status", "project", "realm", "source_ref", "source_ref_hash", "sources", "start_time", "tags", "test_id", "test_result_id", "test_result_system", "test_run_id", "test_run_result_count", "test_run_result_index", "test_variant_branch", "variant", "variant_hash"]
    class TestExoneration(_message.Message):
        __slots__ = ["reason"]
        REASON_FIELD_NUMBER: _ClassVar[int]
        reason: _common_pb2.ExonerationReason
        def __init__(self, reason: _Optional[_Union[_common_pb2.ExonerationReason, str]] = ...) -> None: ...
    class TestVariantBranch(_message.Message):
        __slots__ = ["flaky_verdicts_24h", "total_verdicts_24h", "unexpected_verdicts_24h"]
        FLAKY_VERDICTS_24H_FIELD_NUMBER: _ClassVar[int]
        TOTAL_VERDICTS_24H_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_VERDICTS_24H_FIELD_NUMBER: _ClassVar[int]
        flaky_verdicts_24h: int
        total_verdicts_24h: int
        unexpected_verdicts_24h: int
        def __init__(self, flaky_verdicts_24h: _Optional[int] = ..., unexpected_verdicts_24h: _Optional[int] = ..., total_verdicts_24h: _Optional[int] = ...) -> None: ...
    BUG_TRACKING_COMPONENT_FIELD_NUMBER: _ClassVar[int]
    BUILD_CRITICAL_FIELD_NUMBER: _ClassVar[int]
    BUILD_GARDENER_ROTATIONS_FIELD_NUMBER: _ClassVar[int]
    BUILD_STATUS_FIELD_NUMBER: _ClassVar[int]
    CHUNK_ID_FIELD_NUMBER: _ClassVar[int]
    CHUNK_INDEX_FIELD_NUMBER: _ClassVar[int]
    CLUSTER_ALGORITHM_FIELD_NUMBER: _ClassVar[int]
    CLUSTER_ID_FIELD_NUMBER: _ClassVar[int]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    EXONERATIONS_FIELD_NUMBER: _ClassVar[int]
    FAILURE_REASON_FIELD_NUMBER: _ClassVar[int]
    INGESTED_INVOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    INGESTED_INVOCATION_RESULT_COUNT_FIELD_NUMBER: _ClassVar[int]
    INGESTED_INVOCATION_RESULT_INDEX_FIELD_NUMBER: _ClassVar[int]
    IS_INCLUDED_FIELD_NUMBER: _ClassVar[int]
    IS_INCLUDED_WITH_HIGH_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    IS_INGESTED_INVOCATION_BLOCKED_FIELD_NUMBER: _ClassVar[int]
    IS_TEST_RUN_BLOCKED_FIELD_NUMBER: _ClassVar[int]
    LAST_UPDATED_FIELD_NUMBER: _ClassVar[int]
    PARTITION_TIME_FIELD_NUMBER: _ClassVar[int]
    PRESUBMIT_RUN_ID_FIELD_NUMBER: _ClassVar[int]
    PRESUBMIT_RUN_MODE_FIELD_NUMBER: _ClassVar[int]
    PRESUBMIT_RUN_OWNER_FIELD_NUMBER: _ClassVar[int]
    PRESUBMIT_RUN_STATUS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    SOURCES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_REF_FIELD_NUMBER: _ClassVar[int]
    SOURCE_REF_HASH_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULT_ID_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULT_SYSTEM_FIELD_NUMBER: _ClassVar[int]
    TEST_RUN_ID_FIELD_NUMBER: _ClassVar[int]
    TEST_RUN_RESULT_COUNT_FIELD_NUMBER: _ClassVar[int]
    TEST_RUN_RESULT_INDEX_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANT_BRANCH_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    bug_tracking_component: _common_pb2.BugTrackingComponent
    build_critical: bool
    build_gardener_rotations: _containers.RepeatedScalarFieldContainer[str]
    build_status: str
    chunk_id: str
    chunk_index: int
    cluster_algorithm: str
    cluster_id: str
    duration: float
    exonerations: _containers.RepeatedCompositeFieldContainer[ClusteredFailureRow.TestExoneration]
    failure_reason: _failure_reason_pb2.FailureReason
    ingested_invocation_id: str
    ingested_invocation_result_count: int
    ingested_invocation_result_index: int
    is_included: bool
    is_included_with_high_priority: bool
    is_ingested_invocation_blocked: bool
    is_test_run_blocked: bool
    last_updated: _timestamp_pb2.Timestamp
    partition_time: _timestamp_pb2.Timestamp
    presubmit_run_id: _common_pb2.PresubmitRunId
    presubmit_run_mode: str
    presubmit_run_owner: str
    presubmit_run_status: str
    project: str
    realm: str
    source_ref: _sources_pb2.SourceRef
    source_ref_hash: str
    sources: _sources_pb2.Sources
    start_time: _timestamp_pb2.Timestamp
    tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    test_id: str
    test_result_id: str
    test_result_system: str
    test_run_id: str
    test_run_result_count: int
    test_run_result_index: int
    test_variant_branch: ClusteredFailureRow.TestVariantBranch
    variant: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    variant_hash: str
    def __init__(self, project: _Optional[str] = ..., cluster_algorithm: _Optional[str] = ..., cluster_id: _Optional[str] = ..., test_result_system: _Optional[str] = ..., ingested_invocation_id: _Optional[str] = ..., test_result_id: _Optional[str] = ..., last_updated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., partition_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., is_included: bool = ..., is_included_with_high_priority: bool = ..., chunk_id: _Optional[str] = ..., chunk_index: _Optional[int] = ..., realm: _Optional[str] = ..., test_id: _Optional[str] = ..., variant: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., variant_hash: _Optional[str] = ..., failure_reason: _Optional[_Union[_failure_reason_pb2.FailureReason, _Mapping]] = ..., bug_tracking_component: _Optional[_Union[_common_pb2.BugTrackingComponent, _Mapping]] = ..., start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., duration: _Optional[float] = ..., exonerations: _Optional[_Iterable[_Union[ClusteredFailureRow.TestExoneration, _Mapping]]] = ..., presubmit_run_id: _Optional[_Union[_common_pb2.PresubmitRunId, _Mapping]] = ..., presubmit_run_owner: _Optional[str] = ..., presubmit_run_mode: _Optional[str] = ..., presubmit_run_status: _Optional[str] = ..., build_status: _Optional[str] = ..., build_critical: bool = ..., ingested_invocation_result_index: _Optional[int] = ..., ingested_invocation_result_count: _Optional[int] = ..., is_ingested_invocation_blocked: bool = ..., test_run_id: _Optional[str] = ..., test_run_result_index: _Optional[int] = ..., test_run_result_count: _Optional[int] = ..., is_test_run_blocked: bool = ..., sources: _Optional[_Union[_sources_pb2.Sources, _Mapping]] = ..., source_ref: _Optional[_Union[_sources_pb2.SourceRef, _Mapping]] = ..., source_ref_hash: _Optional[str] = ..., build_gardener_rotations: _Optional[_Iterable[str]] = ..., test_variant_branch: _Optional[_Union[ClusteredFailureRow.TestVariantBranch, _Mapping]] = ...) -> None: ...
