from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import failure_reason as _failure_reason_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import sources as _sources_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import test_metadata as _test_metadata_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import test_verdict as _test_verdict_pb2
from PB.go.chromium.org.luci.common.bq.pb import options as _options_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class TestVerdictRow(_message.Message):
    __slots__ = ["buildbucket_build", "change_verifier_run", "counts", "exonerations", "invocation", "partition_time", "project", "results", "source_ref", "source_ref_hash", "sources", "status", "test_id", "test_metadata", "variant", "variant_hash"]
    class BuildbucketBuild(_message.Message):
        __slots__ = ["builder", "gardener_rotations", "id", "status"]
        class Builder(_message.Message):
            __slots__ = ["bucket", "builder", "project"]
            BUCKET_FIELD_NUMBER: _ClassVar[int]
            BUILDER_FIELD_NUMBER: _ClassVar[int]
            PROJECT_FIELD_NUMBER: _ClassVar[int]
            bucket: str
            builder: str
            project: str
            def __init__(self, project: _Optional[str] = ..., bucket: _Optional[str] = ..., builder: _Optional[str] = ...) -> None: ...
        BUILDER_FIELD_NUMBER: _ClassVar[int]
        GARDENER_ROTATIONS_FIELD_NUMBER: _ClassVar[int]
        ID_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        builder: TestVerdictRow.BuildbucketBuild.Builder
        gardener_rotations: _containers.RepeatedScalarFieldContainer[str]
        id: int
        status: str
        def __init__(self, id: _Optional[int] = ..., builder: _Optional[_Union[TestVerdictRow.BuildbucketBuild.Builder, _Mapping]] = ..., status: _Optional[str] = ..., gardener_rotations: _Optional[_Iterable[str]] = ...) -> None: ...
    class ChangeVerifierRun(_message.Message):
        __slots__ = ["id", "is_build_critical", "mode", "status"]
        ID_FIELD_NUMBER: _ClassVar[int]
        IS_BUILD_CRITICAL_FIELD_NUMBER: _ClassVar[int]
        MODE_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        id: str
        is_build_critical: bool
        mode: _common_pb2.PresubmitRunMode
        status: str
        def __init__(self, id: _Optional[str] = ..., mode: _Optional[_Union[_common_pb2.PresubmitRunMode, str]] = ..., status: _Optional[str] = ..., is_build_critical: bool = ...) -> None: ...
    class Counts(_message.Message):
        __slots__ = ["total", "total_non_skipped", "unexpected", "unexpected_non_skipped", "unexpected_non_skipped_non_passed"]
        TOTAL_FIELD_NUMBER: _ClassVar[int]
        TOTAL_NON_SKIPPED_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_NON_SKIPPED_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_NON_SKIPPED_NON_PASSED_FIELD_NUMBER: _ClassVar[int]
        total: int
        total_non_skipped: int
        unexpected: int
        unexpected_non_skipped: int
        unexpected_non_skipped_non_passed: int
        def __init__(self, unexpected: _Optional[int] = ..., total: _Optional[int] = ..., unexpected_non_skipped: _Optional[int] = ..., unexpected_non_skipped_non_passed: _Optional[int] = ..., total_non_skipped: _Optional[int] = ...) -> None: ...
    class Exoneration(_message.Message):
        __slots__ = ["explanation_html", "reason"]
        EXPLANATION_HTML_FIELD_NUMBER: _ClassVar[int]
        REASON_FIELD_NUMBER: _ClassVar[int]
        explanation_html: str
        reason: _common_pb2.ExonerationReason
        def __init__(self, explanation_html: _Optional[str] = ..., reason: _Optional[_Union[_common_pb2.ExonerationReason, str]] = ...) -> None: ...
    class InvocationRecord(_message.Message):
        __slots__ = ["id", "properties", "realm", "tags"]
        ID_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        REALM_FIELD_NUMBER: _ClassVar[int]
        TAGS_FIELD_NUMBER: _ClassVar[int]
        id: str
        properties: str
        realm: str
        tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
        def __init__(self, id: _Optional[str] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., realm: _Optional[str] = ..., properties: _Optional[str] = ...) -> None: ...
    class ParentInvocationRecord(_message.Message):
        __slots__ = ["id"]
        ID_FIELD_NUMBER: _ClassVar[int]
        id: str
        def __init__(self, id: _Optional[str] = ...) -> None: ...
    class TestResult(_message.Message):
        __slots__ = ["duration", "expected", "failure_reason", "name", "parent", "properties", "result_id", "skip_reason", "start_time", "status", "summary_html", "tags"]
        DURATION_FIELD_NUMBER: _ClassVar[int]
        EXPECTED_FIELD_NUMBER: _ClassVar[int]
        FAILURE_REASON_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        PARENT_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        RESULT_ID_FIELD_NUMBER: _ClassVar[int]
        SKIP_REASON_FIELD_NUMBER: _ClassVar[int]
        START_TIME_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        SUMMARY_HTML_FIELD_NUMBER: _ClassVar[int]
        TAGS_FIELD_NUMBER: _ClassVar[int]
        duration: float
        expected: bool
        failure_reason: _failure_reason_pb2.FailureReason
        name: str
        parent: TestVerdictRow.ParentInvocationRecord
        properties: str
        result_id: str
        skip_reason: str
        start_time: _timestamp_pb2.Timestamp
        status: _test_verdict_pb2.TestResultStatus
        summary_html: str
        tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
        def __init__(self, parent: _Optional[_Union[TestVerdictRow.ParentInvocationRecord, _Mapping]] = ..., name: _Optional[str] = ..., result_id: _Optional[str] = ..., expected: bool = ..., status: _Optional[_Union[_test_verdict_pb2.TestResultStatus, str]] = ..., summary_html: _Optional[str] = ..., start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., duration: _Optional[float] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., failure_reason: _Optional[_Union[_failure_reason_pb2.FailureReason, _Mapping]] = ..., skip_reason: _Optional[str] = ..., properties: _Optional[str] = ...) -> None: ...
    BUILDBUCKET_BUILD_FIELD_NUMBER: _ClassVar[int]
    CHANGE_VERIFIER_RUN_FIELD_NUMBER: _ClassVar[int]
    COUNTS_FIELD_NUMBER: _ClassVar[int]
    EXONERATIONS_FIELD_NUMBER: _ClassVar[int]
    INVOCATION_FIELD_NUMBER: _ClassVar[int]
    PARTITION_TIME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    SOURCES_FIELD_NUMBER: _ClassVar[int]
    SOURCE_REF_FIELD_NUMBER: _ClassVar[int]
    SOURCE_REF_HASH_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    TEST_METADATA_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    buildbucket_build: TestVerdictRow.BuildbucketBuild
    change_verifier_run: TestVerdictRow.ChangeVerifierRun
    counts: TestVerdictRow.Counts
    exonerations: _containers.RepeatedCompositeFieldContainer[TestVerdictRow.Exoneration]
    invocation: TestVerdictRow.InvocationRecord
    partition_time: _timestamp_pb2.Timestamp
    project: str
    results: _containers.RepeatedCompositeFieldContainer[TestVerdictRow.TestResult]
    source_ref: _sources_pb2.SourceRef
    source_ref_hash: str
    sources: _sources_pb2.Sources
    status: _test_verdict_pb2.TestVerdictStatus
    test_id: str
    test_metadata: _test_metadata_pb2.TestMetadata
    variant: str
    variant_hash: str
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., variant: _Optional[str] = ..., variant_hash: _Optional[str] = ..., invocation: _Optional[_Union[TestVerdictRow.InvocationRecord, _Mapping]] = ..., partition_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., status: _Optional[_Union[_test_verdict_pb2.TestVerdictStatus, str]] = ..., results: _Optional[_Iterable[_Union[TestVerdictRow.TestResult, _Mapping]]] = ..., exonerations: _Optional[_Iterable[_Union[TestVerdictRow.Exoneration, _Mapping]]] = ..., counts: _Optional[_Union[TestVerdictRow.Counts, _Mapping]] = ..., buildbucket_build: _Optional[_Union[TestVerdictRow.BuildbucketBuild, _Mapping]] = ..., change_verifier_run: _Optional[_Union[TestVerdictRow.ChangeVerifierRun, _Mapping]] = ..., sources: _Optional[_Union[_sources_pb2.Sources, _Mapping]] = ..., source_ref: _Optional[_Union[_sources_pb2.SourceRef, _Mapping]] = ..., source_ref_hash: _Optional[str] = ..., test_metadata: _Optional[_Union[_test_metadata_pb2.TestMetadata, _Mapping]] = ...) -> None: ...
