from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BugManagementSystem(_message.Message):
    __slots__ = ["policy_based_management_enabled"]
    POLICY_BASED_MANAGEMENT_ENABLED_FIELD_NUMBER: _ClassVar[int]
    policy_based_management_enabled: bool
    def __init__(self, policy_based_management_enabled: bool = ...) -> None: ...

class ClusteringSystem(_message.Message):
    __slots__ = ["query_test_variant_analysis_enabled"]
    QUERY_TEST_VARIANT_ANALYSIS_ENABLED_FIELD_NUMBER: _ClassVar[int]
    query_test_variant_analysis_enabled: bool
    def __init__(self, query_test_variant_analysis_enabled: bool = ...) -> None: ...

class Config(_message.Message):
    __slots__ = ["bug_management", "bug_updates_enabled", "chunk_gcs_bucket", "clustering", "ingestion", "monorail_hostname", "reclustering_interval_minutes", "reclustering_workers", "test_variant_analysis", "test_verdict_export"]
    BUG_MANAGEMENT_FIELD_NUMBER: _ClassVar[int]
    BUG_UPDATES_ENABLED_FIELD_NUMBER: _ClassVar[int]
    CHUNK_GCS_BUCKET_FIELD_NUMBER: _ClassVar[int]
    CLUSTERING_FIELD_NUMBER: _ClassVar[int]
    INGESTION_FIELD_NUMBER: _ClassVar[int]
    MONORAIL_HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    RECLUSTERING_INTERVAL_MINUTES_FIELD_NUMBER: _ClassVar[int]
    RECLUSTERING_WORKERS_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANT_ANALYSIS_FIELD_NUMBER: _ClassVar[int]
    TEST_VERDICT_EXPORT_FIELD_NUMBER: _ClassVar[int]
    bug_management: BugManagementSystem
    bug_updates_enabled: bool
    chunk_gcs_bucket: str
    clustering: ClusteringSystem
    ingestion: Ingestion
    monorail_hostname: str
    reclustering_interval_minutes: int
    reclustering_workers: int
    test_variant_analysis: TestVariantAnalysis
    test_verdict_export: TestVerdictExport
    def __init__(self, monorail_hostname: _Optional[str] = ..., chunk_gcs_bucket: _Optional[str] = ..., reclustering_workers: _Optional[int] = ..., reclustering_interval_minutes: _Optional[int] = ..., bug_updates_enabled: bool = ..., test_variant_analysis: _Optional[_Union[TestVariantAnalysis, _Mapping]] = ..., ingestion: _Optional[_Union[Ingestion, _Mapping]] = ..., test_verdict_export: _Optional[_Union[TestVerdictExport, _Mapping]] = ..., clustering: _Optional[_Union[ClusteringSystem, _Mapping]] = ..., bug_management: _Optional[_Union[BugManagementSystem, _Mapping]] = ...) -> None: ...

class Ingestion(_message.Message):
    __slots__ = ["project_allowlist", "project_allowlist_enabled"]
    PROJECT_ALLOWLIST_ENABLED_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ALLOWLIST_FIELD_NUMBER: _ClassVar[int]
    project_allowlist: _containers.RepeatedScalarFieldContainer[str]
    project_allowlist_enabled: bool
    def __init__(self, project_allowlist_enabled: bool = ..., project_allowlist: _Optional[_Iterable[str]] = ...) -> None: ...

class TestVariantAnalysis(_message.Message):
    __slots__ = ["bigquery_export_enabled", "enabled"]
    BIGQUERY_EXPORT_ENABLED_FIELD_NUMBER: _ClassVar[int]
    ENABLED_FIELD_NUMBER: _ClassVar[int]
    bigquery_export_enabled: bool
    enabled: bool
    def __init__(self, enabled: bool = ..., bigquery_export_enabled: bool = ...) -> None: ...

class TestVerdictExport(_message.Message):
    __slots__ = ["enabled"]
    ENABLED_FIELD_NUMBER: _ClassVar[int]
    enabled: bool
    def __init__(self, enabled: bool = ...) -> None: ...
