from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.config import test_variant_analysis_config as _test_variant_analysis_config_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

BUGANIZER: BugSystem
BUGANIZER_PRIORITY_UNSPECIFIED: BuganizerPriority
BUG_SYSTEM_UNSPECIFIED: BugSystem
DESCRIPTOR: _descriptor.FileDescriptor
MONORAIL: BugSystem
P0: BuganizerPriority
P1: BuganizerPriority
P2: BuganizerPriority
P3: BuganizerPriority
P4: BuganizerPriority

class BugManagement(_message.Message):
    __slots__ = ["buganizer", "default_bug_system", "disable_duplicate_bug_comments", "monorail", "policies"]
    BUGANIZER_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_BUG_SYSTEM_FIELD_NUMBER: _ClassVar[int]
    DISABLE_DUPLICATE_BUG_COMMENTS_FIELD_NUMBER: _ClassVar[int]
    MONORAIL_FIELD_NUMBER: _ClassVar[int]
    POLICIES_FIELD_NUMBER: _ClassVar[int]
    buganizer: BuganizerProject
    default_bug_system: BugSystem
    disable_duplicate_bug_comments: bool
    monorail: MonorailProject
    policies: _containers.RepeatedCompositeFieldContainer[BugManagementPolicy]
    def __init__(self, disable_duplicate_bug_comments: bool = ..., policies: _Optional[_Iterable[_Union[BugManagementPolicy, _Mapping]]] = ..., default_bug_system: _Optional[_Union[BugSystem, str]] = ..., buganizer: _Optional[_Union[BuganizerProject, _Mapping]] = ..., monorail: _Optional[_Union[MonorailProject, _Mapping]] = ...) -> None: ...

class BugManagementPolicy(_message.Message):
    __slots__ = ["bug_template", "explanation", "human_readable_name", "id", "metrics", "owners", "priority"]
    class BugTemplate(_message.Message):
        __slots__ = ["buganizer", "comment_template", "monorail"]
        class Buganizer(_message.Message):
            __slots__ = ["hotlists"]
            HOTLISTS_FIELD_NUMBER: _ClassVar[int]
            hotlists: _containers.RepeatedScalarFieldContainer[int]
            def __init__(self, hotlists: _Optional[_Iterable[int]] = ...) -> None: ...
        class Monorail(_message.Message):
            __slots__ = ["labels"]
            LABELS_FIELD_NUMBER: _ClassVar[int]
            labels: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, labels: _Optional[_Iterable[str]] = ...) -> None: ...
        BUGANIZER_FIELD_NUMBER: _ClassVar[int]
        COMMENT_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
        MONORAIL_FIELD_NUMBER: _ClassVar[int]
        buganizer: BugManagementPolicy.BugTemplate.Buganizer
        comment_template: str
        monorail: BugManagementPolicy.BugTemplate.Monorail
        def __init__(self, comment_template: _Optional[str] = ..., buganizer: _Optional[_Union[BugManagementPolicy.BugTemplate.Buganizer, _Mapping]] = ..., monorail: _Optional[_Union[BugManagementPolicy.BugTemplate.Monorail, _Mapping]] = ...) -> None: ...
    class Explanation(_message.Message):
        __slots__ = ["action_html", "problem_html"]
        ACTION_HTML_FIELD_NUMBER: _ClassVar[int]
        PROBLEM_HTML_FIELD_NUMBER: _ClassVar[int]
        action_html: str
        problem_html: str
        def __init__(self, problem_html: _Optional[str] = ..., action_html: _Optional[str] = ...) -> None: ...
    class Metric(_message.Message):
        __slots__ = ["activation_threshold", "deactivation_threshold", "metric_id"]
        ACTIVATION_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        DEACTIVATION_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        METRIC_ID_FIELD_NUMBER: _ClassVar[int]
        activation_threshold: MetricThreshold
        deactivation_threshold: MetricThreshold
        metric_id: str
        def __init__(self, metric_id: _Optional[str] = ..., activation_threshold: _Optional[_Union[MetricThreshold, _Mapping]] = ..., deactivation_threshold: _Optional[_Union[MetricThreshold, _Mapping]] = ...) -> None: ...
    BUG_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    EXPLANATION_FIELD_NUMBER: _ClassVar[int]
    HUMAN_READABLE_NAME_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    OWNERS_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    bug_template: BugManagementPolicy.BugTemplate
    explanation: BugManagementPolicy.Explanation
    human_readable_name: str
    id: str
    metrics: _containers.RepeatedCompositeFieldContainer[BugManagementPolicy.Metric]
    owners: _containers.RepeatedScalarFieldContainer[str]
    priority: BuganizerPriority
    def __init__(self, id: _Optional[str] = ..., owners: _Optional[_Iterable[str]] = ..., human_readable_name: _Optional[str] = ..., priority: _Optional[_Union[BuganizerPriority, str]] = ..., metrics: _Optional[_Iterable[_Union[BugManagementPolicy.Metric, _Mapping]]] = ..., explanation: _Optional[_Union[BugManagementPolicy.Explanation, _Mapping]] = ..., bug_template: _Optional[_Union[BugManagementPolicy.BugTemplate, _Mapping]] = ...) -> None: ...

class BuganizerComponent(_message.Message):
    __slots__ = ["id"]
    ID_FIELD_NUMBER: _ClassVar[int]
    id: int
    def __init__(self, id: _Optional[int] = ...) -> None: ...

class BuganizerProject(_message.Message):
    __slots__ = ["default_component", "priority_hysteresis_percent", "priority_mappings"]
    class PriorityMapping(_message.Message):
        __slots__ = ["priority", "threshold", "thresholds"]
        PRIORITY_FIELD_NUMBER: _ClassVar[int]
        THRESHOLDS_FIELD_NUMBER: _ClassVar[int]
        THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        priority: BuganizerPriority
        threshold: ImpactThreshold
        thresholds: _containers.RepeatedCompositeFieldContainer[ImpactMetricThreshold]
        def __init__(self, priority: _Optional[_Union[BuganizerPriority, str]] = ..., threshold: _Optional[_Union[ImpactThreshold, _Mapping]] = ..., thresholds: _Optional[_Iterable[_Union[ImpactMetricThreshold, _Mapping]]] = ...) -> None: ...
    DEFAULT_COMPONENT_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_HYSTERESIS_PERCENT_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_MAPPINGS_FIELD_NUMBER: _ClassVar[int]
    default_component: BuganizerComponent
    priority_hysteresis_percent: int
    priority_mappings: _containers.RepeatedCompositeFieldContainer[BuganizerProject.PriorityMapping]
    def __init__(self, default_component: _Optional[_Union[BuganizerComponent, _Mapping]] = ..., priority_hysteresis_percent: _Optional[int] = ..., priority_mappings: _Optional[_Iterable[_Union[BuganizerProject.PriorityMapping, _Mapping]]] = ...) -> None: ...

class Clustering(_message.Message):
    __slots__ = ["reason_mask_patterns", "test_name_rules"]
    REASON_MASK_PATTERNS_FIELD_NUMBER: _ClassVar[int]
    TEST_NAME_RULES_FIELD_NUMBER: _ClassVar[int]
    reason_mask_patterns: _containers.RepeatedScalarFieldContainer[str]
    test_name_rules: _containers.RepeatedCompositeFieldContainer[TestNameClusteringRule]
    def __init__(self, test_name_rules: _Optional[_Iterable[_Union[TestNameClusteringRule, _Mapping]]] = ..., reason_mask_patterns: _Optional[_Iterable[str]] = ...) -> None: ...

class ImpactMetricThreshold(_message.Message):
    __slots__ = ["metric_id", "threshold"]
    METRIC_ID_FIELD_NUMBER: _ClassVar[int]
    THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    metric_id: str
    threshold: MetricThreshold
    def __init__(self, metric_id: _Optional[str] = ..., threshold: _Optional[_Union[MetricThreshold, _Mapping]] = ...) -> None: ...

class ImpactThreshold(_message.Message):
    __slots__ = ["critical_failures_exonerated", "presubmit_runs_failed", "test_results_failed", "test_runs_failed", "unexpected_failures_1d", "unexpected_failures_3d", "unexpected_failures_7d"]
    CRITICAL_FAILURES_EXONERATED_FIELD_NUMBER: _ClassVar[int]
    PRESUBMIT_RUNS_FAILED_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULTS_FAILED_FIELD_NUMBER: _ClassVar[int]
    TEST_RUNS_FAILED_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_FAILURES_1D_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_FAILURES_3D_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_FAILURES_7D_FIELD_NUMBER: _ClassVar[int]
    critical_failures_exonerated: MetricThreshold
    presubmit_runs_failed: MetricThreshold
    test_results_failed: MetricThreshold
    test_runs_failed: MetricThreshold
    unexpected_failures_1d: int
    unexpected_failures_3d: int
    unexpected_failures_7d: int
    def __init__(self, test_results_failed: _Optional[_Union[MetricThreshold, _Mapping]] = ..., test_runs_failed: _Optional[_Union[MetricThreshold, _Mapping]] = ..., presubmit_runs_failed: _Optional[_Union[MetricThreshold, _Mapping]] = ..., critical_failures_exonerated: _Optional[_Union[MetricThreshold, _Mapping]] = ..., unexpected_failures_1d: _Optional[int] = ..., unexpected_failures_3d: _Optional[int] = ..., unexpected_failures_7d: _Optional[int] = ...) -> None: ...

class MetricThreshold(_message.Message):
    __slots__ = ["one_day", "seven_day", "three_day"]
    ONE_DAY_FIELD_NUMBER: _ClassVar[int]
    SEVEN_DAY_FIELD_NUMBER: _ClassVar[int]
    THREE_DAY_FIELD_NUMBER: _ClassVar[int]
    one_day: int
    seven_day: int
    three_day: int
    def __init__(self, one_day: _Optional[int] = ..., three_day: _Optional[int] = ..., seven_day: _Optional[int] = ...) -> None: ...

class Metrics(_message.Message):
    __slots__ = ["overrides"]
    class MetricOverride(_message.Message):
        __slots__ = ["is_default", "metric_id", "sort_priority"]
        IS_DEFAULT_FIELD_NUMBER: _ClassVar[int]
        METRIC_ID_FIELD_NUMBER: _ClassVar[int]
        SORT_PRIORITY_FIELD_NUMBER: _ClassVar[int]
        is_default: bool
        metric_id: str
        sort_priority: int
        def __init__(self, metric_id: _Optional[str] = ..., is_default: bool = ..., sort_priority: _Optional[int] = ...) -> None: ...
    OVERRIDES_FIELD_NUMBER: _ClassVar[int]
    overrides: _containers.RepeatedCompositeFieldContainer[Metrics.MetricOverride]
    def __init__(self, overrides: _Optional[_Iterable[_Union[Metrics.MetricOverride, _Mapping]]] = ...) -> None: ...

class MonorailFieldValue(_message.Message):
    __slots__ = ["field_id", "value"]
    FIELD_ID_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    field_id: int
    value: str
    def __init__(self, field_id: _Optional[int] = ..., value: _Optional[str] = ...) -> None: ...

class MonorailPriority(_message.Message):
    __slots__ = ["priority", "threshold", "thresholds"]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    THRESHOLDS_FIELD_NUMBER: _ClassVar[int]
    THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    priority: str
    threshold: ImpactThreshold
    thresholds: _containers.RepeatedCompositeFieldContainer[ImpactMetricThreshold]
    def __init__(self, priority: _Optional[str] = ..., threshold: _Optional[_Union[ImpactThreshold, _Mapping]] = ..., thresholds: _Optional[_Iterable[_Union[ImpactMetricThreshold, _Mapping]]] = ...) -> None: ...

class MonorailProject(_message.Message):
    __slots__ = ["default_field_values", "display_prefix", "file_without_restrict_view_google", "monorail_hostname", "priorities", "priority_field_id", "priority_hysteresis_percent", "project"]
    DEFAULT_FIELD_VALUES_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_PREFIX_FIELD_NUMBER: _ClassVar[int]
    FILE_WITHOUT_RESTRICT_VIEW_GOOGLE_FIELD_NUMBER: _ClassVar[int]
    MONORAIL_HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    PRIORITIES_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_ID_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_HYSTERESIS_PERCENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    default_field_values: _containers.RepeatedCompositeFieldContainer[MonorailFieldValue]
    display_prefix: str
    file_without_restrict_view_google: bool
    monorail_hostname: str
    priorities: _containers.RepeatedCompositeFieldContainer[MonorailPriority]
    priority_field_id: int
    priority_hysteresis_percent: int
    project: str
    def __init__(self, project: _Optional[str] = ..., default_field_values: _Optional[_Iterable[_Union[MonorailFieldValue, _Mapping]]] = ..., priority_field_id: _Optional[int] = ..., priorities: _Optional[_Iterable[_Union[MonorailPriority, _Mapping]]] = ..., priority_hysteresis_percent: _Optional[int] = ..., display_prefix: _Optional[str] = ..., monorail_hostname: _Optional[str] = ..., file_without_restrict_view_google: bool = ...) -> None: ...

class ProjectConfig(_message.Message):
    __slots__ = ["bug_filing_threshold", "bug_filing_thresholds", "bug_management", "bug_system", "buganizer", "clustering", "last_updated", "metrics", "monorail", "project_metadata", "realms", "test_stability_criteria"]
    BUGANIZER_FIELD_NUMBER: _ClassVar[int]
    BUG_FILING_THRESHOLDS_FIELD_NUMBER: _ClassVar[int]
    BUG_FILING_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
    BUG_MANAGEMENT_FIELD_NUMBER: _ClassVar[int]
    BUG_SYSTEM_FIELD_NUMBER: _ClassVar[int]
    CLUSTERING_FIELD_NUMBER: _ClassVar[int]
    LAST_UPDATED_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    MONORAIL_FIELD_NUMBER: _ClassVar[int]
    PROJECT_METADATA_FIELD_NUMBER: _ClassVar[int]
    REALMS_FIELD_NUMBER: _ClassVar[int]
    TEST_STABILITY_CRITERIA_FIELD_NUMBER: _ClassVar[int]
    bug_filing_threshold: ImpactThreshold
    bug_filing_thresholds: _containers.RepeatedCompositeFieldContainer[ImpactMetricThreshold]
    bug_management: BugManagement
    bug_system: BugSystem
    buganizer: BuganizerProject
    clustering: Clustering
    last_updated: _timestamp_pb2.Timestamp
    metrics: Metrics
    monorail: MonorailProject
    project_metadata: ProjectMetadata
    realms: _containers.RepeatedCompositeFieldContainer[RealmConfig]
    test_stability_criteria: TestStabilityCriteria
    def __init__(self, project_metadata: _Optional[_Union[ProjectMetadata, _Mapping]] = ..., last_updated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., clustering: _Optional[_Union[Clustering, _Mapping]] = ..., bug_management: _Optional[_Union[BugManagement, _Mapping]] = ..., metrics: _Optional[_Union[Metrics, _Mapping]] = ..., test_stability_criteria: _Optional[_Union[TestStabilityCriteria, _Mapping]] = ..., realms: _Optional[_Iterable[_Union[RealmConfig, _Mapping]]] = ..., bug_system: _Optional[_Union[BugSystem, str]] = ..., monorail: _Optional[_Union[MonorailProject, _Mapping]] = ..., buganizer: _Optional[_Union[BuganizerProject, _Mapping]] = ..., bug_filing_threshold: _Optional[_Union[ImpactThreshold, _Mapping]] = ..., bug_filing_thresholds: _Optional[_Iterable[_Union[ImpactMetricThreshold, _Mapping]]] = ...) -> None: ...

class ProjectMetadata(_message.Message):
    __slots__ = ["display_name"]
    DISPLAY_NAME_FIELD_NUMBER: _ClassVar[int]
    display_name: str
    def __init__(self, display_name: _Optional[str] = ...) -> None: ...

class RealmConfig(_message.Message):
    __slots__ = ["name", "test_variant_analysis"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANT_ANALYSIS_FIELD_NUMBER: _ClassVar[int]
    name: str
    test_variant_analysis: _test_variant_analysis_config_pb2.TestVariantAnalysisConfig
    def __init__(self, name: _Optional[str] = ..., test_variant_analysis: _Optional[_Union[_test_variant_analysis_config_pb2.TestVariantAnalysisConfig, _Mapping]] = ...) -> None: ...

class TestNameClusteringRule(_message.Message):
    __slots__ = ["like_template", "name", "pattern"]
    LIKE_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATTERN_FIELD_NUMBER: _ClassVar[int]
    like_template: str
    name: str
    pattern: str
    def __init__(self, name: _Optional[str] = ..., pattern: _Optional[str] = ..., like_template: _Optional[str] = ...) -> None: ...

class TestStabilityCriteria(_message.Message):
    __slots__ = ["failure_rate", "flake_rate"]
    class FailureRateCriteria(_message.Message):
        __slots__ = ["consecutive_failure_threshold", "failure_threshold"]
        CONSECUTIVE_FAILURE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        FAILURE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        consecutive_failure_threshold: int
        failure_threshold: int
        def __init__(self, failure_threshold: _Optional[int] = ..., consecutive_failure_threshold: _Optional[int] = ...) -> None: ...
    class FlakeRateCriteria(_message.Message):
        __slots__ = ["flake_rate_threshold", "flake_threshold", "min_window"]
        FLAKE_RATE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        FLAKE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        MIN_WINDOW_FIELD_NUMBER: _ClassVar[int]
        flake_rate_threshold: float
        flake_threshold: int
        min_window: int
        def __init__(self, min_window: _Optional[int] = ..., flake_threshold: _Optional[int] = ..., flake_rate_threshold: _Optional[float] = ...) -> None: ...
    FAILURE_RATE_FIELD_NUMBER: _ClassVar[int]
    FLAKE_RATE_FIELD_NUMBER: _ClassVar[int]
    failure_rate: TestStabilityCriteria.FailureRateCriteria
    flake_rate: TestStabilityCriteria.FlakeRateCriteria
    def __init__(self, failure_rate: _Optional[_Union[TestStabilityCriteria.FailureRateCriteria, _Mapping]] = ..., flake_rate: _Optional[_Union[TestStabilityCriteria.FlakeRateCriteria, _Mapping]] = ...) -> None: ...

class BugSystem(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class BuganizerPriority(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
