from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import sources as _sources_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import failure_reason as _failure_reason_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

BASIC: ClusterSummaryView
CLUSTER_SUMMARY_VIEW_UNSPECIFIED: ClusterSummaryView
DESCRIPTOR: _descriptor.FileDescriptor
FULL: ClusterSummaryView

class Cluster(_message.Message):
    __slots__ = ["equivalent_failure_association_rule", "has_example", "metrics", "name", "title"]
    class Counts(_message.Message):
        __slots__ = ["nominal"]
        NOMINAL_FIELD_NUMBER: _ClassVar[int]
        nominal: int
        def __init__(self, nominal: _Optional[int] = ...) -> None: ...
    class MetricsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: Cluster.TimewiseCounts
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[Cluster.TimewiseCounts, _Mapping]] = ...) -> None: ...
    class TimewiseCounts(_message.Message):
        __slots__ = ["one_day", "seven_day", "three_day"]
        ONE_DAY_FIELD_NUMBER: _ClassVar[int]
        SEVEN_DAY_FIELD_NUMBER: _ClassVar[int]
        THREE_DAY_FIELD_NUMBER: _ClassVar[int]
        one_day: Cluster.Counts
        seven_day: Cluster.Counts
        three_day: Cluster.Counts
        def __init__(self, one_day: _Optional[_Union[Cluster.Counts, _Mapping]] = ..., three_day: _Optional[_Union[Cluster.Counts, _Mapping]] = ..., seven_day: _Optional[_Union[Cluster.Counts, _Mapping]] = ...) -> None: ...
    EQUIVALENT_FAILURE_ASSOCIATION_RULE_FIELD_NUMBER: _ClassVar[int]
    HAS_EXAMPLE_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    TITLE_FIELD_NUMBER: _ClassVar[int]
    equivalent_failure_association_rule: str
    has_example: bool
    metrics: _containers.MessageMap[str, Cluster.TimewiseCounts]
    name: str
    title: str
    def __init__(self, name: _Optional[str] = ..., has_example: bool = ..., title: _Optional[str] = ..., metrics: _Optional[_Mapping[str, Cluster.TimewiseCounts]] = ..., equivalent_failure_association_rule: _Optional[str] = ...) -> None: ...

class ClusterExoneratedTestVariant(_message.Message):
    __slots__ = ["critical_failures_exonerated", "last_exoneration", "test_id", "variant"]
    CRITICAL_FAILURES_EXONERATED_FIELD_NUMBER: _ClassVar[int]
    LAST_EXONERATION_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    critical_failures_exonerated: int
    last_exoneration: _timestamp_pb2.Timestamp
    test_id: str
    variant: _common_pb2.Variant
    def __init__(self, test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., critical_failures_exonerated: _Optional[int] = ..., last_exoneration: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class ClusterExoneratedTestVariantBranch(_message.Message):
    __slots__ = ["critical_failures_exonerated", "last_exoneration", "project", "source_ref", "test_id", "variant"]
    CRITICAL_FAILURES_EXONERATED_FIELD_NUMBER: _ClassVar[int]
    LAST_EXONERATION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SOURCE_REF_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    critical_failures_exonerated: int
    last_exoneration: _timestamp_pb2.Timestamp
    project: str
    source_ref: _sources_pb2.SourceRef
    test_id: str
    variant: _common_pb2.Variant
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., source_ref: _Optional[_Union[_sources_pb2.SourceRef, _Mapping]] = ..., critical_failures_exonerated: _Optional[int] = ..., last_exoneration: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class ClusterHistoryDay(_message.Message):
    __slots__ = ["date", "metrics"]
    class MetricsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: int
        def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
    DATE_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    date: str
    metrics: _containers.ScalarMap[str, int]
    def __init__(self, metrics: _Optional[_Mapping[str, int]] = ..., date: _Optional[str] = ...) -> None: ...

class ClusterRequest(_message.Message):
    __slots__ = ["project", "test_results"]
    class TestResult(_message.Message):
        __slots__ = ["failure_reason", "request_tag", "test_id"]
        FAILURE_REASON_FIELD_NUMBER: _ClassVar[int]
        REQUEST_TAG_FIELD_NUMBER: _ClassVar[int]
        TEST_ID_FIELD_NUMBER: _ClassVar[int]
        failure_reason: _failure_reason_pb2.FailureReason
        request_tag: str
        test_id: str
        def __init__(self, request_tag: _Optional[str] = ..., test_id: _Optional[str] = ..., failure_reason: _Optional[_Union[_failure_reason_pb2.FailureReason, _Mapping]] = ...) -> None: ...
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULTS_FIELD_NUMBER: _ClassVar[int]
    project: str
    test_results: _containers.RepeatedCompositeFieldContainer[ClusterRequest.TestResult]
    def __init__(self, project: _Optional[str] = ..., test_results: _Optional[_Iterable[_Union[ClusterRequest.TestResult, _Mapping]]] = ...) -> None: ...

class ClusterResponse(_message.Message):
    __slots__ = ["clustered_test_results", "clustering_version"]
    class ClusteredTestResult(_message.Message):
        __slots__ = ["clusters", "request_tag"]
        class ClusterEntry(_message.Message):
            __slots__ = ["bug", "cluster_id"]
            BUG_FIELD_NUMBER: _ClassVar[int]
            CLUSTER_ID_FIELD_NUMBER: _ClassVar[int]
            bug: _common_pb2.AssociatedBug
            cluster_id: _common_pb2.ClusterId
            def __init__(self, cluster_id: _Optional[_Union[_common_pb2.ClusterId, _Mapping]] = ..., bug: _Optional[_Union[_common_pb2.AssociatedBug, _Mapping]] = ...) -> None: ...
        CLUSTERS_FIELD_NUMBER: _ClassVar[int]
        REQUEST_TAG_FIELD_NUMBER: _ClassVar[int]
        clusters: _containers.RepeatedCompositeFieldContainer[ClusterResponse.ClusteredTestResult.ClusterEntry]
        request_tag: str
        def __init__(self, request_tag: _Optional[str] = ..., clusters: _Optional[_Iterable[_Union[ClusterResponse.ClusteredTestResult.ClusterEntry, _Mapping]]] = ...) -> None: ...
    CLUSTERED_TEST_RESULTS_FIELD_NUMBER: _ClassVar[int]
    CLUSTERING_VERSION_FIELD_NUMBER: _ClassVar[int]
    clustered_test_results: _containers.RepeatedCompositeFieldContainer[ClusterResponse.ClusteredTestResult]
    clustering_version: ClusteringVersion
    def __init__(self, clustered_test_results: _Optional[_Iterable[_Union[ClusterResponse.ClusteredTestResult, _Mapping]]] = ..., clustering_version: _Optional[_Union[ClusteringVersion, _Mapping]] = ...) -> None: ...

class ClusterSummary(_message.Message):
    __slots__ = ["bug", "cluster_id", "metrics", "title"]
    class MetricValue(_message.Message):
        __slots__ = ["daily_breakdown", "value"]
        DAILY_BREAKDOWN_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        daily_breakdown: _containers.RepeatedScalarFieldContainer[int]
        value: int
        def __init__(self, value: _Optional[int] = ..., daily_breakdown: _Optional[_Iterable[int]] = ...) -> None: ...
    class MetricsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ClusterSummary.MetricValue
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ClusterSummary.MetricValue, _Mapping]] = ...) -> None: ...
    BUG_FIELD_NUMBER: _ClassVar[int]
    CLUSTER_ID_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    TITLE_FIELD_NUMBER: _ClassVar[int]
    bug: _common_pb2.AssociatedBug
    cluster_id: _common_pb2.ClusterId
    metrics: _containers.MessageMap[str, ClusterSummary.MetricValue]
    title: str
    def __init__(self, cluster_id: _Optional[_Union[_common_pb2.ClusterId, _Mapping]] = ..., title: _Optional[str] = ..., bug: _Optional[_Union[_common_pb2.AssociatedBug, _Mapping]] = ..., metrics: _Optional[_Mapping[str, ClusterSummary.MetricValue]] = ...) -> None: ...

class ClusteringVersion(_message.Message):
    __slots__ = ["algorithms_version", "config_version", "rules_version"]
    ALGORITHMS_VERSION_FIELD_NUMBER: _ClassVar[int]
    CONFIG_VERSION_FIELD_NUMBER: _ClassVar[int]
    RULES_VERSION_FIELD_NUMBER: _ClassVar[int]
    algorithms_version: int
    config_version: _timestamp_pb2.Timestamp
    rules_version: _timestamp_pb2.Timestamp
    def __init__(self, algorithms_version: _Optional[int] = ..., rules_version: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., config_version: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class DistinctClusterFailure(_message.Message):
    __slots__ = ["build_status", "changelists", "count", "exonerations", "ingested_invocation_id", "is_build_critical", "is_ingested_invocation_blocked", "partition_time", "presubmit_run", "test_id", "variant"]
    class Exoneration(_message.Message):
        __slots__ = ["reason"]
        REASON_FIELD_NUMBER: _ClassVar[int]
        reason: _common_pb2.ExonerationReason
        def __init__(self, reason: _Optional[_Union[_common_pb2.ExonerationReason, str]] = ...) -> None: ...
    class PresubmitRun(_message.Message):
        __slots__ = ["mode", "owner", "presubmit_run_id", "status"]
        MODE_FIELD_NUMBER: _ClassVar[int]
        OWNER_FIELD_NUMBER: _ClassVar[int]
        PRESUBMIT_RUN_ID_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        mode: _common_pb2.PresubmitRunMode
        owner: str
        presubmit_run_id: _common_pb2.PresubmitRunId
        status: _common_pb2.PresubmitRunStatus
        def __init__(self, presubmit_run_id: _Optional[_Union[_common_pb2.PresubmitRunId, _Mapping]] = ..., owner: _Optional[str] = ..., mode: _Optional[_Union[_common_pb2.PresubmitRunMode, str]] = ..., status: _Optional[_Union[_common_pb2.PresubmitRunStatus, str]] = ...) -> None: ...
    BUILD_STATUS_FIELD_NUMBER: _ClassVar[int]
    CHANGELISTS_FIELD_NUMBER: _ClassVar[int]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    EXONERATIONS_FIELD_NUMBER: _ClassVar[int]
    INGESTED_INVOCATION_ID_FIELD_NUMBER: _ClassVar[int]
    IS_BUILD_CRITICAL_FIELD_NUMBER: _ClassVar[int]
    IS_INGESTED_INVOCATION_BLOCKED_FIELD_NUMBER: _ClassVar[int]
    PARTITION_TIME_FIELD_NUMBER: _ClassVar[int]
    PRESUBMIT_RUN_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    build_status: _common_pb2.BuildStatus
    changelists: _containers.RepeatedCompositeFieldContainer[_sources_pb2.Changelist]
    count: int
    exonerations: _containers.RepeatedCompositeFieldContainer[DistinctClusterFailure.Exoneration]
    ingested_invocation_id: str
    is_build_critical: bool
    is_ingested_invocation_blocked: bool
    partition_time: _timestamp_pb2.Timestamp
    presubmit_run: DistinctClusterFailure.PresubmitRun
    test_id: str
    variant: _common_pb2.Variant
    def __init__(self, test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., partition_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., presubmit_run: _Optional[_Union[DistinctClusterFailure.PresubmitRun, _Mapping]] = ..., is_build_critical: bool = ..., exonerations: _Optional[_Iterable[_Union[DistinctClusterFailure.Exoneration, _Mapping]]] = ..., build_status: _Optional[_Union[_common_pb2.BuildStatus, str]] = ..., ingested_invocation_id: _Optional[str] = ..., is_ingested_invocation_blocked: bool = ..., changelists: _Optional[_Iterable[_Union[_sources_pb2.Changelist, _Mapping]]] = ..., count: _Optional[int] = ...) -> None: ...

class GetClusterRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class GetReclusteringProgressRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class QueryClusterExoneratedTestVariantBranchesRequest(_message.Message):
    __slots__ = ["parent"]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    parent: str
    def __init__(self, parent: _Optional[str] = ...) -> None: ...

class QueryClusterExoneratedTestVariantBranchesResponse(_message.Message):
    __slots__ = ["test_variant_branches"]
    TEST_VARIANT_BRANCHES_FIELD_NUMBER: _ClassVar[int]
    test_variant_branches: _containers.RepeatedCompositeFieldContainer[ClusterExoneratedTestVariantBranch]
    def __init__(self, test_variant_branches: _Optional[_Iterable[_Union[ClusterExoneratedTestVariantBranch, _Mapping]]] = ...) -> None: ...

class QueryClusterExoneratedTestVariantsRequest(_message.Message):
    __slots__ = ["parent"]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    parent: str
    def __init__(self, parent: _Optional[str] = ...) -> None: ...

class QueryClusterExoneratedTestVariantsResponse(_message.Message):
    __slots__ = ["test_variants"]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    test_variants: _containers.RepeatedCompositeFieldContainer[ClusterExoneratedTestVariant]
    def __init__(self, test_variants: _Optional[_Iterable[_Union[ClusterExoneratedTestVariant, _Mapping]]] = ...) -> None: ...

class QueryClusterFailuresRequest(_message.Message):
    __slots__ = ["metric_filter", "parent"]
    METRIC_FILTER_FIELD_NUMBER: _ClassVar[int]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    metric_filter: str
    parent: str
    def __init__(self, parent: _Optional[str] = ..., metric_filter: _Optional[str] = ...) -> None: ...

class QueryClusterFailuresResponse(_message.Message):
    __slots__ = ["failures"]
    FAILURES_FIELD_NUMBER: _ClassVar[int]
    failures: _containers.RepeatedCompositeFieldContainer[DistinctClusterFailure]
    def __init__(self, failures: _Optional[_Iterable[_Union[DistinctClusterFailure, _Mapping]]] = ...) -> None: ...

class QueryClusterHistoryRequest(_message.Message):
    __slots__ = ["days", "failure_filter", "metrics", "project"]
    DAYS_FIELD_NUMBER: _ClassVar[int]
    FAILURE_FILTER_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    days: int
    failure_filter: str
    metrics: _containers.RepeatedScalarFieldContainer[str]
    project: str
    def __init__(self, project: _Optional[str] = ..., failure_filter: _Optional[str] = ..., days: _Optional[int] = ..., metrics: _Optional[_Iterable[str]] = ...) -> None: ...

class QueryClusterHistoryResponse(_message.Message):
    __slots__ = ["days"]
    DAYS_FIELD_NUMBER: _ClassVar[int]
    days: _containers.RepeatedCompositeFieldContainer[ClusterHistoryDay]
    def __init__(self, days: _Optional[_Iterable[_Union[ClusterHistoryDay, _Mapping]]] = ...) -> None: ...

class QueryClusterSummariesRequest(_message.Message):
    __slots__ = ["failure_filter", "metrics", "order_by", "project", "time_range", "view"]
    FAILURE_FILTER_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TIME_RANGE_FIELD_NUMBER: _ClassVar[int]
    VIEW_FIELD_NUMBER: _ClassVar[int]
    failure_filter: str
    metrics: _containers.RepeatedScalarFieldContainer[str]
    order_by: str
    project: str
    time_range: _common_pb2.TimeRange
    view: ClusterSummaryView
    def __init__(self, project: _Optional[str] = ..., failure_filter: _Optional[str] = ..., order_by: _Optional[str] = ..., metrics: _Optional[_Iterable[str]] = ..., time_range: _Optional[_Union[_common_pb2.TimeRange, _Mapping]] = ..., view: _Optional[_Union[ClusterSummaryView, str]] = ...) -> None: ...

class QueryClusterSummariesResponse(_message.Message):
    __slots__ = ["cluster_summaries"]
    CLUSTER_SUMMARIES_FIELD_NUMBER: _ClassVar[int]
    cluster_summaries: _containers.RepeatedCompositeFieldContainer[ClusterSummary]
    def __init__(self, cluster_summaries: _Optional[_Iterable[_Union[ClusterSummary, _Mapping]]] = ...) -> None: ...

class ReclusteringProgress(_message.Message):
    __slots__ = ["last", "name", "next", "progress_per_mille"]
    LAST_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NEXT_FIELD_NUMBER: _ClassVar[int]
    PROGRESS_PER_MILLE_FIELD_NUMBER: _ClassVar[int]
    last: ClusteringVersion
    name: str
    next: ClusteringVersion
    progress_per_mille: int
    def __init__(self, name: _Optional[str] = ..., progress_per_mille: _Optional[int] = ..., last: _Optional[_Union[ClusteringVersion, _Mapping]] = ..., next: _Optional[_Union[ClusteringVersion, _Mapping]] = ...) -> None: ...

class ClusterSummaryView(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
