from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

BUILD_STATUS_CANCELED: BuildStatus
BUILD_STATUS_FAILURE: BuildStatus
BUILD_STATUS_INFRA_FAILURE: BuildStatus
BUILD_STATUS_SUCCESS: BuildStatus
BUILD_STATUS_UNSPECIFIED: BuildStatus
DESCRIPTOR: _descriptor.FileDescriptor
DRY_RUN: PresubmitRunMode
EXONERATION_REASON_UNSPECIFIED: ExonerationReason
FULL_RUN: PresubmitRunMode
NEW_PATCHSET_RUN: PresubmitRunMode
NOT_CRITICAL: ExonerationReason
OCCURS_ON_MAINLINE: ExonerationReason
OCCURS_ON_OTHER_CLS: ExonerationReason
ONLY_SUBMITTED: SubmittedFilter
ONLY_UNSUBMITTED: SubmittedFilter
PRESUBMIT_RUN_MODE_UNSPECIFIED: PresubmitRunMode
PRESUBMIT_RUN_STATUS_CANCELED: PresubmitRunStatus
PRESUBMIT_RUN_STATUS_FAILED: PresubmitRunStatus
PRESUBMIT_RUN_STATUS_SUCCEEDED: PresubmitRunStatus
PRESUBMIT_RUN_STATUS_UNSPECIFIED: PresubmitRunStatus
QUICK_DRY_RUN: PresubmitRunMode
SUBMITTED_FILTER_UNSPECIFIED: SubmittedFilter
UNEXPECTED_PASS: ExonerationReason

class AssociatedBug(_message.Message):
    __slots__ = ["id", "link_text", "system", "url"]
    ID_FIELD_NUMBER: _ClassVar[int]
    LINK_TEXT_FIELD_NUMBER: _ClassVar[int]
    SYSTEM_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    id: str
    link_text: str
    system: str
    url: str
    def __init__(self, system: _Optional[str] = ..., id: _Optional[str] = ..., link_text: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class BugTrackingComponent(_message.Message):
    __slots__ = ["component", "system"]
    COMPONENT_FIELD_NUMBER: _ClassVar[int]
    SYSTEM_FIELD_NUMBER: _ClassVar[int]
    component: str
    system: str
    def __init__(self, system: _Optional[str] = ..., component: _Optional[str] = ...) -> None: ...

class ClusterId(_message.Message):
    __slots__ = ["algorithm", "id"]
    ALGORITHM_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    algorithm: str
    id: str
    def __init__(self, algorithm: _Optional[str] = ..., id: _Optional[str] = ...) -> None: ...

class PresubmitRunId(_message.Message):
    __slots__ = ["id", "system"]
    ID_FIELD_NUMBER: _ClassVar[int]
    SYSTEM_FIELD_NUMBER: _ClassVar[int]
    id: str
    system: str
    def __init__(self, system: _Optional[str] = ..., id: _Optional[str] = ...) -> None: ...

class StringPair(_message.Message):
    __slots__ = ["key", "value"]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class TestResultId(_message.Message):
    __slots__ = ["id", "system"]
    ID_FIELD_NUMBER: _ClassVar[int]
    SYSTEM_FIELD_NUMBER: _ClassVar[int]
    id: str
    system: str
    def __init__(self, system: _Optional[str] = ..., id: _Optional[str] = ...) -> None: ...

class TimeRange(_message.Message):
    __slots__ = ["earliest", "latest"]
    EARLIEST_FIELD_NUMBER: _ClassVar[int]
    LATEST_FIELD_NUMBER: _ClassVar[int]
    earliest: _timestamp_pb2.Timestamp
    latest: _timestamp_pb2.Timestamp
    def __init__(self, earliest: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., latest: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class Variant(_message.Message):
    __slots__ = []
    class DefEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DEF_FIELD_NUMBER: _ClassVar[int]
    def __init__(self, **kwargs) -> None: ...

class BuildStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class ExonerationReason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class SubmittedFilter(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class PresubmitRunMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class PresubmitRunStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
