from PB.go.chromium.org.luci.analysis.proto.v1 import project as _project_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

BUGANIZER_PRIORITY_UNSPECIFIED: BuganizerPriority
DESCRIPTOR: _descriptor.FileDescriptor
P0: BuganizerPriority
P1: BuganizerPriority
P2: BuganizerPriority
P3: BuganizerPriority
P4: BuganizerPriority

class BugManagement(_message.Message):
    __slots__ = ["monorail", "policies"]
    MONORAIL_FIELD_NUMBER: _ClassVar[int]
    POLICIES_FIELD_NUMBER: _ClassVar[int]
    monorail: MonorailProject
    policies: _containers.RepeatedCompositeFieldContainer[BugManagementPolicy]
    def __init__(self, policies: _Optional[_Iterable[_Union[BugManagementPolicy, _Mapping]]] = ..., monorail: _Optional[_Union[MonorailProject, _Mapping]] = ...) -> None: ...

class BugManagementPolicy(_message.Message):
    __slots__ = ["explanation", "human_readable_name", "id", "metrics", "owners", "priority"]
    class Explanation(_message.Message):
        __slots__ = ["action_html", "problem_html"]
        ACTION_HTML_FIELD_NUMBER: _ClassVar[int]
        PROBLEM_HTML_FIELD_NUMBER: _ClassVar[int]
        action_html: str
        problem_html: str
        def __init__(self, problem_html: _Optional[str] = ..., action_html: _Optional[str] = ...) -> None: ...
    class Metric(_message.Message):
        __slots__ = ["activation_threshold", "deactivation_threshold", "metric_id"]
        ACTIVATION_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        DEACTIVATION_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        METRIC_ID_FIELD_NUMBER: _ClassVar[int]
        activation_threshold: MetricThreshold
        deactivation_threshold: MetricThreshold
        metric_id: str
        def __init__(self, metric_id: _Optional[str] = ..., activation_threshold: _Optional[_Union[MetricThreshold, _Mapping]] = ..., deactivation_threshold: _Optional[_Union[MetricThreshold, _Mapping]] = ...) -> None: ...
    EXPLANATION_FIELD_NUMBER: _ClassVar[int]
    HUMAN_READABLE_NAME_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    OWNERS_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    explanation: BugManagementPolicy.Explanation
    human_readable_name: str
    id: str
    metrics: _containers.RepeatedCompositeFieldContainer[BugManagementPolicy.Metric]
    owners: _containers.RepeatedScalarFieldContainer[str]
    priority: BuganizerPriority
    def __init__(self, id: _Optional[str] = ..., owners: _Optional[_Iterable[str]] = ..., human_readable_name: _Optional[str] = ..., priority: _Optional[_Union[BuganizerPriority, str]] = ..., metrics: _Optional[_Iterable[_Union[BugManagementPolicy.Metric, _Mapping]]] = ..., explanation: _Optional[_Union[BugManagementPolicy.Explanation, _Mapping]] = ...) -> None: ...

class GetProjectConfigRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class ListProjectsRequest(_message.Message):
    __slots__ = []
    def __init__(self) -> None: ...

class ListProjectsResponse(_message.Message):
    __slots__ = ["projects"]
    PROJECTS_FIELD_NUMBER: _ClassVar[int]
    projects: _containers.RepeatedCompositeFieldContainer[_project_pb2.Project]
    def __init__(self, projects: _Optional[_Iterable[_Union[_project_pb2.Project, _Mapping]]] = ...) -> None: ...

class MetricThreshold(_message.Message):
    __slots__ = ["one_day", "seven_day", "three_day"]
    ONE_DAY_FIELD_NUMBER: _ClassVar[int]
    SEVEN_DAY_FIELD_NUMBER: _ClassVar[int]
    THREE_DAY_FIELD_NUMBER: _ClassVar[int]
    one_day: int
    seven_day: int
    three_day: int
    def __init__(self, one_day: _Optional[int] = ..., three_day: _Optional[int] = ..., seven_day: _Optional[int] = ...) -> None: ...

class MonorailProject(_message.Message):
    __slots__ = ["display_prefix", "project"]
    DISPLAY_PREFIX_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    display_prefix: str
    project: str
    def __init__(self, project: _Optional[str] = ..., display_prefix: _Optional[str] = ...) -> None: ...

class ProjectConfig(_message.Message):
    __slots__ = ["bug_management", "name"]
    BUG_MANAGEMENT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    bug_management: BugManagement
    name: str
    def __init__(self, name: _Optional[str] = ..., bug_management: _Optional[_Union[BugManagement, _Mapping]] = ...) -> None: ...

class BuganizerPriority(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
