from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import field_mask_pb2 as _field_mask_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BugManagementState(_message.Message):
    __slots__ = ["policy_state"]
    class PolicyState(_message.Message):
        __slots__ = ["is_active", "last_activation_time", "last_deactivation_time", "policy_id"]
        IS_ACTIVE_FIELD_NUMBER: _ClassVar[int]
        LAST_ACTIVATION_TIME_FIELD_NUMBER: _ClassVar[int]
        LAST_DEACTIVATION_TIME_FIELD_NUMBER: _ClassVar[int]
        POLICY_ID_FIELD_NUMBER: _ClassVar[int]
        is_active: bool
        last_activation_time: _timestamp_pb2.Timestamp
        last_deactivation_time: _timestamp_pb2.Timestamp
        policy_id: str
        def __init__(self, policy_id: _Optional[str] = ..., is_active: bool = ..., last_activation_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., last_deactivation_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    POLICY_STATE_FIELD_NUMBER: _ClassVar[int]
    policy_state: _containers.RepeatedCompositeFieldContainer[BugManagementState.PolicyState]
    def __init__(self, policy_state: _Optional[_Iterable[_Union[BugManagementState.PolicyState, _Mapping]]] = ...) -> None: ...

class CreateRuleRequest(_message.Message):
    __slots__ = ["parent", "rule"]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    RULE_FIELD_NUMBER: _ClassVar[int]
    parent: str
    rule: Rule
    def __init__(self, parent: _Optional[str] = ..., rule: _Optional[_Union[Rule, _Mapping]] = ...) -> None: ...

class GetRuleRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class ListRulesRequest(_message.Message):
    __slots__ = ["parent"]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    parent: str
    def __init__(self, parent: _Optional[str] = ...) -> None: ...

class ListRulesResponse(_message.Message):
    __slots__ = ["rules"]
    RULES_FIELD_NUMBER: _ClassVar[int]
    rules: _containers.RepeatedCompositeFieldContainer[Rule]
    def __init__(self, rules: _Optional[_Iterable[_Union[Rule, _Mapping]]] = ...) -> None: ...

class LookupBugRequest(_message.Message):
    __slots__ = ["id", "system"]
    ID_FIELD_NUMBER: _ClassVar[int]
    SYSTEM_FIELD_NUMBER: _ClassVar[int]
    id: str
    system: str
    def __init__(self, system: _Optional[str] = ..., id: _Optional[str] = ...) -> None: ...

class LookupBugResponse(_message.Message):
    __slots__ = ["rules"]
    RULES_FIELD_NUMBER: _ClassVar[int]
    rules: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, rules: _Optional[_Iterable[str]] = ...) -> None: ...

class Rule(_message.Message):
    __slots__ = ["bug", "bug_management_state", "create_time", "create_user", "etag", "is_active", "is_managing_bug", "is_managing_bug_priority", "is_managing_bug_priority_last_update_time", "last_auditable_update_time", "last_auditable_update_user", "last_update_time", "name", "predicate_last_update_time", "project", "rule_definition", "rule_id", "source_cluster"]
    BUG_FIELD_NUMBER: _ClassVar[int]
    BUG_MANAGEMENT_STATE_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    CREATE_USER_FIELD_NUMBER: _ClassVar[int]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    IS_ACTIVE_FIELD_NUMBER: _ClassVar[int]
    IS_MANAGING_BUG_FIELD_NUMBER: _ClassVar[int]
    IS_MANAGING_BUG_PRIORITY_FIELD_NUMBER: _ClassVar[int]
    IS_MANAGING_BUG_PRIORITY_LAST_UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    LAST_AUDITABLE_UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    LAST_AUDITABLE_UPDATE_USER_FIELD_NUMBER: _ClassVar[int]
    LAST_UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_LAST_UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    RULE_DEFINITION_FIELD_NUMBER: _ClassVar[int]
    RULE_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_CLUSTER_FIELD_NUMBER: _ClassVar[int]
    bug: _common_pb2.AssociatedBug
    bug_management_state: BugManagementState
    create_time: _timestamp_pb2.Timestamp
    create_user: str
    etag: str
    is_active: bool
    is_managing_bug: bool
    is_managing_bug_priority: bool
    is_managing_bug_priority_last_update_time: _timestamp_pb2.Timestamp
    last_auditable_update_time: _timestamp_pb2.Timestamp
    last_auditable_update_user: str
    last_update_time: _timestamp_pb2.Timestamp
    name: str
    predicate_last_update_time: _timestamp_pb2.Timestamp
    project: str
    rule_definition: str
    rule_id: str
    source_cluster: _common_pb2.ClusterId
    def __init__(self, name: _Optional[str] = ..., project: _Optional[str] = ..., rule_id: _Optional[str] = ..., rule_definition: _Optional[str] = ..., bug: _Optional[_Union[_common_pb2.AssociatedBug, _Mapping]] = ..., is_active: bool = ..., is_managing_bug: bool = ..., is_managing_bug_priority: bool = ..., is_managing_bug_priority_last_update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., source_cluster: _Optional[_Union[_common_pb2.ClusterId, _Mapping]] = ..., bug_management_state: _Optional[_Union[BugManagementState, _Mapping]] = ..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., create_user: _Optional[str] = ..., last_auditable_update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., last_auditable_update_user: _Optional[str] = ..., last_update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., predicate_last_update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., etag: _Optional[str] = ...) -> None: ...

class UpdateRuleRequest(_message.Message):
    __slots__ = ["etag", "rule", "update_mask"]
    ETAG_FIELD_NUMBER: _ClassVar[int]
    RULE_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    etag: str
    rule: Rule
    update_mask: _field_mask_pb2.FieldMask
    def __init__(self, rule: _Optional[_Union[Rule, _Mapping]] = ..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., etag: _Optional[str] = ...) -> None: ...
