from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import predicate as _predicate_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import test_verdict as _test_verdict_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class QueryTestHistoryRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "predicate", "project", "test_id"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    predicate: _predicate_pb2.TestVerdictPredicate
    project: str
    test_id: str
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., predicate: _Optional[_Union[_predicate_pb2.TestVerdictPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryTestHistoryResponse(_message.Message):
    __slots__ = ["next_page_token", "verdicts"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    VERDICTS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    verdicts: _containers.RepeatedCompositeFieldContainer[_test_verdict_pb2.TestVerdict]
    def __init__(self, verdicts: _Optional[_Iterable[_Union[_test_verdict_pb2.TestVerdict, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryTestHistoryStatsRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "predicate", "project", "test_id"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    predicate: _predicate_pb2.TestVerdictPredicate
    project: str
    test_id: str
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., predicate: _Optional[_Union[_predicate_pb2.TestVerdictPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryTestHistoryStatsResponse(_message.Message):
    __slots__ = ["groups", "next_page_token"]
    class Group(_message.Message):
        __slots__ = ["exonerated_count", "expected_count", "flaky_count", "partition_time", "passed_avg_duration", "unexpected_count", "unexpectedly_skipped_count", "variant_hash"]
        EXONERATED_COUNT_FIELD_NUMBER: _ClassVar[int]
        EXPECTED_COUNT_FIELD_NUMBER: _ClassVar[int]
        FLAKY_COUNT_FIELD_NUMBER: _ClassVar[int]
        PARTITION_TIME_FIELD_NUMBER: _ClassVar[int]
        PASSED_AVG_DURATION_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTEDLY_SKIPPED_COUNT_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_COUNT_FIELD_NUMBER: _ClassVar[int]
        VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
        exonerated_count: int
        expected_count: int
        flaky_count: int
        partition_time: _timestamp_pb2.Timestamp
        passed_avg_duration: _duration_pb2.Duration
        unexpected_count: int
        unexpectedly_skipped_count: int
        variant_hash: str
        def __init__(self, partition_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., variant_hash: _Optional[str] = ..., unexpected_count: _Optional[int] = ..., unexpectedly_skipped_count: _Optional[int] = ..., flaky_count: _Optional[int] = ..., exonerated_count: _Optional[int] = ..., expected_count: _Optional[int] = ..., passed_avg_duration: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...
    GROUPS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    groups: _containers.RepeatedCompositeFieldContainer[QueryTestHistoryStatsResponse.Group]
    next_page_token: str
    def __init__(self, groups: _Optional[_Iterable[_Union[QueryTestHistoryStatsResponse.Group, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryTestsRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "project", "sub_realm", "test_id_substring"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SUB_REALM_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_SUBSTRING_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    project: str
    sub_realm: str
    test_id_substring: str
    def __init__(self, project: _Optional[str] = ..., test_id_substring: _Optional[str] = ..., sub_realm: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryTestsResponse(_message.Message):
    __slots__ = ["next_page_token", "test_ids"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TEST_IDS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    test_ids: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, test_ids: _Optional[_Iterable[str]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryVariantsRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "project", "sub_realm", "test_id", "variant_predicate"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SUB_REALM_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_PREDICATE_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    project: str
    sub_realm: str
    test_id: str
    variant_predicate: _predicate_pb2.VariantPredicate
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., sub_realm: _Optional[str] = ..., variant_predicate: _Optional[_Union[_predicate_pb2.VariantPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryVariantsResponse(_message.Message):
    __slots__ = ["next_page_token", "variants"]
    class VariantInfo(_message.Message):
        __slots__ = ["variant", "variant_hash"]
        VARIANT_FIELD_NUMBER: _ClassVar[int]
        VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
        variant: _common_pb2.Variant
        variant_hash: str
        def __init__(self, variant_hash: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ...) -> None: ...
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    VARIANTS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    variants: _containers.RepeatedCompositeFieldContainer[QueryVariantsResponse.VariantInfo]
    def __init__(self, variants: _Optional[_Iterable[_Union[QueryVariantsResponse.VariantInfo, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...
