from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import sources as _sources_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class QueryTestVariantFailureRateRequest(_message.Message):
    __slots__ = ["project", "test_variants"]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    project: str
    test_variants: _containers.RepeatedCompositeFieldContainer[TestVariantIdentifier]
    def __init__(self, project: _Optional[str] = ..., test_variants: _Optional[_Iterable[_Union[TestVariantIdentifier, _Mapping]]] = ...) -> None: ...

class QueryTestVariantFailureRateResponse(_message.Message):
    __slots__ = ["intervals", "test_variants"]
    class Interval(_message.Message):
        __slots__ = ["end_time", "interval_age", "start_time"]
        END_TIME_FIELD_NUMBER: _ClassVar[int]
        INTERVAL_AGE_FIELD_NUMBER: _ClassVar[int]
        START_TIME_FIELD_NUMBER: _ClassVar[int]
        end_time: _timestamp_pb2.Timestamp
        interval_age: int
        start_time: _timestamp_pb2.Timestamp
        def __init__(self, interval_age: _Optional[int] = ..., start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    INTERVALS_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    intervals: _containers.RepeatedCompositeFieldContainer[QueryTestVariantFailureRateResponse.Interval]
    test_variants: _containers.RepeatedCompositeFieldContainer[TestVariantFailureRateAnalysis]
    def __init__(self, intervals: _Optional[_Iterable[_Union[QueryTestVariantFailureRateResponse.Interval, _Mapping]]] = ..., test_variants: _Optional[_Iterable[_Union[TestVariantFailureRateAnalysis, _Mapping]]] = ...) -> None: ...

class QueryTestVariantStabilityRequest(_message.Message):
    __slots__ = ["project", "test_variants"]
    class TestVariantPosition(_message.Message):
        __slots__ = ["sources", "test_id", "variant", "variant_hash"]
        SOURCES_FIELD_NUMBER: _ClassVar[int]
        TEST_ID_FIELD_NUMBER: _ClassVar[int]
        VARIANT_FIELD_NUMBER: _ClassVar[int]
        VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
        sources: _sources_pb2.Sources
        test_id: str
        variant: _common_pb2.Variant
        variant_hash: str
        def __init__(self, test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., variant_hash: _Optional[str] = ..., sources: _Optional[_Union[_sources_pb2.Sources, _Mapping]] = ...) -> None: ...
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    project: str
    test_variants: _containers.RepeatedCompositeFieldContainer[QueryTestVariantStabilityRequest.TestVariantPosition]
    def __init__(self, project: _Optional[str] = ..., test_variants: _Optional[_Iterable[_Union[QueryTestVariantStabilityRequest.TestVariantPosition, _Mapping]]] = ...) -> None: ...

class QueryTestVariantStabilityResponse(_message.Message):
    __slots__ = ["criteria", "test_variants"]
    CRITERIA_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    criteria: TestStabilityCriteria
    test_variants: _containers.RepeatedCompositeFieldContainer[TestVariantStabilityAnalysis]
    def __init__(self, test_variants: _Optional[_Iterable[_Union[TestVariantStabilityAnalysis, _Mapping]]] = ..., criteria: _Optional[_Union[TestStabilityCriteria, _Mapping]] = ...) -> None: ...

class TestStabilityCriteria(_message.Message):
    __slots__ = ["failure_rate", "flake_rate"]
    class FailureRateCriteria(_message.Message):
        __slots__ = ["consecutive_failure_threshold", "failure_threshold"]
        CONSECUTIVE_FAILURE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        FAILURE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        consecutive_failure_threshold: int
        failure_threshold: int
        def __init__(self, failure_threshold: _Optional[int] = ..., consecutive_failure_threshold: _Optional[int] = ...) -> None: ...
    class FlakeRateCriteria(_message.Message):
        __slots__ = ["flake_rate_threshold", "flake_threshold", "min_window"]
        FLAKE_RATE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        FLAKE_THRESHOLD_FIELD_NUMBER: _ClassVar[int]
        MIN_WINDOW_FIELD_NUMBER: _ClassVar[int]
        flake_rate_threshold: float
        flake_threshold: int
        min_window: int
        def __init__(self, min_window: _Optional[int] = ..., flake_threshold: _Optional[int] = ..., flake_rate_threshold: _Optional[float] = ...) -> None: ...
    FAILURE_RATE_FIELD_NUMBER: _ClassVar[int]
    FLAKE_RATE_FIELD_NUMBER: _ClassVar[int]
    failure_rate: TestStabilityCriteria.FailureRateCriteria
    flake_rate: TestStabilityCriteria.FlakeRateCriteria
    def __init__(self, failure_rate: _Optional[_Union[TestStabilityCriteria.FailureRateCriteria, _Mapping]] = ..., flake_rate: _Optional[_Union[TestStabilityCriteria.FlakeRateCriteria, _Mapping]] = ...) -> None: ...

class TestVariantFailureRateAnalysis(_message.Message):
    __slots__ = ["interval_stats", "recent_verdicts", "run_flaky_verdict_examples", "test_id", "variant", "variant_hash"]
    class IntervalStats(_message.Message):
        __slots__ = ["interval_age", "total_run_expected_verdicts", "total_run_flaky_verdicts", "total_run_unexpected_verdicts"]
        INTERVAL_AGE_FIELD_NUMBER: _ClassVar[int]
        TOTAL_RUN_EXPECTED_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        TOTAL_RUN_FLAKY_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        TOTAL_RUN_UNEXPECTED_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        interval_age: int
        total_run_expected_verdicts: int
        total_run_flaky_verdicts: int
        total_run_unexpected_verdicts: int
        def __init__(self, interval_age: _Optional[int] = ..., total_run_expected_verdicts: _Optional[int] = ..., total_run_flaky_verdicts: _Optional[int] = ..., total_run_unexpected_verdicts: _Optional[int] = ...) -> None: ...
    class RecentVerdict(_message.Message):
        __slots__ = ["changelists", "has_unexpected_runs", "ingested_invocation_id", "partition_time"]
        CHANGELISTS_FIELD_NUMBER: _ClassVar[int]
        HAS_UNEXPECTED_RUNS_FIELD_NUMBER: _ClassVar[int]
        INGESTED_INVOCATION_ID_FIELD_NUMBER: _ClassVar[int]
        PARTITION_TIME_FIELD_NUMBER: _ClassVar[int]
        changelists: _containers.RepeatedCompositeFieldContainer[_sources_pb2.Changelist]
        has_unexpected_runs: bool
        ingested_invocation_id: str
        partition_time: _timestamp_pb2.Timestamp
        def __init__(self, partition_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., ingested_invocation_id: _Optional[str] = ..., changelists: _Optional[_Iterable[_Union[_sources_pb2.Changelist, _Mapping]]] = ..., has_unexpected_runs: bool = ...) -> None: ...
    class VerdictExample(_message.Message):
        __slots__ = ["changelists", "ingested_invocation_id", "partition_time"]
        CHANGELISTS_FIELD_NUMBER: _ClassVar[int]
        INGESTED_INVOCATION_ID_FIELD_NUMBER: _ClassVar[int]
        PARTITION_TIME_FIELD_NUMBER: _ClassVar[int]
        changelists: _containers.RepeatedCompositeFieldContainer[_sources_pb2.Changelist]
        ingested_invocation_id: str
        partition_time: _timestamp_pb2.Timestamp
        def __init__(self, partition_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., ingested_invocation_id: _Optional[str] = ..., changelists: _Optional[_Iterable[_Union[_sources_pb2.Changelist, _Mapping]]] = ...) -> None: ...
    INTERVAL_STATS_FIELD_NUMBER: _ClassVar[int]
    RECENT_VERDICTS_FIELD_NUMBER: _ClassVar[int]
    RUN_FLAKY_VERDICT_EXAMPLES_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    interval_stats: _containers.RepeatedCompositeFieldContainer[TestVariantFailureRateAnalysis.IntervalStats]
    recent_verdicts: _containers.RepeatedCompositeFieldContainer[TestVariantFailureRateAnalysis.RecentVerdict]
    run_flaky_verdict_examples: _containers.RepeatedCompositeFieldContainer[TestVariantFailureRateAnalysis.VerdictExample]
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., variant_hash: _Optional[str] = ..., interval_stats: _Optional[_Iterable[_Union[TestVariantFailureRateAnalysis.IntervalStats, _Mapping]]] = ..., run_flaky_verdict_examples: _Optional[_Iterable[_Union[TestVariantFailureRateAnalysis.VerdictExample, _Mapping]]] = ..., recent_verdicts: _Optional[_Iterable[_Union[TestVariantFailureRateAnalysis.RecentVerdict, _Mapping]]] = ...) -> None: ...

class TestVariantIdentifier(_message.Message):
    __slots__ = ["test_id", "variant", "variant_hash"]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., variant_hash: _Optional[str] = ...) -> None: ...

class TestVariantStabilityAnalysis(_message.Message):
    __slots__ = ["failure_rate", "flake_rate", "test_id", "variant", "variant_hash"]
    class FailureRate(_message.Message):
        __slots__ = ["consecutive_unexpected_test_runs", "is_met", "recent_verdicts", "unexpected_test_runs"]
        class RecentVerdict(_message.Message):
            __slots__ = ["changelists", "invocations", "position", "total_runs", "unexpected_runs"]
            CHANGELISTS_FIELD_NUMBER: _ClassVar[int]
            INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
            POSITION_FIELD_NUMBER: _ClassVar[int]
            TOTAL_RUNS_FIELD_NUMBER: _ClassVar[int]
            UNEXPECTED_RUNS_FIELD_NUMBER: _ClassVar[int]
            changelists: _containers.RepeatedCompositeFieldContainer[_sources_pb2.Changelist]
            invocations: _containers.RepeatedScalarFieldContainer[str]
            position: int
            total_runs: int
            unexpected_runs: int
            def __init__(self, position: _Optional[int] = ..., changelists: _Optional[_Iterable[_Union[_sources_pb2.Changelist, _Mapping]]] = ..., invocations: _Optional[_Iterable[str]] = ..., unexpected_runs: _Optional[int] = ..., total_runs: _Optional[int] = ...) -> None: ...
        CONSECUTIVE_UNEXPECTED_TEST_RUNS_FIELD_NUMBER: _ClassVar[int]
        IS_MET_FIELD_NUMBER: _ClassVar[int]
        RECENT_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_TEST_RUNS_FIELD_NUMBER: _ClassVar[int]
        consecutive_unexpected_test_runs: int
        is_met: bool
        recent_verdicts: _containers.RepeatedCompositeFieldContainer[TestVariantStabilityAnalysis.FailureRate.RecentVerdict]
        unexpected_test_runs: int
        def __init__(self, is_met: bool = ..., unexpected_test_runs: _Optional[int] = ..., consecutive_unexpected_test_runs: _Optional[int] = ..., recent_verdicts: _Optional[_Iterable[_Union[TestVariantStabilityAnalysis.FailureRate.RecentVerdict, _Mapping]]] = ...) -> None: ...
    class FlakeRate(_message.Message):
        __slots__ = ["end_position", "flake_examples", "is_met", "run_flaky_verdicts", "start_position", "total_verdicts"]
        class VerdictExample(_message.Message):
            __slots__ = ["changelists", "invocations", "position"]
            CHANGELISTS_FIELD_NUMBER: _ClassVar[int]
            INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
            POSITION_FIELD_NUMBER: _ClassVar[int]
            changelists: _containers.RepeatedCompositeFieldContainer[_sources_pb2.Changelist]
            invocations: _containers.RepeatedScalarFieldContainer[str]
            position: int
            def __init__(self, position: _Optional[int] = ..., changelists: _Optional[_Iterable[_Union[_sources_pb2.Changelist, _Mapping]]] = ..., invocations: _Optional[_Iterable[str]] = ...) -> None: ...
        END_POSITION_FIELD_NUMBER: _ClassVar[int]
        FLAKE_EXAMPLES_FIELD_NUMBER: _ClassVar[int]
        IS_MET_FIELD_NUMBER: _ClassVar[int]
        RUN_FLAKY_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        START_POSITION_FIELD_NUMBER: _ClassVar[int]
        TOTAL_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        end_position: int
        flake_examples: _containers.RepeatedCompositeFieldContainer[TestVariantStabilityAnalysis.FlakeRate.VerdictExample]
        is_met: bool
        run_flaky_verdicts: int
        start_position: int
        total_verdicts: int
        def __init__(self, is_met: bool = ..., run_flaky_verdicts: _Optional[int] = ..., total_verdicts: _Optional[int] = ..., flake_examples: _Optional[_Iterable[_Union[TestVariantStabilityAnalysis.FlakeRate.VerdictExample, _Mapping]]] = ..., start_position: _Optional[int] = ..., end_position: _Optional[int] = ...) -> None: ...
    FAILURE_RATE_FIELD_NUMBER: _ClassVar[int]
    FLAKE_RATE_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    failure_rate: TestVariantStabilityAnalysis.FailureRate
    flake_rate: TestVariantStabilityAnalysis.FlakeRate
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., variant_hash: _Optional[str] = ..., failure_rate: _Optional[_Union[TestVariantStabilityAnalysis.FailureRate, _Mapping]] = ..., flake_rate: _Optional[_Union[TestVariantStabilityAnalysis.FlakeRate, _Mapping]] = ...) -> None: ...
