from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import struct_pb2 as _struct_pb2
from PB.google.rpc import status as _status_pb2
from PB.go.chromium.org.luci.buildbucket.proto import common as _common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import launcher as _launcher_pb2
from PB.go.chromium.org.luci.buildbucket.proto import task as _task_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CancelTasksRequest(_message.Message):
    __slots__ = ["task_ids"]
    TASK_IDS_FIELD_NUMBER: _ClassVar[int]
    task_ids: _containers.RepeatedCompositeFieldContainer[_task_pb2.TaskID]
    def __init__(self, task_ids: _Optional[_Iterable[_Union[_task_pb2.TaskID, _Mapping]]] = ...) -> None: ...

class CancelTasksResponse(_message.Message):
    __slots__ = ["tasks"]
    TASKS_FIELD_NUMBER: _ClassVar[int]
    tasks: _containers.RepeatedCompositeFieldContainer[_task_pb2.Task]
    def __init__(self, tasks: _Optional[_Iterable[_Union[_task_pb2.Task, _Mapping]]] = ...) -> None: ...

class FetchTasksRequest(_message.Message):
    __slots__ = ["task_ids"]
    TASK_IDS_FIELD_NUMBER: _ClassVar[int]
    task_ids: _containers.RepeatedCompositeFieldContainer[_task_pb2.TaskID]
    def __init__(self, task_ids: _Optional[_Iterable[_Union[_task_pb2.TaskID, _Mapping]]] = ...) -> None: ...

class FetchTasksResponse(_message.Message):
    __slots__ = ["responses"]
    class Response(_message.Message):
        __slots__ = ["error", "task"]
        ERROR_FIELD_NUMBER: _ClassVar[int]
        TASK_FIELD_NUMBER: _ClassVar[int]
        error: _status_pb2.Status
        task: _task_pb2.Task
        def __init__(self, task: _Optional[_Union[_task_pb2.Task, _Mapping]] = ..., error: _Optional[_Union[_status_pb2.Status, _Mapping]] = ...) -> None: ...
    RESPONSES_FIELD_NUMBER: _ClassVar[int]
    responses: _containers.RepeatedCompositeFieldContainer[FetchTasksResponse.Response]
    def __init__(self, responses: _Optional[_Iterable[_Union[FetchTasksResponse.Response, _Mapping]]] = ...) -> None: ...

class RunTaskRequest(_message.Message):
    __slots__ = ["agent", "agent_args", "backend_config", "build_id", "buildbucket_host", "caches", "dimensions", "execution_timeout", "experiments", "grace_period", "pubsub_topic", "realm", "register_backend_task_token", "request_id", "secrets", "start_deadline", "target"]
    class AgentExecutable(_message.Message):
        __slots__ = ["source"]
        class AgentSource(_message.Message):
            __slots__ = ["sha256", "size_bytes", "url"]
            SHA256_FIELD_NUMBER: _ClassVar[int]
            SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
            URL_FIELD_NUMBER: _ClassVar[int]
            sha256: str
            size_bytes: int
            url: str
            def __init__(self, sha256: _Optional[str] = ..., size_bytes: _Optional[int] = ..., url: _Optional[str] = ...) -> None: ...
        class SourceEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: RunTaskRequest.AgentExecutable.AgentSource
            def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[RunTaskRequest.AgentExecutable.AgentSource, _Mapping]] = ...) -> None: ...
        SOURCE_FIELD_NUMBER: _ClassVar[int]
        source: _containers.MessageMap[str, RunTaskRequest.AgentExecutable.AgentSource]
        def __init__(self, source: _Optional[_Mapping[str, RunTaskRequest.AgentExecutable.AgentSource]] = ...) -> None: ...
    AGENT_ARGS_FIELD_NUMBER: _ClassVar[int]
    AGENT_FIELD_NUMBER: _ClassVar[int]
    BACKEND_CONFIG_FIELD_NUMBER: _ClassVar[int]
    BUILDBUCKET_HOST_FIELD_NUMBER: _ClassVar[int]
    BUILD_ID_FIELD_NUMBER: _ClassVar[int]
    CACHES_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    GRACE_PERIOD_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_TOPIC_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    REGISTER_BACKEND_TASK_TOKEN_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SECRETS_FIELD_NUMBER: _ClassVar[int]
    START_DEADLINE_FIELD_NUMBER: _ClassVar[int]
    TARGET_FIELD_NUMBER: _ClassVar[int]
    agent: RunTaskRequest.AgentExecutable
    agent_args: _containers.RepeatedScalarFieldContainer[str]
    backend_config: _struct_pb2.Struct
    build_id: str
    buildbucket_host: str
    caches: _containers.RepeatedCompositeFieldContainer[_common_pb2.CacheEntry]
    dimensions: _containers.RepeatedCompositeFieldContainer[_common_pb2.RequestedDimension]
    execution_timeout: _duration_pb2.Duration
    experiments: _containers.RepeatedScalarFieldContainer[str]
    grace_period: _duration_pb2.Duration
    pubsub_topic: str
    realm: str
    register_backend_task_token: str
    request_id: str
    secrets: _launcher_pb2.BuildSecrets
    start_deadline: _timestamp_pb2.Timestamp
    target: str
    def __init__(self, target: _Optional[str] = ..., register_backend_task_token: _Optional[str] = ..., realm: _Optional[str] = ..., agent: _Optional[_Union[RunTaskRequest.AgentExecutable, _Mapping]] = ..., agent_args: _Optional[_Iterable[str]] = ..., secrets: _Optional[_Union[_launcher_pb2.BuildSecrets, _Mapping]] = ..., buildbucket_host: _Optional[str] = ..., build_id: _Optional[str] = ..., dimensions: _Optional[_Iterable[_Union[_common_pb2.RequestedDimension, _Mapping]]] = ..., start_deadline: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., execution_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., grace_period: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., caches: _Optional[_Iterable[_Union[_common_pb2.CacheEntry, _Mapping]]] = ..., backend_config: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., experiments: _Optional[_Iterable[str]] = ..., request_id: _Optional[str] = ..., pubsub_topic: _Optional[str] = ...) -> None: ...

class RunTaskResponse(_message.Message):
    __slots__ = ["task"]
    TASK_FIELD_NUMBER: _ClassVar[int]
    task: _task_pb2.Task
    def __init__(self, task: _Optional[_Union[_task_pb2.Task, _Mapping]] = ...) -> None: ...

class ValidateConfigsRequest(_message.Message):
    __slots__ = ["configs"]
    class ConfigContext(_message.Message):
        __slots__ = ["config_json", "target"]
        CONFIG_JSON_FIELD_NUMBER: _ClassVar[int]
        TARGET_FIELD_NUMBER: _ClassVar[int]
        config_json: _struct_pb2.Struct
        target: str
        def __init__(self, target: _Optional[str] = ..., config_json: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ...) -> None: ...
    CONFIGS_FIELD_NUMBER: _ClassVar[int]
    configs: _containers.RepeatedCompositeFieldContainer[ValidateConfigsRequest.ConfigContext]
    def __init__(self, configs: _Optional[_Iterable[_Union[ValidateConfigsRequest.ConfigContext, _Mapping]]] = ...) -> None: ...

class ValidateConfigsResponse(_message.Message):
    __slots__ = ["config_errors"]
    class ErrorDetail(_message.Message):
        __slots__ = ["error", "index"]
        ERROR_FIELD_NUMBER: _ClassVar[int]
        INDEX_FIELD_NUMBER: _ClassVar[int]
        error: str
        index: int
        def __init__(self, index: _Optional[int] = ..., error: _Optional[str] = ...) -> None: ...
    CONFIG_ERRORS_FIELD_NUMBER: _ClassVar[int]
    config_errors: _containers.RepeatedCompositeFieldContainer[ValidateConfigsResponse.ErrorDetail]
    def __init__(self, config_errors: _Optional[_Iterable[_Union[ValidateConfigsResponse.ErrorDetail, _Mapping]]] = ...) -> None: ...
