from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf import struct_pb2 as _struct_pb2
from PB.go.chromium.org.luci.buildbucket.proto import build_field_visibility as _build_field_visibility_pb2
from PB.go.chromium.org.luci.buildbucket.proto import builder_common as _builder_common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import common as _common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import field_option as _field_option_pb2
from PB.go.chromium.org.luci.buildbucket.proto import step as _step_pb2
from PB.go.chromium.org.luci.buildbucket.proto import task as _task_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import invocation as _invocation_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Build(_message.Message):
    __slots__ = ["ancestor_ids", "builder", "builder_info", "can_outlive_parent", "canary", "cancel_time", "canceled_by", "cancellation_markdown", "create_time", "created_by", "critical", "end_time", "exe", "execution_timeout", "grace_period", "id", "infra", "input", "number", "output", "retriable", "scheduling_timeout", "start_time", "status", "status_details", "steps", "summary_markdown", "tags", "update_time", "wait_for_capacity"]
    class BuilderInfo(_message.Message):
        __slots__ = ["description"]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        description: str
        def __init__(self, description: _Optional[str] = ...) -> None: ...
    class Input(_message.Message):
        __slots__ = ["experimental", "experiments", "gerrit_changes", "gitiles_commit", "properties"]
        EXPERIMENTAL_FIELD_NUMBER: _ClassVar[int]
        EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
        GERRIT_CHANGES_FIELD_NUMBER: _ClassVar[int]
        GITILES_COMMIT_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        experimental: bool
        experiments: _containers.RepeatedScalarFieldContainer[str]
        gerrit_changes: _containers.RepeatedCompositeFieldContainer[_common_pb2.GerritChange]
        gitiles_commit: _common_pb2.GitilesCommit
        properties: _struct_pb2.Struct
        def __init__(self, properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., gitiles_commit: _Optional[_Union[_common_pb2.GitilesCommit, _Mapping]] = ..., gerrit_changes: _Optional[_Iterable[_Union[_common_pb2.GerritChange, _Mapping]]] = ..., experimental: bool = ..., experiments: _Optional[_Iterable[str]] = ...) -> None: ...
    class Output(_message.Message):
        __slots__ = ["gitiles_commit", "logs", "properties", "status", "status_details", "summary_html", "summary_markdown"]
        GITILES_COMMIT_FIELD_NUMBER: _ClassVar[int]
        LOGS_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        STATUS_DETAILS_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        SUMMARY_HTML_FIELD_NUMBER: _ClassVar[int]
        SUMMARY_MARKDOWN_FIELD_NUMBER: _ClassVar[int]
        gitiles_commit: _common_pb2.GitilesCommit
        logs: _containers.RepeatedCompositeFieldContainer[_common_pb2.Log]
        properties: _struct_pb2.Struct
        status: _common_pb2.Status
        status_details: _common_pb2.StatusDetails
        summary_html: str
        summary_markdown: str
        def __init__(self, properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., gitiles_commit: _Optional[_Union[_common_pb2.GitilesCommit, _Mapping]] = ..., logs: _Optional[_Iterable[_Union[_common_pb2.Log, _Mapping]]] = ..., status: _Optional[_Union[_common_pb2.Status, str]] = ..., status_details: _Optional[_Union[_common_pb2.StatusDetails, _Mapping]] = ..., summary_html: _Optional[str] = ..., summary_markdown: _Optional[str] = ...) -> None: ...
    ANCESTOR_IDS_FIELD_NUMBER: _ClassVar[int]
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    BUILDER_INFO_FIELD_NUMBER: _ClassVar[int]
    CANARY_FIELD_NUMBER: _ClassVar[int]
    CANCELED_BY_FIELD_NUMBER: _ClassVar[int]
    CANCELLATION_MARKDOWN_FIELD_NUMBER: _ClassVar[int]
    CANCEL_TIME_FIELD_NUMBER: _ClassVar[int]
    CAN_OUTLIVE_PARENT_FIELD_NUMBER: _ClassVar[int]
    CREATED_BY_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    CRITICAL_FIELD_NUMBER: _ClassVar[int]
    END_TIME_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    EXE_FIELD_NUMBER: _ClassVar[int]
    GRACE_PERIOD_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    INFRA_FIELD_NUMBER: _ClassVar[int]
    INPUT_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_FIELD_NUMBER: _ClassVar[int]
    RETRIABLE_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    STATUS_DETAILS_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STEPS_FIELD_NUMBER: _ClassVar[int]
    SUMMARY_MARKDOWN_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TIME_FIELD_NUMBER: _ClassVar[int]
    WAIT_FOR_CAPACITY_FIELD_NUMBER: _ClassVar[int]
    ancestor_ids: _containers.RepeatedScalarFieldContainer[int]
    builder: _builder_common_pb2.BuilderID
    builder_info: Build.BuilderInfo
    can_outlive_parent: bool
    canary: bool
    cancel_time: _timestamp_pb2.Timestamp
    canceled_by: str
    cancellation_markdown: str
    create_time: _timestamp_pb2.Timestamp
    created_by: str
    critical: _common_pb2.Trinary
    end_time: _timestamp_pb2.Timestamp
    exe: _common_pb2.Executable
    execution_timeout: _duration_pb2.Duration
    grace_period: _duration_pb2.Duration
    id: int
    infra: BuildInfra
    input: Build.Input
    number: int
    output: Build.Output
    retriable: _common_pb2.Trinary
    scheduling_timeout: _duration_pb2.Duration
    start_time: _timestamp_pb2.Timestamp
    status: _common_pb2.Status
    status_details: _common_pb2.StatusDetails
    steps: _containers.RepeatedCompositeFieldContainer[_step_pb2.Step]
    summary_markdown: str
    tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    update_time: _timestamp_pb2.Timestamp
    wait_for_capacity: bool
    def __init__(self, id: _Optional[int] = ..., builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., builder_info: _Optional[_Union[Build.BuilderInfo, _Mapping]] = ..., number: _Optional[int] = ..., created_by: _Optional[str] = ..., canceled_by: _Optional[str] = ..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., update_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., cancel_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., status: _Optional[_Union[_common_pb2.Status, str]] = ..., summary_markdown: _Optional[str] = ..., cancellation_markdown: _Optional[str] = ..., critical: _Optional[_Union[_common_pb2.Trinary, str]] = ..., status_details: _Optional[_Union[_common_pb2.StatusDetails, _Mapping]] = ..., input: _Optional[_Union[Build.Input, _Mapping]] = ..., output: _Optional[_Union[Build.Output, _Mapping]] = ..., steps: _Optional[_Iterable[_Union[_step_pb2.Step, _Mapping]]] = ..., infra: _Optional[_Union[BuildInfra, _Mapping]] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., exe: _Optional[_Union[_common_pb2.Executable, _Mapping]] = ..., canary: bool = ..., scheduling_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., execution_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., grace_period: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., wait_for_capacity: bool = ..., can_outlive_parent: bool = ..., ancestor_ids: _Optional[_Iterable[int]] = ..., retriable: _Optional[_Union[_common_pb2.Trinary, str]] = ...) -> None: ...

class BuildInfra(_message.Message):
    __slots__ = ["backend", "bbagent", "buildbucket", "led", "logdog", "recipe", "resultdb", "swarming"]
    class BBAgent(_message.Message):
        __slots__ = ["cache_dir", "input", "known_public_gerrit_hosts", "payload_path"]
        class Input(_message.Message):
            __slots__ = ["cipd_packages"]
            class CIPDPackage(_message.Message):
                __slots__ = ["name", "path", "server", "version"]
                NAME_FIELD_NUMBER: _ClassVar[int]
                PATH_FIELD_NUMBER: _ClassVar[int]
                SERVER_FIELD_NUMBER: _ClassVar[int]
                VERSION_FIELD_NUMBER: _ClassVar[int]
                name: str
                path: str
                server: str
                version: str
                def __init__(self, name: _Optional[str] = ..., version: _Optional[str] = ..., server: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...
            CIPD_PACKAGES_FIELD_NUMBER: _ClassVar[int]
            cipd_packages: _containers.RepeatedCompositeFieldContainer[BuildInfra.BBAgent.Input.CIPDPackage]
            def __init__(self, cipd_packages: _Optional[_Iterable[_Union[BuildInfra.BBAgent.Input.CIPDPackage, _Mapping]]] = ...) -> None: ...
        CACHE_DIR_FIELD_NUMBER: _ClassVar[int]
        INPUT_FIELD_NUMBER: _ClassVar[int]
        KNOWN_PUBLIC_GERRIT_HOSTS_FIELD_NUMBER: _ClassVar[int]
        PAYLOAD_PATH_FIELD_NUMBER: _ClassVar[int]
        cache_dir: str
        input: BuildInfra.BBAgent.Input
        known_public_gerrit_hosts: _containers.RepeatedScalarFieldContainer[str]
        payload_path: str
        def __init__(self, payload_path: _Optional[str] = ..., cache_dir: _Optional[str] = ..., known_public_gerrit_hosts: _Optional[_Iterable[str]] = ..., input: _Optional[_Union[BuildInfra.BBAgent.Input, _Mapping]] = ...) -> None: ...
    class Backend(_message.Message):
        __slots__ = ["caches", "config", "hostname", "task", "task_dimensions"]
        CACHES_FIELD_NUMBER: _ClassVar[int]
        CONFIG_FIELD_NUMBER: _ClassVar[int]
        HOSTNAME_FIELD_NUMBER: _ClassVar[int]
        TASK_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
        TASK_FIELD_NUMBER: _ClassVar[int]
        caches: _containers.RepeatedCompositeFieldContainer[_common_pb2.CacheEntry]
        config: _struct_pb2.Struct
        hostname: str
        task: _task_pb2.Task
        task_dimensions: _containers.RepeatedCompositeFieldContainer[_common_pb2.RequestedDimension]
        def __init__(self, config: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., task: _Optional[_Union[_task_pb2.Task, _Mapping]] = ..., caches: _Optional[_Iterable[_Union[_common_pb2.CacheEntry, _Mapping]]] = ..., task_dimensions: _Optional[_Iterable[_Union[_common_pb2.RequestedDimension, _Mapping]]] = ..., hostname: _Optional[str] = ...) -> None: ...
    class Buildbucket(_message.Message):
        __slots__ = ["agent", "agent_executable", "build_number", "experiment_reasons", "hostname", "known_public_gerrit_hosts", "requested_dimensions", "requested_properties", "service_config_revision"]
        class ExperimentReason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = []
        class Agent(_message.Message):
            __slots__ = ["cipd_client_cache", "cipd_packages_cache", "input", "output", "purposes", "source"]
            class Purpose(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
                __slots__ = []
            class Input(_message.Message):
                __slots__ = ["cipd_source", "data"]
                class CipdSourceEntry(_message.Message):
                    __slots__ = ["key", "value"]
                    KEY_FIELD_NUMBER: _ClassVar[int]
                    VALUE_FIELD_NUMBER: _ClassVar[int]
                    key: str
                    value: InputDataRef
                    def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InputDataRef, _Mapping]] = ...) -> None: ...
                class DataEntry(_message.Message):
                    __slots__ = ["key", "value"]
                    KEY_FIELD_NUMBER: _ClassVar[int]
                    VALUE_FIELD_NUMBER: _ClassVar[int]
                    key: str
                    value: InputDataRef
                    def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[InputDataRef, _Mapping]] = ...) -> None: ...
                CIPD_SOURCE_FIELD_NUMBER: _ClassVar[int]
                DATA_FIELD_NUMBER: _ClassVar[int]
                cipd_source: _containers.MessageMap[str, InputDataRef]
                data: _containers.MessageMap[str, InputDataRef]
                def __init__(self, data: _Optional[_Mapping[str, InputDataRef]] = ..., cipd_source: _Optional[_Mapping[str, InputDataRef]] = ...) -> None: ...
            class Output(_message.Message):
                __slots__ = ["agent_platform", "resolved_data", "status", "status_details", "summary_html", "summary_markdown", "total_duration"]
                class ResolvedDataEntry(_message.Message):
                    __slots__ = ["key", "value"]
                    KEY_FIELD_NUMBER: _ClassVar[int]
                    VALUE_FIELD_NUMBER: _ClassVar[int]
                    key: str
                    value: ResolvedDataRef
                    def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ResolvedDataRef, _Mapping]] = ...) -> None: ...
                AGENT_PLATFORM_FIELD_NUMBER: _ClassVar[int]
                RESOLVED_DATA_FIELD_NUMBER: _ClassVar[int]
                STATUS_DETAILS_FIELD_NUMBER: _ClassVar[int]
                STATUS_FIELD_NUMBER: _ClassVar[int]
                SUMMARY_HTML_FIELD_NUMBER: _ClassVar[int]
                SUMMARY_MARKDOWN_FIELD_NUMBER: _ClassVar[int]
                TOTAL_DURATION_FIELD_NUMBER: _ClassVar[int]
                agent_platform: str
                resolved_data: _containers.MessageMap[str, ResolvedDataRef]
                status: _common_pb2.Status
                status_details: _common_pb2.StatusDetails
                summary_html: str
                summary_markdown: str
                total_duration: _duration_pb2.Duration
                def __init__(self, resolved_data: _Optional[_Mapping[str, ResolvedDataRef]] = ..., status: _Optional[_Union[_common_pb2.Status, str]] = ..., status_details: _Optional[_Union[_common_pb2.StatusDetails, _Mapping]] = ..., summary_html: _Optional[str] = ..., agent_platform: _Optional[str] = ..., total_duration: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., summary_markdown: _Optional[str] = ...) -> None: ...
            class PurposesEntry(_message.Message):
                __slots__ = ["key", "value"]
                KEY_FIELD_NUMBER: _ClassVar[int]
                VALUE_FIELD_NUMBER: _ClassVar[int]
                key: str
                value: BuildInfra.Buildbucket.Agent.Purpose
                def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[BuildInfra.Buildbucket.Agent.Purpose, str]] = ...) -> None: ...
            class Source(_message.Message):
                __slots__ = ["cipd"]
                class CIPD(_message.Message):
                    __slots__ = ["package", "resolved_instances", "server", "version"]
                    class ResolvedInstancesEntry(_message.Message):
                        __slots__ = ["key", "value"]
                        KEY_FIELD_NUMBER: _ClassVar[int]
                        VALUE_FIELD_NUMBER: _ClassVar[int]
                        key: str
                        value: str
                        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
                    PACKAGE_FIELD_NUMBER: _ClassVar[int]
                    RESOLVED_INSTANCES_FIELD_NUMBER: _ClassVar[int]
                    SERVER_FIELD_NUMBER: _ClassVar[int]
                    VERSION_FIELD_NUMBER: _ClassVar[int]
                    package: str
                    resolved_instances: _containers.ScalarMap[str, str]
                    server: str
                    version: str
                    def __init__(self, package: _Optional[str] = ..., version: _Optional[str] = ..., server: _Optional[str] = ..., resolved_instances: _Optional[_Mapping[str, str]] = ...) -> None: ...
                CIPD_FIELD_NUMBER: _ClassVar[int]
                cipd: BuildInfra.Buildbucket.Agent.Source.CIPD
                def __init__(self, cipd: _Optional[_Union[BuildInfra.Buildbucket.Agent.Source.CIPD, _Mapping]] = ...) -> None: ...
            CIPD_CLIENT_CACHE_FIELD_NUMBER: _ClassVar[int]
            CIPD_PACKAGES_CACHE_FIELD_NUMBER: _ClassVar[int]
            INPUT_FIELD_NUMBER: _ClassVar[int]
            OUTPUT_FIELD_NUMBER: _ClassVar[int]
            PURPOSES_FIELD_NUMBER: _ClassVar[int]
            PURPOSE_BBAGENT_UTILITY: BuildInfra.Buildbucket.Agent.Purpose
            PURPOSE_EXE_PAYLOAD: BuildInfra.Buildbucket.Agent.Purpose
            PURPOSE_UNSPECIFIED: BuildInfra.Buildbucket.Agent.Purpose
            SOURCE_FIELD_NUMBER: _ClassVar[int]
            cipd_client_cache: _common_pb2.CacheEntry
            cipd_packages_cache: _common_pb2.CacheEntry
            input: BuildInfra.Buildbucket.Agent.Input
            output: BuildInfra.Buildbucket.Agent.Output
            purposes: _containers.ScalarMap[str, BuildInfra.Buildbucket.Agent.Purpose]
            source: BuildInfra.Buildbucket.Agent.Source
            def __init__(self, input: _Optional[_Union[BuildInfra.Buildbucket.Agent.Input, _Mapping]] = ..., output: _Optional[_Union[BuildInfra.Buildbucket.Agent.Output, _Mapping]] = ..., source: _Optional[_Union[BuildInfra.Buildbucket.Agent.Source, _Mapping]] = ..., purposes: _Optional[_Mapping[str, BuildInfra.Buildbucket.Agent.Purpose]] = ..., cipd_client_cache: _Optional[_Union[_common_pb2.CacheEntry, _Mapping]] = ..., cipd_packages_cache: _Optional[_Union[_common_pb2.CacheEntry, _Mapping]] = ...) -> None: ...
        class AgentExecutableEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: ResolvedDataRef
            def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ResolvedDataRef, _Mapping]] = ...) -> None: ...
        class ExperimentReasonsEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: BuildInfra.Buildbucket.ExperimentReason
            def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[BuildInfra.Buildbucket.ExperimentReason, str]] = ...) -> None: ...
        AGENT_EXECUTABLE_FIELD_NUMBER: _ClassVar[int]
        AGENT_FIELD_NUMBER: _ClassVar[int]
        BUILD_NUMBER_FIELD_NUMBER: _ClassVar[int]
        EXPERIMENT_REASONS_FIELD_NUMBER: _ClassVar[int]
        EXPERIMENT_REASON_BUILDER_CONFIG: BuildInfra.Buildbucket.ExperimentReason
        EXPERIMENT_REASON_GLOBAL_DEFAULT: BuildInfra.Buildbucket.ExperimentReason
        EXPERIMENT_REASON_GLOBAL_INACTIVE: BuildInfra.Buildbucket.ExperimentReason
        EXPERIMENT_REASON_GLOBAL_MINIMUM: BuildInfra.Buildbucket.ExperimentReason
        EXPERIMENT_REASON_REQUESTED: BuildInfra.Buildbucket.ExperimentReason
        EXPERIMENT_REASON_UNSET: BuildInfra.Buildbucket.ExperimentReason
        HOSTNAME_FIELD_NUMBER: _ClassVar[int]
        KNOWN_PUBLIC_GERRIT_HOSTS_FIELD_NUMBER: _ClassVar[int]
        REQUESTED_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
        REQUESTED_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        SERVICE_CONFIG_REVISION_FIELD_NUMBER: _ClassVar[int]
        agent: BuildInfra.Buildbucket.Agent
        agent_executable: _containers.MessageMap[str, ResolvedDataRef]
        build_number: bool
        experiment_reasons: _containers.ScalarMap[str, BuildInfra.Buildbucket.ExperimentReason]
        hostname: str
        known_public_gerrit_hosts: _containers.RepeatedScalarFieldContainer[str]
        requested_dimensions: _containers.RepeatedCompositeFieldContainer[_common_pb2.RequestedDimension]
        requested_properties: _struct_pb2.Struct
        service_config_revision: str
        def __init__(self, service_config_revision: _Optional[str] = ..., requested_properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., requested_dimensions: _Optional[_Iterable[_Union[_common_pb2.RequestedDimension, _Mapping]]] = ..., hostname: _Optional[str] = ..., experiment_reasons: _Optional[_Mapping[str, BuildInfra.Buildbucket.ExperimentReason]] = ..., agent_executable: _Optional[_Mapping[str, ResolvedDataRef]] = ..., agent: _Optional[_Union[BuildInfra.Buildbucket.Agent, _Mapping]] = ..., known_public_gerrit_hosts: _Optional[_Iterable[str]] = ..., build_number: bool = ...) -> None: ...
    class Led(_message.Message):
        __slots__ = ["shadowed_bucket"]
        SHADOWED_BUCKET_FIELD_NUMBER: _ClassVar[int]
        shadowed_bucket: str
        def __init__(self, shadowed_bucket: _Optional[str] = ...) -> None: ...
    class LogDog(_message.Message):
        __slots__ = ["hostname", "prefix", "project"]
        HOSTNAME_FIELD_NUMBER: _ClassVar[int]
        PREFIX_FIELD_NUMBER: _ClassVar[int]
        PROJECT_FIELD_NUMBER: _ClassVar[int]
        hostname: str
        prefix: str
        project: str
        def __init__(self, hostname: _Optional[str] = ..., project: _Optional[str] = ..., prefix: _Optional[str] = ...) -> None: ...
    class Recipe(_message.Message):
        __slots__ = ["cipd_package", "name"]
        CIPD_PACKAGE_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        cipd_package: str
        name: str
        def __init__(self, cipd_package: _Optional[str] = ..., name: _Optional[str] = ...) -> None: ...
    class ResultDB(_message.Message):
        __slots__ = ["bq_exports", "enable", "history_options", "hostname", "invocation"]
        BQ_EXPORTS_FIELD_NUMBER: _ClassVar[int]
        ENABLE_FIELD_NUMBER: _ClassVar[int]
        HISTORY_OPTIONS_FIELD_NUMBER: _ClassVar[int]
        HOSTNAME_FIELD_NUMBER: _ClassVar[int]
        INVOCATION_FIELD_NUMBER: _ClassVar[int]
        bq_exports: _containers.RepeatedCompositeFieldContainer[_invocation_pb2.BigQueryExport]
        enable: bool
        history_options: _invocation_pb2.HistoryOptions
        hostname: str
        invocation: str
        def __init__(self, hostname: _Optional[str] = ..., invocation: _Optional[str] = ..., enable: bool = ..., bq_exports: _Optional[_Iterable[_Union[_invocation_pb2.BigQueryExport, _Mapping]]] = ..., history_options: _Optional[_Union[_invocation_pb2.HistoryOptions, _Mapping]] = ...) -> None: ...
    class Swarming(_message.Message):
        __slots__ = ["bot_dimensions", "caches", "hostname", "parent_run_id", "priority", "task_dimensions", "task_id", "task_service_account"]
        class CacheEntry(_message.Message):
            __slots__ = ["env_var", "name", "path", "wait_for_warm_cache"]
            ENV_VAR_FIELD_NUMBER: _ClassVar[int]
            NAME_FIELD_NUMBER: _ClassVar[int]
            PATH_FIELD_NUMBER: _ClassVar[int]
            WAIT_FOR_WARM_CACHE_FIELD_NUMBER: _ClassVar[int]
            env_var: str
            name: str
            path: str
            wait_for_warm_cache: _duration_pb2.Duration
            def __init__(self, name: _Optional[str] = ..., path: _Optional[str] = ..., wait_for_warm_cache: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., env_var: _Optional[str] = ...) -> None: ...
        BOT_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
        CACHES_FIELD_NUMBER: _ClassVar[int]
        HOSTNAME_FIELD_NUMBER: _ClassVar[int]
        PARENT_RUN_ID_FIELD_NUMBER: _ClassVar[int]
        PRIORITY_FIELD_NUMBER: _ClassVar[int]
        TASK_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
        TASK_ID_FIELD_NUMBER: _ClassVar[int]
        TASK_SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
        bot_dimensions: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
        caches: _containers.RepeatedCompositeFieldContainer[BuildInfra.Swarming.CacheEntry]
        hostname: str
        parent_run_id: str
        priority: int
        task_dimensions: _containers.RepeatedCompositeFieldContainer[_common_pb2.RequestedDimension]
        task_id: str
        task_service_account: str
        def __init__(self, hostname: _Optional[str] = ..., task_id: _Optional[str] = ..., parent_run_id: _Optional[str] = ..., task_service_account: _Optional[str] = ..., priority: _Optional[int] = ..., task_dimensions: _Optional[_Iterable[_Union[_common_pb2.RequestedDimension, _Mapping]]] = ..., bot_dimensions: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., caches: _Optional[_Iterable[_Union[BuildInfra.Swarming.CacheEntry, _Mapping]]] = ...) -> None: ...
    BACKEND_FIELD_NUMBER: _ClassVar[int]
    BBAGENT_FIELD_NUMBER: _ClassVar[int]
    BUILDBUCKET_FIELD_NUMBER: _ClassVar[int]
    LED_FIELD_NUMBER: _ClassVar[int]
    LOGDOG_FIELD_NUMBER: _ClassVar[int]
    RECIPE_FIELD_NUMBER: _ClassVar[int]
    RESULTDB_FIELD_NUMBER: _ClassVar[int]
    SWARMING_FIELD_NUMBER: _ClassVar[int]
    backend: BuildInfra.Backend
    bbagent: BuildInfra.BBAgent
    buildbucket: BuildInfra.Buildbucket
    led: BuildInfra.Led
    logdog: BuildInfra.LogDog
    recipe: BuildInfra.Recipe
    resultdb: BuildInfra.ResultDB
    swarming: BuildInfra.Swarming
    def __init__(self, buildbucket: _Optional[_Union[BuildInfra.Buildbucket, _Mapping]] = ..., swarming: _Optional[_Union[BuildInfra.Swarming, _Mapping]] = ..., logdog: _Optional[_Union[BuildInfra.LogDog, _Mapping]] = ..., recipe: _Optional[_Union[BuildInfra.Recipe, _Mapping]] = ..., resultdb: _Optional[_Union[BuildInfra.ResultDB, _Mapping]] = ..., bbagent: _Optional[_Union[BuildInfra.BBAgent, _Mapping]] = ..., backend: _Optional[_Union[BuildInfra.Backend, _Mapping]] = ..., led: _Optional[_Union[BuildInfra.Led, _Mapping]] = ...) -> None: ...

class InputDataRef(_message.Message):
    __slots__ = ["cas", "cipd", "on_path"]
    class CAS(_message.Message):
        __slots__ = ["cas_instance", "digest"]
        class Digest(_message.Message):
            __slots__ = ["hash", "size_bytes"]
            HASH_FIELD_NUMBER: _ClassVar[int]
            SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
            hash: str
            size_bytes: int
            def __init__(self, hash: _Optional[str] = ..., size_bytes: _Optional[int] = ...) -> None: ...
        CAS_INSTANCE_FIELD_NUMBER: _ClassVar[int]
        DIGEST_FIELD_NUMBER: _ClassVar[int]
        cas_instance: str
        digest: InputDataRef.CAS.Digest
        def __init__(self, cas_instance: _Optional[str] = ..., digest: _Optional[_Union[InputDataRef.CAS.Digest, _Mapping]] = ...) -> None: ...
    class CIPD(_message.Message):
        __slots__ = ["server", "specs"]
        class PkgSpec(_message.Message):
            __slots__ = ["package", "version"]
            PACKAGE_FIELD_NUMBER: _ClassVar[int]
            VERSION_FIELD_NUMBER: _ClassVar[int]
            package: str
            version: str
            def __init__(self, package: _Optional[str] = ..., version: _Optional[str] = ...) -> None: ...
        SERVER_FIELD_NUMBER: _ClassVar[int]
        SPECS_FIELD_NUMBER: _ClassVar[int]
        server: str
        specs: _containers.RepeatedCompositeFieldContainer[InputDataRef.CIPD.PkgSpec]
        def __init__(self, server: _Optional[str] = ..., specs: _Optional[_Iterable[_Union[InputDataRef.CIPD.PkgSpec, _Mapping]]] = ...) -> None: ...
    CAS_FIELD_NUMBER: _ClassVar[int]
    CIPD_FIELD_NUMBER: _ClassVar[int]
    ON_PATH_FIELD_NUMBER: _ClassVar[int]
    cas: InputDataRef.CAS
    cipd: InputDataRef.CIPD
    on_path: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, cas: _Optional[_Union[InputDataRef.CAS, _Mapping]] = ..., cipd: _Optional[_Union[InputDataRef.CIPD, _Mapping]] = ..., on_path: _Optional[_Iterable[str]] = ...) -> None: ...

class ResolvedDataRef(_message.Message):
    __slots__ = ["cas", "cipd"]
    class CAS(_message.Message):
        __slots__ = ["timing"]
        TIMING_FIELD_NUMBER: _ClassVar[int]
        timing: ResolvedDataRef.Timing
        def __init__(self, timing: _Optional[_Union[ResolvedDataRef.Timing, _Mapping]] = ...) -> None: ...
    class CIPD(_message.Message):
        __slots__ = ["specs"]
        class PkgSpec(_message.Message):
            __slots__ = ["package", "skipped", "timing", "version", "was_cached"]
            PACKAGE_FIELD_NUMBER: _ClassVar[int]
            SKIPPED_FIELD_NUMBER: _ClassVar[int]
            TIMING_FIELD_NUMBER: _ClassVar[int]
            VERSION_FIELD_NUMBER: _ClassVar[int]
            WAS_CACHED_FIELD_NUMBER: _ClassVar[int]
            package: str
            skipped: bool
            timing: ResolvedDataRef.Timing
            version: str
            was_cached: _common_pb2.Trinary
            def __init__(self, skipped: bool = ..., package: _Optional[str] = ..., version: _Optional[str] = ..., was_cached: _Optional[_Union[_common_pb2.Trinary, str]] = ..., timing: _Optional[_Union[ResolvedDataRef.Timing, _Mapping]] = ...) -> None: ...
        SPECS_FIELD_NUMBER: _ClassVar[int]
        specs: _containers.RepeatedCompositeFieldContainer[ResolvedDataRef.CIPD.PkgSpec]
        def __init__(self, specs: _Optional[_Iterable[_Union[ResolvedDataRef.CIPD.PkgSpec, _Mapping]]] = ...) -> None: ...
    class Timing(_message.Message):
        __slots__ = ["fetch_duration", "install_duration"]
        FETCH_DURATION_FIELD_NUMBER: _ClassVar[int]
        INSTALL_DURATION_FIELD_NUMBER: _ClassVar[int]
        fetch_duration: _duration_pb2.Duration
        install_duration: _duration_pb2.Duration
        def __init__(self, fetch_duration: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., install_duration: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...
    CAS_FIELD_NUMBER: _ClassVar[int]
    CIPD_FIELD_NUMBER: _ClassVar[int]
    cas: ResolvedDataRef.CAS
    cipd: ResolvedDataRef.CIPD
    def __init__(self, cas: _Optional[_Union[ResolvedDataRef.CAS, _Mapping]] = ..., cipd: _Optional[_Union[ResolvedDataRef.CIPD, _Mapping]] = ...) -> None: ...
