from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from PB.google.rpc import status as _status_pb2
from PB.go.chromium.org.luci.buildbucket.proto import builder_common as _builder_common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import common as _common_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BuilderMask(_message.Message):
    __slots__ = ["type"]
    class BuilderMaskType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    ALL: BuilderMask.BuilderMaskType
    BUILDER_MASK_TYPE_UNSPECIFIED: BuilderMask.BuilderMaskType
    CONFIG_ONLY: BuilderMask.BuilderMaskType
    METADATA_ONLY: BuilderMask.BuilderMaskType
    TYPE_FIELD_NUMBER: _ClassVar[int]
    type: BuilderMask.BuilderMaskType
    def __init__(self, type: _Optional[_Union[BuilderMask.BuilderMaskType, str]] = ...) -> None: ...

class GetBuilderRequest(_message.Message):
    __slots__ = ["id", "mask"]
    ID_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    id: _builder_common_pb2.BuilderID
    mask: BuilderMask
    def __init__(self, id: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., mask: _Optional[_Union[BuilderMask, _Mapping]] = ...) -> None: ...

class ListBuildersRequest(_message.Message):
    __slots__ = ["bucket", "page_size", "page_token", "project"]
    BUCKET_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    bucket: str
    page_size: int
    page_token: str
    project: str
    def __init__(self, project: _Optional[str] = ..., bucket: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class ListBuildersResponse(_message.Message):
    __slots__ = ["builders", "next_page_token"]
    BUILDERS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    builders: _containers.RepeatedCompositeFieldContainer[_builder_common_pb2.BuilderItem]
    next_page_token: str
    def __init__(self, builders: _Optional[_Iterable[_Union[_builder_common_pb2.BuilderItem, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class SetBuilderHealthRequest(_message.Message):
    __slots__ = ["health"]
    class BuilderHealth(_message.Message):
        __slots__ = ["health", "id"]
        HEALTH_FIELD_NUMBER: _ClassVar[int]
        ID_FIELD_NUMBER: _ClassVar[int]
        health: _common_pb2.HealthStatus
        id: _builder_common_pb2.BuilderID
        def __init__(self, id: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., health: _Optional[_Union[_common_pb2.HealthStatus, _Mapping]] = ...) -> None: ...
    HEALTH_FIELD_NUMBER: _ClassVar[int]
    health: _containers.RepeatedCompositeFieldContainer[SetBuilderHealthRequest.BuilderHealth]
    def __init__(self, health: _Optional[_Iterable[_Union[SetBuilderHealthRequest.BuilderHealth, _Mapping]]] = ...) -> None: ...

class SetBuilderHealthResponse(_message.Message):
    __slots__ = ["responses"]
    class Response(_message.Message):
        __slots__ = ["error", "result"]
        ERROR_FIELD_NUMBER: _ClassVar[int]
        RESULT_FIELD_NUMBER: _ClassVar[int]
        error: _status_pb2.Status
        result: _empty_pb2.Empty
        def __init__(self, result: _Optional[_Union[_empty_pb2.Empty, _Mapping]] = ..., error: _Optional[_Union[_status_pb2.Status, _Mapping]] = ...) -> None: ...
    RESPONSES_FIELD_NUMBER: _ClassVar[int]
    responses: _containers.RepeatedCompositeFieldContainer[SetBuilderHealthResponse.Response]
    def __init__(self, responses: _Optional[_Iterable[_Union[SetBuilderHealthResponse.Response, _Mapping]]] = ...) -> None: ...
