from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import field_mask_pb2 as _field_mask_pb2
from google.protobuf import struct_pb2 as _struct_pb2
from PB.google.rpc import status as _status_pb2
from PB.go.chromium.org.luci.buildbucket.proto import build as _build_pb2
from PB.go.chromium.org.luci.buildbucket.proto import builder_common as _builder_common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import common as _common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import notification as _notification_pb2
from PB.go.chromium.org.luci.common.proto.structmask import structmask as _structmask_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BatchRequest(_message.Message):
    __slots__ = ["requests"]
    class Request(_message.Message):
        __slots__ = ["cancel_build", "get_build", "get_build_status", "schedule_build", "search_builds"]
        CANCEL_BUILD_FIELD_NUMBER: _ClassVar[int]
        GET_BUILD_FIELD_NUMBER: _ClassVar[int]
        GET_BUILD_STATUS_FIELD_NUMBER: _ClassVar[int]
        SCHEDULE_BUILD_FIELD_NUMBER: _ClassVar[int]
        SEARCH_BUILDS_FIELD_NUMBER: _ClassVar[int]
        cancel_build: CancelBuildRequest
        get_build: GetBuildRequest
        get_build_status: GetBuildStatusRequest
        schedule_build: ScheduleBuildRequest
        search_builds: SearchBuildsRequest
        def __init__(self, get_build: _Optional[_Union[GetBuildRequest, _Mapping]] = ..., search_builds: _Optional[_Union[SearchBuildsRequest, _Mapping]] = ..., schedule_build: _Optional[_Union[ScheduleBuildRequest, _Mapping]] = ..., cancel_build: _Optional[_Union[CancelBuildRequest, _Mapping]] = ..., get_build_status: _Optional[_Union[GetBuildStatusRequest, _Mapping]] = ...) -> None: ...
    REQUESTS_FIELD_NUMBER: _ClassVar[int]
    requests: _containers.RepeatedCompositeFieldContainer[BatchRequest.Request]
    def __init__(self, requests: _Optional[_Iterable[_Union[BatchRequest.Request, _Mapping]]] = ...) -> None: ...

class BatchResponse(_message.Message):
    __slots__ = ["responses"]
    class Response(_message.Message):
        __slots__ = ["cancel_build", "error", "get_build", "get_build_status", "schedule_build", "search_builds"]
        CANCEL_BUILD_FIELD_NUMBER: _ClassVar[int]
        ERROR_FIELD_NUMBER: _ClassVar[int]
        GET_BUILD_FIELD_NUMBER: _ClassVar[int]
        GET_BUILD_STATUS_FIELD_NUMBER: _ClassVar[int]
        SCHEDULE_BUILD_FIELD_NUMBER: _ClassVar[int]
        SEARCH_BUILDS_FIELD_NUMBER: _ClassVar[int]
        cancel_build: _build_pb2.Build
        error: _status_pb2.Status
        get_build: _build_pb2.Build
        get_build_status: _build_pb2.Build
        schedule_build: _build_pb2.Build
        search_builds: SearchBuildsResponse
        def __init__(self, get_build: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., search_builds: _Optional[_Union[SearchBuildsResponse, _Mapping]] = ..., schedule_build: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., cancel_build: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., get_build_status: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., error: _Optional[_Union[_status_pb2.Status, _Mapping]] = ...) -> None: ...
    RESPONSES_FIELD_NUMBER: _ClassVar[int]
    responses: _containers.RepeatedCompositeFieldContainer[BatchResponse.Response]
    def __init__(self, responses: _Optional[_Iterable[_Union[BatchResponse.Response, _Mapping]]] = ...) -> None: ...

class BuildMask(_message.Message):
    __slots__ = ["all_fields", "fields", "input_properties", "output_properties", "requested_properties", "step_status"]
    ALL_FIELDS_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    INPUT_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REQUESTED_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    STEP_STATUS_FIELD_NUMBER: _ClassVar[int]
    all_fields: bool
    fields: _field_mask_pb2.FieldMask
    input_properties: _containers.RepeatedCompositeFieldContainer[_structmask_pb2.StructMask]
    output_properties: _containers.RepeatedCompositeFieldContainer[_structmask_pb2.StructMask]
    requested_properties: _containers.RepeatedCompositeFieldContainer[_structmask_pb2.StructMask]
    step_status: _containers.RepeatedScalarFieldContainer[_common_pb2.Status]
    def __init__(self, fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., input_properties: _Optional[_Iterable[_Union[_structmask_pb2.StructMask, _Mapping]]] = ..., output_properties: _Optional[_Iterable[_Union[_structmask_pb2.StructMask, _Mapping]]] = ..., requested_properties: _Optional[_Iterable[_Union[_structmask_pb2.StructMask, _Mapping]]] = ..., all_fields: bool = ..., step_status: _Optional[_Iterable[_Union[_common_pb2.Status, str]]] = ...) -> None: ...

class BuildPredicate(_message.Message):
    __slots__ = ["build", "builder", "canary", "child_of", "create_time", "created_by", "descendant_of", "experiments", "gerrit_changes", "include_experimental", "output_gitiles_commit", "status", "tags"]
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    BUILD_FIELD_NUMBER: _ClassVar[int]
    CANARY_FIELD_NUMBER: _ClassVar[int]
    CHILD_OF_FIELD_NUMBER: _ClassVar[int]
    CREATED_BY_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    DESCENDANT_OF_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    GERRIT_CHANGES_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_EXPERIMENTAL_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_GITILES_COMMIT_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    build: BuildRange
    builder: _builder_common_pb2.BuilderID
    canary: _common_pb2.Trinary
    child_of: int
    create_time: _common_pb2.TimeRange
    created_by: str
    descendant_of: int
    experiments: _containers.RepeatedScalarFieldContainer[str]
    gerrit_changes: _containers.RepeatedCompositeFieldContainer[_common_pb2.GerritChange]
    include_experimental: bool
    output_gitiles_commit: _common_pb2.GitilesCommit
    status: _common_pb2.Status
    tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    def __init__(self, builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., status: _Optional[_Union[_common_pb2.Status, str]] = ..., gerrit_changes: _Optional[_Iterable[_Union[_common_pb2.GerritChange, _Mapping]]] = ..., output_gitiles_commit: _Optional[_Union[_common_pb2.GitilesCommit, _Mapping]] = ..., created_by: _Optional[str] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., create_time: _Optional[_Union[_common_pb2.TimeRange, _Mapping]] = ..., include_experimental: bool = ..., build: _Optional[_Union[BuildRange, _Mapping]] = ..., canary: _Optional[_Union[_common_pb2.Trinary, str]] = ..., experiments: _Optional[_Iterable[str]] = ..., descendant_of: _Optional[int] = ..., child_of: _Optional[int] = ...) -> None: ...

class BuildRange(_message.Message):
    __slots__ = ["end_build_id", "start_build_id"]
    END_BUILD_ID_FIELD_NUMBER: _ClassVar[int]
    START_BUILD_ID_FIELD_NUMBER: _ClassVar[int]
    end_build_id: int
    start_build_id: int
    def __init__(self, start_build_id: _Optional[int] = ..., end_build_id: _Optional[int] = ...) -> None: ...

class CancelBuildRequest(_message.Message):
    __slots__ = ["fields", "id", "mask", "summary_markdown"]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    SUMMARY_MARKDOWN_FIELD_NUMBER: _ClassVar[int]
    fields: _field_mask_pb2.FieldMask
    id: int
    mask: BuildMask
    summary_markdown: str
    def __init__(self, id: _Optional[int] = ..., summary_markdown: _Optional[str] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., mask: _Optional[_Union[BuildMask, _Mapping]] = ...) -> None: ...

class CreateBuildRequest(_message.Message):
    __slots__ = ["build", "mask", "request_id"]
    BUILD_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    build: _build_pb2.Build
    mask: BuildMask
    request_id: str
    def __init__(self, build: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., request_id: _Optional[str] = ..., mask: _Optional[_Union[BuildMask, _Mapping]] = ...) -> None: ...

class GetBuildRequest(_message.Message):
    __slots__ = ["build_number", "builder", "fields", "id", "mask"]
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    BUILD_NUMBER_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    build_number: int
    builder: _builder_common_pb2.BuilderID
    fields: _field_mask_pb2.FieldMask
    id: int
    mask: BuildMask
    def __init__(self, id: _Optional[int] = ..., builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., build_number: _Optional[int] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., mask: _Optional[_Union[BuildMask, _Mapping]] = ...) -> None: ...

class GetBuildStatusRequest(_message.Message):
    __slots__ = ["build_number", "builder", "id"]
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    BUILD_NUMBER_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    build_number: int
    builder: _builder_common_pb2.BuilderID
    id: int
    def __init__(self, id: _Optional[int] = ..., builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., build_number: _Optional[int] = ...) -> None: ...

class ScheduleBuildRequest(_message.Message):
    __slots__ = ["builder", "can_outlive_parent", "canary", "critical", "dimensions", "dry_run", "exe", "execution_timeout", "experimental", "experiments", "fields", "gerrit_changes", "gitiles_commit", "grace_period", "mask", "notify", "priority", "properties", "request_id", "retriable", "scheduling_timeout", "shadow_input", "swarming", "tags", "template_build_id"]
    class ExperimentsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: bool
        def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
    class ShadowInput(_message.Message):
        __slots__ = []
        def __init__(self) -> None: ...
    class Swarming(_message.Message):
        __slots__ = ["parent_run_id"]
        PARENT_RUN_ID_FIELD_NUMBER: _ClassVar[int]
        parent_run_id: str
        def __init__(self, parent_run_id: _Optional[str] = ...) -> None: ...
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    CANARY_FIELD_NUMBER: _ClassVar[int]
    CAN_OUTLIVE_PARENT_FIELD_NUMBER: _ClassVar[int]
    CRITICAL_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    DRY_RUN_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    EXE_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTAL_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    GERRIT_CHANGES_FIELD_NUMBER: _ClassVar[int]
    GITILES_COMMIT_FIELD_NUMBER: _ClassVar[int]
    GRACE_PERIOD_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    RETRIABLE_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    SHADOW_INPUT_FIELD_NUMBER: _ClassVar[int]
    SWARMING_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TEMPLATE_BUILD_ID_FIELD_NUMBER: _ClassVar[int]
    builder: _builder_common_pb2.BuilderID
    can_outlive_parent: _common_pb2.Trinary
    canary: _common_pb2.Trinary
    critical: _common_pb2.Trinary
    dimensions: _containers.RepeatedCompositeFieldContainer[_common_pb2.RequestedDimension]
    dry_run: bool
    exe: _common_pb2.Executable
    execution_timeout: _duration_pb2.Duration
    experimental: _common_pb2.Trinary
    experiments: _containers.ScalarMap[str, bool]
    fields: _field_mask_pb2.FieldMask
    gerrit_changes: _containers.RepeatedCompositeFieldContainer[_common_pb2.GerritChange]
    gitiles_commit: _common_pb2.GitilesCommit
    grace_period: _duration_pb2.Duration
    mask: BuildMask
    notify: _notification_pb2.NotificationConfig
    priority: int
    properties: _struct_pb2.Struct
    request_id: str
    retriable: _common_pb2.Trinary
    scheduling_timeout: _duration_pb2.Duration
    shadow_input: ScheduleBuildRequest.ShadowInput
    swarming: ScheduleBuildRequest.Swarming
    tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    template_build_id: int
    def __init__(self, request_id: _Optional[str] = ..., template_build_id: _Optional[int] = ..., builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., canary: _Optional[_Union[_common_pb2.Trinary, str]] = ..., experimental: _Optional[_Union[_common_pb2.Trinary, str]] = ..., experiments: _Optional[_Mapping[str, bool]] = ..., properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., gitiles_commit: _Optional[_Union[_common_pb2.GitilesCommit, _Mapping]] = ..., gerrit_changes: _Optional[_Iterable[_Union[_common_pb2.GerritChange, _Mapping]]] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., dimensions: _Optional[_Iterable[_Union[_common_pb2.RequestedDimension, _Mapping]]] = ..., priority: _Optional[int] = ..., notify: _Optional[_Union[_notification_pb2.NotificationConfig, _Mapping]] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., mask: _Optional[_Union[BuildMask, _Mapping]] = ..., critical: _Optional[_Union[_common_pb2.Trinary, str]] = ..., exe: _Optional[_Union[_common_pb2.Executable, _Mapping]] = ..., swarming: _Optional[_Union[ScheduleBuildRequest.Swarming, _Mapping]] = ..., scheduling_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., execution_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., grace_period: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., dry_run: bool = ..., can_outlive_parent: _Optional[_Union[_common_pb2.Trinary, str]] = ..., retriable: _Optional[_Union[_common_pb2.Trinary, str]] = ..., shadow_input: _Optional[_Union[ScheduleBuildRequest.ShadowInput, _Mapping]] = ...) -> None: ...

class SearchBuildsRequest(_message.Message):
    __slots__ = ["fields", "mask", "page_size", "page_token", "predicate"]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    fields: _field_mask_pb2.FieldMask
    mask: BuildMask
    page_size: int
    page_token: str
    predicate: BuildPredicate
    def __init__(self, predicate: _Optional[_Union[BuildPredicate, _Mapping]] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., mask: _Optional[_Union[BuildMask, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class SearchBuildsResponse(_message.Message):
    __slots__ = ["builds", "next_page_token"]
    BUILDS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    builds: _containers.RepeatedCompositeFieldContainer[_build_pb2.Build]
    next_page_token: str
    def __init__(self, builds: _Optional[_Iterable[_Union[_build_pb2.Build, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class StartBuildRequest(_message.Message):
    __slots__ = ["build_id", "request_id", "task_id"]
    BUILD_ID_FIELD_NUMBER: _ClassVar[int]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    build_id: int
    request_id: str
    task_id: str
    def __init__(self, request_id: _Optional[str] = ..., build_id: _Optional[int] = ..., task_id: _Optional[str] = ...) -> None: ...

class StartBuildResponse(_message.Message):
    __slots__ = ["build", "update_build_token"]
    BUILD_FIELD_NUMBER: _ClassVar[int]
    UPDATE_BUILD_TOKEN_FIELD_NUMBER: _ClassVar[int]
    build: _build_pb2.Build
    update_build_token: str
    def __init__(self, build: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., update_build_token: _Optional[str] = ...) -> None: ...

class SynthesizeBuildRequest(_message.Message):
    __slots__ = ["builder", "experiments", "template_build_id"]
    class ExperimentsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: bool
        def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    TEMPLATE_BUILD_ID_FIELD_NUMBER: _ClassVar[int]
    builder: _builder_common_pb2.BuilderID
    experiments: _containers.ScalarMap[str, bool]
    template_build_id: int
    def __init__(self, template_build_id: _Optional[int] = ..., builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ..., experiments: _Optional[_Mapping[str, bool]] = ...) -> None: ...

class UpdateBuildRequest(_message.Message):
    __slots__ = ["build", "fields", "mask", "update_mask"]
    BUILD_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    MASK_FIELD_NUMBER: _ClassVar[int]
    UPDATE_MASK_FIELD_NUMBER: _ClassVar[int]
    build: _build_pb2.Build
    fields: _field_mask_pb2.FieldMask
    mask: BuildMask
    update_mask: _field_mask_pb2.FieldMask
    def __init__(self, build: _Optional[_Union[_build_pb2.Build, _Mapping]] = ..., update_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ..., mask: _Optional[_Union[BuildMask, _Mapping]] = ...) -> None: ...
