from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

CANCELED: Status
DESCRIPTOR: _descriptor.FileDescriptor
ENDED_MASK: Status
FAILURE: Status
INFRA_FAILURE: Status
NO: Trinary
SCHEDULED: Status
STARTED: Status
STATUS_UNSPECIFIED: Status
SUCCESS: Status
UNSET: Trinary
YES: Trinary
ZLIB: Compression
ZSTD: Compression

class CacheEntry(_message.Message):
    __slots__ = ["env_var", "name", "path", "wait_for_warm_cache"]
    ENV_VAR_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    WAIT_FOR_WARM_CACHE_FIELD_NUMBER: _ClassVar[int]
    env_var: str
    name: str
    path: str
    wait_for_warm_cache: _duration_pb2.Duration
    def __init__(self, name: _Optional[str] = ..., path: _Optional[str] = ..., wait_for_warm_cache: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., env_var: _Optional[str] = ...) -> None: ...

class Executable(_message.Message):
    __slots__ = ["cipd_package", "cipd_version", "cmd", "wrapper"]
    CIPD_PACKAGE_FIELD_NUMBER: _ClassVar[int]
    CIPD_VERSION_FIELD_NUMBER: _ClassVar[int]
    CMD_FIELD_NUMBER: _ClassVar[int]
    WRAPPER_FIELD_NUMBER: _ClassVar[int]
    cipd_package: str
    cipd_version: str
    cmd: _containers.RepeatedScalarFieldContainer[str]
    wrapper: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, cipd_package: _Optional[str] = ..., cipd_version: _Optional[str] = ..., cmd: _Optional[_Iterable[str]] = ..., wrapper: _Optional[_Iterable[str]] = ...) -> None: ...

class GerritChange(_message.Message):
    __slots__ = ["change", "host", "patchset", "project"]
    CHANGE_FIELD_NUMBER: _ClassVar[int]
    HOST_FIELD_NUMBER: _ClassVar[int]
    PATCHSET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    change: int
    host: str
    patchset: int
    project: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., change: _Optional[int] = ..., patchset: _Optional[int] = ...) -> None: ...

class GitilesCommit(_message.Message):
    __slots__ = ["host", "id", "position", "project", "ref"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    POSITION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    host: str
    id: str
    position: int
    project: str
    ref: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., id: _Optional[str] = ..., ref: _Optional[str] = ..., position: _Optional[int] = ...) -> None: ...

class HealthStatus(_message.Message):
    __slots__ = ["contact_team_email", "data_links", "description", "doc_links", "health_metrics", "health_score", "reported_time", "reporter"]
    class DataLinksEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class DocLinksEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class HealthMetricsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: float
        def __init__(self, key: _Optional[str] = ..., value: _Optional[float] = ...) -> None: ...
    CONTACT_TEAM_EMAIL_FIELD_NUMBER: _ClassVar[int]
    DATA_LINKS_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    DOC_LINKS_FIELD_NUMBER: _ClassVar[int]
    HEALTH_METRICS_FIELD_NUMBER: _ClassVar[int]
    HEALTH_SCORE_FIELD_NUMBER: _ClassVar[int]
    REPORTED_TIME_FIELD_NUMBER: _ClassVar[int]
    REPORTER_FIELD_NUMBER: _ClassVar[int]
    contact_team_email: str
    data_links: _containers.ScalarMap[str, str]
    description: str
    doc_links: _containers.ScalarMap[str, str]
    health_metrics: _containers.ScalarMap[str, float]
    health_score: int
    reported_time: _timestamp_pb2.Timestamp
    reporter: str
    def __init__(self, health_score: _Optional[int] = ..., health_metrics: _Optional[_Mapping[str, float]] = ..., description: _Optional[str] = ..., doc_links: _Optional[_Mapping[str, str]] = ..., data_links: _Optional[_Mapping[str, str]] = ..., reporter: _Optional[str] = ..., reported_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., contact_team_email: _Optional[str] = ...) -> None: ...

class Log(_message.Message):
    __slots__ = ["name", "url", "view_url"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    VIEW_URL_FIELD_NUMBER: _ClassVar[int]
    name: str
    url: str
    view_url: str
    def __init__(self, name: _Optional[str] = ..., view_url: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class RequestedDimension(_message.Message):
    __slots__ = ["expiration", "key", "value"]
    EXPIRATION_FIELD_NUMBER: _ClassVar[int]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    expiration: _duration_pb2.Duration
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ..., expiration: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...

class StatusDetails(_message.Message):
    __slots__ = ["resource_exhaustion", "timeout"]
    class ResourceExhaustion(_message.Message):
        __slots__ = []
        def __init__(self) -> None: ...
    class Timeout(_message.Message):
        __slots__ = []
        def __init__(self) -> None: ...
    RESOURCE_EXHAUSTION_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    resource_exhaustion: StatusDetails.ResourceExhaustion
    timeout: StatusDetails.Timeout
    def __init__(self, resource_exhaustion: _Optional[_Union[StatusDetails.ResourceExhaustion, _Mapping]] = ..., timeout: _Optional[_Union[StatusDetails.Timeout, _Mapping]] = ...) -> None: ...

class StringPair(_message.Message):
    __slots__ = ["key", "value"]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class TimeRange(_message.Message):
    __slots__ = ["end_time", "start_time"]
    END_TIME_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    end_time: _timestamp_pb2.Timestamp
    start_time: _timestamp_pb2.Timestamp
    def __init__(self, start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class Trinary(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class Compression(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
