from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import wrappers_pb2 as _wrappers_pb2
from PB.go.chromium.org.luci.buildbucket.proto import common as _common_pb2
from PB.go.chromium.org.luci.common.proto import options as _options_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import invocation as _invocation_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor
NO: Toggle
UNSET: Toggle
YES: Toggle

class Acl(_message.Message):
    __slots__ = ["group", "identity", "role"]
    class Role(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    GROUP_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    READER: Acl.Role
    ROLE_FIELD_NUMBER: _ClassVar[int]
    SCHEDULER: Acl.Role
    WRITER: Acl.Role
    group: str
    identity: str
    role: Acl.Role
    def __init__(self, role: _Optional[_Union[Acl.Role, str]] = ..., group: _Optional[str] = ..., identity: _Optional[str] = ...) -> None: ...

class Bucket(_message.Message):
    __slots__ = ["acls", "constraints", "dynamic_builder_template", "name", "shadow", "swarming"]
    class Constraints(_message.Message):
        __slots__ = ["pools", "service_accounts"]
        POOLS_FIELD_NUMBER: _ClassVar[int]
        SERVICE_ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
        pools: _containers.RepeatedScalarFieldContainer[str]
        service_accounts: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, pools: _Optional[_Iterable[str]] = ..., service_accounts: _Optional[_Iterable[str]] = ...) -> None: ...
    class DynamicBuilderTemplate(_message.Message):
        __slots__ = ["template"]
        TEMPLATE_FIELD_NUMBER: _ClassVar[int]
        template: BuilderConfig
        def __init__(self, template: _Optional[_Union[BuilderConfig, _Mapping]] = ...) -> None: ...
    ACLS_FIELD_NUMBER: _ClassVar[int]
    CONSTRAINTS_FIELD_NUMBER: _ClassVar[int]
    DYNAMIC_BUILDER_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SHADOW_FIELD_NUMBER: _ClassVar[int]
    SWARMING_FIELD_NUMBER: _ClassVar[int]
    acls: _containers.RepeatedCompositeFieldContainer[Acl]
    constraints: Bucket.Constraints
    dynamic_builder_template: Bucket.DynamicBuilderTemplate
    name: str
    shadow: str
    swarming: Swarming
    def __init__(self, name: _Optional[str] = ..., acls: _Optional[_Iterable[_Union[Acl, _Mapping]]] = ..., swarming: _Optional[_Union[Swarming, _Mapping]] = ..., shadow: _Optional[str] = ..., constraints: _Optional[_Union[Bucket.Constraints, _Mapping]] = ..., dynamic_builder_template: _Optional[_Union[Bucket.DynamicBuilderTemplate, _Mapping]] = ...) -> None: ...

class BuildbucketCfg(_message.Message):
    __slots__ = ["buckets", "common_config"]
    class CommonConfig(_message.Message):
        __slots__ = ["builds_notification_topics"]
        BUILDS_NOTIFICATION_TOPICS_FIELD_NUMBER: _ClassVar[int]
        builds_notification_topics: _containers.RepeatedCompositeFieldContainer[BuildbucketCfg.Topic]
        def __init__(self, builds_notification_topics: _Optional[_Iterable[_Union[BuildbucketCfg.Topic, _Mapping]]] = ...) -> None: ...
    class Topic(_message.Message):
        __slots__ = ["compression", "name"]
        COMPRESSION_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        compression: _common_pb2.Compression
        name: str
        def __init__(self, name: _Optional[str] = ..., compression: _Optional[_Union[_common_pb2.Compression, str]] = ...) -> None: ...
    BUCKETS_FIELD_NUMBER: _ClassVar[int]
    COMMON_CONFIG_FIELD_NUMBER: _ClassVar[int]
    buckets: _containers.RepeatedCompositeFieldContainer[Bucket]
    common_config: BuildbucketCfg.CommonConfig
    def __init__(self, buckets: _Optional[_Iterable[_Union[Bucket, _Mapping]]] = ..., common_config: _Optional[_Union[BuildbucketCfg.CommonConfig, _Mapping]] = ...) -> None: ...

class BuilderConfig(_message.Message):
    __slots__ = ["allowed_property_overrides", "auto_builder_dimension", "backend", "backend_alt", "build_numbers", "builder_health_metrics_links", "caches", "category", "contact_team_email", "critical", "description_html", "dimensions", "exe", "execution_timeout_secs", "experimental", "experiments", "expiration_secs", "grace_period", "heartbeat_timeout_secs", "name", "priority", "properties", "recipe", "resultdb", "retriable", "service_account", "shadow_builder_adjustments", "swarming_host", "swarming_tags", "task_template_canary_percentage", "wait_for_capacity"]
    class Backend(_message.Message):
        __slots__ = ["config_json", "target"]
        CONFIG_JSON_FIELD_NUMBER: _ClassVar[int]
        TARGET_FIELD_NUMBER: _ClassVar[int]
        config_json: str
        target: str
        def __init__(self, target: _Optional[str] = ..., config_json: _Optional[str] = ...) -> None: ...
    class BuilderHealthLinks(_message.Message):
        __slots__ = ["data_links", "doc_links"]
        class DataLinksEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: str
            def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
        class DocLinksEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: str
            def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
        DATA_LINKS_FIELD_NUMBER: _ClassVar[int]
        DOC_LINKS_FIELD_NUMBER: _ClassVar[int]
        data_links: _containers.ScalarMap[str, str]
        doc_links: _containers.ScalarMap[str, str]
        def __init__(self, doc_links: _Optional[_Mapping[str, str]] = ..., data_links: _Optional[_Mapping[str, str]] = ...) -> None: ...
    class CacheEntry(_message.Message):
        __slots__ = ["env_var", "name", "path", "wait_for_warm_cache_secs"]
        ENV_VAR_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        WAIT_FOR_WARM_CACHE_SECS_FIELD_NUMBER: _ClassVar[int]
        env_var: str
        name: str
        path: str
        wait_for_warm_cache_secs: int
        def __init__(self, name: _Optional[str] = ..., path: _Optional[str] = ..., wait_for_warm_cache_secs: _Optional[int] = ..., env_var: _Optional[str] = ...) -> None: ...
    class ExperimentsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: int
        def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
    class Recipe(_message.Message):
        __slots__ = ["cipd_package", "cipd_version", "name", "properties", "properties_j"]
        CIPD_PACKAGE_FIELD_NUMBER: _ClassVar[int]
        CIPD_VERSION_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_J_FIELD_NUMBER: _ClassVar[int]
        cipd_package: str
        cipd_version: str
        name: str
        properties: _containers.RepeatedScalarFieldContainer[str]
        properties_j: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, name: _Optional[str] = ..., cipd_package: _Optional[str] = ..., cipd_version: _Optional[str] = ..., properties: _Optional[_Iterable[str]] = ..., properties_j: _Optional[_Iterable[str]] = ...) -> None: ...
    class ResultDB(_message.Message):
        __slots__ = ["bq_exports", "enable", "history_options"]
        BQ_EXPORTS_FIELD_NUMBER: _ClassVar[int]
        ENABLE_FIELD_NUMBER: _ClassVar[int]
        HISTORY_OPTIONS_FIELD_NUMBER: _ClassVar[int]
        bq_exports: _containers.RepeatedCompositeFieldContainer[_invocation_pb2.BigQueryExport]
        enable: bool
        history_options: _invocation_pb2.HistoryOptions
        def __init__(self, enable: bool = ..., bq_exports: _Optional[_Iterable[_Union[_invocation_pb2.BigQueryExport, _Mapping]]] = ..., history_options: _Optional[_Union[_invocation_pb2.HistoryOptions, _Mapping]] = ...) -> None: ...
    class ShadowBuilderAdjustments(_message.Message):
        __slots__ = ["dimensions", "pool", "properties", "service_account"]
        DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
        POOL_FIELD_NUMBER: _ClassVar[int]
        PROPERTIES_FIELD_NUMBER: _ClassVar[int]
        SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
        dimensions: _containers.RepeatedScalarFieldContainer[str]
        pool: str
        properties: str
        service_account: str
        def __init__(self, service_account: _Optional[str] = ..., pool: _Optional[str] = ..., properties: _Optional[str] = ..., dimensions: _Optional[_Iterable[str]] = ...) -> None: ...
    ALLOWED_PROPERTY_OVERRIDES_FIELD_NUMBER: _ClassVar[int]
    AUTO_BUILDER_DIMENSION_FIELD_NUMBER: _ClassVar[int]
    BACKEND_ALT_FIELD_NUMBER: _ClassVar[int]
    BACKEND_FIELD_NUMBER: _ClassVar[int]
    BUILDER_HEALTH_METRICS_LINKS_FIELD_NUMBER: _ClassVar[int]
    BUILD_NUMBERS_FIELD_NUMBER: _ClassVar[int]
    CACHES_FIELD_NUMBER: _ClassVar[int]
    CATEGORY_FIELD_NUMBER: _ClassVar[int]
    CONTACT_TEAM_EMAIL_FIELD_NUMBER: _ClassVar[int]
    CRITICAL_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_HTML_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_TIMEOUT_SECS_FIELD_NUMBER: _ClassVar[int]
    EXE_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTAL_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    EXPIRATION_SECS_FIELD_NUMBER: _ClassVar[int]
    GRACE_PERIOD_FIELD_NUMBER: _ClassVar[int]
    HEARTBEAT_TIMEOUT_SECS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    RECIPE_FIELD_NUMBER: _ClassVar[int]
    RESULTDB_FIELD_NUMBER: _ClassVar[int]
    RETRIABLE_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    SHADOW_BUILDER_ADJUSTMENTS_FIELD_NUMBER: _ClassVar[int]
    SWARMING_HOST_FIELD_NUMBER: _ClassVar[int]
    SWARMING_TAGS_FIELD_NUMBER: _ClassVar[int]
    TASK_TEMPLATE_CANARY_PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
    WAIT_FOR_CAPACITY_FIELD_NUMBER: _ClassVar[int]
    allowed_property_overrides: _containers.RepeatedScalarFieldContainer[str]
    auto_builder_dimension: Toggle
    backend: BuilderConfig.Backend
    backend_alt: BuilderConfig.Backend
    build_numbers: Toggle
    builder_health_metrics_links: BuilderConfig.BuilderHealthLinks
    caches: _containers.RepeatedCompositeFieldContainer[BuilderConfig.CacheEntry]
    category: str
    contact_team_email: str
    critical: _common_pb2.Trinary
    description_html: str
    dimensions: _containers.RepeatedScalarFieldContainer[str]
    exe: _common_pb2.Executable
    execution_timeout_secs: int
    experimental: Toggle
    experiments: _containers.ScalarMap[str, int]
    expiration_secs: int
    grace_period: _duration_pb2.Duration
    heartbeat_timeout_secs: int
    name: str
    priority: int
    properties: str
    recipe: BuilderConfig.Recipe
    resultdb: BuilderConfig.ResultDB
    retriable: _common_pb2.Trinary
    service_account: str
    shadow_builder_adjustments: BuilderConfig.ShadowBuilderAdjustments
    swarming_host: str
    swarming_tags: _containers.RepeatedScalarFieldContainer[str]
    task_template_canary_percentage: _wrappers_pb2.UInt32Value
    wait_for_capacity: _common_pb2.Trinary
    def __init__(self, name: _Optional[str] = ..., backend: _Optional[_Union[BuilderConfig.Backend, _Mapping]] = ..., backend_alt: _Optional[_Union[BuilderConfig.Backend, _Mapping]] = ..., swarming_host: _Optional[str] = ..., category: _Optional[str] = ..., swarming_tags: _Optional[_Iterable[str]] = ..., dimensions: _Optional[_Iterable[str]] = ..., recipe: _Optional[_Union[BuilderConfig.Recipe, _Mapping]] = ..., exe: _Optional[_Union[_common_pb2.Executable, _Mapping]] = ..., properties: _Optional[str] = ..., allowed_property_overrides: _Optional[_Iterable[str]] = ..., priority: _Optional[int] = ..., execution_timeout_secs: _Optional[int] = ..., heartbeat_timeout_secs: _Optional[int] = ..., expiration_secs: _Optional[int] = ..., grace_period: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., wait_for_capacity: _Optional[_Union[_common_pb2.Trinary, str]] = ..., caches: _Optional[_Iterable[_Union[BuilderConfig.CacheEntry, _Mapping]]] = ..., build_numbers: _Optional[_Union[Toggle, str]] = ..., service_account: _Optional[str] = ..., auto_builder_dimension: _Optional[_Union[Toggle, str]] = ..., experimental: _Optional[_Union[Toggle, str]] = ..., task_template_canary_percentage: _Optional[_Union[_wrappers_pb2.UInt32Value, _Mapping]] = ..., experiments: _Optional[_Mapping[str, int]] = ..., critical: _Optional[_Union[_common_pb2.Trinary, str]] = ..., resultdb: _Optional[_Union[BuilderConfig.ResultDB, _Mapping]] = ..., description_html: _Optional[str] = ..., shadow_builder_adjustments: _Optional[_Union[BuilderConfig.ShadowBuilderAdjustments, _Mapping]] = ..., retriable: _Optional[_Union[_common_pb2.Trinary, str]] = ..., builder_health_metrics_links: _Optional[_Union[BuilderConfig.BuilderHealthLinks, _Mapping]] = ..., contact_team_email: _Optional[str] = ...) -> None: ...

class Swarming(_message.Message):
    __slots__ = ["builders", "task_template_canary_percentage"]
    BUILDERS_FIELD_NUMBER: _ClassVar[int]
    TASK_TEMPLATE_CANARY_PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
    builders: _containers.RepeatedCompositeFieldContainer[BuilderConfig]
    task_template_canary_percentage: _wrappers_pb2.UInt32Value
    def __init__(self, builders: _Optional[_Iterable[_Union[BuilderConfig, _Mapping]]] = ..., task_template_canary_percentage: _Optional[_Union[_wrappers_pb2.UInt32Value, _Mapping]] = ...) -> None: ...

class Toggle(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
