from google.protobuf import duration_pb2 as _duration_pb2
from PB.go.chromium.org.luci.buildbucket.proto import project_config as _project_config_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BackendSetting(_message.Message):
    __slots__ = ["build_sync_setting", "full_mode", "hostname", "lite_mode", "pubsub_id", "target", "task_creating_timeout"]
    class BuildSyncSetting(_message.Message):
        __slots__ = ["shards", "sync_interval_seconds"]
        SHARDS_FIELD_NUMBER: _ClassVar[int]
        SYNC_INTERVAL_SECONDS_FIELD_NUMBER: _ClassVar[int]
        shards: int
        sync_interval_seconds: int
        def __init__(self, shards: _Optional[int] = ..., sync_interval_seconds: _Optional[int] = ...) -> None: ...
    class FullMode(_message.Message):
        __slots__ = ["build_sync_setting", "pubsub_id"]
        BUILD_SYNC_SETTING_FIELD_NUMBER: _ClassVar[int]
        PUBSUB_ID_FIELD_NUMBER: _ClassVar[int]
        build_sync_setting: BackendSetting.BuildSyncSetting
        pubsub_id: str
        def __init__(self, pubsub_id: _Optional[str] = ..., build_sync_setting: _Optional[_Union[BackendSetting.BuildSyncSetting, _Mapping]] = ...) -> None: ...
    class LiteMode(_message.Message):
        __slots__ = []
        def __init__(self) -> None: ...
    BUILD_SYNC_SETTING_FIELD_NUMBER: _ClassVar[int]
    FULL_MODE_FIELD_NUMBER: _ClassVar[int]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    LITE_MODE_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_ID_FIELD_NUMBER: _ClassVar[int]
    TARGET_FIELD_NUMBER: _ClassVar[int]
    TASK_CREATING_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    build_sync_setting: BackendSetting.BuildSyncSetting
    full_mode: BackendSetting.FullMode
    hostname: str
    lite_mode: BackendSetting.LiteMode
    pubsub_id: str
    target: str
    task_creating_timeout: _duration_pb2.Duration
    def __init__(self, target: _Optional[str] = ..., hostname: _Optional[str] = ..., pubsub_id: _Optional[str] = ..., build_sync_setting: _Optional[_Union[BackendSetting.BuildSyncSetting, _Mapping]] = ..., full_mode: _Optional[_Union[BackendSetting.FullMode, _Mapping]] = ..., lite_mode: _Optional[_Union[BackendSetting.LiteMode, _Mapping]] = ..., task_creating_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...

class BuilderPredicate(_message.Message):
    __slots__ = ["regex", "regex_exclude"]
    REGEX_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
    REGEX_FIELD_NUMBER: _ClassVar[int]
    regex: _containers.RepeatedScalarFieldContainer[str]
    regex_exclude: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, regex: _Optional[_Iterable[str]] = ..., regex_exclude: _Optional[_Iterable[str]] = ...) -> None: ...

class CipdSettings(_message.Message):
    __slots__ = ["server", "source"]
    class Source(_message.Message):
        __slots__ = ["package_name", "version", "version_canary"]
        PACKAGE_NAME_FIELD_NUMBER: _ClassVar[int]
        VERSION_CANARY_FIELD_NUMBER: _ClassVar[int]
        VERSION_FIELD_NUMBER: _ClassVar[int]
        package_name: str
        version: str
        version_canary: str
        def __init__(self, package_name: _Optional[str] = ..., version: _Optional[str] = ..., version_canary: _Optional[str] = ...) -> None: ...
    SERVER_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    server: str
    source: CipdSettings.Source
    def __init__(self, server: _Optional[str] = ..., source: _Optional[_Union[CipdSettings.Source, _Mapping]] = ...) -> None: ...

class ExperimentSettings(_message.Message):
    __slots__ = ["experiments"]
    class Experiment(_message.Message):
        __slots__ = ["builders", "default_value", "inactive", "minimum_value", "name"]
        BUILDERS_FIELD_NUMBER: _ClassVar[int]
        DEFAULT_VALUE_FIELD_NUMBER: _ClassVar[int]
        INACTIVE_FIELD_NUMBER: _ClassVar[int]
        MINIMUM_VALUE_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        builders: BuilderPredicate
        default_value: int
        inactive: bool
        minimum_value: int
        name: str
        def __init__(self, name: _Optional[str] = ..., default_value: _Optional[int] = ..., minimum_value: _Optional[int] = ..., builders: _Optional[_Union[BuilderPredicate, _Mapping]] = ..., inactive: bool = ...) -> None: ...
    EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    experiments: _containers.RepeatedCompositeFieldContainer[ExperimentSettings.Experiment]
    def __init__(self, experiments: _Optional[_Iterable[_Union[ExperimentSettings.Experiment, _Mapping]]] = ...) -> None: ...

class LogDogSettings(_message.Message):
    __slots__ = ["hostname"]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    hostname: str
    def __init__(self, hostname: _Optional[str] = ...) -> None: ...

class ResultDBSettings(_message.Message):
    __slots__ = ["hostname"]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    hostname: str
    def __init__(self, hostname: _Optional[str] = ...) -> None: ...

class SettingsCfg(_message.Message):
    __slots__ = ["backends", "cipd", "experiment", "known_public_gerrit_hosts", "logdog", "resultdb", "swarming", "swarming_backends"]
    class SwarmingBackendsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    BACKENDS_FIELD_NUMBER: _ClassVar[int]
    CIPD_FIELD_NUMBER: _ClassVar[int]
    EXPERIMENT_FIELD_NUMBER: _ClassVar[int]
    KNOWN_PUBLIC_GERRIT_HOSTS_FIELD_NUMBER: _ClassVar[int]
    LOGDOG_FIELD_NUMBER: _ClassVar[int]
    RESULTDB_FIELD_NUMBER: _ClassVar[int]
    SWARMING_BACKENDS_FIELD_NUMBER: _ClassVar[int]
    SWARMING_FIELD_NUMBER: _ClassVar[int]
    backends: _containers.RepeatedCompositeFieldContainer[BackendSetting]
    cipd: CipdSettings
    experiment: ExperimentSettings
    known_public_gerrit_hosts: _containers.RepeatedScalarFieldContainer[str]
    logdog: LogDogSettings
    resultdb: ResultDBSettings
    swarming: SwarmingSettings
    swarming_backends: _containers.ScalarMap[str, str]
    def __init__(self, swarming: _Optional[_Union[SwarmingSettings, _Mapping]] = ..., logdog: _Optional[_Union[LogDogSettings, _Mapping]] = ..., resultdb: _Optional[_Union[ResultDBSettings, _Mapping]] = ..., experiment: _Optional[_Union[ExperimentSettings, _Mapping]] = ..., cipd: _Optional[_Union[CipdSettings, _Mapping]] = ..., known_public_gerrit_hosts: _Optional[_Iterable[str]] = ..., backends: _Optional[_Iterable[_Union[BackendSetting, _Mapping]]] = ..., swarming_backends: _Optional[_Mapping[str, str]] = ...) -> None: ...

class SwarmingSettings(_message.Message):
    __slots__ = ["alternative_agent_packages", "bbagent_package", "bbagent_utility_packages", "global_caches", "kitchen_package", "milo_hostname", "user_packages"]
    class Package(_message.Message):
        __slots__ = ["builders", "include_on_experiment", "omit_on_experiment", "package_name", "subdir", "version", "version_canary"]
        BUILDERS_FIELD_NUMBER: _ClassVar[int]
        INCLUDE_ON_EXPERIMENT_FIELD_NUMBER: _ClassVar[int]
        OMIT_ON_EXPERIMENT_FIELD_NUMBER: _ClassVar[int]
        PACKAGE_NAME_FIELD_NUMBER: _ClassVar[int]
        SUBDIR_FIELD_NUMBER: _ClassVar[int]
        VERSION_CANARY_FIELD_NUMBER: _ClassVar[int]
        VERSION_FIELD_NUMBER: _ClassVar[int]
        builders: BuilderPredicate
        include_on_experiment: _containers.RepeatedScalarFieldContainer[str]
        omit_on_experiment: _containers.RepeatedScalarFieldContainer[str]
        package_name: str
        subdir: str
        version: str
        version_canary: str
        def __init__(self, package_name: _Optional[str] = ..., version: _Optional[str] = ..., version_canary: _Optional[str] = ..., builders: _Optional[_Union[BuilderPredicate, _Mapping]] = ..., subdir: _Optional[str] = ..., omit_on_experiment: _Optional[_Iterable[str]] = ..., include_on_experiment: _Optional[_Iterable[str]] = ...) -> None: ...
    ALTERNATIVE_AGENT_PACKAGES_FIELD_NUMBER: _ClassVar[int]
    BBAGENT_PACKAGE_FIELD_NUMBER: _ClassVar[int]
    BBAGENT_UTILITY_PACKAGES_FIELD_NUMBER: _ClassVar[int]
    GLOBAL_CACHES_FIELD_NUMBER: _ClassVar[int]
    KITCHEN_PACKAGE_FIELD_NUMBER: _ClassVar[int]
    MILO_HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    USER_PACKAGES_FIELD_NUMBER: _ClassVar[int]
    alternative_agent_packages: _containers.RepeatedCompositeFieldContainer[SwarmingSettings.Package]
    bbagent_package: SwarmingSettings.Package
    bbagent_utility_packages: _containers.RepeatedCompositeFieldContainer[SwarmingSettings.Package]
    global_caches: _containers.RepeatedCompositeFieldContainer[_project_config_pb2.BuilderConfig.CacheEntry]
    kitchen_package: SwarmingSettings.Package
    milo_hostname: str
    user_packages: _containers.RepeatedCompositeFieldContainer[SwarmingSettings.Package]
    def __init__(self, milo_hostname: _Optional[str] = ..., global_caches: _Optional[_Iterable[_Union[_project_config_pb2.BuilderConfig.CacheEntry, _Mapping]]] = ..., user_packages: _Optional[_Iterable[_Union[SwarmingSettings.Package, _Mapping]]] = ..., bbagent_package: _Optional[_Union[SwarmingSettings.Package, _Mapping]] = ..., kitchen_package: _Optional[_Union[SwarmingSettings.Package, _Mapping]] = ..., alternative_agent_packages: _Optional[_Iterable[_Union[SwarmingSettings.Package, _Mapping]]] = ..., bbagent_utility_packages: _Optional[_Iterable[_Union[SwarmingSettings.Package, _Mapping]]] = ...) -> None: ...
