from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class AclCfg(_message.Message):
    __slots__ = ["project_access_group", "project_reimport_group", "project_validation_group", "service_access_group", "service_reimport_group", "service_validation_group"]
    PROJECT_ACCESS_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_REIMPORT_GROUP_FIELD_NUMBER: _ClassVar[int]
    PROJECT_VALIDATION_GROUP_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCESS_GROUP_FIELD_NUMBER: _ClassVar[int]
    SERVICE_REIMPORT_GROUP_FIELD_NUMBER: _ClassVar[int]
    SERVICE_VALIDATION_GROUP_FIELD_NUMBER: _ClassVar[int]
    project_access_group: str
    project_reimport_group: str
    project_validation_group: str
    service_access_group: str
    service_reimport_group: str
    service_validation_group: str
    def __init__(self, project_access_group: _Optional[str] = ..., project_validation_group: _Optional[str] = ..., project_reimport_group: _Optional[str] = ..., service_access_group: _Optional[str] = ..., service_validation_group: _Optional[str] = ..., service_reimport_group: _Optional[str] = ...) -> None: ...

class ConfigPattern(_message.Message):
    __slots__ = ["config_set", "path"]
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    path: str
    def __init__(self, config_set: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class GitilesLocation(_message.Message):
    __slots__ = ["path", "ref", "repo"]
    PATH_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    REPO_FIELD_NUMBER: _ClassVar[int]
    path: str
    ref: str
    repo: str
    def __init__(self, repo: _Optional[str] = ..., ref: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class IdentityConfig(_message.Message):
    __slots__ = ["service_account_email"]
    SERVICE_ACCOUNT_EMAIL_FIELD_NUMBER: _ClassVar[int]
    service_account_email: str
    def __init__(self, service_account_email: _Optional[str] = ...) -> None: ...

class ImportCfg(_message.Message):
    __slots__ = ["gitiles"]
    class Gitiles(_message.Message):
        __slots__ = ["fetch_archive_deadline", "fetch_log_deadline", "project_config_default_path", "project_config_default_ref", "ref_config_default_path"]
        FETCH_ARCHIVE_DEADLINE_FIELD_NUMBER: _ClassVar[int]
        FETCH_LOG_DEADLINE_FIELD_NUMBER: _ClassVar[int]
        PROJECT_CONFIG_DEFAULT_PATH_FIELD_NUMBER: _ClassVar[int]
        PROJECT_CONFIG_DEFAULT_REF_FIELD_NUMBER: _ClassVar[int]
        REF_CONFIG_DEFAULT_PATH_FIELD_NUMBER: _ClassVar[int]
        fetch_archive_deadline: int
        fetch_log_deadline: int
        project_config_default_path: str
        project_config_default_ref: str
        ref_config_default_path: str
        def __init__(self, fetch_log_deadline: _Optional[int] = ..., fetch_archive_deadline: _Optional[int] = ..., project_config_default_ref: _Optional[str] = ..., project_config_default_path: _Optional[str] = ..., ref_config_default_path: _Optional[str] = ...) -> None: ...
    GITILES_FIELD_NUMBER: _ClassVar[int]
    gitiles: ImportCfg.Gitiles
    def __init__(self, gitiles: _Optional[_Union[ImportCfg.Gitiles, _Mapping]] = ...) -> None: ...

class Location(_message.Message):
    __slots__ = ["gitiles_location"]
    GITILES_LOCATION_FIELD_NUMBER: _ClassVar[int]
    gitiles_location: GitilesLocation
    def __init__(self, gitiles_location: _Optional[_Union[GitilesLocation, _Mapping]] = ...) -> None: ...

class Project(_message.Message):
    __slots__ = ["gitiles_location", "id", "identity_config", "owned_by"]
    GITILES_LOCATION_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_CONFIG_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    OWNED_BY_FIELD_NUMBER: _ClassVar[int]
    gitiles_location: GitilesLocation
    id: str
    identity_config: IdentityConfig
    owned_by: str
    def __init__(self, id: _Optional[str] = ..., gitiles_location: _Optional[_Union[GitilesLocation, _Mapping]] = ..., identity_config: _Optional[_Union[IdentityConfig, _Mapping]] = ..., owned_by: _Optional[str] = ...) -> None: ...

class ProjectsCfg(_message.Message):
    __slots__ = ["projects", "teams"]
    PROJECTS_FIELD_NUMBER: _ClassVar[int]
    TEAMS_FIELD_NUMBER: _ClassVar[int]
    projects: _containers.RepeatedCompositeFieldContainer[Project]
    teams: _containers.RepeatedCompositeFieldContainer[Team]
    def __init__(self, projects: _Optional[_Iterable[_Union[Project, _Mapping]]] = ..., teams: _Optional[_Iterable[_Union[Team, _Mapping]]] = ...) -> None: ...

class SchemasCfg(_message.Message):
    __slots__ = ["schemas"]
    class Schema(_message.Message):
        __slots__ = ["name", "url"]
        NAME_FIELD_NUMBER: _ClassVar[int]
        URL_FIELD_NUMBER: _ClassVar[int]
        name: str
        url: str
        def __init__(self, name: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...
    SCHEMAS_FIELD_NUMBER: _ClassVar[int]
    schemas: _containers.RepeatedCompositeFieldContainer[SchemasCfg.Schema]
    def __init__(self, schemas: _Optional[_Iterable[_Union[SchemasCfg.Schema, _Mapping]]] = ...) -> None: ...

class Service(_message.Message):
    __slots__ = ["access", "hostname", "id", "jwt_auth", "metadata_url", "owners"]
    class JWTAuth(_message.Message):
        __slots__ = ["audience"]
        AUDIENCE_FIELD_NUMBER: _ClassVar[int]
        audience: str
        def __init__(self, audience: _Optional[str] = ...) -> None: ...
    ACCESS_FIELD_NUMBER: _ClassVar[int]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    JWT_AUTH_FIELD_NUMBER: _ClassVar[int]
    METADATA_URL_FIELD_NUMBER: _ClassVar[int]
    OWNERS_FIELD_NUMBER: _ClassVar[int]
    access: _containers.RepeatedScalarFieldContainer[str]
    hostname: str
    id: str
    jwt_auth: Service.JWTAuth
    metadata_url: str
    owners: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, id: _Optional[str] = ..., owners: _Optional[_Iterable[str]] = ..., metadata_url: _Optional[str] = ..., hostname: _Optional[str] = ..., access: _Optional[_Iterable[str]] = ..., jwt_auth: _Optional[_Union[Service.JWTAuth, _Mapping]] = ...) -> None: ...

class ServiceDynamicMetadata(_message.Message):
    __slots__ = ["supports_gzip_compression", "validation", "version"]
    SUPPORTS_GZIP_COMPRESSION_FIELD_NUMBER: _ClassVar[int]
    VALIDATION_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    supports_gzip_compression: bool
    validation: Validator
    version: str
    def __init__(self, version: _Optional[str] = ..., validation: _Optional[_Union[Validator, _Mapping]] = ..., supports_gzip_compression: bool = ...) -> None: ...

class ServiceMetadata(_message.Message):
    __slots__ = ["config_patterns"]
    CONFIG_PATTERNS_FIELD_NUMBER: _ClassVar[int]
    config_patterns: _containers.RepeatedCompositeFieldContainer[ConfigPattern]
    def __init__(self, config_patterns: _Optional[_Iterable[_Union[ConfigPattern, _Mapping]]] = ...) -> None: ...

class ServicesCfg(_message.Message):
    __slots__ = ["services"]
    SERVICES_FIELD_NUMBER: _ClassVar[int]
    services: _containers.RepeatedCompositeFieldContainer[Service]
    def __init__(self, services: _Optional[_Iterable[_Union[Service, _Mapping]]] = ...) -> None: ...

class Team(_message.Message):
    __slots__ = ["escalation_contact", "maintenance_contact", "name"]
    ESCALATION_CONTACT_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_CONTACT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    escalation_contact: _containers.RepeatedScalarFieldContainer[str]
    maintenance_contact: _containers.RepeatedScalarFieldContainer[str]
    name: str
    def __init__(self, name: _Optional[str] = ..., maintenance_contact: _Optional[_Iterable[str]] = ..., escalation_contact: _Optional[_Iterable[str]] = ...) -> None: ...

class ValidateConfigsRequest(_message.Message):
    __slots__ = ["config_set", "files"]
    class File(_message.Message):
        __slots__ = ["path", "raw_content", "signed_url"]
        PATH_FIELD_NUMBER: _ClassVar[int]
        RAW_CONTENT_FIELD_NUMBER: _ClassVar[int]
        SIGNED_URL_FIELD_NUMBER: _ClassVar[int]
        path: str
        raw_content: bytes
        signed_url: str
        def __init__(self, path: _Optional[str] = ..., raw_content: _Optional[bytes] = ..., signed_url: _Optional[str] = ...) -> None: ...
    class Files(_message.Message):
        __slots__ = ["files"]
        FILES_FIELD_NUMBER: _ClassVar[int]
        files: _containers.RepeatedCompositeFieldContainer[ValidateConfigsRequest.File]
        def __init__(self, files: _Optional[_Iterable[_Union[ValidateConfigsRequest.File, _Mapping]]] = ...) -> None: ...
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    FILES_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    files: ValidateConfigsRequest.Files
    def __init__(self, config_set: _Optional[str] = ..., files: _Optional[_Union[ValidateConfigsRequest.Files, _Mapping]] = ...) -> None: ...

class ValidationRequestMessage(_message.Message):
    __slots__ = ["config_set", "content", "path"]
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    content: bytes
    path: str
    def __init__(self, config_set: _Optional[str] = ..., path: _Optional[str] = ..., content: _Optional[bytes] = ...) -> None: ...

class ValidationResponseMessage(_message.Message):
    __slots__ = ["messages"]
    class Severity(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class Message(_message.Message):
        __slots__ = ["path", "severity", "text"]
        PATH_FIELD_NUMBER: _ClassVar[int]
        SEVERITY_FIELD_NUMBER: _ClassVar[int]
        TEXT_FIELD_NUMBER: _ClassVar[int]
        path: str
        severity: ValidationResponseMessage.Severity
        text: str
        def __init__(self, path: _Optional[str] = ..., severity: _Optional[_Union[ValidationResponseMessage.Severity, str]] = ..., text: _Optional[str] = ...) -> None: ...
    CRITICAL: ValidationResponseMessage.Severity
    DEBUG: ValidationResponseMessage.Severity
    ERROR: ValidationResponseMessage.Severity
    INFO: ValidationResponseMessage.Severity
    MESSAGES_FIELD_NUMBER: _ClassVar[int]
    UNKNOWN: ValidationResponseMessage.Severity
    WARNING: ValidationResponseMessage.Severity
    messages: _containers.RepeatedCompositeFieldContainer[ValidationResponseMessage.Message]
    def __init__(self, messages: _Optional[_Iterable[_Union[ValidationResponseMessage.Message, _Mapping]]] = ...) -> None: ...

class ValidationResult(_message.Message):
    __slots__ = ["messages"]
    class Severity(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class Message(_message.Message):
        __slots__ = ["path", "severity", "text"]
        PATH_FIELD_NUMBER: _ClassVar[int]
        SEVERITY_FIELD_NUMBER: _ClassVar[int]
        TEXT_FIELD_NUMBER: _ClassVar[int]
        path: str
        severity: ValidationResult.Severity
        text: str
        def __init__(self, path: _Optional[str] = ..., severity: _Optional[_Union[ValidationResult.Severity, str]] = ..., text: _Optional[str] = ...) -> None: ...
    CRITICAL: ValidationResult.Severity
    DEBUG: ValidationResult.Severity
    ERROR: ValidationResult.Severity
    INFO: ValidationResult.Severity
    MESSAGES_FIELD_NUMBER: _ClassVar[int]
    UNKNOWN: ValidationResult.Severity
    WARNING: ValidationResult.Severity
    messages: _containers.RepeatedCompositeFieldContainer[ValidationResult.Message]
    def __init__(self, messages: _Optional[_Iterable[_Union[ValidationResult.Message, _Mapping]]] = ...) -> None: ...

class Validator(_message.Message):
    __slots__ = ["patterns", "url"]
    PATTERNS_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    patterns: _containers.RepeatedCompositeFieldContainer[ConfigPattern]
    url: str
    def __init__(self, patterns: _Optional[_Iterable[_Union[ConfigPattern, _Mapping]]] = ..., url: _Optional[str] = ...) -> None: ...
