from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

ABANDONED: ChangeStatus
ALL_COMMITS: QueryOption
ALL_FILES: QueryOption
ALL_REVISIONS: QueryOption
CHANGE_ACTIONS: QueryOption
CHANGE_STATUS_INVALID: ChangeStatus
CHECK: QueryOption
COMMIT_FOOTERS: QueryOption
CURRENT_ACTIONS: QueryOption
CURRENT_COMMIT: QueryOption
CURRENT_FILES: QueryOption
CURRENT_REVISION: QueryOption
DESCRIPTOR: _descriptor.FileDescriptor
DETAILED_ACCOUNTS: QueryOption
DETAILED_LABELS: QueryOption
DOWNLOAD_COMMANDS: QueryOption
LABELS: QueryOption
MAX_QUERY_OPTION: QueryOption
MERGEABLE_STRATEGY_UNSPECIFIED: MergeableStrategy
MERGED: ChangeStatus
MESSAGES: QueryOption
NEW: ChangeStatus
NOTIFY_ALL: Notify
NOTIFY_NONE: Notify
NOTIFY_OWNER: Notify
NOTIFY_OWNER_REVIEWERS: Notify
NOTIFY_UNSPECIFIED: Notify
OPTION_UNSPECIFIED: QueryOption
OURS: MergeableStrategy
PUSH_CERTIFICATES: QueryOption
RECURSIVE: MergeableStrategy
RESOLVE: MergeableStrategy
REVIEWED: QueryOption
REVIEWER_UPDATES: QueryOption
SIMPLE_TWO_WAY_IN_CORE: MergeableStrategy
SKIP_MERGEABLE: QueryOption
SUBMITTABLE: QueryOption
SUBMIT_REQUIREMENTS: QueryOption
THEIRS: MergeableStrategy
TRACKING_IDS: QueryOption
WEB_LINKS: QueryOption

class AbandonChangeRequest(_message.Message):
    __slots__ = ["message", "number", "project"]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    message: str
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., message: _Optional[str] = ...) -> None: ...

class AccountInfo(_message.Message):
    __slots__ = ["account_id", "email", "name", "secondary_emails", "username"]
    ACCOUNT_ID_FIELD_NUMBER: _ClassVar[int]
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SECONDARY_EMAILS_FIELD_NUMBER: _ClassVar[int]
    USERNAME_FIELD_NUMBER: _ClassVar[int]
    account_id: int
    email: str
    name: str
    secondary_emails: _containers.RepeatedScalarFieldContainer[str]
    username: str
    def __init__(self, name: _Optional[str] = ..., email: _Optional[str] = ..., secondary_emails: _Optional[_Iterable[str]] = ..., username: _Optional[str] = ..., account_id: _Optional[int] = ...) -> None: ...

class AccountOptions(_message.Message):
    __slots__ = ["all_emails", "details"]
    ALL_EMAILS_FIELD_NUMBER: _ClassVar[int]
    DETAILS_FIELD_NUMBER: _ClassVar[int]
    all_emails: bool
    details: bool
    def __init__(self, details: bool = ..., all_emails: bool = ...) -> None: ...

class AddReviewerRequest(_message.Message):
    __slots__ = ["confirmed", "notify", "number", "project", "reviewer", "state"]
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    ADD_REVIEWER_STATE_CC: AddReviewerRequest.State
    ADD_REVIEWER_STATE_REVIEWER: AddReviewerRequest.State
    ADD_REVIEWER_STATE_UNSPECIFIED: AddReviewerRequest.State
    CONFIRMED_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REVIEWER_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    confirmed: bool
    notify: Notify
    number: int
    project: str
    reviewer: str
    state: AddReviewerRequest.State
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., reviewer: _Optional[str] = ..., state: _Optional[_Union[AddReviewerRequest.State, str]] = ..., confirmed: bool = ..., notify: _Optional[_Union[Notify, str]] = ...) -> None: ...

class AddReviewerResult(_message.Message):
    __slots__ = ["ccs", "confirm", "error", "input", "reviewers"]
    CCS_FIELD_NUMBER: _ClassVar[int]
    CONFIRM_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    INPUT_FIELD_NUMBER: _ClassVar[int]
    REVIEWERS_FIELD_NUMBER: _ClassVar[int]
    ccs: _containers.RepeatedCompositeFieldContainer[ReviewerInfo]
    confirm: bool
    error: str
    input: str
    reviewers: _containers.RepeatedCompositeFieldContainer[ReviewerInfo]
    def __init__(self, input: _Optional[str] = ..., reviewers: _Optional[_Iterable[_Union[ReviewerInfo, _Mapping]]] = ..., ccs: _Optional[_Iterable[_Union[ReviewerInfo, _Mapping]]] = ..., error: _Optional[str] = ..., confirm: bool = ...) -> None: ...

class ApprovalInfo(_message.Message):
    __slots__ = ["date", "permitted_voting_range", "post_submit", "tag", "user", "value"]
    DATE_FIELD_NUMBER: _ClassVar[int]
    PERMITTED_VOTING_RANGE_FIELD_NUMBER: _ClassVar[int]
    POST_SUBMIT_FIELD_NUMBER: _ClassVar[int]
    TAG_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    date: _timestamp_pb2.Timestamp
    permitted_voting_range: VotingRangeInfo
    post_submit: bool
    tag: str
    user: AccountInfo
    value: int
    def __init__(self, user: _Optional[_Union[AccountInfo, _Mapping]] = ..., value: _Optional[int] = ..., permitted_voting_range: _Optional[_Union[VotingRangeInfo, _Mapping]] = ..., date: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., tag: _Optional[str] = ..., post_submit: bool = ...) -> None: ...

class AttentionSetInput(_message.Message):
    __slots__ = ["notify", "notify_details", "reason", "user"]
    NOTIFY_DETAILS_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_FIELD_NUMBER: _ClassVar[int]
    REASON_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    notify: Notify
    notify_details: NotifyDetails
    reason: str
    user: str
    def __init__(self, user: _Optional[str] = ..., reason: _Optional[str] = ..., notify: _Optional[_Union[Notify, str]] = ..., notify_details: _Optional[_Union[NotifyDetails, _Mapping]] = ...) -> None: ...

class AttentionSetRequest(_message.Message):
    __slots__ = ["input", "number", "project"]
    INPUT_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    input: AttentionSetInput
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., input: _Optional[_Union[AttentionSetInput, _Mapping]] = ...) -> None: ...

class ChangeEditFileContentRequest(_message.Message):
    __slots__ = ["content", "file_path", "number", "project"]
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    FILE_PATH_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    content: bytes
    file_path: str
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., file_path: _Optional[str] = ..., content: _Optional[bytes] = ...) -> None: ...

class ChangeEditPublishRequest(_message.Message):
    __slots__ = ["number", "project"]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ...) -> None: ...

class ChangeInfo(_message.Message):
    __slots__ = ["branch", "cherry_pick_of_change", "created", "current_revision", "hashtags", "is_private", "labels", "messages", "meta_rev_id", "number", "owner", "project", "ref", "requirements", "revert_of", "reviewers", "revisions", "status", "subject", "submit_requirements", "submittable", "submitted", "updated"]
    class LabelsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: LabelInfo
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[LabelInfo, _Mapping]] = ...) -> None: ...
    class RevisionsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: RevisionInfo
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[RevisionInfo, _Mapping]] = ...) -> None: ...
    BRANCH_FIELD_NUMBER: _ClassVar[int]
    CHERRY_PICK_OF_CHANGE_FIELD_NUMBER: _ClassVar[int]
    CREATED_FIELD_NUMBER: _ClassVar[int]
    CURRENT_REVISION_FIELD_NUMBER: _ClassVar[int]
    HASHTAGS_FIELD_NUMBER: _ClassVar[int]
    IS_PRIVATE_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    MESSAGES_FIELD_NUMBER: _ClassVar[int]
    META_REV_ID_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    OWNER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    REQUIREMENTS_FIELD_NUMBER: _ClassVar[int]
    REVERT_OF_FIELD_NUMBER: _ClassVar[int]
    REVIEWERS_FIELD_NUMBER: _ClassVar[int]
    REVISIONS_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUBJECT_FIELD_NUMBER: _ClassVar[int]
    SUBMITTABLE_FIELD_NUMBER: _ClassVar[int]
    SUBMITTED_FIELD_NUMBER: _ClassVar[int]
    SUBMIT_REQUIREMENTS_FIELD_NUMBER: _ClassVar[int]
    UPDATED_FIELD_NUMBER: _ClassVar[int]
    branch: str
    cherry_pick_of_change: int
    created: _timestamp_pb2.Timestamp
    current_revision: str
    hashtags: _containers.RepeatedScalarFieldContainer[str]
    is_private: bool
    labels: _containers.MessageMap[str, LabelInfo]
    messages: _containers.RepeatedCompositeFieldContainer[ChangeMessageInfo]
    meta_rev_id: str
    number: int
    owner: AccountInfo
    project: str
    ref: str
    requirements: _containers.RepeatedCompositeFieldContainer[Requirement]
    revert_of: int
    reviewers: ReviewerStatusMap
    revisions: _containers.MessageMap[str, RevisionInfo]
    status: ChangeStatus
    subject: str
    submit_requirements: _containers.RepeatedCompositeFieldContainer[SubmitRequirementResultInfo]
    submittable: bool
    submitted: _timestamp_pb2.Timestamp
    updated: _timestamp_pb2.Timestamp
    def __init__(self, number: _Optional[int] = ..., owner: _Optional[_Union[AccountInfo, _Mapping]] = ..., project: _Optional[str] = ..., ref: _Optional[str] = ..., status: _Optional[_Union[ChangeStatus, str]] = ..., current_revision: _Optional[str] = ..., revisions: _Optional[_Mapping[str, RevisionInfo]] = ..., labels: _Optional[_Mapping[str, LabelInfo]] = ..., messages: _Optional[_Iterable[_Union[ChangeMessageInfo, _Mapping]]] = ..., requirements: _Optional[_Iterable[_Union[Requirement, _Mapping]]] = ..., submittable: bool = ..., is_private: bool = ..., hashtags: _Optional[_Iterable[str]] = ..., created: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., updated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., submitted: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., revert_of: _Optional[int] = ..., cherry_pick_of_change: _Optional[int] = ..., reviewers: _Optional[_Union[ReviewerStatusMap, _Mapping]] = ..., meta_rev_id: _Optional[str] = ..., submit_requirements: _Optional[_Iterable[_Union[SubmitRequirementResultInfo, _Mapping]]] = ..., subject: _Optional[str] = ..., branch: _Optional[str] = ...) -> None: ...

class ChangeMessageInfo(_message.Message):
    __slots__ = ["author", "date", "id", "message", "real_author", "tag"]
    AUTHOR_FIELD_NUMBER: _ClassVar[int]
    DATE_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    REAL_AUTHOR_FIELD_NUMBER: _ClassVar[int]
    TAG_FIELD_NUMBER: _ClassVar[int]
    author: AccountInfo
    date: _timestamp_pb2.Timestamp
    id: str
    message: str
    real_author: AccountInfo
    tag: str
    def __init__(self, id: _Optional[str] = ..., author: _Optional[_Union[AccountInfo, _Mapping]] = ..., real_author: _Optional[_Union[AccountInfo, _Mapping]] = ..., date: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., message: _Optional[str] = ..., tag: _Optional[str] = ...) -> None: ...

class CommitInfo(_message.Message):
    __slots__ = ["author", "id", "message", "parents"]
    class Parent(_message.Message):
        __slots__ = ["id"]
        ID_FIELD_NUMBER: _ClassVar[int]
        id: str
        def __init__(self, id: _Optional[str] = ...) -> None: ...
    AUTHOR_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    PARENTS_FIELD_NUMBER: _ClassVar[int]
    author: GitPersonInfo
    id: str
    message: str
    parents: _containers.RepeatedCompositeFieldContainer[CommitInfo.Parent]
    def __init__(self, id: _Optional[str] = ..., parents: _Optional[_Iterable[_Union[CommitInfo.Parent, _Mapping]]] = ..., message: _Optional[str] = ..., author: _Optional[_Union[GitPersonInfo, _Mapping]] = ...) -> None: ...

class CreateChangeRequest(_message.Message):
    __slots__ = ["base_commit", "notify", "project", "ref", "subject"]
    BASE_COMMIT_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    SUBJECT_FIELD_NUMBER: _ClassVar[int]
    base_commit: str
    notify: Notify
    project: str
    ref: str
    subject: str
    def __init__(self, project: _Optional[str] = ..., ref: _Optional[str] = ..., subject: _Optional[str] = ..., base_commit: _Optional[str] = ..., notify: _Optional[_Union[Notify, str]] = ...) -> None: ...

class DeleteEditFileContentRequest(_message.Message):
    __slots__ = ["file_path", "number", "project"]
    FILE_PATH_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    file_path: str
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., file_path: _Optional[str] = ...) -> None: ...

class DeleteReviewerRequest(_message.Message):
    __slots__ = ["account_id", "number", "project"]
    ACCOUNT_ID_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    account_id: str
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., account_id: _Optional[str] = ...) -> None: ...

class FileInfo(_message.Message):
    __slots__ = ["binary", "lines_deleted", "lines_inserted", "old_path", "size", "size_delta", "status"]
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    A: FileInfo.Status
    BINARY_FIELD_NUMBER: _ClassVar[int]
    C: FileInfo.Status
    D: FileInfo.Status
    LINES_DELETED_FIELD_NUMBER: _ClassVar[int]
    LINES_INSERTED_FIELD_NUMBER: _ClassVar[int]
    M: FileInfo.Status
    OLD_PATH_FIELD_NUMBER: _ClassVar[int]
    R: FileInfo.Status
    SIZE_DELTA_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    W: FileInfo.Status
    binary: bool
    lines_deleted: int
    lines_inserted: int
    old_path: str
    size: int
    size_delta: int
    status: FileInfo.Status
    def __init__(self, status: _Optional[_Union[FileInfo.Status, str]] = ..., binary: bool = ..., old_path: _Optional[str] = ..., lines_inserted: _Optional[int] = ..., lines_deleted: _Optional[int] = ..., size_delta: _Optional[int] = ..., size: _Optional[int] = ...) -> None: ...

class GetChangeRequest(_message.Message):
    __slots__ = ["meta", "number", "options", "project"]
    META_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    OPTIONS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    meta: str
    number: int
    options: _containers.RepeatedScalarFieldContainer[QueryOption]
    project: str
    def __init__(self, number: _Optional[int] = ..., options: _Optional[_Iterable[_Union[QueryOption, str]]] = ..., project: _Optional[str] = ..., meta: _Optional[str] = ...) -> None: ...

class GetMergeableRequest(_message.Message):
    __slots__ = ["number", "project", "revision_id", "source", "strategy"]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REVISION_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    STRATEGY_FIELD_NUMBER: _ClassVar[int]
    number: int
    project: str
    revision_id: str
    source: str
    strategy: MergeableStrategy
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., revision_id: _Optional[str] = ..., source: _Optional[str] = ..., strategy: _Optional[_Union[MergeableStrategy, str]] = ...) -> None: ...

class GetMetaDiffRequest(_message.Message):
    __slots__ = ["meta", "number", "old", "options", "project"]
    META_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    OLD_FIELD_NUMBER: _ClassVar[int]
    OPTIONS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    meta: str
    number: int
    old: str
    options: _containers.RepeatedScalarFieldContainer[QueryOption]
    project: str
    def __init__(self, project: _Optional[str] = ..., number: _Optional[int] = ..., old: _Optional[str] = ..., meta: _Optional[str] = ..., options: _Optional[_Iterable[_Union[QueryOption, str]]] = ...) -> None: ...

class GetPureRevertRequest(_message.Message):
    __slots__ = ["number", "project"]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ...) -> None: ...

class GetRelatedChangesRequest(_message.Message):
    __slots__ = ["number", "project", "revision_id"]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REVISION_ID_FIELD_NUMBER: _ClassVar[int]
    number: int
    project: str
    revision_id: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., revision_id: _Optional[str] = ...) -> None: ...

class GetRelatedChangesResponse(_message.Message):
    __slots__ = ["changes"]
    class ChangeAndCommit(_message.Message):
        __slots__ = ["commit", "current_patchset", "number", "patchset", "project", "status"]
        COMMIT_FIELD_NUMBER: _ClassVar[int]
        CURRENT_PATCHSET_FIELD_NUMBER: _ClassVar[int]
        NUMBER_FIELD_NUMBER: _ClassVar[int]
        PATCHSET_FIELD_NUMBER: _ClassVar[int]
        PROJECT_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        commit: CommitInfo
        current_patchset: int
        number: int
        patchset: int
        project: str
        status: ChangeStatus
        def __init__(self, project: _Optional[str] = ..., commit: _Optional[_Union[CommitInfo, _Mapping]] = ..., number: _Optional[int] = ..., patchset: _Optional[int] = ..., current_patchset: _Optional[int] = ..., status: _Optional[_Union[ChangeStatus, str]] = ...) -> None: ...
    CHANGES_FIELD_NUMBER: _ClassVar[int]
    changes: _containers.RepeatedCompositeFieldContainer[GetRelatedChangesResponse.ChangeAndCommit]
    def __init__(self, changes: _Optional[_Iterable[_Union[GetRelatedChangesResponse.ChangeAndCommit, _Mapping]]] = ...) -> None: ...

class GitPersonInfo(_message.Message):
    __slots__ = ["email", "name"]
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    email: str
    name: str
    def __init__(self, name: _Optional[str] = ..., email: _Optional[str] = ...) -> None: ...

class LabelInfo(_message.Message):
    __slots__ = ["all", "approved", "blocking", "default_value", "disliked", "optional", "recommended", "rejected", "value", "values"]
    class ValuesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: int
        value: str
        def __init__(self, key: _Optional[int] = ..., value: _Optional[str] = ...) -> None: ...
    ALL_FIELD_NUMBER: _ClassVar[int]
    APPROVED_FIELD_NUMBER: _ClassVar[int]
    BLOCKING_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_VALUE_FIELD_NUMBER: _ClassVar[int]
    DISLIKED_FIELD_NUMBER: _ClassVar[int]
    OPTIONAL_FIELD_NUMBER: _ClassVar[int]
    RECOMMENDED_FIELD_NUMBER: _ClassVar[int]
    REJECTED_FIELD_NUMBER: _ClassVar[int]
    VALUES_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    all: _containers.RepeatedCompositeFieldContainer[ApprovalInfo]
    approved: AccountInfo
    blocking: bool
    default_value: int
    disliked: AccountInfo
    optional: bool
    recommended: AccountInfo
    rejected: AccountInfo
    value: int
    values: _containers.ScalarMap[int, str]
    def __init__(self, optional: bool = ..., approved: _Optional[_Union[AccountInfo, _Mapping]] = ..., rejected: _Optional[_Union[AccountInfo, _Mapping]] = ..., recommended: _Optional[_Union[AccountInfo, _Mapping]] = ..., disliked: _Optional[_Union[AccountInfo, _Mapping]] = ..., blocking: bool = ..., value: _Optional[int] = ..., default_value: _Optional[int] = ..., all: _Optional[_Iterable[_Union[ApprovalInfo, _Mapping]]] = ..., values: _Optional[_Mapping[int, str]] = ...) -> None: ...

class ListChangesRequest(_message.Message):
    __slots__ = ["limit", "offset", "options", "query"]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    OFFSET_FIELD_NUMBER: _ClassVar[int]
    OPTIONS_FIELD_NUMBER: _ClassVar[int]
    QUERY_FIELD_NUMBER: _ClassVar[int]
    limit: int
    offset: int
    options: _containers.RepeatedScalarFieldContainer[QueryOption]
    query: str
    def __init__(self, query: _Optional[str] = ..., options: _Optional[_Iterable[_Union[QueryOption, str]]] = ..., limit: _Optional[int] = ..., offset: _Optional[int] = ...) -> None: ...

class ListChangesResponse(_message.Message):
    __slots__ = ["changes", "more_changes"]
    CHANGES_FIELD_NUMBER: _ClassVar[int]
    MORE_CHANGES_FIELD_NUMBER: _ClassVar[int]
    changes: _containers.RepeatedCompositeFieldContainer[ChangeInfo]
    more_changes: bool
    def __init__(self, changes: _Optional[_Iterable[_Union[ChangeInfo, _Mapping]]] = ..., more_changes: bool = ...) -> None: ...

class ListFileOwnersRequest(_message.Message):
    __slots__ = ["options", "path", "project", "ref"]
    OPTIONS_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    options: AccountOptions
    path: str
    project: str
    ref: str
    def __init__(self, project: _Optional[str] = ..., ref: _Optional[str] = ..., path: _Optional[str] = ..., options: _Optional[_Union[AccountOptions, _Mapping]] = ...) -> None: ...

class ListFilesRequest(_message.Message):
    __slots__ = ["base", "number", "parent", "project", "revision_id", "substring_query"]
    BASE_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REVISION_ID_FIELD_NUMBER: _ClassVar[int]
    SUBSTRING_QUERY_FIELD_NUMBER: _ClassVar[int]
    base: str
    number: int
    parent: int
    project: str
    revision_id: str
    substring_query: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., revision_id: _Optional[str] = ..., substring_query: _Optional[str] = ..., parent: _Optional[int] = ..., base: _Optional[str] = ...) -> None: ...

class ListFilesResponse(_message.Message):
    __slots__ = ["files"]
    class FilesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: FileInfo
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[FileInfo, _Mapping]] = ...) -> None: ...
    FILES_FIELD_NUMBER: _ClassVar[int]
    files: _containers.MessageMap[str, FileInfo]
    def __init__(self, files: _Optional[_Mapping[str, FileInfo]] = ...) -> None: ...

class ListOwnersResponse(_message.Message):
    __slots__ = ["owners"]
    OWNERS_FIELD_NUMBER: _ClassVar[int]
    owners: _containers.RepeatedCompositeFieldContainer[OwnerInfo]
    def __init__(self, owners: _Optional[_Iterable[_Union[OwnerInfo, _Mapping]]] = ...) -> None: ...

class ListProjectsRequest(_message.Message):
    __slots__ = ["refs"]
    REFS_FIELD_NUMBER: _ClassVar[int]
    refs: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, refs: _Optional[_Iterable[str]] = ...) -> None: ...

class ListProjectsResponse(_message.Message):
    __slots__ = ["Projects"]
    class ProjectsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: ProjectInfo
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ProjectInfo, _Mapping]] = ...) -> None: ...
    PROJECTS_FIELD_NUMBER: _ClassVar[int]
    Projects: _containers.MessageMap[str, ProjectInfo]
    def __init__(self, Projects: _Optional[_Mapping[str, ProjectInfo]] = ...) -> None: ...

class MergeableInfo(_message.Message):
    __slots__ = ["commit_merged", "conflicts", "content_merged", "mergeable", "mergeable_into", "strategy", "submit_type"]
    class SubmitType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    CHERRY_PICK: MergeableInfo.SubmitType
    COMMIT_MERGED_FIELD_NUMBER: _ClassVar[int]
    CONFLICTS_FIELD_NUMBER: _ClassVar[int]
    CONTENT_MERGED_FIELD_NUMBER: _ClassVar[int]
    FAST_FORWARD_ONLY: MergeableInfo.SubmitType
    MERGEABLE_FIELD_NUMBER: _ClassVar[int]
    MERGEABLE_INTO_FIELD_NUMBER: _ClassVar[int]
    MERGE_ALWAYS: MergeableInfo.SubmitType
    MERGE_IF_NECESSARY: MergeableInfo.SubmitType
    REBASE_ALWAYS: MergeableInfo.SubmitType
    REBASE_IF_NECESSARY: MergeableInfo.SubmitType
    STRATEGY_FIELD_NUMBER: _ClassVar[int]
    SUBMIT_TYPE_FIELD_NUMBER: _ClassVar[int]
    SUBMIT_TYPE_UNSPECIFIED: MergeableInfo.SubmitType
    commit_merged: bool
    conflicts: _containers.RepeatedScalarFieldContainer[str]
    content_merged: bool
    mergeable: bool
    mergeable_into: _containers.RepeatedScalarFieldContainer[str]
    strategy: MergeableStrategy
    submit_type: MergeableInfo.SubmitType
    def __init__(self, submit_type: _Optional[_Union[MergeableInfo.SubmitType, str]] = ..., strategy: _Optional[_Union[MergeableStrategy, str]] = ..., mergeable: bool = ..., commit_merged: bool = ..., content_merged: bool = ..., conflicts: _Optional[_Iterable[str]] = ..., mergeable_into: _Optional[_Iterable[str]] = ...) -> None: ...

class MetaDiff(_message.Message):
    __slots__ = ["added", "new_change_info", "old_change_info", "removed"]
    ADDED_FIELD_NUMBER: _ClassVar[int]
    NEW_CHANGE_INFO_FIELD_NUMBER: _ClassVar[int]
    OLD_CHANGE_INFO_FIELD_NUMBER: _ClassVar[int]
    REMOVED_FIELD_NUMBER: _ClassVar[int]
    added: ChangeInfo
    new_change_info: ChangeInfo
    old_change_info: ChangeInfo
    removed: ChangeInfo
    def __init__(self, added: _Optional[_Union[ChangeInfo, _Mapping]] = ..., removed: _Optional[_Union[ChangeInfo, _Mapping]] = ..., old_change_info: _Optional[_Union[ChangeInfo, _Mapping]] = ..., new_change_info: _Optional[_Union[ChangeInfo, _Mapping]] = ...) -> None: ...

class NotifyDetails(_message.Message):
    __slots__ = ["recipients"]
    class RecipientType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class Info(_message.Message):
        __slots__ = ["accounts"]
        ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
        accounts: _containers.RepeatedScalarFieldContainer[int]
        def __init__(self, accounts: _Optional[_Iterable[int]] = ...) -> None: ...
    class Recipient(_message.Message):
        __slots__ = ["info", "recipient_type"]
        INFO_FIELD_NUMBER: _ClassVar[int]
        RECIPIENT_TYPE_FIELD_NUMBER: _ClassVar[int]
        info: NotifyDetails.Info
        recipient_type: NotifyDetails.RecipientType
        def __init__(self, recipient_type: _Optional[_Union[NotifyDetails.RecipientType, str]] = ..., info: _Optional[_Union[NotifyDetails.Info, _Mapping]] = ...) -> None: ...
    RECIPIENTS_FIELD_NUMBER: _ClassVar[int]
    RECIPIENT_TYPE_BCC: NotifyDetails.RecipientType
    RECIPIENT_TYPE_CC: NotifyDetails.RecipientType
    RECIPIENT_TYPE_TO: NotifyDetails.RecipientType
    RECIPIENT_TYPE_UNSPECIFIED: NotifyDetails.RecipientType
    recipients: _containers.RepeatedCompositeFieldContainer[NotifyDetails.Recipient]
    def __init__(self, recipients: _Optional[_Iterable[_Union[NotifyDetails.Recipient, _Mapping]]] = ...) -> None: ...

class OwnerInfo(_message.Message):
    __slots__ = ["account"]
    ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    account: AccountInfo
    def __init__(self, account: _Optional[_Union[AccountInfo, _Mapping]] = ...) -> None: ...

class ProjectInfo(_message.Message):
    __slots__ = ["description", "name", "parent", "refs", "state", "web_links"]
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class RefsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_STATE_ACTIVE: ProjectInfo.State
    PROJECT_STATE_HIDDEN: ProjectInfo.State
    PROJECT_STATE_READ_ONLY: ProjectInfo.State
    PROJECT_STATE_UNSPECIFIED: ProjectInfo.State
    REFS_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    WEB_LINKS_FIELD_NUMBER: _ClassVar[int]
    description: str
    name: str
    parent: str
    refs: _containers.ScalarMap[str, str]
    state: ProjectInfo.State
    web_links: _containers.RepeatedCompositeFieldContainer[WebLinkInfo]
    def __init__(self, name: _Optional[str] = ..., parent: _Optional[str] = ..., description: _Optional[str] = ..., state: _Optional[_Union[ProjectInfo.State, str]] = ..., refs: _Optional[_Mapping[str, str]] = ..., web_links: _Optional[_Iterable[_Union[WebLinkInfo, _Mapping]]] = ...) -> None: ...

class PureRevertInfo(_message.Message):
    __slots__ = ["is_pure_revert"]
    IS_PURE_REVERT_FIELD_NUMBER: _ClassVar[int]
    is_pure_revert: bool
    def __init__(self, is_pure_revert: bool = ...) -> None: ...

class RefInfo(_message.Message):
    __slots__ = ["ref", "revision"]
    REF_FIELD_NUMBER: _ClassVar[int]
    REVISION_FIELD_NUMBER: _ClassVar[int]
    ref: str
    revision: str
    def __init__(self, ref: _Optional[str] = ..., revision: _Optional[str] = ...) -> None: ...

class RefInfoRequest(_message.Message):
    __slots__ = ["project", "ref"]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    project: str
    ref: str
    def __init__(self, project: _Optional[str] = ..., ref: _Optional[str] = ...) -> None: ...

class Requirement(_message.Message):
    __slots__ = ["fallback_text", "status", "type"]
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    FALLBACK_TEXT_FIELD_NUMBER: _ClassVar[int]
    REQUIREMENT_STATUS_NOT_READY: Requirement.Status
    REQUIREMENT_STATUS_OK: Requirement.Status
    REQUIREMENT_STATUS_RULE_ERROR: Requirement.Status
    REQUIREMENT_STATUS_UNSPECIFIED: Requirement.Status
    STATUS_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    fallback_text: str
    status: Requirement.Status
    type: str
    def __init__(self, status: _Optional[_Union[Requirement.Status, str]] = ..., fallback_text: _Optional[str] = ..., type: _Optional[str] = ...) -> None: ...

class RevertChangeRequest(_message.Message):
    __slots__ = ["message", "number", "project"]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    message: str
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., message: _Optional[str] = ...) -> None: ...

class ReviewResult(_message.Message):
    __slots__ = ["labels", "reviewers"]
    class LabelsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: int
        def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
    class ReviewersEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: AddReviewerResult
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[AddReviewerResult, _Mapping]] = ...) -> None: ...
    LABELS_FIELD_NUMBER: _ClassVar[int]
    REVIEWERS_FIELD_NUMBER: _ClassVar[int]
    labels: _containers.ScalarMap[str, int]
    reviewers: _containers.MessageMap[str, AddReviewerResult]
    def __init__(self, labels: _Optional[_Mapping[str, int]] = ..., reviewers: _Optional[_Mapping[str, AddReviewerResult]] = ...) -> None: ...

class ReviewerInfo(_message.Message):
    __slots__ = ["account", "approvals"]
    class ApprovalsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: int
        def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
    ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    APPROVALS_FIELD_NUMBER: _ClassVar[int]
    account: AccountInfo
    approvals: _containers.ScalarMap[str, int]
    def __init__(self, account: _Optional[_Union[AccountInfo, _Mapping]] = ..., approvals: _Optional[_Mapping[str, int]] = ...) -> None: ...

class ReviewerInput(_message.Message):
    __slots__ = ["reviewer", "state"]
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    REVIEWER_FIELD_NUMBER: _ClassVar[int]
    REVIEWER_INPUT_STATE_CC: ReviewerInput.State
    REVIEWER_INPUT_STATE_REVIEWER: ReviewerInput.State
    REVIEWER_INPUT_STATE_UNSPECIFIED: ReviewerInput.State
    STATE_FIELD_NUMBER: _ClassVar[int]
    reviewer: str
    state: ReviewerInput.State
    def __init__(self, reviewer: _Optional[str] = ..., state: _Optional[_Union[ReviewerInput.State, str]] = ...) -> None: ...

class ReviewerStatusMap(_message.Message):
    __slots__ = ["ccs", "removed", "reviewers"]
    CCS_FIELD_NUMBER: _ClassVar[int]
    REMOVED_FIELD_NUMBER: _ClassVar[int]
    REVIEWERS_FIELD_NUMBER: _ClassVar[int]
    ccs: _containers.RepeatedCompositeFieldContainer[AccountInfo]
    removed: _containers.RepeatedCompositeFieldContainer[AccountInfo]
    reviewers: _containers.RepeatedCompositeFieldContainer[AccountInfo]
    def __init__(self, reviewers: _Optional[_Iterable[_Union[AccountInfo, _Mapping]]] = ..., ccs: _Optional[_Iterable[_Union[AccountInfo, _Mapping]]] = ..., removed: _Optional[_Iterable[_Union[AccountInfo, _Mapping]]] = ...) -> None: ...

class RevisionInfo(_message.Message):
    __slots__ = ["commit", "created", "description", "files", "kind", "number", "ref", "uploader"]
    class Kind(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class FilesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: FileInfo
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[FileInfo, _Mapping]] = ...) -> None: ...
    COMMIT_FIELD_NUMBER: _ClassVar[int]
    CREATED_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    FILES_FIELD_NUMBER: _ClassVar[int]
    KIND_FIELD_NUMBER: _ClassVar[int]
    KIND_INVALID: RevisionInfo.Kind
    MERGE_FIRST_PARENT_UPDATE: RevisionInfo.Kind
    NO_CHANGE: RevisionInfo.Kind
    NO_CODE_CHANGE: RevisionInfo.Kind
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    REWORK: RevisionInfo.Kind
    TRIVIAL_REBASE: RevisionInfo.Kind
    UPLOADER_FIELD_NUMBER: _ClassVar[int]
    commit: CommitInfo
    created: _timestamp_pb2.Timestamp
    description: str
    files: _containers.MessageMap[str, FileInfo]
    kind: RevisionInfo.Kind
    number: int
    ref: str
    uploader: AccountInfo
    def __init__(self, kind: _Optional[_Union[RevisionInfo.Kind, str]] = ..., number: _Optional[int] = ..., uploader: _Optional[_Union[AccountInfo, _Mapping]] = ..., ref: _Optional[str] = ..., created: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., description: _Optional[str] = ..., commit: _Optional[_Union[CommitInfo, _Mapping]] = ..., files: _Optional[_Mapping[str, FileInfo]] = ...) -> None: ...

class SetReviewRequest(_message.Message):
    __slots__ = ["add_to_attention_set", "ignore_automatic_attention_set_rules", "labels", "message", "notify", "notify_details", "number", "on_behalf_of", "project", "ready", "remove_from_attention_set", "reviewers", "revision_id", "tag", "work_in_progress"]
    class LabelsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: int
        def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
    ADD_TO_ATTENTION_SET_FIELD_NUMBER: _ClassVar[int]
    IGNORE_AUTOMATIC_ATTENTION_SET_RULES_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_DETAILS_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_FIELD_NUMBER: _ClassVar[int]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    ON_BEHALF_OF_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    READY_FIELD_NUMBER: _ClassVar[int]
    REMOVE_FROM_ATTENTION_SET_FIELD_NUMBER: _ClassVar[int]
    REVIEWERS_FIELD_NUMBER: _ClassVar[int]
    REVISION_ID_FIELD_NUMBER: _ClassVar[int]
    TAG_FIELD_NUMBER: _ClassVar[int]
    WORK_IN_PROGRESS_FIELD_NUMBER: _ClassVar[int]
    add_to_attention_set: _containers.RepeatedCompositeFieldContainer[AttentionSetInput]
    ignore_automatic_attention_set_rules: bool
    labels: _containers.ScalarMap[str, int]
    message: str
    notify: Notify
    notify_details: NotifyDetails
    number: int
    on_behalf_of: int
    project: str
    ready: bool
    remove_from_attention_set: _containers.RepeatedCompositeFieldContainer[AttentionSetInput]
    reviewers: _containers.RepeatedCompositeFieldContainer[ReviewerInput]
    revision_id: str
    tag: str
    work_in_progress: bool
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ..., revision_id: _Optional[str] = ..., message: _Optional[str] = ..., labels: _Optional[_Mapping[str, int]] = ..., tag: _Optional[str] = ..., notify: _Optional[_Union[Notify, str]] = ..., notify_details: _Optional[_Union[NotifyDetails, _Mapping]] = ..., on_behalf_of: _Optional[int] = ..., ready: bool = ..., work_in_progress: bool = ..., add_to_attention_set: _Optional[_Iterable[_Union[AttentionSetInput, _Mapping]]] = ..., remove_from_attention_set: _Optional[_Iterable[_Union[AttentionSetInput, _Mapping]]] = ..., ignore_automatic_attention_set_rules: bool = ..., reviewers: _Optional[_Iterable[_Union[ReviewerInput, _Mapping]]] = ...) -> None: ...

class SubmitChangeRequest(_message.Message):
    __slots__ = ["number", "project"]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    number: int
    project: str
    def __init__(self, number: _Optional[int] = ..., project: _Optional[str] = ...) -> None: ...

class SubmitInfo(_message.Message):
    __slots__ = ["status"]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    status: ChangeStatus
    def __init__(self, status: _Optional[_Union[ChangeStatus, str]] = ...) -> None: ...

class SubmitRequirementExpressionInfo(_message.Message):
    __slots__ = ["error_message", "expression", "failing_atoms", "fulfilled", "passing_atoms"]
    ERROR_MESSAGE_FIELD_NUMBER: _ClassVar[int]
    EXPRESSION_FIELD_NUMBER: _ClassVar[int]
    FAILING_ATOMS_FIELD_NUMBER: _ClassVar[int]
    FULFILLED_FIELD_NUMBER: _ClassVar[int]
    PASSING_ATOMS_FIELD_NUMBER: _ClassVar[int]
    error_message: str
    expression: str
    failing_atoms: _containers.RepeatedScalarFieldContainer[str]
    fulfilled: bool
    passing_atoms: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, expression: _Optional[str] = ..., fulfilled: bool = ..., passing_atoms: _Optional[_Iterable[str]] = ..., failing_atoms: _Optional[_Iterable[str]] = ..., error_message: _Optional[str] = ...) -> None: ...

class SubmitRequirementResultInfo(_message.Message):
    __slots__ = ["applicability_expression_result", "description", "is_legacy", "name", "override_expression_result", "status", "submittability_expression_result"]
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    APPLICABILITY_EXPRESSION_RESULT_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    ERROR: SubmitRequirementResultInfo.Status
    FORCED: SubmitRequirementResultInfo.Status
    IS_LEGACY_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NOT_APPLICABLE: SubmitRequirementResultInfo.Status
    OVERRIDDEN: SubmitRequirementResultInfo.Status
    OVERRIDE_EXPRESSION_RESULT_FIELD_NUMBER: _ClassVar[int]
    SATISFIED: SubmitRequirementResultInfo.Status
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUBMITTABILITY_EXPRESSION_RESULT_FIELD_NUMBER: _ClassVar[int]
    SUBMIT_REQUIREMENT_STATUS_UNSPECIFIED: SubmitRequirementResultInfo.Status
    UNSATISFIED: SubmitRequirementResultInfo.Status
    applicability_expression_result: SubmitRequirementExpressionInfo
    description: str
    is_legacy: bool
    name: str
    override_expression_result: SubmitRequirementExpressionInfo
    status: SubmitRequirementResultInfo.Status
    submittability_expression_result: SubmitRequirementExpressionInfo
    def __init__(self, name: _Optional[str] = ..., description: _Optional[str] = ..., status: _Optional[_Union[SubmitRequirementResultInfo.Status, str]] = ..., is_legacy: bool = ..., applicability_expression_result: _Optional[_Union[SubmitRequirementExpressionInfo, _Mapping]] = ..., submittability_expression_result: _Optional[_Union[SubmitRequirementExpressionInfo, _Mapping]] = ..., override_expression_result: _Optional[_Union[SubmitRequirementExpressionInfo, _Mapping]] = ...) -> None: ...

class SubmitRevisionRequest(_message.Message):
    __slots__ = ["number", "project", "revision_id"]
    NUMBER_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REVISION_ID_FIELD_NUMBER: _ClassVar[int]
    number: int
    project: str
    revision_id: str
    def __init__(self, number: _Optional[int] = ..., revision_id: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...

class VotingRangeInfo(_message.Message):
    __slots__ = ["max", "min"]
    MAX_FIELD_NUMBER: _ClassVar[int]
    MIN_FIELD_NUMBER: _ClassVar[int]
    max: int
    min: int
    def __init__(self, min: _Optional[int] = ..., max: _Optional[int] = ...) -> None: ...

class WebLinkInfo(_message.Message):
    __slots__ = ["image_url", "name", "url"]
    IMAGE_URL_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    image_url: str
    name: str
    url: str
    def __init__(self, name: _Optional[str] = ..., url: _Optional[str] = ..., image_url: _Optional[str] = ...) -> None: ...

class QueryOption(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class Notify(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class ChangeStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class MergeableStrategy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
