from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Commit(_message.Message):
    __slots__ = ["author", "committer", "id", "message", "parents", "tree", "tree_diff"]
    class TreeDiff(_message.Message):
        __slots__ = ["new_id", "new_mode", "new_path", "old_id", "old_mode", "old_path", "type"]
        class ChangeType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = []
        ADD: Commit.TreeDiff.ChangeType
        COPY: Commit.TreeDiff.ChangeType
        DELETE: Commit.TreeDiff.ChangeType
        MODIFY: Commit.TreeDiff.ChangeType
        NEW_ID_FIELD_NUMBER: _ClassVar[int]
        NEW_MODE_FIELD_NUMBER: _ClassVar[int]
        NEW_PATH_FIELD_NUMBER: _ClassVar[int]
        OLD_ID_FIELD_NUMBER: _ClassVar[int]
        OLD_MODE_FIELD_NUMBER: _ClassVar[int]
        OLD_PATH_FIELD_NUMBER: _ClassVar[int]
        RENAME: Commit.TreeDiff.ChangeType
        TYPE_FIELD_NUMBER: _ClassVar[int]
        new_id: str
        new_mode: int
        new_path: str
        old_id: str
        old_mode: int
        old_path: str
        type: Commit.TreeDiff.ChangeType
        def __init__(self, type: _Optional[_Union[Commit.TreeDiff.ChangeType, str]] = ..., old_id: _Optional[str] = ..., old_mode: _Optional[int] = ..., old_path: _Optional[str] = ..., new_id: _Optional[str] = ..., new_mode: _Optional[int] = ..., new_path: _Optional[str] = ...) -> None: ...
    class User(_message.Message):
        __slots__ = ["email", "name", "time"]
        EMAIL_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        TIME_FIELD_NUMBER: _ClassVar[int]
        email: str
        name: str
        time: _timestamp_pb2.Timestamp
        def __init__(self, name: _Optional[str] = ..., email: _Optional[str] = ..., time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    AUTHOR_FIELD_NUMBER: _ClassVar[int]
    COMMITTER_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    PARENTS_FIELD_NUMBER: _ClassVar[int]
    TREE_DIFF_FIELD_NUMBER: _ClassVar[int]
    TREE_FIELD_NUMBER: _ClassVar[int]
    author: Commit.User
    committer: Commit.User
    id: str
    message: str
    parents: _containers.RepeatedScalarFieldContainer[str]
    tree: str
    tree_diff: _containers.RepeatedCompositeFieldContainer[Commit.TreeDiff]
    def __init__(self, id: _Optional[str] = ..., tree: _Optional[str] = ..., parents: _Optional[_Iterable[str]] = ..., author: _Optional[_Union[Commit.User, _Mapping]] = ..., committer: _Optional[_Union[Commit.User, _Mapping]] = ..., message: _Optional[str] = ..., tree_diff: _Optional[_Iterable[_Union[Commit.TreeDiff, _Mapping]]] = ...) -> None: ...

class File(_message.Message):
    __slots__ = ["id", "mode", "path", "type"]
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    BLOB: File.Type
    ID_FIELD_NUMBER: _ClassVar[int]
    MODE_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    TREE: File.Type
    TYPE_FIELD_NUMBER: _ClassVar[int]
    UNKNOWN: File.Type
    id: str
    mode: int
    path: str
    type: File.Type
    def __init__(self, id: _Optional[str] = ..., path: _Optional[str] = ..., mode: _Optional[int] = ..., type: _Optional[_Union[File.Type, str]] = ...) -> None: ...
