from PB.go.chromium.org.luci.common.proto.git import commit as _commit_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ArchiveRequest(_message.Message):
    __slots__ = ["format", "path", "project", "ref"]
    class Format(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    BZIP2: ArchiveRequest.Format
    FORMAT_FIELD_NUMBER: _ClassVar[int]
    GZIP: ArchiveRequest.Format
    Invalid: ArchiveRequest.Format
    PATH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    TAR: ArchiveRequest.Format
    XZ: ArchiveRequest.Format
    format: ArchiveRequest.Format
    path: str
    project: str
    ref: str
    def __init__(self, project: _Optional[str] = ..., ref: _Optional[str] = ..., format: _Optional[_Union[ArchiveRequest.Format, str]] = ..., path: _Optional[str] = ...) -> None: ...

class ArchiveResponse(_message.Message):
    __slots__ = ["contents", "filename"]
    CONTENTS_FIELD_NUMBER: _ClassVar[int]
    FILENAME_FIELD_NUMBER: _ClassVar[int]
    contents: bytes
    filename: str
    def __init__(self, filename: _Optional[str] = ..., contents: _Optional[bytes] = ...) -> None: ...

class DownloadDiffRequest(_message.Message):
    __slots__ = ["base", "committish", "path", "project"]
    BASE_FIELD_NUMBER: _ClassVar[int]
    COMMITTISH_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    base: str
    committish: str
    path: str
    project: str
    def __init__(self, project: _Optional[str] = ..., committish: _Optional[str] = ..., base: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class DownloadDiffResponse(_message.Message):
    __slots__ = ["contents"]
    CONTENTS_FIELD_NUMBER: _ClassVar[int]
    contents: str
    def __init__(self, contents: _Optional[str] = ...) -> None: ...

class DownloadFileRequest(_message.Message):
    __slots__ = ["committish", "path", "project"]
    COMMITTISH_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    committish: str
    path: str
    project: str
    def __init__(self, project: _Optional[str] = ..., committish: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class DownloadFileResponse(_message.Message):
    __slots__ = ["contents"]
    CONTENTS_FIELD_NUMBER: _ClassVar[int]
    contents: str
    def __init__(self, contents: _Optional[str] = ...) -> None: ...

class ListFilesRequest(_message.Message):
    __slots__ = ["committish", "path", "project"]
    COMMITTISH_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    committish: str
    path: str
    project: str
    def __init__(self, project: _Optional[str] = ..., committish: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class ListFilesResponse(_message.Message):
    __slots__ = ["files"]
    FILES_FIELD_NUMBER: _ClassVar[int]
    files: _containers.RepeatedCompositeFieldContainer[_commit_pb2.File]
    def __init__(self, files: _Optional[_Iterable[_Union[_commit_pb2.File, _Mapping]]] = ...) -> None: ...

class LogRequest(_message.Message):
    __slots__ = ["committish", "exclude_ancestors_of", "page_size", "page_token", "path", "project", "tree_diff"]
    COMMITTISH_FIELD_NUMBER: _ClassVar[int]
    EXCLUDE_ANCESTORS_OF_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TREE_DIFF_FIELD_NUMBER: _ClassVar[int]
    committish: str
    exclude_ancestors_of: str
    page_size: int
    page_token: str
    path: str
    project: str
    tree_diff: bool
    def __init__(self, project: _Optional[str] = ..., committish: _Optional[str] = ..., exclude_ancestors_of: _Optional[str] = ..., tree_diff: bool = ..., path: _Optional[str] = ..., page_token: _Optional[str] = ..., page_size: _Optional[int] = ...) -> None: ...

class LogResponse(_message.Message):
    __slots__ = ["log", "next_page_token"]
    LOG_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    log: _containers.RepeatedCompositeFieldContainer[_commit_pb2.Commit]
    next_page_token: str
    def __init__(self, log: _Optional[_Iterable[_Union[_commit_pb2.Commit, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class ProjectsRequest(_message.Message):
    __slots__ = []
    def __init__(self) -> None: ...

class ProjectsResponse(_message.Message):
    __slots__ = ["projects"]
    PROJECTS_FIELD_NUMBER: _ClassVar[int]
    projects: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, projects: _Optional[_Iterable[str]] = ...) -> None: ...

class RefsRequest(_message.Message):
    __slots__ = ["project", "refs_path"]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REFS_PATH_FIELD_NUMBER: _ClassVar[int]
    project: str
    refs_path: str
    def __init__(self, project: _Optional[str] = ..., refs_path: _Optional[str] = ...) -> None: ...

class RefsResponse(_message.Message):
    __slots__ = ["revisions"]
    class RevisionsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    REVISIONS_FIELD_NUMBER: _ClassVar[int]
    revisions: _containers.ScalarMap[str, str]
    def __init__(self, revisions: _Optional[_Mapping[str, str]] = ...) -> None: ...
