from PB.google.rpc import status as _status_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class AuthenticateRequest(_message.Message):
    __slots__ = ["groups", "metadata", "protocol"]
    class Protocol(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class Metadata(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    GROUPS_FIELD_NUMBER: _ClassVar[int]
    GRPC: AuthenticateRequest.Protocol
    HTTP1: AuthenticateRequest.Protocol
    HTTP2: AuthenticateRequest.Protocol
    METADATA_FIELD_NUMBER: _ClassVar[int]
    PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    PROTOCOL_UNSPECIFIED: AuthenticateRequest.Protocol
    groups: _containers.RepeatedScalarFieldContainer[str]
    metadata: _containers.RepeatedCompositeFieldContainer[AuthenticateRequest.Metadata]
    protocol: AuthenticateRequest.Protocol
    def __init__(self, protocol: _Optional[_Union[AuthenticateRequest.Protocol, str]] = ..., metadata: _Optional[_Iterable[_Union[AuthenticateRequest.Metadata, _Mapping]]] = ..., groups: _Optional[_Iterable[str]] = ...) -> None: ...

class AuthenticateResponse(_message.Message):
    __slots__ = ["anonymous", "error", "groups", "identity", "project", "server_info", "user"]
    class Anonymous(_message.Message):
        __slots__ = []
        def __init__(self) -> None: ...
    class Project(_message.Message):
        __slots__ = ["project", "service"]
        PROJECT_FIELD_NUMBER: _ClassVar[int]
        SERVICE_FIELD_NUMBER: _ClassVar[int]
        project: str
        service: str
        def __init__(self, project: _Optional[str] = ..., service: _Optional[str] = ...) -> None: ...
    class User(_message.Message):
        __slots__ = ["client_id", "email", "name", "picture"]
        CLIENT_ID_FIELD_NUMBER: _ClassVar[int]
        EMAIL_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        PICTURE_FIELD_NUMBER: _ClassVar[int]
        client_id: str
        email: str
        name: str
        picture: str
        def __init__(self, email: _Optional[str] = ..., name: _Optional[str] = ..., picture: _Optional[str] = ..., client_id: _Optional[str] = ...) -> None: ...
    ANONYMOUS_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    GROUPS_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SERVER_INFO_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    anonymous: AuthenticateResponse.Anonymous
    error: _status_pb2.Status
    groups: _containers.RepeatedScalarFieldContainer[str]
    identity: str
    project: AuthenticateResponse.Project
    server_info: ServerInfo
    user: AuthenticateResponse.User
    def __init__(self, identity: _Optional[str] = ..., server_info: _Optional[_Union[ServerInfo, _Mapping]] = ..., groups: _Optional[_Iterable[str]] = ..., error: _Optional[_Union[_status_pb2.Status, _Mapping]] = ..., anonymous: _Optional[_Union[AuthenticateResponse.Anonymous, _Mapping]] = ..., user: _Optional[_Union[AuthenticateResponse.User, _Mapping]] = ..., project: _Optional[_Union[AuthenticateResponse.Project, _Mapping]] = ...) -> None: ...

class HasPermissionRequest(_message.Message):
    __slots__ = ["attributes", "identity", "permission", "realm"]
    class AttributesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    PERMISSION_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    attributes: _containers.ScalarMap[str, str]
    identity: str
    permission: str
    realm: str
    def __init__(self, identity: _Optional[str] = ..., permission: _Optional[str] = ..., realm: _Optional[str] = ..., attributes: _Optional[_Mapping[str, str]] = ...) -> None: ...

class HasPermissionResponse(_message.Message):
    __slots__ = ["has_permission", "server_info"]
    HAS_PERMISSION_FIELD_NUMBER: _ClassVar[int]
    SERVER_INFO_FIELD_NUMBER: _ClassVar[int]
    has_permission: bool
    server_info: ServerInfo
    def __init__(self, has_permission: bool = ..., server_info: _Optional[_Union[ServerInfo, _Mapping]] = ...) -> None: ...

class IsMemberRequest(_message.Message):
    __slots__ = ["groups", "identity"]
    GROUPS_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    groups: _containers.RepeatedScalarFieldContainer[str]
    identity: str
    def __init__(self, identity: _Optional[str] = ..., groups: _Optional[_Iterable[str]] = ...) -> None: ...

class IsMemberResponse(_message.Message):
    __slots__ = ["is_member", "server_info"]
    IS_MEMBER_FIELD_NUMBER: _ClassVar[int]
    SERVER_INFO_FIELD_NUMBER: _ClassVar[int]
    is_member: bool
    server_info: ServerInfo
    def __init__(self, is_member: bool = ..., server_info: _Optional[_Union[ServerInfo, _Mapping]] = ...) -> None: ...

class ServerInfo(_message.Message):
    __slots__ = ["auth_db_rev", "auth_db_service", "sidecar_host", "sidecar_job", "sidecar_service", "sidecar_version"]
    AUTH_DB_REV_FIELD_NUMBER: _ClassVar[int]
    AUTH_DB_SERVICE_FIELD_NUMBER: _ClassVar[int]
    SIDECAR_HOST_FIELD_NUMBER: _ClassVar[int]
    SIDECAR_JOB_FIELD_NUMBER: _ClassVar[int]
    SIDECAR_SERVICE_FIELD_NUMBER: _ClassVar[int]
    SIDECAR_VERSION_FIELD_NUMBER: _ClassVar[int]
    auth_db_rev: int
    auth_db_service: str
    sidecar_host: str
    sidecar_job: str
    sidecar_service: str
    sidecar_version: str
    def __init__(self, sidecar_service: _Optional[str] = ..., sidecar_job: _Optional[str] = ..., sidecar_host: _Optional[str] = ..., sidecar_version: _Optional[str] = ..., auth_db_service: _Optional[str] = ..., auth_db_rev: _Optional[int] = ...) -> None: ...
