from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Manifest(_message.Message):
    __slots__ = ["directories", "version"]
    class CIPDPackage(_message.Message):
        __slots__ = ["instance_id", "package_pattern", "version"]
        INSTANCE_ID_FIELD_NUMBER: _ClassVar[int]
        PACKAGE_PATTERN_FIELD_NUMBER: _ClassVar[int]
        VERSION_FIELD_NUMBER: _ClassVar[int]
        instance_id: str
        package_pattern: str
        version: str
        def __init__(self, package_pattern: _Optional[str] = ..., instance_id: _Optional[str] = ..., version: _Optional[str] = ...) -> None: ...
    class DirectoriesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: Manifest.Directory
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[Manifest.Directory, _Mapping]] = ...) -> None: ...
    class Directory(_message.Message):
        __slots__ = ["cipd_package", "cipd_server_host", "git_checkout"]
        class CipdPackageEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: Manifest.CIPDPackage
            def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[Manifest.CIPDPackage, _Mapping]] = ...) -> None: ...
        CIPD_PACKAGE_FIELD_NUMBER: _ClassVar[int]
        CIPD_SERVER_HOST_FIELD_NUMBER: _ClassVar[int]
        GIT_CHECKOUT_FIELD_NUMBER: _ClassVar[int]
        cipd_package: _containers.MessageMap[str, Manifest.CIPDPackage]
        cipd_server_host: str
        git_checkout: Manifest.GitCheckout
        def __init__(self, git_checkout: _Optional[_Union[Manifest.GitCheckout, _Mapping]] = ..., cipd_server_host: _Optional[str] = ..., cipd_package: _Optional[_Mapping[str, Manifest.CIPDPackage]] = ...) -> None: ...
    class GitCheckout(_message.Message):
        __slots__ = ["fetch_ref", "fetch_url", "patch_fetch_ref", "patch_revision", "repo_url", "revision"]
        FETCH_REF_FIELD_NUMBER: _ClassVar[int]
        FETCH_URL_FIELD_NUMBER: _ClassVar[int]
        PATCH_FETCH_REF_FIELD_NUMBER: _ClassVar[int]
        PATCH_REVISION_FIELD_NUMBER: _ClassVar[int]
        REPO_URL_FIELD_NUMBER: _ClassVar[int]
        REVISION_FIELD_NUMBER: _ClassVar[int]
        fetch_ref: str
        fetch_url: str
        patch_fetch_ref: str
        patch_revision: str
        repo_url: str
        revision: str
        def __init__(self, repo_url: _Optional[str] = ..., fetch_url: _Optional[str] = ..., revision: _Optional[str] = ..., fetch_ref: _Optional[str] = ..., patch_revision: _Optional[str] = ..., patch_fetch_ref: _Optional[str] = ...) -> None: ...
    DIRECTORIES_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    directories: _containers.MessageMap[str, Manifest.Directory]
    version: int
    def __init__(self, version: _Optional[int] = ..., directories: _Optional[_Mapping[str, Manifest.Directory]] = ...) -> None: ...

class ManifestLink(_message.Message):
    __slots__ = ["sha256", "url"]
    SHA256_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    sha256: bytes
    url: str
    def __init__(self, url: _Optional[str] = ..., sha256: _Optional[bytes] = ...) -> None: ...
