from google.protobuf import field_mask_pb2 as _field_mask_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.common.proto.config import service_config as _service_config_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from google.protobuf import service as _service
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BadValidationRequestFixInfo(_message.Message):
    __slots__ = ["unvalidatable_files", "upload_files"]
    class UploadFile(_message.Message):
        __slots__ = ["max_config_size", "path", "signed_url"]
        MAX_CONFIG_SIZE_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        SIGNED_URL_FIELD_NUMBER: _ClassVar[int]
        max_config_size: int
        path: str
        signed_url: str
        def __init__(self, path: _Optional[str] = ..., signed_url: _Optional[str] = ..., max_config_size: _Optional[int] = ...) -> None: ...
    UNVALIDATABLE_FILES_FIELD_NUMBER: _ClassVar[int]
    UPLOAD_FILES_FIELD_NUMBER: _ClassVar[int]
    unvalidatable_files: _containers.RepeatedScalarFieldContainer[str]
    upload_files: _containers.RepeatedCompositeFieldContainer[BadValidationRequestFixInfo.UploadFile]
    def __init__(self, upload_files: _Optional[_Iterable[_Union[BadValidationRequestFixInfo.UploadFile, _Mapping]]] = ..., unvalidatable_files: _Optional[_Iterable[str]] = ...) -> None: ...

class Config(_message.Message):
    __slots__ = ["config_set", "content_sha256", "path", "raw_content", "revision", "signed_url", "size", "url"]
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    CONTENT_SHA256_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    RAW_CONTENT_FIELD_NUMBER: _ClassVar[int]
    REVISION_FIELD_NUMBER: _ClassVar[int]
    SIGNED_URL_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    content_sha256: str
    path: str
    raw_content: bytes
    revision: str
    signed_url: str
    size: int
    url: str
    def __init__(self, config_set: _Optional[str] = ..., path: _Optional[str] = ..., raw_content: _Optional[bytes] = ..., signed_url: _Optional[str] = ..., content_sha256: _Optional[str] = ..., size: _Optional[int] = ..., revision: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...

class ConfigSet(_message.Message):
    __slots__ = ["configs", "file_paths", "last_import_attempt", "name", "revision", "url"]
    class Attempt(_message.Message):
        __slots__ = ["message", "revision", "success", "timestamp", "validationResult"]
        MESSAGE_FIELD_NUMBER: _ClassVar[int]
        REVISION_FIELD_NUMBER: _ClassVar[int]
        SUCCESS_FIELD_NUMBER: _ClassVar[int]
        TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
        VALIDATIONRESULT_FIELD_NUMBER: _ClassVar[int]
        message: str
        revision: ConfigSet.Revision
        success: bool
        timestamp: _timestamp_pb2.Timestamp
        validationResult: _service_config_pb2.ValidationResult
        def __init__(self, message: _Optional[str] = ..., success: bool = ..., revision: _Optional[_Union[ConfigSet.Revision, _Mapping]] = ..., timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., validationResult: _Optional[_Union[_service_config_pb2.ValidationResult, _Mapping]] = ...) -> None: ...
    class Revision(_message.Message):
        __slots__ = ["author_email", "committer_email", "id", "timestamp", "url"]
        AUTHOR_EMAIL_FIELD_NUMBER: _ClassVar[int]
        COMMITTER_EMAIL_FIELD_NUMBER: _ClassVar[int]
        ID_FIELD_NUMBER: _ClassVar[int]
        TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
        URL_FIELD_NUMBER: _ClassVar[int]
        author_email: str
        committer_email: str
        id: str
        timestamp: _timestamp_pb2.Timestamp
        url: str
        def __init__(self, id: _Optional[str] = ..., url: _Optional[str] = ..., committer_email: _Optional[str] = ..., author_email: _Optional[str] = ..., timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    CONFIGS_FIELD_NUMBER: _ClassVar[int]
    FILE_PATHS_FIELD_NUMBER: _ClassVar[int]
    LAST_IMPORT_ATTEMPT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REVISION_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    configs: _containers.RepeatedCompositeFieldContainer[Config]
    file_paths: _containers.RepeatedScalarFieldContainer[str]
    last_import_attempt: ConfigSet.Attempt
    name: str
    revision: ConfigSet.Revision
    url: str
    def __init__(self, name: _Optional[str] = ..., url: _Optional[str] = ..., revision: _Optional[_Union[ConfigSet.Revision, _Mapping]] = ..., file_paths: _Optional[_Iterable[str]] = ..., last_import_attempt: _Optional[_Union[ConfigSet.Attempt, _Mapping]] = ..., configs: _Optional[_Iterable[_Union[Config, _Mapping]]] = ...) -> None: ...

class GetConfigRequest(_message.Message):
    __slots__ = ["config_set", "content_sha256", "fields", "path"]
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    CONTENT_SHA256_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    content_sha256: str
    fields: _field_mask_pb2.FieldMask
    path: str
    def __init__(self, config_set: _Optional[str] = ..., path: _Optional[str] = ..., content_sha256: _Optional[str] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class GetConfigSetRequest(_message.Message):
    __slots__ = ["config_set", "fields"]
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    fields: _field_mask_pb2.FieldMask
    def __init__(self, config_set: _Optional[str] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class GetProjectConfigsRequest(_message.Message):
    __slots__ = ["fields", "path"]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    fields: _field_mask_pb2.FieldMask
    path: str
    def __init__(self, path: _Optional[str] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class GetProjectConfigsResponse(_message.Message):
    __slots__ = ["configs"]
    CONFIGS_FIELD_NUMBER: _ClassVar[int]
    configs: _containers.RepeatedCompositeFieldContainer[Config]
    def __init__(self, configs: _Optional[_Iterable[_Union[Config, _Mapping]]] = ...) -> None: ...

class ListConfigSetsRequest(_message.Message):
    __slots__ = ["domain", "fields"]
    class ConfigSetDomain(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    ALL: ListConfigSetsRequest.ConfigSetDomain
    DOMAIN_FIELD_NUMBER: _ClassVar[int]
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    PROJECT: ListConfigSetsRequest.ConfigSetDomain
    SERVICE: ListConfigSetsRequest.ConfigSetDomain
    domain: ListConfigSetsRequest.ConfigSetDomain
    fields: _field_mask_pb2.FieldMask
    def __init__(self, domain: _Optional[_Union[ListConfigSetsRequest.ConfigSetDomain, str]] = ..., fields: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class ListConfigSetsResponse(_message.Message):
    __slots__ = ["config_sets"]
    CONFIG_SETS_FIELD_NUMBER: _ClassVar[int]
    config_sets: _containers.RepeatedCompositeFieldContainer[ConfigSet]
    def __init__(self, config_sets: _Optional[_Iterable[_Union[ConfigSet, _Mapping]]] = ...) -> None: ...

class ValidateConfigsRequest(_message.Message):
    __slots__ = ["config_set", "file_hashes"]
    class FileHash(_message.Message):
        __slots__ = ["path", "sha256"]
        PATH_FIELD_NUMBER: _ClassVar[int]
        SHA256_FIELD_NUMBER: _ClassVar[int]
        path: str
        sha256: str
        def __init__(self, path: _Optional[str] = ..., sha256: _Optional[str] = ...) -> None: ...
    CONFIG_SET_FIELD_NUMBER: _ClassVar[int]
    FILE_HASHES_FIELD_NUMBER: _ClassVar[int]
    config_set: str
    file_hashes: _containers.RepeatedCompositeFieldContainer[ValidateConfigsRequest.FileHash]
    def __init__(self, config_set: _Optional[str] = ..., file_hashes: _Optional[_Iterable[_Union[ValidateConfigsRequest.FileHash, _Mapping]]] = ...) -> None: ...

class Configs(_service.service): ...

class Configs_Stub(Configs): ...
