from google.protobuf import duration_pb2 as _duration_pb2
from PB.validate import validate as _validate_pb2
from PB.go.chromium.org.luci.common.proto import options as _options_pb2
from PB.go.chromium.org.luci.cv.api.v1 import run as _run_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

COMMENT_LEVEL_FULL: CommentLevel
COMMENT_LEVEL_RESTRICTED: CommentLevel
COMMENT_LEVEL_UNSET: CommentLevel
DESCRIPTOR: _descriptor.FileDescriptor
NO: Toggle
UNSET: Toggle
YES: Toggle

class CombineCLs(_message.Message):
    __slots__ = ["stabilization_delay"]
    STABILIZATION_DELAY_FIELD_NUMBER: _ClassVar[int]
    stabilization_delay: _duration_pb2.Duration
    def __init__(self, stabilization_delay: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...

class Config(_message.Message):
    __slots__ = ["config_groups", "cq_status_host", "draining_start_time", "project_scoped_account", "submit_options"]
    CONFIG_GROUPS_FIELD_NUMBER: _ClassVar[int]
    CQ_STATUS_HOST_FIELD_NUMBER: _ClassVar[int]
    DRAINING_START_TIME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_SCOPED_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    SUBMIT_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    config_groups: _containers.RepeatedCompositeFieldContainer[ConfigGroup]
    cq_status_host: str
    draining_start_time: str
    project_scoped_account: Toggle
    submit_options: SubmitOptions
    def __init__(self, draining_start_time: _Optional[str] = ..., cq_status_host: _Optional[str] = ..., submit_options: _Optional[_Union[SubmitOptions, _Mapping]] = ..., config_groups: _Optional[_Iterable[_Union[ConfigGroup, _Mapping]]] = ..., project_scoped_account: _Optional[_Union[Toggle, str]] = ...) -> None: ...

class ConfigGroup(_message.Message):
    __slots__ = ["additional_modes", "combine_cls", "fallback", "gerrit", "name", "post_actions", "tryjob_experiments", "user_limit_default", "user_limits", "verifiers"]
    class Gerrit(_message.Message):
        __slots__ = ["projects", "url"]
        class Project(_message.Message):
            __slots__ = ["name", "ref_regexp", "ref_regexp_exclude"]
            NAME_FIELD_NUMBER: _ClassVar[int]
            REF_REGEXP_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
            REF_REGEXP_FIELD_NUMBER: _ClassVar[int]
            name: str
            ref_regexp: _containers.RepeatedScalarFieldContainer[str]
            ref_regexp_exclude: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, name: _Optional[str] = ..., ref_regexp: _Optional[_Iterable[str]] = ..., ref_regexp_exclude: _Optional[_Iterable[str]] = ...) -> None: ...
        PROJECTS_FIELD_NUMBER: _ClassVar[int]
        URL_FIELD_NUMBER: _ClassVar[int]
        projects: _containers.RepeatedCompositeFieldContainer[ConfigGroup.Gerrit.Project]
        url: str
        def __init__(self, url: _Optional[str] = ..., projects: _Optional[_Iterable[_Union[ConfigGroup.Gerrit.Project, _Mapping]]] = ...) -> None: ...
    class PostAction(_message.Message):
        __slots__ = ["conditions", "name", "vote_gerrit_labels"]
        class TriggeringCondition(_message.Message):
            __slots__ = ["mode", "statuses"]
            MODE_FIELD_NUMBER: _ClassVar[int]
            STATUSES_FIELD_NUMBER: _ClassVar[int]
            mode: str
            statuses: _containers.RepeatedScalarFieldContainer[_run_pb2.Run.Status]
            def __init__(self, mode: _Optional[str] = ..., statuses: _Optional[_Iterable[_Union[_run_pb2.Run.Status, str]]] = ...) -> None: ...
        class VoteGerritLabels(_message.Message):
            __slots__ = ["votes"]
            class Vote(_message.Message):
                __slots__ = ["name", "value"]
                NAME_FIELD_NUMBER: _ClassVar[int]
                VALUE_FIELD_NUMBER: _ClassVar[int]
                name: str
                value: int
                def __init__(self, name: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
            VOTES_FIELD_NUMBER: _ClassVar[int]
            votes: _containers.RepeatedCompositeFieldContainer[ConfigGroup.PostAction.VoteGerritLabels.Vote]
            def __init__(self, votes: _Optional[_Iterable[_Union[ConfigGroup.PostAction.VoteGerritLabels.Vote, _Mapping]]] = ...) -> None: ...
        CONDITIONS_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        VOTE_GERRIT_LABELS_FIELD_NUMBER: _ClassVar[int]
        conditions: _containers.RepeatedCompositeFieldContainer[ConfigGroup.PostAction.TriggeringCondition]
        name: str
        vote_gerrit_labels: ConfigGroup.PostAction.VoteGerritLabels
        def __init__(self, name: _Optional[str] = ..., conditions: _Optional[_Iterable[_Union[ConfigGroup.PostAction.TriggeringCondition, _Mapping]]] = ..., vote_gerrit_labels: _Optional[_Union[ConfigGroup.PostAction.VoteGerritLabels, _Mapping]] = ...) -> None: ...
    class TryjobExperiment(_message.Message):
        __slots__ = ["condition", "name"]
        class Condition(_message.Message):
            __slots__ = ["owner_group_allowlist"]
            OWNER_GROUP_ALLOWLIST_FIELD_NUMBER: _ClassVar[int]
            owner_group_allowlist: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, owner_group_allowlist: _Optional[_Iterable[str]] = ...) -> None: ...
        CONDITION_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        condition: ConfigGroup.TryjobExperiment.Condition
        name: str
        def __init__(self, name: _Optional[str] = ..., condition: _Optional[_Union[ConfigGroup.TryjobExperiment.Condition, _Mapping]] = ...) -> None: ...
    ADDITIONAL_MODES_FIELD_NUMBER: _ClassVar[int]
    COMBINE_CLS_FIELD_NUMBER: _ClassVar[int]
    FALLBACK_FIELD_NUMBER: _ClassVar[int]
    GERRIT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    POST_ACTIONS_FIELD_NUMBER: _ClassVar[int]
    TRYJOB_EXPERIMENTS_FIELD_NUMBER: _ClassVar[int]
    USER_LIMITS_FIELD_NUMBER: _ClassVar[int]
    USER_LIMIT_DEFAULT_FIELD_NUMBER: _ClassVar[int]
    VERIFIERS_FIELD_NUMBER: _ClassVar[int]
    additional_modes: _containers.RepeatedCompositeFieldContainer[Mode]
    combine_cls: CombineCLs
    fallback: Toggle
    gerrit: _containers.RepeatedCompositeFieldContainer[ConfigGroup.Gerrit]
    name: str
    post_actions: _containers.RepeatedCompositeFieldContainer[ConfigGroup.PostAction]
    tryjob_experiments: _containers.RepeatedCompositeFieldContainer[ConfigGroup.TryjobExperiment]
    user_limit_default: UserLimit
    user_limits: _containers.RepeatedCompositeFieldContainer[UserLimit]
    verifiers: Verifiers
    def __init__(self, name: _Optional[str] = ..., gerrit: _Optional[_Iterable[_Union[ConfigGroup.Gerrit, _Mapping]]] = ..., combine_cls: _Optional[_Union[CombineCLs, _Mapping]] = ..., verifiers: _Optional[_Union[Verifiers, _Mapping]] = ..., fallback: _Optional[_Union[Toggle, str]] = ..., additional_modes: _Optional[_Iterable[_Union[Mode, _Mapping]]] = ..., user_limits: _Optional[_Iterable[_Union[UserLimit, _Mapping]]] = ..., user_limit_default: _Optional[_Union[UserLimit, _Mapping]] = ..., post_actions: _Optional[_Iterable[_Union[ConfigGroup.PostAction, _Mapping]]] = ..., tryjob_experiments: _Optional[_Iterable[_Union[ConfigGroup.TryjobExperiment, _Mapping]]] = ...) -> None: ...

class Mode(_message.Message):
    __slots__ = ["cq_label_value", "name", "triggering_label", "triggering_value"]
    CQ_LABEL_VALUE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    TRIGGERING_LABEL_FIELD_NUMBER: _ClassVar[int]
    TRIGGERING_VALUE_FIELD_NUMBER: _ClassVar[int]
    cq_label_value: int
    name: str
    triggering_label: str
    triggering_value: int
    def __init__(self, name: _Optional[str] = ..., cq_label_value: _Optional[int] = ..., triggering_label: _Optional[str] = ..., triggering_value: _Optional[int] = ...) -> None: ...

class SubmitOptions(_message.Message):
    __slots__ = ["burst_delay", "max_burst"]
    BURST_DELAY_FIELD_NUMBER: _ClassVar[int]
    MAX_BURST_FIELD_NUMBER: _ClassVar[int]
    burst_delay: _duration_pb2.Duration
    max_burst: int
    def __init__(self, max_burst: _Optional[int] = ..., burst_delay: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...

class UserLimit(_message.Message):
    __slots__ = ["name", "principals", "run", "tryjob"]
    class Limit(_message.Message):
        __slots__ = ["unlimited", "value"]
        UNLIMITED_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        unlimited: bool
        value: int
        def __init__(self, value: _Optional[int] = ..., unlimited: bool = ...) -> None: ...
    class Run(_message.Message):
        __slots__ = ["max_active"]
        MAX_ACTIVE_FIELD_NUMBER: _ClassVar[int]
        max_active: UserLimit.Limit
        def __init__(self, max_active: _Optional[_Union[UserLimit.Limit, _Mapping]] = ...) -> None: ...
    class Tryjob(_message.Message):
        __slots__ = ["max_active"]
        MAX_ACTIVE_FIELD_NUMBER: _ClassVar[int]
        max_active: UserLimit.Limit
        def __init__(self, max_active: _Optional[_Union[UserLimit.Limit, _Mapping]] = ...) -> None: ...
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRINCIPALS_FIELD_NUMBER: _ClassVar[int]
    RUN_FIELD_NUMBER: _ClassVar[int]
    TRYJOB_FIELD_NUMBER: _ClassVar[int]
    name: str
    principals: _containers.RepeatedScalarFieldContainer[str]
    run: UserLimit.Run
    tryjob: UserLimit.Tryjob
    def __init__(self, name: _Optional[str] = ..., principals: _Optional[_Iterable[str]] = ..., run: _Optional[_Union[UserLimit.Run, _Mapping]] = ..., tryjob: _Optional[_Union[UserLimit.Tryjob, _Mapping]] = ...) -> None: ...

class Verifiers(_message.Message):
    __slots__ = ["cqlinter", "fake", "gerrit_cq_ability", "tree_status", "tryjob"]
    class CQLinter(_message.Message):
        __slots__ = []
        def __init__(self) -> None: ...
    class Fake(_message.Message):
        __slots__ = ["delay", "eventual_state", "name"]
        DELAY_FIELD_NUMBER: _ClassVar[int]
        EVENTUAL_STATE_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        delay: int
        eventual_state: str
        name: str
        def __init__(self, name: _Optional[str] = ..., eventual_state: _Optional[str] = ..., delay: _Optional[int] = ...) -> None: ...
    class GerritCQAbility(_message.Message):
        __slots__ = ["allow_owner_if_submittable", "allow_submit_with_open_deps", "committer_list", "dry_run_access_list", "new_patchset_run_access_list", "trust_dry_runner_deps"]
        class CQAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = []
        ALLOW_OWNER_IF_SUBMITTABLE_FIELD_NUMBER: _ClassVar[int]
        ALLOW_SUBMIT_WITH_OPEN_DEPS_FIELD_NUMBER: _ClassVar[int]
        COMMIT: Verifiers.GerritCQAbility.CQAction
        COMMITTER_LIST_FIELD_NUMBER: _ClassVar[int]
        DRY_RUN: Verifiers.GerritCQAbility.CQAction
        DRY_RUN_ACCESS_LIST_FIELD_NUMBER: _ClassVar[int]
        NEW_PATCHSET_RUN_ACCESS_LIST_FIELD_NUMBER: _ClassVar[int]
        TRUST_DRY_RUNNER_DEPS_FIELD_NUMBER: _ClassVar[int]
        UNSET: Verifiers.GerritCQAbility.CQAction
        allow_owner_if_submittable: Verifiers.GerritCQAbility.CQAction
        allow_submit_with_open_deps: bool
        committer_list: _containers.RepeatedScalarFieldContainer[str]
        dry_run_access_list: _containers.RepeatedScalarFieldContainer[str]
        new_patchset_run_access_list: _containers.RepeatedScalarFieldContainer[str]
        trust_dry_runner_deps: bool
        def __init__(self, committer_list: _Optional[_Iterable[str]] = ..., dry_run_access_list: _Optional[_Iterable[str]] = ..., new_patchset_run_access_list: _Optional[_Iterable[str]] = ..., allow_submit_with_open_deps: bool = ..., allow_owner_if_submittable: _Optional[_Union[Verifiers.GerritCQAbility.CQAction, str]] = ..., trust_dry_runner_deps: bool = ...) -> None: ...
    class TreeStatus(_message.Message):
        __slots__ = ["url"]
        URL_FIELD_NUMBER: _ClassVar[int]
        url: str
        def __init__(self, url: _Optional[str] = ...) -> None: ...
    class Tryjob(_message.Message):
        __slots__ = ["builders", "cancel_stale_tryjobs", "retry_config"]
        class Builder(_message.Message):
            __slots__ = ["cancel_stale", "disable_reuse", "equivalent_to", "experiment_percentage", "host", "includable_only", "location_filters", "mode_allowlist", "name", "owner_whitelist_group", "result_visibility"]
            class LocationFilter(_message.Message):
                __slots__ = ["exclude", "gerrit_host_regexp", "gerrit_project_regexp", "path_regexp"]
                EXCLUDE_FIELD_NUMBER: _ClassVar[int]
                GERRIT_HOST_REGEXP_FIELD_NUMBER: _ClassVar[int]
                GERRIT_PROJECT_REGEXP_FIELD_NUMBER: _ClassVar[int]
                PATH_REGEXP_FIELD_NUMBER: _ClassVar[int]
                exclude: bool
                gerrit_host_regexp: str
                gerrit_project_regexp: str
                path_regexp: str
                def __init__(self, gerrit_host_regexp: _Optional[str] = ..., gerrit_project_regexp: _Optional[str] = ..., path_regexp: _Optional[str] = ..., exclude: bool = ...) -> None: ...
            CANCEL_STALE_FIELD_NUMBER: _ClassVar[int]
            DISABLE_REUSE_FIELD_NUMBER: _ClassVar[int]
            EQUIVALENT_TO_FIELD_NUMBER: _ClassVar[int]
            EXPERIMENT_PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
            HOST_FIELD_NUMBER: _ClassVar[int]
            INCLUDABLE_ONLY_FIELD_NUMBER: _ClassVar[int]
            LOCATION_FILTERS_FIELD_NUMBER: _ClassVar[int]
            MODE_ALLOWLIST_FIELD_NUMBER: _ClassVar[int]
            NAME_FIELD_NUMBER: _ClassVar[int]
            OWNER_WHITELIST_GROUP_FIELD_NUMBER: _ClassVar[int]
            RESULT_VISIBILITY_FIELD_NUMBER: _ClassVar[int]
            cancel_stale: Toggle
            disable_reuse: bool
            equivalent_to: Verifiers.Tryjob.EquivalentBuilder
            experiment_percentage: float
            host: str
            includable_only: bool
            location_filters: _containers.RepeatedCompositeFieldContainer[Verifiers.Tryjob.Builder.LocationFilter]
            mode_allowlist: _containers.RepeatedScalarFieldContainer[str]
            name: str
            owner_whitelist_group: _containers.RepeatedScalarFieldContainer[str]
            result_visibility: CommentLevel
            def __init__(self, host: _Optional[str] = ..., name: _Optional[str] = ..., includable_only: bool = ..., result_visibility: _Optional[_Union[CommentLevel, str]] = ..., disable_reuse: bool = ..., cancel_stale: _Optional[_Union[Toggle, str]] = ..., experiment_percentage: _Optional[float] = ..., equivalent_to: _Optional[_Union[Verifiers.Tryjob.EquivalentBuilder, _Mapping]] = ..., location_filters: _Optional[_Iterable[_Union[Verifiers.Tryjob.Builder.LocationFilter, _Mapping]]] = ..., owner_whitelist_group: _Optional[_Iterable[str]] = ..., mode_allowlist: _Optional[_Iterable[str]] = ...) -> None: ...
        class EquivalentBuilder(_message.Message):
            __slots__ = ["name", "owner_whitelist_group", "percentage"]
            NAME_FIELD_NUMBER: _ClassVar[int]
            OWNER_WHITELIST_GROUP_FIELD_NUMBER: _ClassVar[int]
            PERCENTAGE_FIELD_NUMBER: _ClassVar[int]
            name: str
            owner_whitelist_group: str
            percentage: float
            def __init__(self, name: _Optional[str] = ..., percentage: _Optional[float] = ..., owner_whitelist_group: _Optional[str] = ...) -> None: ...
        class IncludableBuilder(_message.Message):
            __slots__ = ["name"]
            NAME_FIELD_NUMBER: _ClassVar[int]
            name: str
            def __init__(self, name: _Optional[str] = ...) -> None: ...
        class RetryConfig(_message.Message):
            __slots__ = ["failure_weight", "global_quota", "single_quota", "timeout_weight", "transient_failure_weight"]
            FAILURE_WEIGHT_FIELD_NUMBER: _ClassVar[int]
            GLOBAL_QUOTA_FIELD_NUMBER: _ClassVar[int]
            SINGLE_QUOTA_FIELD_NUMBER: _ClassVar[int]
            TIMEOUT_WEIGHT_FIELD_NUMBER: _ClassVar[int]
            TRANSIENT_FAILURE_WEIGHT_FIELD_NUMBER: _ClassVar[int]
            failure_weight: int
            global_quota: int
            single_quota: int
            timeout_weight: int
            transient_failure_weight: int
            def __init__(self, single_quota: _Optional[int] = ..., global_quota: _Optional[int] = ..., failure_weight: _Optional[int] = ..., transient_failure_weight: _Optional[int] = ..., timeout_weight: _Optional[int] = ...) -> None: ...
        BUILDERS_FIELD_NUMBER: _ClassVar[int]
        CANCEL_STALE_TRYJOBS_FIELD_NUMBER: _ClassVar[int]
        RETRY_CONFIG_FIELD_NUMBER: _ClassVar[int]
        builders: _containers.RepeatedCompositeFieldContainer[Verifiers.Tryjob.Builder]
        cancel_stale_tryjobs: Toggle
        retry_config: Verifiers.Tryjob.RetryConfig
        def __init__(self, builders: _Optional[_Iterable[_Union[Verifiers.Tryjob.Builder, _Mapping]]] = ..., retry_config: _Optional[_Union[Verifiers.Tryjob.RetryConfig, _Mapping]] = ..., cancel_stale_tryjobs: _Optional[_Union[Toggle, str]] = ...) -> None: ...
    CQLINTER_FIELD_NUMBER: _ClassVar[int]
    FAKE_FIELD_NUMBER: _ClassVar[int]
    GERRIT_CQ_ABILITY_FIELD_NUMBER: _ClassVar[int]
    TREE_STATUS_FIELD_NUMBER: _ClassVar[int]
    TRYJOB_FIELD_NUMBER: _ClassVar[int]
    cqlinter: Verifiers.CQLinter
    fake: Verifiers.Fake
    gerrit_cq_ability: Verifiers.GerritCQAbility
    tree_status: Verifiers.TreeStatus
    tryjob: Verifiers.Tryjob
    def __init__(self, gerrit_cq_ability: _Optional[_Union[Verifiers.GerritCQAbility, _Mapping]] = ..., tree_status: _Optional[_Union[Verifiers.TreeStatus, _Mapping]] = ..., tryjob: _Optional[_Union[Verifiers.Tryjob, _Mapping]] = ..., cqlinter: _Optional[_Union[Verifiers.CQLinter, _Mapping]] = ..., fake: _Optional[_Union[Verifiers.Fake, _Mapping]] = ...) -> None: ...

class CommentLevel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class Toggle(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
