from PB.go.chromium.org.luci.buildbucket.proto import builder_common as _builder_common_pb2
from PB.go.chromium.org.luci.cv.api.config.v2 import config as _config_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

CANCELLED: TryjobStatus
DESCRIPTOR: _descriptor.FileDescriptor
FAILED: TryjobStatus
PENDING: TryjobStatus
RUNNING: TryjobStatus
SUCCEEDED: TryjobStatus
TRYJOB_STATUS_UNSPECIFIED: TryjobStatus
UNTRIGGERED: TryjobStatus

class Tryjob(_message.Message):
    __slots__ = ["critical", "result", "reuse", "status"]
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class Result(_message.Message):
        __slots__ = ["buildbucket", "status"]
        class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = []
        class Buildbucket(_message.Message):
            __slots__ = ["id"]
            ID_FIELD_NUMBER: _ClassVar[int]
            id: int
            def __init__(self, id: _Optional[int] = ...) -> None: ...
        BUILDBUCKET_FIELD_NUMBER: _ClassVar[int]
        FAILED_PERMANENTLY: Tryjob.Result.Status
        FAILED_TRANSIENTLY: Tryjob.Result.Status
        RESULT_STATUS_UNSPECIFIED: Tryjob.Result.Status
        STATUS_FIELD_NUMBER: _ClassVar[int]
        SUCCEEDED: Tryjob.Result.Status
        TIMEOUT: Tryjob.Result.Status
        UNKNOWN: Tryjob.Result.Status
        buildbucket: Tryjob.Result.Buildbucket
        status: Tryjob.Result.Status
        def __init__(self, status: _Optional[_Union[Tryjob.Result.Status, str]] = ..., buildbucket: _Optional[_Union[Tryjob.Result.Buildbucket, _Mapping]] = ...) -> None: ...
    CANCELLED: Tryjob.Status
    CRITICAL_FIELD_NUMBER: _ClassVar[int]
    ENDED: Tryjob.Status
    PENDING: Tryjob.Status
    RESULT_FIELD_NUMBER: _ClassVar[int]
    REUSE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STATUS_UNSPECIFIED: Tryjob.Status
    TRIGGERED: Tryjob.Status
    UNTRIGGERED: Tryjob.Status
    critical: bool
    result: Tryjob.Result
    reuse: bool
    status: Tryjob.Status
    def __init__(self, status: _Optional[_Union[Tryjob.Status, str]] = ..., result: _Optional[_Union[Tryjob.Result, _Mapping]] = ..., critical: bool = ..., reuse: bool = ...) -> None: ...

class TryjobInvocation(_message.Message):
    __slots__ = ["attempts", "builder_config", "critical", "status"]
    class Attempt(_message.Message):
        __slots__ = ["result", "reuse", "status"]
        RESULT_FIELD_NUMBER: _ClassVar[int]
        REUSE_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        result: TryjobResult
        reuse: bool
        status: TryjobStatus
        def __init__(self, status: _Optional[_Union[TryjobStatus, str]] = ..., result: _Optional[_Union[TryjobResult, _Mapping]] = ..., reuse: bool = ...) -> None: ...
    ATTEMPTS_FIELD_NUMBER: _ClassVar[int]
    BUILDER_CONFIG_FIELD_NUMBER: _ClassVar[int]
    CRITICAL_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    attempts: _containers.RepeatedCompositeFieldContainer[TryjobInvocation.Attempt]
    builder_config: _config_pb2.Verifiers.Tryjob.Builder
    critical: bool
    status: TryjobStatus
    def __init__(self, builder_config: _Optional[_Union[_config_pb2.Verifiers.Tryjob.Builder, _Mapping]] = ..., status: _Optional[_Union[TryjobStatus, str]] = ..., critical: bool = ..., attempts: _Optional[_Iterable[_Union[TryjobInvocation.Attempt, _Mapping]]] = ...) -> None: ...

class TryjobResult(_message.Message):
    __slots__ = ["buildbucket"]
    class Buildbucket(_message.Message):
        __slots__ = ["builder", "host", "id"]
        BUILDER_FIELD_NUMBER: _ClassVar[int]
        HOST_FIELD_NUMBER: _ClassVar[int]
        ID_FIELD_NUMBER: _ClassVar[int]
        builder: _builder_common_pb2.BuilderID
        host: str
        id: int
        def __init__(self, host: _Optional[str] = ..., id: _Optional[int] = ..., builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ...) -> None: ...
    BUILDBUCKET_FIELD_NUMBER: _ClassVar[int]
    buildbucket: TryjobResult.Buildbucket
    def __init__(self, buildbucket: _Optional[_Union[TryjobResult.Buildbucket, _Mapping]] = ...) -> None: ...

class TryjobStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
