from PB.google.type import dayofweek as _dayofweek_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from PB.go.chromium.org.luci.common.proto import options as _options_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

ARCHITECTURAL: PerformanceMonitoringUnit
DESCRIPTOR: _descriptor.FileDescriptor
ENHANCED: PerformanceMonitoringUnit
GCP_CHANNEL_ALPHA: GCPChannel
GCP_CHANNEL_BETA: GCPChannel
GCP_CHANNEL_STABLE: GCPChannel
GCP_CHANNEL_UNSPECIFIED: GCPChannel
IN: NodeAffinityOperator
NOT_IN: NodeAffinityOperator
NVME: DiskInterface
ONE_TO_ONE_NAT: AccessConfigType
OPERATOR_UNSPECIFIED: NodeAffinityOperator
PERFORMANCE_MONITORING_UNIT_UNSPECIFIED: PerformanceMonitoringUnit
SCSI: DiskInterface
STANDARD: PerformanceMonitoringUnit

class AccessConfig(_message.Message):
    __slots__ = ["type"]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    type: AccessConfigType
    def __init__(self, type: _Optional[_Union[AccessConfigType, str]] = ...) -> None: ...

class Amount(_message.Message):
    __slots__ = ["change", "max", "min"]
    CHANGE_FIELD_NUMBER: _ClassVar[int]
    MAX_FIELD_NUMBER: _ClassVar[int]
    MIN_FIELD_NUMBER: _ClassVar[int]
    change: _containers.RepeatedCompositeFieldContainer[Schedule]
    max: int
    min: int
    def __init__(self, change: _Optional[_Iterable[_Union[Schedule, _Mapping]]] = ..., min: _Optional[int] = ..., max: _Optional[int] = ...) -> None: ...

class Config(_message.Message):
    __slots__ = ["amount", "attributes", "current_amount", "duts", "lifetime", "owner", "prefix", "revision", "swarming", "timeout"]
    class DutsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _empty_pb2.Empty
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_empty_pb2.Empty, _Mapping]] = ...) -> None: ...
    AMOUNT_FIELD_NUMBER: _ClassVar[int]
    ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    CURRENT_AMOUNT_FIELD_NUMBER: _ClassVar[int]
    DUTS_FIELD_NUMBER: _ClassVar[int]
    LIFETIME_FIELD_NUMBER: _ClassVar[int]
    OWNER_FIELD_NUMBER: _ClassVar[int]
    PREFIX_FIELD_NUMBER: _ClassVar[int]
    REVISION_FIELD_NUMBER: _ClassVar[int]
    SWARMING_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    amount: Amount
    attributes: VM
    current_amount: int
    duts: _containers.MessageMap[str, _empty_pb2.Empty]
    lifetime: TimePeriod
    owner: _containers.RepeatedScalarFieldContainer[str]
    prefix: str
    revision: str
    swarming: str
    timeout: TimePeriod
    def __init__(self, amount: _Optional[_Union[Amount, _Mapping]] = ..., attributes: _Optional[_Union[VM, _Mapping]] = ..., lifetime: _Optional[_Union[TimePeriod, _Mapping]] = ..., prefix: _Optional[str] = ..., swarming: _Optional[str] = ..., timeout: _Optional[_Union[TimePeriod, _Mapping]] = ..., owner: _Optional[_Iterable[str]] = ..., duts: _Optional[_Mapping[str, _empty_pb2.Empty]] = ..., revision: _Optional[str] = ..., current_amount: _Optional[int] = ...) -> None: ...

class Configs(_message.Message):
    __slots__ = ["vms"]
    VMS_FIELD_NUMBER: _ClassVar[int]
    vms: _containers.RepeatedCompositeFieldContainer[Config]
    def __init__(self, vms: _Optional[_Iterable[_Union[Config, _Mapping]]] = ...) -> None: ...

class Disk(_message.Message):
    __slots__ = ["image", "interface", "size", "type"]
    IMAGE_FIELD_NUMBER: _ClassVar[int]
    INTERFACE_FIELD_NUMBER: _ClassVar[int]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    TYPE_FIELD_NUMBER: _ClassVar[int]
    image: str
    interface: DiskInterface
    size: int
    type: str
    def __init__(self, image: _Optional[str] = ..., size: _Optional[int] = ..., type: _Optional[str] = ..., interface: _Optional[_Union[DiskInterface, str]] = ...) -> None: ...

class Metadata(_message.Message):
    __slots__ = ["from_file", "from_text"]
    FROM_FILE_FIELD_NUMBER: _ClassVar[int]
    FROM_TEXT_FIELD_NUMBER: _ClassVar[int]
    from_file: str
    from_text: str
    def __init__(self, from_text: _Optional[str] = ..., from_file: _Optional[str] = ...) -> None: ...

class NetworkInterface(_message.Message):
    __slots__ = ["access_config", "network", "subnetwork"]
    ACCESS_CONFIG_FIELD_NUMBER: _ClassVar[int]
    NETWORK_FIELD_NUMBER: _ClassVar[int]
    SUBNETWORK_FIELD_NUMBER: _ClassVar[int]
    access_config: _containers.RepeatedCompositeFieldContainer[AccessConfig]
    network: str
    subnetwork: str
    def __init__(self, access_config: _Optional[_Iterable[_Union[AccessConfig, _Mapping]]] = ..., network: _Optional[str] = ..., subnetwork: _Optional[str] = ...) -> None: ...

class NodeAffinity(_message.Message):
    __slots__ = ["key", "operator", "values"]
    KEY_FIELD_NUMBER: _ClassVar[int]
    OPERATOR_FIELD_NUMBER: _ClassVar[int]
    VALUES_FIELD_NUMBER: _ClassVar[int]
    key: str
    operator: NodeAffinityOperator
    values: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, key: _Optional[str] = ..., operator: _Optional[_Union[NodeAffinityOperator, str]] = ..., values: _Optional[_Iterable[str]] = ...) -> None: ...

class Schedule(_message.Message):
    __slots__ = ["length", "max", "min", "start"]
    LENGTH_FIELD_NUMBER: _ClassVar[int]
    MAX_FIELD_NUMBER: _ClassVar[int]
    MIN_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    length: TimePeriod
    max: int
    min: int
    start: TimeOfDay
    def __init__(self, length: _Optional[_Union[TimePeriod, _Mapping]] = ..., start: _Optional[_Union[TimeOfDay, _Mapping]] = ..., min: _Optional[int] = ..., max: _Optional[int] = ...) -> None: ...

class Scheduling(_message.Message):
    __slots__ = ["node_affinity"]
    NODE_AFFINITY_FIELD_NUMBER: _ClassVar[int]
    node_affinity: _containers.RepeatedCompositeFieldContainer[NodeAffinity]
    def __init__(self, node_affinity: _Optional[_Iterable[_Union[NodeAffinity, _Mapping]]] = ...) -> None: ...

class ServiceAccount(_message.Message):
    __slots__ = ["email", "scope"]
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    SCOPE_FIELD_NUMBER: _ClassVar[int]
    email: str
    scope: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, email: _Optional[str] = ..., scope: _Optional[_Iterable[str]] = ...) -> None: ...

class TimeOfDay(_message.Message):
    __slots__ = ["day", "location", "time"]
    DAY_FIELD_NUMBER: _ClassVar[int]
    LOCATION_FIELD_NUMBER: _ClassVar[int]
    TIME_FIELD_NUMBER: _ClassVar[int]
    day: _dayofweek_pb2.DayOfWeek
    location: str
    time: str
    def __init__(self, day: _Optional[_Union[_dayofweek_pb2.DayOfWeek, str]] = ..., location: _Optional[str] = ..., time: _Optional[str] = ...) -> None: ...

class TimePeriod(_message.Message):
    __slots__ = ["duration", "seconds"]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    SECONDS_FIELD_NUMBER: _ClassVar[int]
    duration: str
    seconds: int
    def __init__(self, duration: _Optional[str] = ..., seconds: _Optional[int] = ...) -> None: ...

class VM(_message.Message):
    __slots__ = ["disable_integrity_monitoring", "disable_vtpm", "disk", "enable_confidential_compute", "enable_secure_boot", "force_send_fields", "gcp_channel", "label", "machine_type", "metadata", "min_cpu_platform", "network_interface", "null_fields", "performance_monitoring_unit", "project", "scheduling", "service_account", "tag", "zone"]
    class LabelEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DISABLE_INTEGRITY_MONITORING_FIELD_NUMBER: _ClassVar[int]
    DISABLE_VTPM_FIELD_NUMBER: _ClassVar[int]
    DISK_FIELD_NUMBER: _ClassVar[int]
    ENABLE_CONFIDENTIAL_COMPUTE_FIELD_NUMBER: _ClassVar[int]
    ENABLE_SECURE_BOOT_FIELD_NUMBER: _ClassVar[int]
    FORCE_SEND_FIELDS_FIELD_NUMBER: _ClassVar[int]
    GCP_CHANNEL_FIELD_NUMBER: _ClassVar[int]
    LABEL_FIELD_NUMBER: _ClassVar[int]
    MACHINE_TYPE_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    MIN_CPU_PLATFORM_FIELD_NUMBER: _ClassVar[int]
    NETWORK_INTERFACE_FIELD_NUMBER: _ClassVar[int]
    NULL_FIELDS_FIELD_NUMBER: _ClassVar[int]
    PERFORMANCE_MONITORING_UNIT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    SCHEDULING_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    TAG_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    disable_integrity_monitoring: bool
    disable_vtpm: bool
    disk: _containers.RepeatedCompositeFieldContainer[Disk]
    enable_confidential_compute: bool
    enable_secure_boot: bool
    force_send_fields: _containers.RepeatedScalarFieldContainer[str]
    gcp_channel: GCPChannel
    label: _containers.ScalarMap[str, str]
    machine_type: str
    metadata: _containers.RepeatedCompositeFieldContainer[Metadata]
    min_cpu_platform: str
    network_interface: _containers.RepeatedCompositeFieldContainer[NetworkInterface]
    null_fields: _containers.RepeatedScalarFieldContainer[str]
    performance_monitoring_unit: PerformanceMonitoringUnit
    project: str
    scheduling: Scheduling
    service_account: _containers.RepeatedCompositeFieldContainer[ServiceAccount]
    tag: _containers.RepeatedScalarFieldContainer[str]
    zone: str
    def __init__(self, disk: _Optional[_Iterable[_Union[Disk, _Mapping]]] = ..., machine_type: _Optional[str] = ..., metadata: _Optional[_Iterable[_Union[Metadata, _Mapping]]] = ..., min_cpu_platform: _Optional[str] = ..., network_interface: _Optional[_Iterable[_Union[NetworkInterface, _Mapping]]] = ..., project: _Optional[str] = ..., service_account: _Optional[_Iterable[_Union[ServiceAccount, _Mapping]]] = ..., tag: _Optional[_Iterable[str]] = ..., zone: _Optional[str] = ..., scheduling: _Optional[_Union[Scheduling, _Mapping]] = ..., label: _Optional[_Mapping[str, str]] = ..., disable_integrity_monitoring: bool = ..., enable_secure_boot: bool = ..., disable_vtpm: bool = ..., enable_confidential_compute: bool = ..., force_send_fields: _Optional[_Iterable[str]] = ..., null_fields: _Optional[_Iterable[str]] = ..., gcp_channel: _Optional[_Union[GCPChannel, str]] = ..., performance_monitoring_unit: _Optional[_Union[PerformanceMonitoringUnit, str]] = ...) -> None: ...

class AccessConfigType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class DiskInterface(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class NodeAffinityOperator(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class GCPChannel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class PerformanceMonitoringUnit(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
