from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Buildbucket(_message.Message):
    __slots__ = ["hostname", "schedule_build_token"]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    SCHEDULE_BUILD_TOKEN_FIELD_NUMBER: _ClassVar[int]
    hostname: str
    schedule_build_token: str
    def __init__(self, hostname: _Optional[str] = ..., schedule_build_token: _Optional[str] = ...) -> None: ...

class Deadline(_message.Message):
    __slots__ = ["grace_period", "soft_deadline"]
    GRACE_PERIOD_FIELD_NUMBER: _ClassVar[int]
    SOFT_DEADLINE_FIELD_NUMBER: _ClassVar[int]
    grace_period: float
    soft_deadline: float
    def __init__(self, soft_deadline: _Optional[float] = ..., grace_period: _Optional[float] = ...) -> None: ...

class LUCIExe(_message.Message):
    __slots__ = ["cache_dir"]
    CACHE_DIR_FIELD_NUMBER: _ClassVar[int]
    cache_dir: str
    def __init__(self, cache_dir: _Optional[str] = ...) -> None: ...

class LocalAuth(_message.Message):
    __slots__ = ["accounts", "default_account_id", "rpc_port", "secret"]
    ACCOUNTS_FIELD_NUMBER: _ClassVar[int]
    DEFAULT_ACCOUNT_ID_FIELD_NUMBER: _ClassVar[int]
    RPC_PORT_FIELD_NUMBER: _ClassVar[int]
    SECRET_FIELD_NUMBER: _ClassVar[int]
    accounts: _containers.RepeatedCompositeFieldContainer[LocalAuthAccount]
    default_account_id: str
    rpc_port: int
    secret: bytes
    def __init__(self, rpc_port: _Optional[int] = ..., secret: _Optional[bytes] = ..., accounts: _Optional[_Iterable[_Union[LocalAuthAccount, _Mapping]]] = ..., default_account_id: _Optional[str] = ...) -> None: ...

class LocalAuthAccount(_message.Message):
    __slots__ = ["email", "id"]
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    email: str
    id: str
    def __init__(self, id: _Optional[str] = ..., email: _Optional[str] = ...) -> None: ...

class Realm(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class ResultDB(_message.Message):
    __slots__ = ["current_invocation", "hostname"]
    CURRENT_INVOCATION_FIELD_NUMBER: _ClassVar[int]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    current_invocation: ResultDBInvocation
    hostname: str
    def __init__(self, hostname: _Optional[str] = ..., current_invocation: _Optional[_Union[ResultDBInvocation, _Mapping]] = ...) -> None: ...

class ResultDBInvocation(_message.Message):
    __slots__ = ["name", "update_token"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    UPDATE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    name: str
    update_token: str
    def __init__(self, name: _Optional[str] = ..., update_token: _Optional[str] = ...) -> None: ...

class ResultSink(_message.Message):
    __slots__ = ["address", "auth_token"]
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    AUTH_TOKEN_FIELD_NUMBER: _ClassVar[int]
    address: str
    auth_token: str
    def __init__(self, address: _Optional[str] = ..., auth_token: _Optional[str] = ...) -> None: ...

class Swarming(_message.Message):
    __slots__ = ["secret_bytes", "task"]
    SECRET_BYTES_FIELD_NUMBER: _ClassVar[int]
    TASK_FIELD_NUMBER: _ClassVar[int]
    secret_bytes: bytes
    task: Task
    def __init__(self, secret_bytes: _Optional[bytes] = ..., task: _Optional[_Union[Task, _Mapping]] = ...) -> None: ...

class Task(_message.Message):
    __slots__ = ["bot_dimensions", "server", "task_id"]
    BOT_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    SERVER_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    bot_dimensions: _containers.RepeatedScalarFieldContainer[str]
    server: str
    task_id: str
    def __init__(self, server: _Optional[str] = ..., task_id: _Optional[str] = ..., bot_dimensions: _Optional[_Iterable[str]] = ...) -> None: ...
