from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CommitPosition(_message.Message):
    __slots__ = ["host", "position", "project", "ref"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    POSITION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    host: str
    position: int
    project: str
    ref: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., ref: _Optional[str] = ..., position: _Optional[int] = ...) -> None: ...

class CommitPositionRange(_message.Message):
    __slots__ = ["earliest", "latest"]
    EARLIEST_FIELD_NUMBER: _ClassVar[int]
    LATEST_FIELD_NUMBER: _ClassVar[int]
    earliest: CommitPosition
    latest: CommitPosition
    def __init__(self, earliest: _Optional[_Union[CommitPosition, _Mapping]] = ..., latest: _Optional[_Union[CommitPosition, _Mapping]] = ...) -> None: ...

class GerritChange(_message.Message):
    __slots__ = ["change", "host", "patchset", "project"]
    CHANGE_FIELD_NUMBER: _ClassVar[int]
    HOST_FIELD_NUMBER: _ClassVar[int]
    PATCHSET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    change: int
    host: str
    patchset: int
    project: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., change: _Optional[int] = ..., patchset: _Optional[int] = ...) -> None: ...

class GitilesCommit(_message.Message):
    __slots__ = ["commit_hash", "host", "position", "project", "ref"]
    COMMIT_HASH_FIELD_NUMBER: _ClassVar[int]
    HOST_FIELD_NUMBER: _ClassVar[int]
    POSITION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    commit_hash: str
    host: str
    position: int
    project: str
    ref: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., ref: _Optional[str] = ..., commit_hash: _Optional[str] = ..., position: _Optional[int] = ...) -> None: ...

class GitilesRef(_message.Message):
    __slots__ = ["host", "project", "ref"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    host: str
    project: str
    ref: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., ref: _Optional[str] = ...) -> None: ...

class SourceRef(_message.Message):
    __slots__ = ["gitiles"]
    GITILES_FIELD_NUMBER: _ClassVar[int]
    gitiles: GitilesRef
    def __init__(self, gitiles: _Optional[_Union[GitilesRef, _Mapping]] = ...) -> None: ...

class StringPair(_message.Message):
    __slots__ = ["key", "value"]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class TimeRange(_message.Message):
    __slots__ = ["earliest", "latest"]
    EARLIEST_FIELD_NUMBER: _ClassVar[int]
    LATEST_FIELD_NUMBER: _ClassVar[int]
    earliest: _timestamp_pb2.Timestamp
    latest: _timestamp_pb2.Timestamp
    def __init__(self, earliest: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., latest: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class Variant(_message.Message):
    __slots__ = []
    class DefEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    DEF_FIELD_NUMBER: _ClassVar[int]
    def __init__(self, **kwargs) -> None: ...
