from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import struct_pb2 as _struct_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import predicate as _predicate_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BigQueryExport(_message.Message):
    __slots__ = ["dataset", "project", "table", "test_results", "text_artifacts"]
    class TestResults(_message.Message):
        __slots__ = ["predicate"]
        PREDICATE_FIELD_NUMBER: _ClassVar[int]
        predicate: _predicate_pb2.TestResultPredicate
        def __init__(self, predicate: _Optional[_Union[_predicate_pb2.TestResultPredicate, _Mapping]] = ...) -> None: ...
    class TextArtifacts(_message.Message):
        __slots__ = ["predicate"]
        PREDICATE_FIELD_NUMBER: _ClassVar[int]
        predicate: _predicate_pb2.ArtifactPredicate
        def __init__(self, predicate: _Optional[_Union[_predicate_pb2.ArtifactPredicate, _Mapping]] = ...) -> None: ...
    DATASET_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    TABLE_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULTS_FIELD_NUMBER: _ClassVar[int]
    TEXT_ARTIFACTS_FIELD_NUMBER: _ClassVar[int]
    dataset: str
    project: str
    table: str
    test_results: BigQueryExport.TestResults
    text_artifacts: BigQueryExport.TextArtifacts
    def __init__(self, project: _Optional[str] = ..., dataset: _Optional[str] = ..., table: _Optional[str] = ..., test_results: _Optional[_Union[BigQueryExport.TestResults, _Mapping]] = ..., text_artifacts: _Optional[_Union[BigQueryExport.TextArtifacts, _Mapping]] = ...) -> None: ...

class HistoryOptions(_message.Message):
    __slots__ = ["commit", "use_invocation_timestamp"]
    COMMIT_FIELD_NUMBER: _ClassVar[int]
    USE_INVOCATION_TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    commit: _common_pb2.CommitPosition
    use_invocation_timestamp: bool
    def __init__(self, use_invocation_timestamp: bool = ..., commit: _Optional[_Union[_common_pb2.CommitPosition, _Mapping]] = ...) -> None: ...

class Invocation(_message.Message):
    __slots__ = ["baseline_id", "bigquery_exports", "create_time", "created_by", "deadline", "finalize_time", "history_options", "included_invocations", "name", "producer_resource", "properties", "realm", "source_spec", "state", "tags"]
    class State(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    ACTIVE: Invocation.State
    BASELINE_ID_FIELD_NUMBER: _ClassVar[int]
    BIGQUERY_EXPORTS_FIELD_NUMBER: _ClassVar[int]
    CREATED_BY_FIELD_NUMBER: _ClassVar[int]
    CREATE_TIME_FIELD_NUMBER: _ClassVar[int]
    DEADLINE_FIELD_NUMBER: _ClassVar[int]
    FINALIZED: Invocation.State
    FINALIZE_TIME_FIELD_NUMBER: _ClassVar[int]
    FINALIZING: Invocation.State
    HISTORY_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    INCLUDED_INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PRODUCER_RESOURCE_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    SOURCE_SPEC_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    STATE_UNSPECIFIED: Invocation.State
    TAGS_FIELD_NUMBER: _ClassVar[int]
    baseline_id: str
    bigquery_exports: _containers.RepeatedCompositeFieldContainer[BigQueryExport]
    create_time: _timestamp_pb2.Timestamp
    created_by: str
    deadline: _timestamp_pb2.Timestamp
    finalize_time: _timestamp_pb2.Timestamp
    history_options: HistoryOptions
    included_invocations: _containers.RepeatedScalarFieldContainer[str]
    name: str
    producer_resource: str
    properties: _struct_pb2.Struct
    realm: str
    source_spec: SourceSpec
    state: Invocation.State
    tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    def __init__(self, name: _Optional[str] = ..., state: _Optional[_Union[Invocation.State, str]] = ..., create_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., finalize_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., deadline: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., included_invocations: _Optional[_Iterable[str]] = ..., bigquery_exports: _Optional[_Iterable[_Union[BigQueryExport, _Mapping]]] = ..., created_by: _Optional[str] = ..., producer_resource: _Optional[str] = ..., realm: _Optional[str] = ..., history_options: _Optional[_Union[HistoryOptions, _Mapping]] = ..., properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., source_spec: _Optional[_Union[SourceSpec, _Mapping]] = ..., baseline_id: _Optional[str] = ...) -> None: ...

class SourceSpec(_message.Message):
    __slots__ = ["inherit", "sources"]
    INHERIT_FIELD_NUMBER: _ClassVar[int]
    SOURCES_FIELD_NUMBER: _ClassVar[int]
    inherit: bool
    sources: Sources
    def __init__(self, sources: _Optional[_Union[Sources, _Mapping]] = ..., inherit: bool = ...) -> None: ...

class Sources(_message.Message):
    __slots__ = ["changelists", "gitiles_commit", "is_dirty"]
    CHANGELISTS_FIELD_NUMBER: _ClassVar[int]
    GITILES_COMMIT_FIELD_NUMBER: _ClassVar[int]
    IS_DIRTY_FIELD_NUMBER: _ClassVar[int]
    changelists: _containers.RepeatedCompositeFieldContainer[_common_pb2.GerritChange]
    gitiles_commit: _common_pb2.GitilesCommit
    is_dirty: bool
    def __init__(self, gitiles_commit: _Optional[_Union[_common_pb2.GitilesCommit, _Mapping]] = ..., changelists: _Optional[_Iterable[_Union[_common_pb2.GerritChange, _Mapping]]] = ..., is_dirty: bool = ...) -> None: ...
