from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import field_mask_pb2 as _field_mask_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import artifact as _artifact_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import invocation as _invocation_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import predicate as _predicate_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import test_result as _test_result_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import test_variant as _test_variant_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import test_metadata as _test_metadata_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BatchGetTestVariantsRequest(_message.Message):
    __slots__ = ["invocation", "result_limit", "test_variants"]
    class TestVariantIdentifier(_message.Message):
        __slots__ = ["test_id", "variant_hash"]
        TEST_ID_FIELD_NUMBER: _ClassVar[int]
        VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
        test_id: str
        variant_hash: str
        def __init__(self, test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ...) -> None: ...
    INVOCATION_FIELD_NUMBER: _ClassVar[int]
    RESULT_LIMIT_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    invocation: str
    result_limit: int
    test_variants: _containers.RepeatedCompositeFieldContainer[BatchGetTestVariantsRequest.TestVariantIdentifier]
    def __init__(self, invocation: _Optional[str] = ..., test_variants: _Optional[_Iterable[_Union[BatchGetTestVariantsRequest.TestVariantIdentifier, _Mapping]]] = ..., result_limit: _Optional[int] = ...) -> None: ...

class BatchGetTestVariantsResponse(_message.Message):
    __slots__ = ["sources", "test_variants"]
    class SourcesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _invocation_pb2.Sources
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_invocation_pb2.Sources, _Mapping]] = ...) -> None: ...
    SOURCES_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    sources: _containers.MessageMap[str, _invocation_pb2.Sources]
    test_variants: _containers.RepeatedCompositeFieldContainer[_test_variant_pb2.TestVariant]
    def __init__(self, test_variants: _Optional[_Iterable[_Union[_test_variant_pb2.TestVariant, _Mapping]]] = ..., sources: _Optional[_Mapping[str, _invocation_pb2.Sources]] = ...) -> None: ...

class GetArtifactRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class GetInvocationRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class GetTestExonerationRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class GetTestResultRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class ListArtifactsRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "parent"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PARENT_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    parent: str
    def __init__(self, parent: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class ListArtifactsResponse(_message.Message):
    __slots__ = ["artifacts", "next_page_token"]
    ARTIFACTS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    artifacts: _containers.RepeatedCompositeFieldContainer[_artifact_pb2.Artifact]
    next_page_token: str
    def __init__(self, artifacts: _Optional[_Iterable[_Union[_artifact_pb2.Artifact, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class ListTestExonerationsRequest(_message.Message):
    __slots__ = ["invocation", "page_size", "page_token"]
    INVOCATION_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    invocation: str
    page_size: int
    page_token: str
    def __init__(self, invocation: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class ListTestExonerationsResponse(_message.Message):
    __slots__ = ["next_page_token", "test_exonerations"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TEST_EXONERATIONS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    test_exonerations: _containers.RepeatedCompositeFieldContainer[_test_result_pb2.TestExoneration]
    def __init__(self, test_exonerations: _Optional[_Iterable[_Union[_test_result_pb2.TestExoneration, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class ListTestResultsRequest(_message.Message):
    __slots__ = ["invocation", "page_size", "page_token", "read_mask"]
    INVOCATION_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    READ_MASK_FIELD_NUMBER: _ClassVar[int]
    invocation: str
    page_size: int
    page_token: str
    read_mask: _field_mask_pb2.FieldMask
    def __init__(self, invocation: _Optional[str] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ..., read_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class ListTestResultsResponse(_message.Message):
    __slots__ = ["next_page_token", "test_results"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULTS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    test_results: _containers.RepeatedCompositeFieldContainer[_test_result_pb2.TestResult]
    def __init__(self, test_results: _Optional[_Iterable[_Union[_test_result_pb2.TestResult, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryArtifactsRequest(_message.Message):
    __slots__ = ["invocations", "page_size", "page_token", "predicate"]
    INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    invocations: _containers.RepeatedScalarFieldContainer[str]
    page_size: int
    page_token: str
    predicate: _predicate_pb2.ArtifactPredicate
    def __init__(self, invocations: _Optional[_Iterable[str]] = ..., predicate: _Optional[_Union[_predicate_pb2.ArtifactPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryArtifactsResponse(_message.Message):
    __slots__ = ["artifacts", "next_page_token"]
    ARTIFACTS_FIELD_NUMBER: _ClassVar[int]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    artifacts: _containers.RepeatedCompositeFieldContainer[_artifact_pb2.Artifact]
    next_page_token: str
    def __init__(self, artifacts: _Optional[_Iterable[_Union[_artifact_pb2.Artifact, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryNewTestVariantsRequest(_message.Message):
    __slots__ = ["baseline", "invocation"]
    BASELINE_FIELD_NUMBER: _ClassVar[int]
    INVOCATION_FIELD_NUMBER: _ClassVar[int]
    baseline: str
    invocation: str
    def __init__(self, invocation: _Optional[str] = ..., baseline: _Optional[str] = ...) -> None: ...

class QueryNewTestVariantsResponse(_message.Message):
    __slots__ = ["is_baseline_ready", "new_test_variants"]
    class NewTestVariant(_message.Message):
        __slots__ = ["test_id", "variant_hash"]
        TEST_ID_FIELD_NUMBER: _ClassVar[int]
        VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
        test_id: str
        variant_hash: str
        def __init__(self, test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ...) -> None: ...
    IS_BASELINE_READY_FIELD_NUMBER: _ClassVar[int]
    NEW_TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    is_baseline_ready: bool
    new_test_variants: _containers.RepeatedCompositeFieldContainer[QueryNewTestVariantsResponse.NewTestVariant]
    def __init__(self, is_baseline_ready: bool = ..., new_test_variants: _Optional[_Iterable[_Union[QueryNewTestVariantsResponse.NewTestVariant, _Mapping]]] = ...) -> None: ...

class QueryTestExonerationsRequest(_message.Message):
    __slots__ = ["invocations", "page_size", "page_token", "predicate"]
    INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    invocations: _containers.RepeatedScalarFieldContainer[str]
    page_size: int
    page_token: str
    predicate: _predicate_pb2.TestExonerationPredicate
    def __init__(self, invocations: _Optional[_Iterable[str]] = ..., predicate: _Optional[_Union[_predicate_pb2.TestExonerationPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryTestExonerationsResponse(_message.Message):
    __slots__ = ["next_page_token", "test_exonerations"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TEST_EXONERATIONS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    test_exonerations: _containers.RepeatedCompositeFieldContainer[_test_result_pb2.TestExoneration]
    def __init__(self, test_exonerations: _Optional[_Iterable[_Union[_test_result_pb2.TestExoneration, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryTestMetadataRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "predicate", "project"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    predicate: _predicate_pb2.TestMetadataPredicate
    project: str
    def __init__(self, project: _Optional[str] = ..., predicate: _Optional[_Union[_predicate_pb2.TestMetadataPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QueryTestMetadataResponse(_message.Message):
    __slots__ = ["next_page_token", "testMetadata"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TESTMETADATA_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    testMetadata: _containers.RepeatedCompositeFieldContainer[_test_metadata_pb2.TestMetadataDetail]
    def __init__(self, testMetadata: _Optional[_Iterable[_Union[_test_metadata_pb2.TestMetadataDetail, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryTestResultStatisticsRequest(_message.Message):
    __slots__ = ["invocations"]
    INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    invocations: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, invocations: _Optional[_Iterable[str]] = ...) -> None: ...

class QueryTestResultStatisticsResponse(_message.Message):
    __slots__ = ["total_test_results"]
    TOTAL_TEST_RESULTS_FIELD_NUMBER: _ClassVar[int]
    total_test_results: int
    def __init__(self, total_test_results: _Optional[int] = ...) -> None: ...

class QueryTestResultsRequest(_message.Message):
    __slots__ = ["invocations", "page_size", "page_token", "predicate", "read_mask"]
    INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    READ_MASK_FIELD_NUMBER: _ClassVar[int]
    invocations: _containers.RepeatedScalarFieldContainer[str]
    page_size: int
    page_token: str
    predicate: _predicate_pb2.TestResultPredicate
    read_mask: _field_mask_pb2.FieldMask
    def __init__(self, invocations: _Optional[_Iterable[str]] = ..., predicate: _Optional[_Union[_predicate_pb2.TestResultPredicate, _Mapping]] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ..., read_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class QueryTestResultsResponse(_message.Message):
    __slots__ = ["next_page_token", "test_results"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    TEST_RESULTS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    test_results: _containers.RepeatedCompositeFieldContainer[_test_result_pb2.TestResult]
    def __init__(self, test_results: _Optional[_Iterable[_Union[_test_result_pb2.TestResult, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class QueryTestVariantsRequest(_message.Message):
    __slots__ = ["invocations", "page_size", "page_token", "predicate", "read_mask", "result_limit"]
    INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    READ_MASK_FIELD_NUMBER: _ClassVar[int]
    RESULT_LIMIT_FIELD_NUMBER: _ClassVar[int]
    invocations: _containers.RepeatedScalarFieldContainer[str]
    page_size: int
    page_token: str
    predicate: _test_variant_pb2.TestVariantPredicate
    read_mask: _field_mask_pb2.FieldMask
    result_limit: int
    def __init__(self, invocations: _Optional[_Iterable[str]] = ..., predicate: _Optional[_Union[_test_variant_pb2.TestVariantPredicate, _Mapping]] = ..., result_limit: _Optional[int] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ..., read_mask: _Optional[_Union[_field_mask_pb2.FieldMask, _Mapping]] = ...) -> None: ...

class QueryTestVariantsResponse(_message.Message):
    __slots__ = ["next_page_token", "sources", "test_variants"]
    class SourcesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _invocation_pb2.Sources
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_invocation_pb2.Sources, _Mapping]] = ...) -> None: ...
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SOURCES_FIELD_NUMBER: _ClassVar[int]
    TEST_VARIANTS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    sources: _containers.MessageMap[str, _invocation_pb2.Sources]
    test_variants: _containers.RepeatedCompositeFieldContainer[_test_variant_pb2.TestVariant]
    def __init__(self, test_variants: _Optional[_Iterable[_Union[_test_variant_pb2.TestVariant, _Mapping]]] = ..., next_page_token: _Optional[str] = ..., sources: _Optional[_Mapping[str, _invocation_pb2.Sources]] = ...) -> None: ...
