from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf import struct_pb2 as _struct_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import test_metadata as _test_metadata_pb2
from PB.go.chromium.org.luci.resultdb.proto.v1 import failure_reason as _failure_reason_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

ABORT: TestStatus
AUTOMATICALLY_DISABLED_FOR_FLAKINESS: SkipReason
CRASH: TestStatus
DESCRIPTOR: _descriptor.FileDescriptor
EXONERATION_REASON_UNSPECIFIED: ExonerationReason
FAIL: TestStatus
NOT_CRITICAL: ExonerationReason
OCCURS_ON_MAINLINE: ExonerationReason
OCCURS_ON_OTHER_CLS: ExonerationReason
PASS: TestStatus
SKIP: TestStatus
SKIP_REASON_UNSPECIFIED: SkipReason
STATUS_UNSPECIFIED: TestStatus
UNEXPECTED_PASS: ExonerationReason

class TestExoneration(_message.Message):
    __slots__ = ["exoneration_id", "explanation_html", "is_masked", "name", "reason", "test_id", "variant", "variant_hash"]
    EXONERATION_ID_FIELD_NUMBER: _ClassVar[int]
    EXPLANATION_HTML_FIELD_NUMBER: _ClassVar[int]
    IS_MASKED_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    REASON_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    exoneration_id: str
    explanation_html: str
    is_masked: bool
    name: str
    reason: ExonerationReason
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, name: _Optional[str] = ..., test_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., exoneration_id: _Optional[str] = ..., explanation_html: _Optional[str] = ..., variant_hash: _Optional[str] = ..., reason: _Optional[_Union[ExonerationReason, str]] = ..., is_masked: bool = ...) -> None: ...

class TestResult(_message.Message):
    __slots__ = ["duration", "expected", "failure_reason", "is_masked", "name", "properties", "result_id", "skip_reason", "start_time", "status", "summary_html", "tags", "test_id", "test_metadata", "variant", "variant_hash"]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_FIELD_NUMBER: _ClassVar[int]
    FAILURE_REASON_FIELD_NUMBER: _ClassVar[int]
    IS_MASKED_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    RESULT_ID_FIELD_NUMBER: _ClassVar[int]
    SKIP_REASON_FIELD_NUMBER: _ClassVar[int]
    START_TIME_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    SUMMARY_HTML_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    TEST_METADATA_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    duration: _duration_pb2.Duration
    expected: bool
    failure_reason: _failure_reason_pb2.FailureReason
    is_masked: bool
    name: str
    properties: _struct_pb2.Struct
    result_id: str
    skip_reason: SkipReason
    start_time: _timestamp_pb2.Timestamp
    status: TestStatus
    summary_html: str
    tags: _containers.RepeatedCompositeFieldContainer[_common_pb2.StringPair]
    test_id: str
    test_metadata: _test_metadata_pb2.TestMetadata
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, name: _Optional[str] = ..., test_id: _Optional[str] = ..., result_id: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., expected: bool = ..., status: _Optional[_Union[TestStatus, str]] = ..., summary_html: _Optional[str] = ..., start_time: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., duration: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ..., tags: _Optional[_Iterable[_Union[_common_pb2.StringPair, _Mapping]]] = ..., variant_hash: _Optional[str] = ..., test_metadata: _Optional[_Union[_test_metadata_pb2.TestMetadata, _Mapping]] = ..., failure_reason: _Optional[_Union[_failure_reason_pb2.FailureReason, _Mapping]] = ..., properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., is_masked: bool = ..., skip_reason: _Optional[_Union[SkipReason, str]] = ...) -> None: ...

class TestStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class SkipReason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class ExonerationReason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
