from PB.go.chromium.org.luci.common.proto import options as _options_pb2
from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Acl(_message.Message):
    __slots__ = ["granted_to", "role"]
    class Role(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    GRANTED_TO_FIELD_NUMBER: _ClassVar[int]
    OWNER: Acl.Role
    READER: Acl.Role
    ROLE_FIELD_NUMBER: _ClassVar[int]
    TRIGGERER: Acl.Role
    granted_to: str
    role: Acl.Role
    def __init__(self, role: _Optional[_Union[Acl.Role, str]] = ..., granted_to: _Optional[str] = ...) -> None: ...

class AclSet(_message.Message):
    __slots__ = ["acls", "name"]
    ACLS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    acls: _containers.RepeatedCompositeFieldContainer[Acl]
    name: str
    def __init__(self, name: _Optional[str] = ..., acls: _Optional[_Iterable[_Union[Acl, _Mapping]]] = ...) -> None: ...

class BuildbucketTask(_message.Message):
    __slots__ = ["bucket", "builder", "properties", "server", "tags"]
    BUCKET_FIELD_NUMBER: _ClassVar[int]
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    SERVER_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    bucket: str
    builder: str
    properties: _containers.RepeatedScalarFieldContainer[str]
    server: str
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, server: _Optional[str] = ..., bucket: _Optional[str] = ..., builder: _Optional[str] = ..., properties: _Optional[_Iterable[str]] = ..., tags: _Optional[_Iterable[str]] = ...) -> None: ...

class GitilesTask(_message.Message):
    __slots__ = ["path_regexps", "path_regexps_exclude", "refs", "repo"]
    PATH_REGEXPS_EXCLUDE_FIELD_NUMBER: _ClassVar[int]
    PATH_REGEXPS_FIELD_NUMBER: _ClassVar[int]
    REFS_FIELD_NUMBER: _ClassVar[int]
    REPO_FIELD_NUMBER: _ClassVar[int]
    path_regexps: _containers.RepeatedScalarFieldContainer[str]
    path_regexps_exclude: _containers.RepeatedScalarFieldContainer[str]
    refs: _containers.RepeatedScalarFieldContainer[str]
    repo: str
    def __init__(self, repo: _Optional[str] = ..., refs: _Optional[_Iterable[str]] = ..., path_regexps: _Optional[_Iterable[str]] = ..., path_regexps_exclude: _Optional[_Iterable[str]] = ...) -> None: ...

class Job(_message.Message):
    __slots__ = ["acl_sets", "acls", "buildbucket", "disabled", "id", "noop", "realm", "schedule", "triggering_policy", "url_fetch"]
    ACLS_FIELD_NUMBER: _ClassVar[int]
    ACL_SETS_FIELD_NUMBER: _ClassVar[int]
    BUILDBUCKET_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    NOOP_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    TRIGGERING_POLICY_FIELD_NUMBER: _ClassVar[int]
    URL_FETCH_FIELD_NUMBER: _ClassVar[int]
    acl_sets: _containers.RepeatedScalarFieldContainer[str]
    acls: _containers.RepeatedCompositeFieldContainer[Acl]
    buildbucket: BuildbucketTask
    disabled: bool
    id: str
    noop: NoopTask
    realm: str
    schedule: str
    triggering_policy: TriggeringPolicy
    url_fetch: UrlFetchTask
    def __init__(self, id: _Optional[str] = ..., realm: _Optional[str] = ..., schedule: _Optional[str] = ..., disabled: bool = ..., acls: _Optional[_Iterable[_Union[Acl, _Mapping]]] = ..., acl_sets: _Optional[_Iterable[str]] = ..., triggering_policy: _Optional[_Union[TriggeringPolicy, _Mapping]] = ..., noop: _Optional[_Union[NoopTask, _Mapping]] = ..., url_fetch: _Optional[_Union[UrlFetchTask, _Mapping]] = ..., buildbucket: _Optional[_Union[BuildbucketTask, _Mapping]] = ...) -> None: ...

class NoopTask(_message.Message):
    __slots__ = ["sleep_ms", "triggers_count"]
    SLEEP_MS_FIELD_NUMBER: _ClassVar[int]
    TRIGGERS_COUNT_FIELD_NUMBER: _ClassVar[int]
    sleep_ms: int
    triggers_count: int
    def __init__(self, sleep_ms: _Optional[int] = ..., triggers_count: _Optional[int] = ...) -> None: ...

class ProjectConfig(_message.Message):
    __slots__ = ["acl_sets", "job", "trigger"]
    ACL_SETS_FIELD_NUMBER: _ClassVar[int]
    JOB_FIELD_NUMBER: _ClassVar[int]
    TRIGGER_FIELD_NUMBER: _ClassVar[int]
    acl_sets: _containers.RepeatedCompositeFieldContainer[AclSet]
    job: _containers.RepeatedCompositeFieldContainer[Job]
    trigger: _containers.RepeatedCompositeFieldContainer[Trigger]
    def __init__(self, job: _Optional[_Iterable[_Union[Job, _Mapping]]] = ..., trigger: _Optional[_Iterable[_Union[Trigger, _Mapping]]] = ..., acl_sets: _Optional[_Iterable[_Union[AclSet, _Mapping]]] = ...) -> None: ...

class TaskDefWrapper(_message.Message):
    __slots__ = ["buildbucket", "gitiles", "noop", "url_fetch"]
    BUILDBUCKET_FIELD_NUMBER: _ClassVar[int]
    GITILES_FIELD_NUMBER: _ClassVar[int]
    NOOP_FIELD_NUMBER: _ClassVar[int]
    URL_FETCH_FIELD_NUMBER: _ClassVar[int]
    buildbucket: BuildbucketTask
    gitiles: GitilesTask
    noop: NoopTask
    url_fetch: UrlFetchTask
    def __init__(self, noop: _Optional[_Union[NoopTask, _Mapping]] = ..., url_fetch: _Optional[_Union[UrlFetchTask, _Mapping]] = ..., buildbucket: _Optional[_Union[BuildbucketTask, _Mapping]] = ..., gitiles: _Optional[_Union[GitilesTask, _Mapping]] = ...) -> None: ...

class Trigger(_message.Message):
    __slots__ = ["acl_sets", "acls", "disabled", "gitiles", "id", "noop", "realm", "schedule", "triggering_policy", "triggers"]
    ACLS_FIELD_NUMBER: _ClassVar[int]
    ACL_SETS_FIELD_NUMBER: _ClassVar[int]
    DISABLED_FIELD_NUMBER: _ClassVar[int]
    GITILES_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    NOOP_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    SCHEDULE_FIELD_NUMBER: _ClassVar[int]
    TRIGGERING_POLICY_FIELD_NUMBER: _ClassVar[int]
    TRIGGERS_FIELD_NUMBER: _ClassVar[int]
    acl_sets: _containers.RepeatedScalarFieldContainer[str]
    acls: _containers.RepeatedCompositeFieldContainer[Acl]
    disabled: bool
    gitiles: GitilesTask
    id: str
    noop: NoopTask
    realm: str
    schedule: str
    triggering_policy: TriggeringPolicy
    triggers: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, id: _Optional[str] = ..., realm: _Optional[str] = ..., schedule: _Optional[str] = ..., disabled: bool = ..., acls: _Optional[_Iterable[_Union[Acl, _Mapping]]] = ..., acl_sets: _Optional[_Iterable[str]] = ..., triggering_policy: _Optional[_Union[TriggeringPolicy, _Mapping]] = ..., triggers: _Optional[_Iterable[str]] = ..., noop: _Optional[_Union[NoopTask, _Mapping]] = ..., gitiles: _Optional[_Union[GitilesTask, _Mapping]] = ...) -> None: ...

class TriggeringPolicy(_message.Message):
    __slots__ = ["kind", "log_base", "max_batch_size", "max_concurrent_invocations", "pending_timeout"]
    class Kind(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    GREEDY_BATCHING: TriggeringPolicy.Kind
    KIND_FIELD_NUMBER: _ClassVar[int]
    LOGARITHMIC_BATCHING: TriggeringPolicy.Kind
    LOG_BASE_FIELD_NUMBER: _ClassVar[int]
    MAX_BATCH_SIZE_FIELD_NUMBER: _ClassVar[int]
    MAX_CONCURRENT_INVOCATIONS_FIELD_NUMBER: _ClassVar[int]
    NEWEST_FIRST: TriggeringPolicy.Kind
    PENDING_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    UNDEFINED: TriggeringPolicy.Kind
    kind: TriggeringPolicy.Kind
    log_base: float
    max_batch_size: int
    max_concurrent_invocations: int
    pending_timeout: _duration_pb2.Duration
    def __init__(self, kind: _Optional[_Union[TriggeringPolicy.Kind, str]] = ..., max_concurrent_invocations: _Optional[int] = ..., max_batch_size: _Optional[int] = ..., log_base: _Optional[float] = ..., pending_timeout: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...

class UrlFetchTask(_message.Message):
    __slots__ = ["method", "timeout_sec", "url"]
    METHOD_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_SEC_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    method: str
    timeout_sec: int
    url: str
    def __init__(self, method: _Optional[str] = ..., url: _Optional[str] = ..., timeout_sec: _Optional[int] = ...) -> None: ...
