from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.google.rpc import status as _status_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

AUTO: ContainmentType
BOT_DIED: TaskState
CANCELED: TaskState
CLIENT_ERROR: TaskState
COMPLETED: TaskState
DESCRIPTOR: _descriptor.FileDescriptor
EXPIRED: TaskState
FALSE: NullableBool
INVALID: TaskState
JOB_OBJECT: ContainmentType
KILLED: TaskState
NONE: ContainmentType
NOT_SPECIFIED: ContainmentType
NO_RESOURCE: TaskState
NULL: NullableBool
PENDING: TaskState
QUERY_ABANDONED_TS: SortQuery
QUERY_ALL: StateQuery
QUERY_BOT_DIED: StateQuery
QUERY_CANCELED: StateQuery
QUERY_CLIENT_ERROR: StateQuery
QUERY_COMPLETED: StateQuery
QUERY_COMPLETED_FAILURE: StateQuery
QUERY_COMPLETED_SUCCESS: StateQuery
QUERY_COMPLETED_TS: SortQuery
QUERY_CREATED_TS: SortQuery
QUERY_DEDUPED: StateQuery
QUERY_EXPIRED: StateQuery
QUERY_KILLED: StateQuery
QUERY_NO_RESOURCE: StateQuery
QUERY_PENDING: StateQuery
QUERY_PENDING_RUNNING: StateQuery
QUERY_RUNNING: StateQuery
QUERY_STARTED_TS: SortQuery
QUERY_TIMED_OUT: StateQuery
RUNNING: TaskState
TIMED_OUT: TaskState
TRUE: NullableBool

class BatchGetResultRequest(_message.Message):
    __slots__ = ["include_performance_stats", "task_ids"]
    INCLUDE_PERFORMANCE_STATS_FIELD_NUMBER: _ClassVar[int]
    TASK_IDS_FIELD_NUMBER: _ClassVar[int]
    include_performance_stats: bool
    task_ids: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, task_ids: _Optional[_Iterable[str]] = ..., include_performance_stats: bool = ...) -> None: ...

class BatchGetResultResponse(_message.Message):
    __slots__ = ["results"]
    class ResultOrError(_message.Message):
        __slots__ = ["error", "result", "task_id"]
        ERROR_FIELD_NUMBER: _ClassVar[int]
        RESULT_FIELD_NUMBER: _ClassVar[int]
        TASK_ID_FIELD_NUMBER: _ClassVar[int]
        error: _status_pb2.Status
        result: TaskResultResponse
        task_id: str
        def __init__(self, task_id: _Optional[str] = ..., result: _Optional[_Union[TaskResultResponse, _Mapping]] = ..., error: _Optional[_Union[_status_pb2.Status, _Mapping]] = ...) -> None: ...
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    results: _containers.RepeatedCompositeFieldContainer[BatchGetResultResponse.ResultOrError]
    def __init__(self, results: _Optional[_Iterable[_Union[BatchGetResultResponse.ResultOrError, _Mapping]]] = ...) -> None: ...

class BootstrapToken(_message.Message):
    __slots__ = ["bootstrap_token"]
    BOOTSTRAP_TOKEN_FIELD_NUMBER: _ClassVar[int]
    bootstrap_token: str
    def __init__(self, bootstrap_token: _Optional[str] = ...) -> None: ...

class BotEventResponse(_message.Message):
    __slots__ = ["authenticated_as", "dimensions", "event_type", "external_ip", "maintenance_msg", "message", "quarantined", "state", "task_id", "ts", "version"]
    AUTHENTICATED_AS_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    EVENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    EXTERNAL_IP_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_MSG_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    QUARANTINED_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    TS_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    authenticated_as: str
    dimensions: _containers.RepeatedCompositeFieldContainer[StringListPair]
    event_type: str
    external_ip: str
    maintenance_msg: str
    message: str
    quarantined: bool
    state: str
    task_id: str
    ts: _timestamp_pb2.Timestamp
    version: str
    def __init__(self, ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., event_type: _Optional[str] = ..., message: _Optional[str] = ..., dimensions: _Optional[_Iterable[_Union[StringListPair, _Mapping]]] = ..., state: _Optional[str] = ..., external_ip: _Optional[str] = ..., authenticated_as: _Optional[str] = ..., version: _Optional[str] = ..., quarantined: bool = ..., maintenance_msg: _Optional[str] = ..., task_id: _Optional[str] = ...) -> None: ...

class BotEventsRequest(_message.Message):
    __slots__ = ["bot_id", "cursor", "end", "limit", "start"]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    bot_id: str
    cursor: str
    end: _timestamp_pb2.Timestamp
    limit: int
    start: _timestamp_pb2.Timestamp
    def __init__(self, bot_id: _Optional[str] = ..., limit: _Optional[int] = ..., cursor: _Optional[str] = ..., start: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class BotEventsResponse(_message.Message):
    __slots__ = ["cursor", "items", "now"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    items: _containers.RepeatedCompositeFieldContainer[BotEventResponse]
    now: _timestamp_pb2.Timestamp
    def __init__(self, cursor: _Optional[str] = ..., items: _Optional[_Iterable[_Union[BotEventResponse, _Mapping]]] = ..., now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class BotInfo(_message.Message):
    __slots__ = ["authenticated_as", "bot_id", "deleted", "dimensions", "external_ip", "first_seen_ts", "is_dead", "last_seen_ts", "maintenance_msg", "quarantined", "state", "task_id", "task_name", "version"]
    AUTHENTICATED_AS_FIELD_NUMBER: _ClassVar[int]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    DELETED_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    EXTERNAL_IP_FIELD_NUMBER: _ClassVar[int]
    FIRST_SEEN_TS_FIELD_NUMBER: _ClassVar[int]
    IS_DEAD_FIELD_NUMBER: _ClassVar[int]
    LAST_SEEN_TS_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_MSG_FIELD_NUMBER: _ClassVar[int]
    QUARANTINED_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    TASK_NAME_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    authenticated_as: str
    bot_id: str
    deleted: bool
    dimensions: _containers.RepeatedCompositeFieldContainer[StringListPair]
    external_ip: str
    first_seen_ts: _timestamp_pb2.Timestamp
    is_dead: bool
    last_seen_ts: _timestamp_pb2.Timestamp
    maintenance_msg: str
    quarantined: bool
    state: str
    task_id: str
    task_name: str
    version: str
    def __init__(self, bot_id: _Optional[str] = ..., task_id: _Optional[str] = ..., external_ip: _Optional[str] = ..., authenticated_as: _Optional[str] = ..., first_seen_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., is_dead: bool = ..., last_seen_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., quarantined: bool = ..., maintenance_msg: _Optional[str] = ..., dimensions: _Optional[_Iterable[_Union[StringListPair, _Mapping]]] = ..., task_name: _Optional[str] = ..., version: _Optional[str] = ..., state: _Optional[str] = ..., deleted: bool = ...) -> None: ...

class BotInfoListResponse(_message.Message):
    __slots__ = ["cursor", "death_timeout", "items", "now"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    DEATH_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    death_timeout: int
    items: _containers.RepeatedCompositeFieldContainer[BotInfo]
    now: _timestamp_pb2.Timestamp
    def __init__(self, cursor: _Optional[str] = ..., items: _Optional[_Iterable[_Union[BotInfo, _Mapping]]] = ..., now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., death_timeout: _Optional[int] = ...) -> None: ...

class BotRequest(_message.Message):
    __slots__ = ["bot_id"]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    bot_id: str
    def __init__(self, bot_id: _Optional[str] = ...) -> None: ...

class BotTasksRequest(_message.Message):
    __slots__ = ["bot_id", "cursor", "end", "include_performance_stats", "limit", "sort", "start", "state"]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_PERFORMANCE_STATS_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    SORT_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    bot_id: str
    cursor: str
    end: _timestamp_pb2.Timestamp
    include_performance_stats: bool
    limit: int
    sort: SortQuery
    start: _timestamp_pb2.Timestamp
    state: StateQuery
    def __init__(self, bot_id: _Optional[str] = ..., limit: _Optional[int] = ..., cursor: _Optional[str] = ..., start: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., state: _Optional[_Union[StateQuery, str]] = ..., sort: _Optional[_Union[SortQuery, str]] = ..., include_performance_stats: bool = ...) -> None: ...

class BotsCount(_message.Message):
    __slots__ = ["busy", "count", "dead", "maintenance", "now", "quarantined"]
    BUSY_FIELD_NUMBER: _ClassVar[int]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    DEAD_FIELD_NUMBER: _ClassVar[int]
    MAINTENANCE_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    QUARANTINED_FIELD_NUMBER: _ClassVar[int]
    busy: int
    count: int
    dead: int
    maintenance: int
    now: _timestamp_pb2.Timestamp
    quarantined: int
    def __init__(self, now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., count: _Optional[int] = ..., quarantined: _Optional[int] = ..., maintenance: _Optional[int] = ..., dead: _Optional[int] = ..., busy: _Optional[int] = ...) -> None: ...

class BotsCountRequest(_message.Message):
    __slots__ = ["dimensions"]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    dimensions: _containers.RepeatedCompositeFieldContainer[StringPair]
    def __init__(self, dimensions: _Optional[_Iterable[_Union[StringPair, _Mapping]]] = ...) -> None: ...

class BotsDimensions(_message.Message):
    __slots__ = ["bots_dimensions", "ts"]
    BOTS_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    TS_FIELD_NUMBER: _ClassVar[int]
    bots_dimensions: _containers.RepeatedCompositeFieldContainer[StringListPair]
    ts: _timestamp_pb2.Timestamp
    def __init__(self, bots_dimensions: _Optional[_Iterable[_Union[StringListPair, _Mapping]]] = ..., ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class BotsDimensionsRequest(_message.Message):
    __slots__ = ["pool"]
    POOL_FIELD_NUMBER: _ClassVar[int]
    pool: str
    def __init__(self, pool: _Optional[str] = ...) -> None: ...

class BotsRequest(_message.Message):
    __slots__ = ["cursor", "dimensions", "in_maintenance", "is_busy", "is_dead", "limit", "quarantined"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    IN_MAINTENANCE_FIELD_NUMBER: _ClassVar[int]
    IS_BUSY_FIELD_NUMBER: _ClassVar[int]
    IS_DEAD_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    QUARANTINED_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    dimensions: _containers.RepeatedCompositeFieldContainer[StringPair]
    in_maintenance: NullableBool
    is_busy: NullableBool
    is_dead: NullableBool
    limit: int
    quarantined: NullableBool
    def __init__(self, limit: _Optional[int] = ..., cursor: _Optional[str] = ..., dimensions: _Optional[_Iterable[_Union[StringPair, _Mapping]]] = ..., quarantined: _Optional[_Union[NullableBool, str]] = ..., in_maintenance: _Optional[_Union[NullableBool, str]] = ..., is_dead: _Optional[_Union[NullableBool, str]] = ..., is_busy: _Optional[_Union[NullableBool, str]] = ...) -> None: ...

class CASOperationStats(_message.Message):
    __slots__ = ["duration", "initial_number_items", "initial_size", "items_cold", "items_hot", "num_items_cold", "num_items_hot", "total_bytes_items_cold", "total_bytes_items_hot"]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    INITIAL_NUMBER_ITEMS_FIELD_NUMBER: _ClassVar[int]
    INITIAL_SIZE_FIELD_NUMBER: _ClassVar[int]
    ITEMS_COLD_FIELD_NUMBER: _ClassVar[int]
    ITEMS_HOT_FIELD_NUMBER: _ClassVar[int]
    NUM_ITEMS_COLD_FIELD_NUMBER: _ClassVar[int]
    NUM_ITEMS_HOT_FIELD_NUMBER: _ClassVar[int]
    TOTAL_BYTES_ITEMS_COLD_FIELD_NUMBER: _ClassVar[int]
    TOTAL_BYTES_ITEMS_HOT_FIELD_NUMBER: _ClassVar[int]
    duration: float
    initial_number_items: int
    initial_size: int
    items_cold: bytes
    items_hot: bytes
    num_items_cold: int
    num_items_hot: int
    total_bytes_items_cold: int
    total_bytes_items_hot: int
    def __init__(self, duration: _Optional[float] = ..., initial_number_items: _Optional[int] = ..., initial_size: _Optional[int] = ..., items_cold: _Optional[bytes] = ..., items_hot: _Optional[bytes] = ..., num_items_cold: _Optional[int] = ..., total_bytes_items_cold: _Optional[int] = ..., num_items_hot: _Optional[int] = ..., total_bytes_items_hot: _Optional[int] = ...) -> None: ...

class CASReference(_message.Message):
    __slots__ = ["cas_instance", "digest"]
    CAS_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    DIGEST_FIELD_NUMBER: _ClassVar[int]
    cas_instance: str
    digest: Digest
    def __init__(self, cas_instance: _Optional[str] = ..., digest: _Optional[_Union[Digest, _Mapping]] = ...) -> None: ...

class CacheEntry(_message.Message):
    __slots__ = ["name", "path"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    name: str
    path: str
    def __init__(self, name: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class CancelResponse(_message.Message):
    __slots__ = ["canceled", "was_running"]
    CANCELED_FIELD_NUMBER: _ClassVar[int]
    WAS_RUNNING_FIELD_NUMBER: _ClassVar[int]
    canceled: bool
    was_running: bool
    def __init__(self, canceled: bool = ..., was_running: bool = ...) -> None: ...

class CipdInput(_message.Message):
    __slots__ = ["client_package", "packages", "server"]
    CLIENT_PACKAGE_FIELD_NUMBER: _ClassVar[int]
    PACKAGES_FIELD_NUMBER: _ClassVar[int]
    SERVER_FIELD_NUMBER: _ClassVar[int]
    client_package: CipdPackage
    packages: _containers.RepeatedCompositeFieldContainer[CipdPackage]
    server: str
    def __init__(self, server: _Optional[str] = ..., client_package: _Optional[_Union[CipdPackage, _Mapping]] = ..., packages: _Optional[_Iterable[_Union[CipdPackage, _Mapping]]] = ...) -> None: ...

class CipdPackage(_message.Message):
    __slots__ = ["package_name", "path", "version"]
    PACKAGE_NAME_FIELD_NUMBER: _ClassVar[int]
    PATH_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    package_name: str
    path: str
    version: str
    def __init__(self, package_name: _Optional[str] = ..., version: _Optional[str] = ..., path: _Optional[str] = ...) -> None: ...

class CipdPins(_message.Message):
    __slots__ = ["client_package", "packages"]
    CLIENT_PACKAGE_FIELD_NUMBER: _ClassVar[int]
    PACKAGES_FIELD_NUMBER: _ClassVar[int]
    client_package: CipdPackage
    packages: _containers.RepeatedCompositeFieldContainer[CipdPackage]
    def __init__(self, client_package: _Optional[_Union[CipdPackage, _Mapping]] = ..., packages: _Optional[_Iterable[_Union[CipdPackage, _Mapping]]] = ...) -> None: ...

class ClientPermissions(_message.Message):
    __slots__ = ["cancel_task", "cancel_tasks", "delete_bot", "delete_bots", "get_bootstrap_token", "get_configs", "list_bots", "list_tasks", "put_configs", "terminate_bot"]
    CANCEL_TASKS_FIELD_NUMBER: _ClassVar[int]
    CANCEL_TASK_FIELD_NUMBER: _ClassVar[int]
    DELETE_BOTS_FIELD_NUMBER: _ClassVar[int]
    DELETE_BOT_FIELD_NUMBER: _ClassVar[int]
    GET_BOOTSTRAP_TOKEN_FIELD_NUMBER: _ClassVar[int]
    GET_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    LIST_BOTS_FIELD_NUMBER: _ClassVar[int]
    LIST_TASKS_FIELD_NUMBER: _ClassVar[int]
    PUT_CONFIGS_FIELD_NUMBER: _ClassVar[int]
    TERMINATE_BOT_FIELD_NUMBER: _ClassVar[int]
    cancel_task: bool
    cancel_tasks: bool
    delete_bot: bool
    delete_bots: bool
    get_bootstrap_token: bool
    get_configs: bool
    list_bots: _containers.RepeatedScalarFieldContainer[str]
    list_tasks: _containers.RepeatedScalarFieldContainer[str]
    put_configs: bool
    terminate_bot: bool
    def __init__(self, delete_bot: bool = ..., delete_bots: bool = ..., terminate_bot: bool = ..., get_configs: bool = ..., put_configs: bool = ..., cancel_task: bool = ..., get_bootstrap_token: bool = ..., cancel_tasks: bool = ..., list_bots: _Optional[_Iterable[str]] = ..., list_tasks: _Optional[_Iterable[str]] = ...) -> None: ...

class Containment(_message.Message):
    __slots__ = ["containment_type"]
    CONTAINMENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    containment_type: ContainmentType
    def __init__(self, containment_type: _Optional[_Union[ContainmentType, str]] = ...) -> None: ...

class DeleteResponse(_message.Message):
    __slots__ = ["deleted"]
    DELETED_FIELD_NUMBER: _ClassVar[int]
    deleted: bool
    def __init__(self, deleted: bool = ...) -> None: ...

class Digest(_message.Message):
    __slots__ = ["hash", "size_bytes"]
    HASH_FIELD_NUMBER: _ClassVar[int]
    SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    hash: str
    size_bytes: int
    def __init__(self, hash: _Optional[str] = ..., size_bytes: _Optional[int] = ...) -> None: ...

class NewTaskRequest(_message.Message):
    __slots__ = ["bot_ping_tolerance_secs", "evaluate_only", "expiration_secs", "name", "parent_task_id", "pool_task_template", "priority", "properties", "pubsub_auth_token", "pubsub_topic", "pubsub_userdata", "realm", "request_uuid", "resultdb", "service_account", "tags", "task_slices", "user"]
    class PoolTaskTemplateField(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    AUTO: NewTaskRequest.PoolTaskTemplateField
    BOT_PING_TOLERANCE_SECS_FIELD_NUMBER: _ClassVar[int]
    CANARY_NEVER: NewTaskRequest.PoolTaskTemplateField
    CANARY_PREFER: NewTaskRequest.PoolTaskTemplateField
    EVALUATE_ONLY_FIELD_NUMBER: _ClassVar[int]
    EXPIRATION_SECS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PARENT_TASK_ID_FIELD_NUMBER: _ClassVar[int]
    POOL_TASK_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_AUTH_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_TOPIC_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_USERDATA_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    REQUEST_UUID_FIELD_NUMBER: _ClassVar[int]
    RESULTDB_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    SKIP: NewTaskRequest.PoolTaskTemplateField
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TASK_SLICES_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    bot_ping_tolerance_secs: int
    evaluate_only: bool
    expiration_secs: int
    name: str
    parent_task_id: str
    pool_task_template: NewTaskRequest.PoolTaskTemplateField
    priority: int
    properties: TaskProperties
    pubsub_auth_token: str
    pubsub_topic: str
    pubsub_userdata: str
    realm: str
    request_uuid: str
    resultdb: ResultDBCfg
    service_account: str
    tags: _containers.RepeatedScalarFieldContainer[str]
    task_slices: _containers.RepeatedCompositeFieldContainer[TaskSlice]
    user: str
    def __init__(self, expiration_secs: _Optional[int] = ..., name: _Optional[str] = ..., parent_task_id: _Optional[str] = ..., priority: _Optional[int] = ..., properties: _Optional[_Union[TaskProperties, _Mapping]] = ..., task_slices: _Optional[_Iterable[_Union[TaskSlice, _Mapping]]] = ..., tags: _Optional[_Iterable[str]] = ..., user: _Optional[str] = ..., service_account: _Optional[str] = ..., pubsub_topic: _Optional[str] = ..., pubsub_auth_token: _Optional[str] = ..., pubsub_userdata: _Optional[str] = ..., evaluate_only: bool = ..., pool_task_template: _Optional[_Union[NewTaskRequest.PoolTaskTemplateField, str]] = ..., bot_ping_tolerance_secs: _Optional[int] = ..., request_uuid: _Optional[str] = ..., resultdb: _Optional[_Union[ResultDBCfg, _Mapping]] = ..., realm: _Optional[str] = ...) -> None: ...

class OperationStats(_message.Message):
    __slots__ = ["duration"]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    duration: float
    def __init__(self, duration: _Optional[float] = ...) -> None: ...

class PerformanceStats(_message.Message):
    __slots__ = ["bot_overhead", "cache_trim", "cleanup", "isolated_download", "isolated_upload", "named_caches_install", "named_caches_uninstall", "package_installation"]
    BOT_OVERHEAD_FIELD_NUMBER: _ClassVar[int]
    CACHE_TRIM_FIELD_NUMBER: _ClassVar[int]
    CLEANUP_FIELD_NUMBER: _ClassVar[int]
    ISOLATED_DOWNLOAD_FIELD_NUMBER: _ClassVar[int]
    ISOLATED_UPLOAD_FIELD_NUMBER: _ClassVar[int]
    NAMED_CACHES_INSTALL_FIELD_NUMBER: _ClassVar[int]
    NAMED_CACHES_UNINSTALL_FIELD_NUMBER: _ClassVar[int]
    PACKAGE_INSTALLATION_FIELD_NUMBER: _ClassVar[int]
    bot_overhead: float
    cache_trim: OperationStats
    cleanup: OperationStats
    isolated_download: CASOperationStats
    isolated_upload: CASOperationStats
    named_caches_install: OperationStats
    named_caches_uninstall: OperationStats
    package_installation: OperationStats
    def __init__(self, bot_overhead: _Optional[float] = ..., isolated_download: _Optional[_Union[CASOperationStats, _Mapping]] = ..., isolated_upload: _Optional[_Union[CASOperationStats, _Mapping]] = ..., package_installation: _Optional[_Union[OperationStats, _Mapping]] = ..., cache_trim: _Optional[_Union[OperationStats, _Mapping]] = ..., named_caches_install: _Optional[_Union[OperationStats, _Mapping]] = ..., named_caches_uninstall: _Optional[_Union[OperationStats, _Mapping]] = ..., cleanup: _Optional[_Union[OperationStats, _Mapping]] = ...) -> None: ...

class PermissionsRequest(_message.Message):
    __slots__ = ["bot_id", "tags", "task_id"]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    bot_id: str
    tags: _containers.RepeatedScalarFieldContainer[str]
    task_id: str
    def __init__(self, bot_id: _Optional[str] = ..., task_id: _Optional[str] = ..., tags: _Optional[_Iterable[str]] = ...) -> None: ...

class ResultDBCfg(_message.Message):
    __slots__ = ["enable"]
    ENABLE_FIELD_NUMBER: _ClassVar[int]
    enable: bool
    def __init__(self, enable: bool = ...) -> None: ...

class ResultDBInfo(_message.Message):
    __slots__ = ["hostname", "invocation"]
    HOSTNAME_FIELD_NUMBER: _ClassVar[int]
    INVOCATION_FIELD_NUMBER: _ClassVar[int]
    hostname: str
    invocation: str
    def __init__(self, hostname: _Optional[str] = ..., invocation: _Optional[str] = ...) -> None: ...

class ServerDetails(_message.Message):
    __slots__ = ["bot_version", "cas_viewer_server", "display_server_url_template", "luci_config", "machine_provider_template", "server_version"]
    BOT_VERSION_FIELD_NUMBER: _ClassVar[int]
    CAS_VIEWER_SERVER_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_SERVER_URL_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    LUCI_CONFIG_FIELD_NUMBER: _ClassVar[int]
    MACHINE_PROVIDER_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    SERVER_VERSION_FIELD_NUMBER: _ClassVar[int]
    bot_version: str
    cas_viewer_server: str
    display_server_url_template: str
    luci_config: str
    machine_provider_template: str
    server_version: str
    def __init__(self, server_version: _Optional[str] = ..., bot_version: _Optional[str] = ..., machine_provider_template: _Optional[str] = ..., display_server_url_template: _Optional[str] = ..., luci_config: _Optional[str] = ..., cas_viewer_server: _Optional[str] = ...) -> None: ...

class StringListPair(_message.Message):
    __slots__ = ["key", "value"]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, key: _Optional[str] = ..., value: _Optional[_Iterable[str]] = ...) -> None: ...

class StringPair(_message.Message):
    __slots__ = ["key", "value"]
    KEY_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    key: str
    value: str
    def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...

class SwarmingTaskBackendConfig(_message.Message):
    __slots__ = ["agent_binary_cipd_filename", "agent_binary_cipd_pkg", "agent_binary_cipd_server", "agent_binary_cipd_vers", "bot_ping_tolerance", "parent_run_id", "priority", "service_account", "tags", "wait_for_capacity"]
    AGENT_BINARY_CIPD_FILENAME_FIELD_NUMBER: _ClassVar[int]
    AGENT_BINARY_CIPD_PKG_FIELD_NUMBER: _ClassVar[int]
    AGENT_BINARY_CIPD_SERVER_FIELD_NUMBER: _ClassVar[int]
    AGENT_BINARY_CIPD_VERS_FIELD_NUMBER: _ClassVar[int]
    BOT_PING_TOLERANCE_FIELD_NUMBER: _ClassVar[int]
    PARENT_RUN_ID_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    WAIT_FOR_CAPACITY_FIELD_NUMBER: _ClassVar[int]
    agent_binary_cipd_filename: str
    agent_binary_cipd_pkg: str
    agent_binary_cipd_server: str
    agent_binary_cipd_vers: str
    bot_ping_tolerance: int
    parent_run_id: str
    priority: int
    service_account: str
    tags: _containers.RepeatedScalarFieldContainer[str]
    wait_for_capacity: bool
    def __init__(self, priority: _Optional[int] = ..., bot_ping_tolerance: _Optional[int] = ..., parent_run_id: _Optional[str] = ..., service_account: _Optional[str] = ..., wait_for_capacity: bool = ..., agent_binary_cipd_pkg: _Optional[str] = ..., agent_binary_cipd_vers: _Optional[str] = ..., agent_binary_cipd_filename: _Optional[str] = ..., agent_binary_cipd_server: _Optional[str] = ..., tags: _Optional[_Iterable[str]] = ...) -> None: ...

class TaskCancelRequest(_message.Message):
    __slots__ = ["kill_running", "task_id"]
    KILL_RUNNING_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    kill_running: bool
    task_id: str
    def __init__(self, task_id: _Optional[str] = ..., kill_running: bool = ...) -> None: ...

class TaskIdRequest(_message.Message):
    __slots__ = ["task_id"]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    task_id: str
    def __init__(self, task_id: _Optional[str] = ...) -> None: ...

class TaskIdWithOffsetRequest(_message.Message):
    __slots__ = ["length", "offset", "task_id"]
    LENGTH_FIELD_NUMBER: _ClassVar[int]
    OFFSET_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    length: int
    offset: int
    task_id: str
    def __init__(self, task_id: _Optional[str] = ..., offset: _Optional[int] = ..., length: _Optional[int] = ...) -> None: ...

class TaskIdWithPerfRequest(_message.Message):
    __slots__ = ["include_performance_stats", "task_id"]
    INCLUDE_PERFORMANCE_STATS_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    include_performance_stats: bool
    task_id: str
    def __init__(self, task_id: _Optional[str] = ..., include_performance_stats: bool = ...) -> None: ...

class TaskListResponse(_message.Message):
    __slots__ = ["cursor", "items", "now"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    items: _containers.RepeatedCompositeFieldContainer[TaskResultResponse]
    now: _timestamp_pb2.Timestamp
    def __init__(self, cursor: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TaskResultResponse, _Mapping]]] = ..., now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class TaskOutputResponse(_message.Message):
    __slots__ = ["output", "state"]
    OUTPUT_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    output: bytes
    state: TaskState
    def __init__(self, output: _Optional[bytes] = ..., state: _Optional[_Union[TaskState, str]] = ...) -> None: ...

class TaskProperties(_message.Message):
    __slots__ = ["caches", "cas_input_root", "cipd_input", "command", "containment", "dimensions", "env", "env_prefixes", "execution_timeout_secs", "grace_period_secs", "idempotent", "io_timeout_secs", "outputs", "relative_cwd", "secret_bytes"]
    CACHES_FIELD_NUMBER: _ClassVar[int]
    CAS_INPUT_ROOT_FIELD_NUMBER: _ClassVar[int]
    CIPD_INPUT_FIELD_NUMBER: _ClassVar[int]
    COMMAND_FIELD_NUMBER: _ClassVar[int]
    CONTAINMENT_FIELD_NUMBER: _ClassVar[int]
    DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    ENV_FIELD_NUMBER: _ClassVar[int]
    ENV_PREFIXES_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_TIMEOUT_SECS_FIELD_NUMBER: _ClassVar[int]
    GRACE_PERIOD_SECS_FIELD_NUMBER: _ClassVar[int]
    IDEMPOTENT_FIELD_NUMBER: _ClassVar[int]
    IO_TIMEOUT_SECS_FIELD_NUMBER: _ClassVar[int]
    OUTPUTS_FIELD_NUMBER: _ClassVar[int]
    RELATIVE_CWD_FIELD_NUMBER: _ClassVar[int]
    SECRET_BYTES_FIELD_NUMBER: _ClassVar[int]
    caches: _containers.RepeatedCompositeFieldContainer[CacheEntry]
    cas_input_root: CASReference
    cipd_input: CipdInput
    command: _containers.RepeatedScalarFieldContainer[str]
    containment: Containment
    dimensions: _containers.RepeatedCompositeFieldContainer[StringPair]
    env: _containers.RepeatedCompositeFieldContainer[StringPair]
    env_prefixes: _containers.RepeatedCompositeFieldContainer[StringListPair]
    execution_timeout_secs: int
    grace_period_secs: int
    idempotent: bool
    io_timeout_secs: int
    outputs: _containers.RepeatedScalarFieldContainer[str]
    relative_cwd: str
    secret_bytes: bytes
    def __init__(self, caches: _Optional[_Iterable[_Union[CacheEntry, _Mapping]]] = ..., cipd_input: _Optional[_Union[CipdInput, _Mapping]] = ..., command: _Optional[_Iterable[str]] = ..., relative_cwd: _Optional[str] = ..., dimensions: _Optional[_Iterable[_Union[StringPair, _Mapping]]] = ..., env: _Optional[_Iterable[_Union[StringPair, _Mapping]]] = ..., env_prefixes: _Optional[_Iterable[_Union[StringListPair, _Mapping]]] = ..., execution_timeout_secs: _Optional[int] = ..., grace_period_secs: _Optional[int] = ..., idempotent: bool = ..., cas_input_root: _Optional[_Union[CASReference, _Mapping]] = ..., io_timeout_secs: _Optional[int] = ..., outputs: _Optional[_Iterable[str]] = ..., secret_bytes: _Optional[bytes] = ..., containment: _Optional[_Union[Containment, _Mapping]] = ...) -> None: ...

class TaskRequestMetadataResponse(_message.Message):
    __slots__ = ["request", "task_id", "task_result"]
    REQUEST_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    TASK_RESULT_FIELD_NUMBER: _ClassVar[int]
    request: TaskRequestResponse
    task_id: str
    task_result: TaskResultResponse
    def __init__(self, task_id: _Optional[str] = ..., request: _Optional[_Union[TaskRequestResponse, _Mapping]] = ..., task_result: _Optional[_Union[TaskResultResponse, _Mapping]] = ...) -> None: ...

class TaskRequestResponse(_message.Message):
    __slots__ = ["authenticated", "bot_ping_tolerance_secs", "created_ts", "expiration_secs", "name", "parent_task_id", "priority", "properties", "pubsub_topic", "pubsub_userdata", "rbe_instance", "realm", "resultdb", "service_account", "tags", "task_id", "task_slices", "user"]
    AUTHENTICATED_FIELD_NUMBER: _ClassVar[int]
    BOT_PING_TOLERANCE_SECS_FIELD_NUMBER: _ClassVar[int]
    CREATED_TS_FIELD_NUMBER: _ClassVar[int]
    EXPIRATION_SECS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PARENT_TASK_ID_FIELD_NUMBER: _ClassVar[int]
    PRIORITY_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_TOPIC_FIELD_NUMBER: _ClassVar[int]
    PUBSUB_USERDATA_FIELD_NUMBER: _ClassVar[int]
    RBE_INSTANCE_FIELD_NUMBER: _ClassVar[int]
    REALM_FIELD_NUMBER: _ClassVar[int]
    RESULTDB_FIELD_NUMBER: _ClassVar[int]
    SERVICE_ACCOUNT_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    TASK_SLICES_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    authenticated: str
    bot_ping_tolerance_secs: int
    created_ts: _timestamp_pb2.Timestamp
    expiration_secs: int
    name: str
    parent_task_id: str
    priority: int
    properties: TaskProperties
    pubsub_topic: str
    pubsub_userdata: str
    rbe_instance: str
    realm: str
    resultdb: ResultDBCfg
    service_account: str
    tags: _containers.RepeatedScalarFieldContainer[str]
    task_id: str
    task_slices: _containers.RepeatedCompositeFieldContainer[TaskSlice]
    user: str
    def __init__(self, task_id: _Optional[str] = ..., expiration_secs: _Optional[int] = ..., name: _Optional[str] = ..., parent_task_id: _Optional[str] = ..., priority: _Optional[int] = ..., properties: _Optional[_Union[TaskProperties, _Mapping]] = ..., tags: _Optional[_Iterable[str]] = ..., created_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., user: _Optional[str] = ..., authenticated: _Optional[str] = ..., task_slices: _Optional[_Iterable[_Union[TaskSlice, _Mapping]]] = ..., service_account: _Optional[str] = ..., realm: _Optional[str] = ..., resultdb: _Optional[_Union[ResultDBCfg, _Mapping]] = ..., pubsub_topic: _Optional[str] = ..., pubsub_userdata: _Optional[str] = ..., bot_ping_tolerance_secs: _Optional[int] = ..., rbe_instance: _Optional[str] = ...) -> None: ...

class TaskRequestsResponse(_message.Message):
    __slots__ = ["cursor", "items", "now"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    ITEMS_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    items: _containers.RepeatedCompositeFieldContainer[TaskRequestResponse]
    now: _timestamp_pb2.Timestamp
    def __init__(self, cursor: _Optional[str] = ..., items: _Optional[_Iterable[_Union[TaskRequestResponse, _Mapping]]] = ..., now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class TaskResultResponse(_message.Message):
    __slots__ = ["abandoned_ts", "bot_dimensions", "bot_id", "bot_idle_since_ts", "bot_logs_cloud_project", "bot_version", "cas_output_root", "cipd_pins", "completed_ts", "cost_saved_usd", "costs_usd", "created_ts", "current_task_slice", "deduped_from", "duration", "exit_code", "failure", "internal_failure", "missing_cas", "missing_cipd", "modified_ts", "name", "performance_stats", "resultdb_info", "run_id", "server_versions", "started_ts", "state", "tags", "task_id", "user"]
    ABANDONED_TS_FIELD_NUMBER: _ClassVar[int]
    BOT_DIMENSIONS_FIELD_NUMBER: _ClassVar[int]
    BOT_IDLE_SINCE_TS_FIELD_NUMBER: _ClassVar[int]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    BOT_LOGS_CLOUD_PROJECT_FIELD_NUMBER: _ClassVar[int]
    BOT_VERSION_FIELD_NUMBER: _ClassVar[int]
    CAS_OUTPUT_ROOT_FIELD_NUMBER: _ClassVar[int]
    CIPD_PINS_FIELD_NUMBER: _ClassVar[int]
    COMPLETED_TS_FIELD_NUMBER: _ClassVar[int]
    COSTS_USD_FIELD_NUMBER: _ClassVar[int]
    COST_SAVED_USD_FIELD_NUMBER: _ClassVar[int]
    CREATED_TS_FIELD_NUMBER: _ClassVar[int]
    CURRENT_TASK_SLICE_FIELD_NUMBER: _ClassVar[int]
    DEDUPED_FROM_FIELD_NUMBER: _ClassVar[int]
    DURATION_FIELD_NUMBER: _ClassVar[int]
    EXIT_CODE_FIELD_NUMBER: _ClassVar[int]
    FAILURE_FIELD_NUMBER: _ClassVar[int]
    INTERNAL_FAILURE_FIELD_NUMBER: _ClassVar[int]
    MISSING_CAS_FIELD_NUMBER: _ClassVar[int]
    MISSING_CIPD_FIELD_NUMBER: _ClassVar[int]
    MODIFIED_TS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PERFORMANCE_STATS_FIELD_NUMBER: _ClassVar[int]
    RESULTDB_INFO_FIELD_NUMBER: _ClassVar[int]
    RUN_ID_FIELD_NUMBER: _ClassVar[int]
    SERVER_VERSIONS_FIELD_NUMBER: _ClassVar[int]
    STARTED_TS_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    USER_FIELD_NUMBER: _ClassVar[int]
    abandoned_ts: _timestamp_pb2.Timestamp
    bot_dimensions: _containers.RepeatedCompositeFieldContainer[StringListPair]
    bot_id: str
    bot_idle_since_ts: _timestamp_pb2.Timestamp
    bot_logs_cloud_project: str
    bot_version: str
    cas_output_root: CASReference
    cipd_pins: CipdPins
    completed_ts: _timestamp_pb2.Timestamp
    cost_saved_usd: float
    costs_usd: _containers.RepeatedScalarFieldContainer[float]
    created_ts: _timestamp_pb2.Timestamp
    current_task_slice: int
    deduped_from: str
    duration: float
    exit_code: int
    failure: bool
    internal_failure: bool
    missing_cas: _containers.RepeatedCompositeFieldContainer[CASReference]
    missing_cipd: _containers.RepeatedCompositeFieldContainer[CipdPackage]
    modified_ts: _timestamp_pb2.Timestamp
    name: str
    performance_stats: PerformanceStats
    resultdb_info: ResultDBInfo
    run_id: str
    server_versions: _containers.RepeatedScalarFieldContainer[str]
    started_ts: _timestamp_pb2.Timestamp
    state: TaskState
    tags: _containers.RepeatedScalarFieldContainer[str]
    task_id: str
    user: str
    def __init__(self, task_id: _Optional[str] = ..., bot_dimensions: _Optional[_Iterable[_Union[StringListPair, _Mapping]]] = ..., bot_id: _Optional[str] = ..., bot_idle_since_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., bot_version: _Optional[str] = ..., bot_logs_cloud_project: _Optional[str] = ..., completed_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., cost_saved_usd: _Optional[float] = ..., created_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., deduped_from: _Optional[str] = ..., duration: _Optional[float] = ..., exit_code: _Optional[int] = ..., failure: bool = ..., internal_failure: bool = ..., modified_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., cas_output_root: _Optional[_Union[CASReference, _Mapping]] = ..., server_versions: _Optional[_Iterable[str]] = ..., started_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., state: _Optional[_Union[TaskState, str]] = ..., abandoned_ts: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., costs_usd: _Optional[_Iterable[float]] = ..., name: _Optional[str] = ..., tags: _Optional[_Iterable[str]] = ..., user: _Optional[str] = ..., performance_stats: _Optional[_Union[PerformanceStats, _Mapping]] = ..., cipd_pins: _Optional[_Union[CipdPins, _Mapping]] = ..., run_id: _Optional[str] = ..., current_task_slice: _Optional[int] = ..., resultdb_info: _Optional[_Union[ResultDBInfo, _Mapping]] = ..., missing_cas: _Optional[_Iterable[_Union[CASReference, _Mapping]]] = ..., missing_cipd: _Optional[_Iterable[_Union[CipdPackage, _Mapping]]] = ...) -> None: ...

class TaskSlice(_message.Message):
    __slots__ = ["expiration_secs", "properties", "wait_for_capacity"]
    EXPIRATION_SECS_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    WAIT_FOR_CAPACITY_FIELD_NUMBER: _ClassVar[int]
    expiration_secs: int
    properties: TaskProperties
    wait_for_capacity: bool
    def __init__(self, properties: _Optional[_Union[TaskProperties, _Mapping]] = ..., expiration_secs: _Optional[int] = ..., wait_for_capacity: bool = ...) -> None: ...

class TaskStates(_message.Message):
    __slots__ = ["states"]
    STATES_FIELD_NUMBER: _ClassVar[int]
    states: _containers.RepeatedScalarFieldContainer[TaskState]
    def __init__(self, states: _Optional[_Iterable[_Union[TaskState, str]]] = ...) -> None: ...

class TaskStatesRequest(_message.Message):
    __slots__ = ["task_id"]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    task_id: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, task_id: _Optional[_Iterable[str]] = ...) -> None: ...

class TasksCancelRequest(_message.Message):
    __slots__ = ["cursor", "end", "kill_running", "limit", "start", "tags"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    KILL_RUNNING_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    end: _timestamp_pb2.Timestamp
    kill_running: bool
    limit: int
    start: _timestamp_pb2.Timestamp
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, limit: _Optional[int] = ..., cursor: _Optional[str] = ..., tags: _Optional[_Iterable[str]] = ..., kill_running: bool = ..., start: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class TasksCancelResponse(_message.Message):
    __slots__ = ["cursor", "matched", "now"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    MATCHED_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    matched: int
    now: _timestamp_pb2.Timestamp
    def __init__(self, cursor: _Optional[str] = ..., now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., matched: _Optional[int] = ...) -> None: ...

class TasksCount(_message.Message):
    __slots__ = ["count", "now"]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    NOW_FIELD_NUMBER: _ClassVar[int]
    count: int
    now: _timestamp_pb2.Timestamp
    def __init__(self, count: _Optional[int] = ..., now: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class TasksCountRequest(_message.Message):
    __slots__ = ["end", "start", "state", "tags"]
    END_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    end: _timestamp_pb2.Timestamp
    start: _timestamp_pb2.Timestamp
    state: StateQuery
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, start: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., state: _Optional[_Union[StateQuery, str]] = ..., tags: _Optional[_Iterable[str]] = ...) -> None: ...

class TasksRequest(_message.Message):
    __slots__ = ["cursor", "end", "limit", "sort", "start", "state", "tags"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    SORT_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    end: _timestamp_pb2.Timestamp
    limit: int
    sort: SortQuery
    start: _timestamp_pb2.Timestamp
    state: StateQuery
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, limit: _Optional[int] = ..., cursor: _Optional[str] = ..., start: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., state: _Optional[_Union[StateQuery, str]] = ..., sort: _Optional[_Union[SortQuery, str]] = ..., tags: _Optional[_Iterable[str]] = ...) -> None: ...

class TasksWithPerfRequest(_message.Message):
    __slots__ = ["cursor", "end", "include_performance_stats", "limit", "sort", "start", "state", "tags"]
    CURSOR_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_PERFORMANCE_STATS_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    SORT_FIELD_NUMBER: _ClassVar[int]
    START_FIELD_NUMBER: _ClassVar[int]
    STATE_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    cursor: str
    end: _timestamp_pb2.Timestamp
    include_performance_stats: bool
    limit: int
    sort: SortQuery
    start: _timestamp_pb2.Timestamp
    state: StateQuery
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, limit: _Optional[int] = ..., cursor: _Optional[str] = ..., start: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., state: _Optional[_Union[StateQuery, str]] = ..., sort: _Optional[_Union[SortQuery, str]] = ..., tags: _Optional[_Iterable[str]] = ..., include_performance_stats: bool = ...) -> None: ...

class TerminateRequest(_message.Message):
    __slots__ = ["bot_id", "reason"]
    BOT_ID_FIELD_NUMBER: _ClassVar[int]
    REASON_FIELD_NUMBER: _ClassVar[int]
    bot_id: str
    reason: str
    def __init__(self, bot_id: _Optional[str] = ..., reason: _Optional[str] = ...) -> None: ...

class TerminateResponse(_message.Message):
    __slots__ = ["task_id"]
    TASK_ID_FIELD_NUMBER: _ClassVar[int]
    task_id: str
    def __init__(self, task_id: _Optional[str] = ...) -> None: ...

class StateQuery(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class SortQuery(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class ContainmentType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class NullableBool(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class TaskState(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
