from PB.go.api.command import command as _command_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class LocalMetadata(_message.Message):
    __slots__ = ["environment", "event_times", "executed_locally", "labels", "rerun_metadata", "result", "updated_cache", "valid_cache_hit", "verification"]
    class EnvironmentEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class EventTimesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _command_pb2.TimeInterval
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_command_pb2.TimeInterval, _Mapping]] = ...) -> None: ...
    class LabelsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ENVIRONMENT_FIELD_NUMBER: _ClassVar[int]
    EVENT_TIMES_FIELD_NUMBER: _ClassVar[int]
    EXECUTED_LOCALLY_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    RERUN_METADATA_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    UPDATED_CACHE_FIELD_NUMBER: _ClassVar[int]
    VALID_CACHE_HIT_FIELD_NUMBER: _ClassVar[int]
    VERIFICATION_FIELD_NUMBER: _ClassVar[int]
    environment: _containers.ScalarMap[str, str]
    event_times: _containers.MessageMap[str, _command_pb2.TimeInterval]
    executed_locally: bool
    labels: _containers.ScalarMap[str, str]
    rerun_metadata: _containers.RepeatedCompositeFieldContainer[RerunMetadata]
    result: _command_pb2.CommandResult
    updated_cache: bool
    valid_cache_hit: bool
    verification: Verification
    def __init__(self, result: _Optional[_Union[_command_pb2.CommandResult, _Mapping]] = ..., executed_locally: bool = ..., valid_cache_hit: bool = ..., updated_cache: bool = ..., verification: _Optional[_Union[Verification, _Mapping]] = ..., event_times: _Optional[_Mapping[str, _command_pb2.TimeInterval]] = ..., environment: _Optional[_Mapping[str, str]] = ..., labels: _Optional[_Mapping[str, str]] = ..., rerun_metadata: _Optional[_Iterable[_Union[RerunMetadata, _Mapping]]] = ...) -> None: ...

class LogDump(_message.Message):
    __slots__ = ["records"]
    RECORDS_FIELD_NUMBER: _ClassVar[int]
    records: _containers.RepeatedCompositeFieldContainer[LogRecord]
    def __init__(self, records: _Optional[_Iterable[_Union[LogRecord, _Mapping]]] = ...) -> None: ...

class LogRecord(_message.Message):
    __slots__ = ["command", "local_metadata", "remote_metadata", "result"]
    COMMAND_FIELD_NUMBER: _ClassVar[int]
    LOCAL_METADATA_FIELD_NUMBER: _ClassVar[int]
    REMOTE_METADATA_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    command: _command_pb2.Command
    local_metadata: LocalMetadata
    remote_metadata: RemoteMetadata
    result: _command_pb2.CommandResult
    def __init__(self, command: _Optional[_Union[_command_pb2.Command, _Mapping]] = ..., result: _Optional[_Union[_command_pb2.CommandResult, _Mapping]] = ..., remote_metadata: _Optional[_Union[RemoteMetadata, _Mapping]] = ..., local_metadata: _Optional[_Union[LocalMetadata, _Mapping]] = ...) -> None: ...

class Metric(_message.Message):
    __slots__ = ["bool_value", "double_value", "int64_value"]
    BOOL_VALUE_FIELD_NUMBER: _ClassVar[int]
    DOUBLE_VALUE_FIELD_NUMBER: _ClassVar[int]
    INT64_VALUE_FIELD_NUMBER: _ClassVar[int]
    bool_value: bool
    double_value: float
    int64_value: int
    def __init__(self, int64_value: _Optional[int] = ..., bool_value: bool = ..., double_value: _Optional[float] = ...) -> None: ...

class ProxyInfo(_message.Message):
    __slots__ = ["event_times", "flags", "metrics"]
    class EventTimesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _command_pb2.TimeInterval
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_command_pb2.TimeInterval, _Mapping]] = ...) -> None: ...
    class FlagsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class MetricsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: Metric
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[Metric, _Mapping]] = ...) -> None: ...
    EVENT_TIMES_FIELD_NUMBER: _ClassVar[int]
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    METRICS_FIELD_NUMBER: _ClassVar[int]
    event_times: _containers.MessageMap[str, _command_pb2.TimeInterval]
    flags: _containers.ScalarMap[str, str]
    metrics: _containers.MessageMap[str, Metric]
    def __init__(self, event_times: _Optional[_Mapping[str, _command_pb2.TimeInterval]] = ..., metrics: _Optional[_Mapping[str, Metric]] = ..., flags: _Optional[_Mapping[str, str]] = ...) -> None: ...

class RemoteMetadata(_message.Message):
    __slots__ = ["action_digest", "cache_hit", "command_digest", "event_times", "logical_bytes_downloaded", "logical_bytes_uploaded", "num_input_directories", "num_input_files", "num_output_directories", "num_output_files", "output_directory_digests", "output_file_digests", "real_bytes_downloaded", "real_bytes_uploaded", "rerun_metadata", "result", "total_input_bytes", "total_output_bytes"]
    class EventTimesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _command_pb2.TimeInterval
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_command_pb2.TimeInterval, _Mapping]] = ...) -> None: ...
    class OutputDirectoryDigestsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class OutputFileDigestsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ACTION_DIGEST_FIELD_NUMBER: _ClassVar[int]
    CACHE_HIT_FIELD_NUMBER: _ClassVar[int]
    COMMAND_DIGEST_FIELD_NUMBER: _ClassVar[int]
    EVENT_TIMES_FIELD_NUMBER: _ClassVar[int]
    LOGICAL_BYTES_DOWNLOADED_FIELD_NUMBER: _ClassVar[int]
    LOGICAL_BYTES_UPLOADED_FIELD_NUMBER: _ClassVar[int]
    NUM_INPUT_DIRECTORIES_FIELD_NUMBER: _ClassVar[int]
    NUM_INPUT_FILES_FIELD_NUMBER: _ClassVar[int]
    NUM_OUTPUT_DIRECTORIES_FIELD_NUMBER: _ClassVar[int]
    NUM_OUTPUT_FILES_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_DIRECTORY_DIGESTS_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_FILE_DIGESTS_FIELD_NUMBER: _ClassVar[int]
    REAL_BYTES_DOWNLOADED_FIELD_NUMBER: _ClassVar[int]
    REAL_BYTES_UPLOADED_FIELD_NUMBER: _ClassVar[int]
    RERUN_METADATA_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    TOTAL_INPUT_BYTES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_OUTPUT_BYTES_FIELD_NUMBER: _ClassVar[int]
    action_digest: str
    cache_hit: bool
    command_digest: str
    event_times: _containers.MessageMap[str, _command_pb2.TimeInterval]
    logical_bytes_downloaded: int
    logical_bytes_uploaded: int
    num_input_directories: int
    num_input_files: int
    num_output_directories: int
    num_output_files: int
    output_directory_digests: _containers.ScalarMap[str, str]
    output_file_digests: _containers.ScalarMap[str, str]
    real_bytes_downloaded: int
    real_bytes_uploaded: int
    rerun_metadata: _containers.RepeatedCompositeFieldContainer[RerunMetadata]
    result: _command_pb2.CommandResult
    total_input_bytes: int
    total_output_bytes: int
    def __init__(self, result: _Optional[_Union[_command_pb2.CommandResult, _Mapping]] = ..., cache_hit: bool = ..., num_input_files: _Optional[int] = ..., num_input_directories: _Optional[int] = ..., total_input_bytes: _Optional[int] = ..., num_output_files: _Optional[int] = ..., num_output_directories: _Optional[int] = ..., total_output_bytes: _Optional[int] = ..., command_digest: _Optional[str] = ..., action_digest: _Optional[str] = ..., event_times: _Optional[_Mapping[str, _command_pb2.TimeInterval]] = ..., logical_bytes_uploaded: _Optional[int] = ..., real_bytes_uploaded: _Optional[int] = ..., logical_bytes_downloaded: _Optional[int] = ..., real_bytes_downloaded: _Optional[int] = ..., rerun_metadata: _Optional[_Iterable[_Union[RerunMetadata, _Mapping]]] = ..., output_file_digests: _Optional[_Mapping[str, str]] = ..., output_directory_digests: _Optional[_Mapping[str, str]] = ...) -> None: ...

class RerunMetadata(_message.Message):
    __slots__ = ["attempt", "event_times", "logical_bytes_downloaded", "num_output_directories", "num_output_files", "output_directory_digests", "output_file_digests", "real_bytes_downloaded", "result", "total_output_bytes"]
    class EventTimesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _command_pb2.TimeInterval
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_command_pb2.TimeInterval, _Mapping]] = ...) -> None: ...
    class OutputDirectoryDigestsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class OutputFileDigestsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ATTEMPT_FIELD_NUMBER: _ClassVar[int]
    EVENT_TIMES_FIELD_NUMBER: _ClassVar[int]
    LOGICAL_BYTES_DOWNLOADED_FIELD_NUMBER: _ClassVar[int]
    NUM_OUTPUT_DIRECTORIES_FIELD_NUMBER: _ClassVar[int]
    NUM_OUTPUT_FILES_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_DIRECTORY_DIGESTS_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_FILE_DIGESTS_FIELD_NUMBER: _ClassVar[int]
    REAL_BYTES_DOWNLOADED_FIELD_NUMBER: _ClassVar[int]
    RESULT_FIELD_NUMBER: _ClassVar[int]
    TOTAL_OUTPUT_BYTES_FIELD_NUMBER: _ClassVar[int]
    attempt: int
    event_times: _containers.MessageMap[str, _command_pb2.TimeInterval]
    logical_bytes_downloaded: int
    num_output_directories: int
    num_output_files: int
    output_directory_digests: _containers.ScalarMap[str, str]
    output_file_digests: _containers.ScalarMap[str, str]
    real_bytes_downloaded: int
    result: _command_pb2.CommandResult
    total_output_bytes: int
    def __init__(self, attempt: _Optional[int] = ..., result: _Optional[_Union[_command_pb2.CommandResult, _Mapping]] = ..., num_output_files: _Optional[int] = ..., num_output_directories: _Optional[int] = ..., total_output_bytes: _Optional[int] = ..., output_file_digests: _Optional[_Mapping[str, str]] = ..., output_directory_digests: _Optional[_Mapping[str, str]] = ..., logical_bytes_downloaded: _Optional[int] = ..., real_bytes_downloaded: _Optional[int] = ..., event_times: _Optional[_Mapping[str, _command_pb2.TimeInterval]] = ...) -> None: ...

class Verification(_message.Message):
    __slots__ = ["mismatches", "total_mismatches", "total_verified"]
    class Mismatch(_message.Message):
        __slots__ = ["action_digest", "local_digest", "local_digests", "non_deterministic", "path", "remote_digest", "remote_digests"]
        ACTION_DIGEST_FIELD_NUMBER: _ClassVar[int]
        LOCAL_DIGESTS_FIELD_NUMBER: _ClassVar[int]
        LOCAL_DIGEST_FIELD_NUMBER: _ClassVar[int]
        NON_DETERMINISTIC_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        REMOTE_DIGESTS_FIELD_NUMBER: _ClassVar[int]
        REMOTE_DIGEST_FIELD_NUMBER: _ClassVar[int]
        action_digest: str
        local_digest: str
        local_digests: _containers.RepeatedScalarFieldContainer[str]
        non_deterministic: bool
        path: str
        remote_digest: str
        remote_digests: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, path: _Optional[str] = ..., remote_digest: _Optional[str] = ..., local_digest: _Optional[str] = ..., non_deterministic: bool = ..., remote_digests: _Optional[_Iterable[str]] = ..., action_digest: _Optional[str] = ..., local_digests: _Optional[_Iterable[str]] = ...) -> None: ...
    MISMATCHES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_MISMATCHES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_VERIFIED_FIELD_NUMBER: _ClassVar[int]
    mismatches: _containers.RepeatedCompositeFieldContainer[Verification.Mismatch]
    total_mismatches: int
    total_verified: int
    def __init__(self, mismatches: _Optional[_Iterable[_Union[Verification.Mismatch, _Mapping]]] = ..., total_mismatches: _Optional[int] = ..., total_verified: _Optional[int] = ...) -> None: ...
