from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class MachineInfo(_message.Message):
    __slots__ = ["num_cpu", "os_family", "ram_mbs"]
    NUM_CPU_FIELD_NUMBER: _ClassVar[int]
    OS_FAMILY_FIELD_NUMBER: _ClassVar[int]
    RAM_MBS_FIELD_NUMBER: _ClassVar[int]
    num_cpu: int
    os_family: str
    ram_mbs: int
    def __init__(self, num_cpu: _Optional[int] = ..., ram_mbs: _Optional[int] = ..., os_family: _Optional[str] = ...) -> None: ...

class Outlier(_message.Message):
    __slots__ = ["command_id", "value"]
    COMMAND_ID_FIELD_NUMBER: _ClassVar[int]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    command_id: str
    value: int
    def __init__(self, command_id: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...

class Stat(_message.Message):
    __slots__ = ["average", "count", "counts_by_value", "median", "name", "outliers", "percentile75", "percentile85", "percentile95"]
    class Value(_message.Message):
        __slots__ = ["count", "name"]
        COUNT_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        count: int
        name: str
        def __init__(self, name: _Optional[str] = ..., count: _Optional[int] = ...) -> None: ...
    AVERAGE_FIELD_NUMBER: _ClassVar[int]
    COUNTS_BY_VALUE_FIELD_NUMBER: _ClassVar[int]
    COUNT_FIELD_NUMBER: _ClassVar[int]
    MEDIAN_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    OUTLIERS_FIELD_NUMBER: _ClassVar[int]
    PERCENTILE75_FIELD_NUMBER: _ClassVar[int]
    PERCENTILE85_FIELD_NUMBER: _ClassVar[int]
    PERCENTILE95_FIELD_NUMBER: _ClassVar[int]
    average: float
    count: int
    counts_by_value: _containers.RepeatedCompositeFieldContainer[Stat.Value]
    median: int
    name: str
    outliers: _containers.RepeatedCompositeFieldContainer[Outlier]
    percentile75: int
    percentile85: int
    percentile95: int
    def __init__(self, name: _Optional[str] = ..., count: _Optional[int] = ..., counts_by_value: _Optional[_Iterable[_Union[Stat.Value, _Mapping]]] = ..., outliers: _Optional[_Iterable[_Union[Outlier, _Mapping]]] = ..., median: _Optional[int] = ..., percentile75: _Optional[int] = ..., percentile85: _Optional[int] = ..., percentile95: _Optional[int] = ..., average: _Optional[float] = ...) -> None: ...

class Stats(_message.Message):
    __slots__ = ["environment", "invocation_ids", "machine_info", "num_records", "stats", "tool_version", "verification"]
    class EnvironmentEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ENVIRONMENT_FIELD_NUMBER: _ClassVar[int]
    INVOCATION_IDS_FIELD_NUMBER: _ClassVar[int]
    MACHINE_INFO_FIELD_NUMBER: _ClassVar[int]
    NUM_RECORDS_FIELD_NUMBER: _ClassVar[int]
    STATS_FIELD_NUMBER: _ClassVar[int]
    TOOL_VERSION_FIELD_NUMBER: _ClassVar[int]
    VERIFICATION_FIELD_NUMBER: _ClassVar[int]
    environment: _containers.ScalarMap[str, str]
    invocation_ids: _containers.RepeatedScalarFieldContainer[str]
    machine_info: MachineInfo
    num_records: int
    stats: _containers.RepeatedCompositeFieldContainer[Stat]
    tool_version: str
    verification: Verification
    def __init__(self, num_records: _Optional[int] = ..., stats: _Optional[_Iterable[_Union[Stat, _Mapping]]] = ..., environment: _Optional[_Mapping[str, str]] = ..., verification: _Optional[_Union[Verification, _Mapping]] = ..., tool_version: _Optional[str] = ..., invocation_ids: _Optional[_Iterable[str]] = ..., machine_info: _Optional[_Union[MachineInfo, _Mapping]] = ...) -> None: ...

class Verification(_message.Message):
    __slots__ = ["mismatches", "total_mismatches"]
    class Mismatch(_message.Message):
        __slots__ = ["local_digest", "path", "remote_digest"]
        LOCAL_DIGEST_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        REMOTE_DIGEST_FIELD_NUMBER: _ClassVar[int]
        local_digest: str
        path: str
        remote_digest: str
        def __init__(self, path: _Optional[str] = ..., remote_digest: _Optional[str] = ..., local_digest: _Optional[str] = ...) -> None: ...
    MISMATCHES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_MISMATCHES_FIELD_NUMBER: _ClassVar[int]
    mismatches: _containers.RepeatedCompositeFieldContainer[Verification.Mismatch]
    total_mismatches: int
    def __init__(self, mismatches: _Optional[_Iterable[_Union[Verification.Mismatch, _Mapping]]] = ..., total_mismatches: _Optional[int] = ...) -> None: ...
