from google.protobuf import struct_pb2 as _struct_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BuildArtifacts(_message.Message):
    __slots__ = ["affected_tests", "build_not_affected", "built_archives", "built_images", "debug_files", "failure_summary", "log_files", "ninja_action_metrics", "ninja_compdb_path", "ninja_duration_seconds", "ninja_graph_path", "ninja_log_path"]
    class LogFilesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    AFFECTED_TESTS_FIELD_NUMBER: _ClassVar[int]
    BUILD_NOT_AFFECTED_FIELD_NUMBER: _ClassVar[int]
    BUILT_ARCHIVES_FIELD_NUMBER: _ClassVar[int]
    BUILT_IMAGES_FIELD_NUMBER: _ClassVar[int]
    DEBUG_FILES_FIELD_NUMBER: _ClassVar[int]
    FAILURE_SUMMARY_FIELD_NUMBER: _ClassVar[int]
    LOG_FILES_FIELD_NUMBER: _ClassVar[int]
    NINJA_ACTION_METRICS_FIELD_NUMBER: _ClassVar[int]
    NINJA_COMPDB_PATH_FIELD_NUMBER: _ClassVar[int]
    NINJA_DURATION_SECONDS_FIELD_NUMBER: _ClassVar[int]
    NINJA_GRAPH_PATH_FIELD_NUMBER: _ClassVar[int]
    NINJA_LOG_PATH_FIELD_NUMBER: _ClassVar[int]
    affected_tests: _containers.RepeatedScalarFieldContainer[str]
    build_not_affected: bool
    built_archives: _containers.RepeatedCompositeFieldContainer[_struct_pb2.Struct]
    built_images: _containers.RepeatedCompositeFieldContainer[_struct_pb2.Struct]
    debug_files: _containers.RepeatedCompositeFieldContainer[DebugFile]
    failure_summary: str
    log_files: _containers.ScalarMap[str, str]
    ninja_action_metrics: NinjaActionMetrics
    ninja_compdb_path: str
    ninja_duration_seconds: int
    ninja_graph_path: str
    ninja_log_path: str
    def __init__(self, failure_summary: _Optional[str] = ..., built_images: _Optional[_Iterable[_Union[_struct_pb2.Struct, _Mapping]]] = ..., built_archives: _Optional[_Iterable[_Union[_struct_pb2.Struct, _Mapping]]] = ..., ninja_log_path: _Optional[str] = ..., ninja_graph_path: _Optional[str] = ..., ninja_compdb_path: _Optional[str] = ..., ninja_duration_seconds: _Optional[int] = ..., ninja_action_metrics: _Optional[_Union[NinjaActionMetrics, _Mapping]] = ..., log_files: _Optional[_Mapping[str, str]] = ..., debug_files: _Optional[_Iterable[_Union[DebugFile, _Mapping]]] = ..., build_not_affected: bool = ..., affected_tests: _Optional[_Iterable[str]] = ...) -> None: ...

class DebugFile(_message.Message):
    __slots__ = ["path", "upload_dest"]
    PATH_FIELD_NUMBER: _ClassVar[int]
    UPLOAD_DEST_FIELD_NUMBER: _ClassVar[int]
    path: str
    upload_dest: str
    def __init__(self, path: _Optional[str] = ..., upload_dest: _Optional[str] = ...) -> None: ...

class NinjaActionMetrics(_message.Message):
    __slots__ = ["actions_by_type", "final_actions", "initial_actions"]
    class ActionsByTypeEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: int
        def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
    ACTIONS_BY_TYPE_FIELD_NUMBER: _ClassVar[int]
    FINAL_ACTIONS_FIELD_NUMBER: _ClassVar[int]
    INITIAL_ACTIONS_FIELD_NUMBER: _ClassVar[int]
    actions_by_type: _containers.ScalarMap[str, int]
    final_actions: int
    initial_actions: int
    def __init__(self, initial_actions: _Optional[int] = ..., final_actions: _Optional[int] = ..., actions_by_type: _Optional[_Mapping[str, int]] = ...) -> None: ...
