from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ArtifactChange(_message.Message):
    __slots__ = ["artifact_location", "replacements"]
    ARTIFACT_LOCATION_FIELD_NUMBER: _ClassVar[int]
    REPLACEMENTS_FIELD_NUMBER: _ClassVar[int]
    artifact_location: ArtifactLocation
    replacements: _containers.RepeatedCompositeFieldContainer[Replacement]
    def __init__(self, artifact_location: _Optional[_Union[ArtifactLocation, _Mapping]] = ..., replacements: _Optional[_Iterable[_Union[Replacement, _Mapping]]] = ...) -> None: ...

class ArtifactContent(_message.Message):
    __slots__ = ["text"]
    TEXT_FIELD_NUMBER: _ClassVar[int]
    text: str
    def __init__(self, text: _Optional[str] = ...) -> None: ...

class ArtifactLocation(_message.Message):
    __slots__ = ["uri"]
    URI_FIELD_NUMBER: _ClassVar[int]
    uri: str
    def __init__(self, uri: _Optional[str] = ...) -> None: ...

class Document(_message.Message):
    __slots__ = ["runs", "version"]
    RUNS_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    runs: _containers.RepeatedCompositeFieldContainer[Run]
    version: str
    def __init__(self, version: _Optional[str] = ..., runs: _Optional[_Iterable[_Union[Run, _Mapping]]] = ...) -> None: ...

class Fix(_message.Message):
    __slots__ = ["artifact_changes", "description"]
    ARTIFACT_CHANGES_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    artifact_changes: _containers.RepeatedCompositeFieldContainer[ArtifactChange]
    description: Message
    def __init__(self, description: _Optional[_Union[Message, _Mapping]] = ..., artifact_changes: _Optional[_Iterable[_Union[ArtifactChange, _Mapping]]] = ...) -> None: ...

class Location(_message.Message):
    __slots__ = ["physical_location"]
    PHYSICAL_LOCATION_FIELD_NUMBER: _ClassVar[int]
    physical_location: PhysicalLocation
    def __init__(self, physical_location: _Optional[_Union[PhysicalLocation, _Mapping]] = ...) -> None: ...

class Message(_message.Message):
    __slots__ = ["text"]
    TEXT_FIELD_NUMBER: _ClassVar[int]
    text: str
    def __init__(self, text: _Optional[str] = ...) -> None: ...

class PhysicalLocation(_message.Message):
    __slots__ = ["artifact_location", "region"]
    ARTIFACT_LOCATION_FIELD_NUMBER: _ClassVar[int]
    REGION_FIELD_NUMBER: _ClassVar[int]
    artifact_location: ArtifactLocation
    region: Region
    def __init__(self, artifact_location: _Optional[_Union[ArtifactLocation, _Mapping]] = ..., region: _Optional[_Union[Region, _Mapping]] = ...) -> None: ...

class Region(_message.Message):
    __slots__ = ["end_column", "end_line", "start_column", "start_line"]
    END_COLUMN_FIELD_NUMBER: _ClassVar[int]
    END_LINE_FIELD_NUMBER: _ClassVar[int]
    START_COLUMN_FIELD_NUMBER: _ClassVar[int]
    START_LINE_FIELD_NUMBER: _ClassVar[int]
    end_column: int
    end_line: int
    start_column: int
    start_line: int
    def __init__(self, start_line: _Optional[int] = ..., start_column: _Optional[int] = ..., end_line: _Optional[int] = ..., end_column: _Optional[int] = ...) -> None: ...

class Replacement(_message.Message):
    __slots__ = ["deleted_region", "inserted_content"]
    DELETED_REGION_FIELD_NUMBER: _ClassVar[int]
    INSERTED_CONTENT_FIELD_NUMBER: _ClassVar[int]
    deleted_region: Region
    inserted_content: ArtifactContent
    def __init__(self, deleted_region: _Optional[_Union[Region, _Mapping]] = ..., inserted_content: _Optional[_Union[ArtifactContent, _Mapping]] = ...) -> None: ...

class Result(_message.Message):
    __slots__ = ["fixes", "level", "locations", "message"]
    FIXES_FIELD_NUMBER: _ClassVar[int]
    LEVEL_FIELD_NUMBER: _ClassVar[int]
    LOCATIONS_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    fixes: _containers.RepeatedCompositeFieldContainer[Fix]
    level: str
    locations: _containers.RepeatedCompositeFieldContainer[Location]
    message: Message
    def __init__(self, level: _Optional[str] = ..., message: _Optional[_Union[Message, _Mapping]] = ..., locations: _Optional[_Iterable[_Union[Location, _Mapping]]] = ..., fixes: _Optional[_Iterable[_Union[Fix, _Mapping]]] = ...) -> None: ...

class Run(_message.Message):
    __slots__ = ["results", "tool"]
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    TOOL_FIELD_NUMBER: _ClassVar[int]
    results: _containers.RepeatedCompositeFieldContainer[Result]
    tool: Tool
    def __init__(self, tool: _Optional[_Union[Tool, _Mapping]] = ..., results: _Optional[_Iterable[_Union[Result, _Mapping]]] = ...) -> None: ...

class Tool(_message.Message):
    __slots__ = ["driver", "extensions"]
    DRIVER_FIELD_NUMBER: _ClassVar[int]
    EXTENSIONS_FIELD_NUMBER: _ClassVar[int]
    driver: ToolComponent
    extensions: _containers.RepeatedCompositeFieldContainer[ToolComponent]
    def __init__(self, driver: _Optional[_Union[ToolComponent, _Mapping]] = ..., extensions: _Optional[_Iterable[_Union[ToolComponent, _Mapping]]] = ...) -> None: ...

class ToolComponent(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...
