from google.protobuf import duration_pb2 as _duration_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BadRequest(_message.Message):
    __slots__ = ["field_violations"]
    class FieldViolation(_message.Message):
        __slots__ = ["description", "field"]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        FIELD_FIELD_NUMBER: _ClassVar[int]
        description: str
        field: str
        def __init__(self, field: _Optional[str] = ..., description: _Optional[str] = ...) -> None: ...
    FIELD_VIOLATIONS_FIELD_NUMBER: _ClassVar[int]
    field_violations: _containers.RepeatedCompositeFieldContainer[BadRequest.FieldViolation]
    def __init__(self, field_violations: _Optional[_Iterable[_Union[BadRequest.FieldViolation, _Mapping]]] = ...) -> None: ...

class DebugInfo(_message.Message):
    __slots__ = ["detail", "stack_entries"]
    DETAIL_FIELD_NUMBER: _ClassVar[int]
    STACK_ENTRIES_FIELD_NUMBER: _ClassVar[int]
    detail: str
    stack_entries: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, stack_entries: _Optional[_Iterable[str]] = ..., detail: _Optional[str] = ...) -> None: ...

class Help(_message.Message):
    __slots__ = ["links"]
    class Link(_message.Message):
        __slots__ = ["description", "url"]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        URL_FIELD_NUMBER: _ClassVar[int]
        description: str
        url: str
        def __init__(self, description: _Optional[str] = ..., url: _Optional[str] = ...) -> None: ...
    LINKS_FIELD_NUMBER: _ClassVar[int]
    links: _containers.RepeatedCompositeFieldContainer[Help.Link]
    def __init__(self, links: _Optional[_Iterable[_Union[Help.Link, _Mapping]]] = ...) -> None: ...

class LocalizedMessage(_message.Message):
    __slots__ = ["locale", "message"]
    LOCALE_FIELD_NUMBER: _ClassVar[int]
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    locale: str
    message: str
    def __init__(self, locale: _Optional[str] = ..., message: _Optional[str] = ...) -> None: ...

class PreconditionFailure(_message.Message):
    __slots__ = ["violations"]
    class Violation(_message.Message):
        __slots__ = ["description", "subject", "type"]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        SUBJECT_FIELD_NUMBER: _ClassVar[int]
        TYPE_FIELD_NUMBER: _ClassVar[int]
        description: str
        subject: str
        type: str
        def __init__(self, type: _Optional[str] = ..., subject: _Optional[str] = ..., description: _Optional[str] = ...) -> None: ...
    VIOLATIONS_FIELD_NUMBER: _ClassVar[int]
    violations: _containers.RepeatedCompositeFieldContainer[PreconditionFailure.Violation]
    def __init__(self, violations: _Optional[_Iterable[_Union[PreconditionFailure.Violation, _Mapping]]] = ...) -> None: ...

class QuotaFailure(_message.Message):
    __slots__ = ["violations"]
    class Violation(_message.Message):
        __slots__ = ["description", "subject"]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        SUBJECT_FIELD_NUMBER: _ClassVar[int]
        description: str
        subject: str
        def __init__(self, subject: _Optional[str] = ..., description: _Optional[str] = ...) -> None: ...
    VIOLATIONS_FIELD_NUMBER: _ClassVar[int]
    violations: _containers.RepeatedCompositeFieldContainer[QuotaFailure.Violation]
    def __init__(self, violations: _Optional[_Iterable[_Union[QuotaFailure.Violation, _Mapping]]] = ...) -> None: ...

class RequestInfo(_message.Message):
    __slots__ = ["request_id", "serving_data"]
    REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
    SERVING_DATA_FIELD_NUMBER: _ClassVar[int]
    request_id: str
    serving_data: str
    def __init__(self, request_id: _Optional[str] = ..., serving_data: _Optional[str] = ...) -> None: ...

class ResourceInfo(_message.Message):
    __slots__ = ["description", "owner", "resource_name", "resource_type"]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    OWNER_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_NAME_FIELD_NUMBER: _ClassVar[int]
    RESOURCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    description: str
    owner: str
    resource_name: str
    resource_type: str
    def __init__(self, resource_type: _Optional[str] = ..., resource_name: _Optional[str] = ..., owner: _Optional[str] = ..., description: _Optional[str] = ...) -> None: ...

class RetryInfo(_message.Message):
    __slots__ = ["retry_delay"]
    RETRY_DELAY_FIELD_NUMBER: _ClassVar[int]
    retry_delay: _duration_pb2.Duration
    def __init__(self, retry_delay: _Optional[_Union[_duration_pb2.Duration, _Mapping]] = ...) -> None: ...
