from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class AutorollRecipeOptions(_message.Message):
    __slots__ = ["disable_reason", "no_cc_authors", "no_owners", "nontrivial", "trivial"]
    class NontrivialOptions(_message.Message):
        __slots__ = ["automatic_commit_dry_run", "extra_reviewer_emails", "set_autosubmit"]
        AUTOMATIC_COMMIT_DRY_RUN_FIELD_NUMBER: _ClassVar[int]
        EXTRA_REVIEWER_EMAILS_FIELD_NUMBER: _ClassVar[int]
        SET_AUTOSUBMIT_FIELD_NUMBER: _ClassVar[int]
        automatic_commit_dry_run: bool
        extra_reviewer_emails: _containers.RepeatedScalarFieldContainer[str]
        set_autosubmit: bool
        def __init__(self, extra_reviewer_emails: _Optional[_Iterable[str]] = ..., automatic_commit_dry_run: bool = ..., set_autosubmit: bool = ...) -> None: ...
    class TrivialOptions(_message.Message):
        __slots__ = ["automatic_commit", "dry_run", "self_approve_method", "tbr_emails"]
        class SelfApproveMethod(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = []
        AUTOMATIC_COMMIT_FIELD_NUMBER: _ClassVar[int]
        BOT_COMMIT_APPROVE: AutorollRecipeOptions.TrivialOptions.SelfApproveMethod
        CODE_REVIEW_1_APPROVE: AutorollRecipeOptions.TrivialOptions.SelfApproveMethod
        CODE_REVIEW_2_APPROVE: AutorollRecipeOptions.TrivialOptions.SelfApproveMethod
        DRY_RUN_FIELD_NUMBER: _ClassVar[int]
        NO_LABELS_APPROVE: AutorollRecipeOptions.TrivialOptions.SelfApproveMethod
        SELF_APPROVE_METHOD_FIELD_NUMBER: _ClassVar[int]
        TBR_EMAILS_FIELD_NUMBER: _ClassVar[int]
        automatic_commit: bool
        dry_run: bool
        self_approve_method: AutorollRecipeOptions.TrivialOptions.SelfApproveMethod
        tbr_emails: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, tbr_emails: _Optional[_Iterable[str]] = ..., automatic_commit: bool = ..., dry_run: bool = ..., self_approve_method: _Optional[_Union[AutorollRecipeOptions.TrivialOptions.SelfApproveMethod, str]] = ...) -> None: ...
    DISABLE_REASON_FIELD_NUMBER: _ClassVar[int]
    NONTRIVIAL_FIELD_NUMBER: _ClassVar[int]
    NO_CC_AUTHORS_FIELD_NUMBER: _ClassVar[int]
    NO_OWNERS_FIELD_NUMBER: _ClassVar[int]
    TRIVIAL_FIELD_NUMBER: _ClassVar[int]
    disable_reason: str
    no_cc_authors: bool
    no_owners: bool
    nontrivial: AutorollRecipeOptions.NontrivialOptions
    trivial: AutorollRecipeOptions.TrivialOptions
    def __init__(self, trivial: _Optional[_Union[AutorollRecipeOptions.TrivialOptions, _Mapping]] = ..., nontrivial: _Optional[_Union[AutorollRecipeOptions.NontrivialOptions, _Mapping]] = ..., disable_reason: _Optional[str] = ..., no_cc_authors: bool = ..., no_owners: bool = ...) -> None: ...

class DepRepoSpecs(_message.Message):
    __slots__ = ["repo_specs"]
    class RepoSpecsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: RepoSpec
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[RepoSpec, _Mapping]] = ...) -> None: ...
    REPO_SPECS_FIELD_NUMBER: _ClassVar[int]
    repo_specs: _containers.MessageMap[str, RepoSpec]
    def __init__(self, repo_specs: _Optional[_Mapping[str, RepoSpec]] = ...) -> None: ...

class DepSpec(_message.Message):
    __slots__ = ["branch", "revision", "url"]
    BRANCH_FIELD_NUMBER: _ClassVar[int]
    REVISION_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    branch: str
    revision: str
    url: str
    def __init__(self, url: _Optional[str] = ..., branch: _Optional[str] = ..., revision: _Optional[str] = ...) -> None: ...

class RepoSpec(_message.Message):
    __slots__ = ["api_version", "autoroll_recipe_options", "canonical_repo_url", "deps", "enforce_test_expected_status", "no_docs", "project_id", "py3_only", "recipes_path", "repo_name", "require_py3_compatibility"]
    class DepsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: DepSpec
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[DepSpec, _Mapping]] = ...) -> None: ...
    API_VERSION_FIELD_NUMBER: _ClassVar[int]
    AUTOROLL_RECIPE_OPTIONS_FIELD_NUMBER: _ClassVar[int]
    CANONICAL_REPO_URL_FIELD_NUMBER: _ClassVar[int]
    DEPS_FIELD_NUMBER: _ClassVar[int]
    ENFORCE_TEST_EXPECTED_STATUS_FIELD_NUMBER: _ClassVar[int]
    NO_DOCS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_ID_FIELD_NUMBER: _ClassVar[int]
    PY3_ONLY_FIELD_NUMBER: _ClassVar[int]
    RECIPES_PATH_FIELD_NUMBER: _ClassVar[int]
    REPO_NAME_FIELD_NUMBER: _ClassVar[int]
    REQUIRE_PY3_COMPATIBILITY_FIELD_NUMBER: _ClassVar[int]
    api_version: int
    autoroll_recipe_options: AutorollRecipeOptions
    canonical_repo_url: str
    deps: _containers.MessageMap[str, DepSpec]
    enforce_test_expected_status: bool
    no_docs: bool
    project_id: str
    py3_only: bool
    recipes_path: str
    repo_name: str
    require_py3_compatibility: bool
    def __init__(self, api_version: _Optional[int] = ..., repo_name: _Optional[str] = ..., project_id: _Optional[str] = ..., canonical_repo_url: _Optional[str] = ..., recipes_path: _Optional[str] = ..., deps: _Optional[_Mapping[str, DepSpec]] = ..., autoroll_recipe_options: _Optional[_Union[AutorollRecipeOptions, _Mapping]] = ..., no_docs: bool = ..., require_py3_compatibility: bool = ..., py3_only: bool = ..., enforce_test_expected_status: bool = ...) -> None: ...
