from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CallSite(_message.Message):
    __slots__ = ["call_stack", "site"]
    CALL_STACK_FIELD_NUMBER: _ClassVar[int]
    SITE_FIELD_NUMBER: _ClassVar[int]
    call_stack: _containers.RepeatedCompositeFieldContainer[Frame]
    site: Frame
    def __init__(self, site: _Optional[_Union[Frame, _Mapping]] = ..., call_stack: _Optional[_Iterable[_Union[Frame, _Mapping]]] = ...) -> None: ...

class Cause(_message.Message):
    __slots__ = ["call_site", "import_site"]
    CALL_SITE_FIELD_NUMBER: _ClassVar[int]
    IMPORT_SITE_FIELD_NUMBER: _ClassVar[int]
    call_site: CallSite
    import_site: ImportSite
    def __init__(self, call_site: _Optional[_Union[CallSite, _Mapping]] = ..., import_site: _Optional[_Union[ImportSite, _Mapping]] = ...) -> None: ...

class Causes(_message.Message):
    __slots__ = ["causes"]
    CAUSES_FIELD_NUMBER: _ClassVar[int]
    causes: _containers.RepeatedCompositeFieldContainer[Cause]
    def __init__(self, causes: _Optional[_Iterable[_Union[Cause, _Mapping]]] = ...) -> None: ...

class Definition(_message.Message):
    __slots__ = ["deadline", "description", "google_issue", "monorail_bug", "name"]
    DEADLINE_FIELD_NUMBER: _ClassVar[int]
    DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
    GOOGLE_ISSUE_FIELD_NUMBER: _ClassVar[int]
    MONORAIL_BUG_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    deadline: str
    description: _containers.RepeatedScalarFieldContainer[str]
    google_issue: _containers.RepeatedCompositeFieldContainer[GoogleIssue]
    monorail_bug: _containers.RepeatedCompositeFieldContainer[MonorailBug]
    name: str
    def __init__(self, name: _Optional[str] = ..., description: _Optional[_Iterable[str]] = ..., deadline: _Optional[str] = ..., monorail_bug: _Optional[_Iterable[_Union[MonorailBug, _Mapping]]] = ..., google_issue: _Optional[_Iterable[_Union[GoogleIssue, _Mapping]]] = ...) -> None: ...

class DefinitionCollection(_message.Message):
    __slots__ = ["google_issue_default", "monorail_bug_default", "warning"]
    GOOGLE_ISSUE_DEFAULT_FIELD_NUMBER: _ClassVar[int]
    MONORAIL_BUG_DEFAULT_FIELD_NUMBER: _ClassVar[int]
    WARNING_FIELD_NUMBER: _ClassVar[int]
    google_issue_default: GoogleIssueDefault
    monorail_bug_default: MonorailBugDefault
    warning: _containers.RepeatedCompositeFieldContainer[Definition]
    def __init__(self, warning: _Optional[_Iterable[_Union[Definition, _Mapping]]] = ..., monorail_bug_default: _Optional[_Union[MonorailBugDefault, _Mapping]] = ..., google_issue_default: _Optional[_Union[GoogleIssueDefault, _Mapping]] = ...) -> None: ...

class Frame(_message.Message):
    __slots__ = ["file", "line"]
    FILE_FIELD_NUMBER: _ClassVar[int]
    LINE_FIELD_NUMBER: _ClassVar[int]
    file: str
    line: int
    def __init__(self, file: _Optional[str] = ..., line: _Optional[int] = ...) -> None: ...

class GoogleIssue(_message.Message):
    __slots__ = ["host", "id"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    host: str
    id: int
    def __init__(self, host: _Optional[str] = ..., id: _Optional[int] = ...) -> None: ...

class GoogleIssueDefault(_message.Message):
    __slots__ = ["host"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    host: str
    def __init__(self, host: _Optional[str] = ...) -> None: ...

class ImportSite(_message.Message):
    __slots__ = ["module", "recipe", "repo"]
    MODULE_FIELD_NUMBER: _ClassVar[int]
    RECIPE_FIELD_NUMBER: _ClassVar[int]
    REPO_FIELD_NUMBER: _ClassVar[int]
    module: str
    recipe: str
    repo: str
    def __init__(self, repo: _Optional[str] = ..., module: _Optional[str] = ..., recipe: _Optional[str] = ...) -> None: ...

class MonorailBug(_message.Message):
    __slots__ = ["host", "id", "project"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    host: str
    id: int
    project: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ..., id: _Optional[int] = ...) -> None: ...

class MonorailBugDefault(_message.Message):
    __slots__ = ["host", "project"]
    HOST_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    host: str
    project: str
    def __init__(self, host: _Optional[str] = ..., project: _Optional[str] = ...) -> None: ...
