from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor
EQ: Operator
GE: Operator
GT: Operator
LE: Operator
LT: Operator
NE: Operator
UNKNOWN: Operator

class CipdSource(_message.Message):
    __slots__ = ["default_version", "original_download_url", "pkg"]
    DEFAULT_VERSION_FIELD_NUMBER: _ClassVar[int]
    ORIGINAL_DOWNLOAD_URL_FIELD_NUMBER: _ClassVar[int]
    PKG_FIELD_NUMBER: _ClassVar[int]
    default_version: str
    original_download_url: str
    pkg: str
    def __init__(self, pkg: _Optional[str] = ..., default_version: _Optional[str] = ..., original_download_url: _Optional[str] = ...) -> None: ...

class GitSource(_message.Message):
    __slots__ = ["fixed_commit", "repo", "tag_filter_re", "tag_pattern", "version_join", "version_restriction"]
    FIXED_COMMIT_FIELD_NUMBER: _ClassVar[int]
    REPO_FIELD_NUMBER: _ClassVar[int]
    TAG_FILTER_RE_FIELD_NUMBER: _ClassVar[int]
    TAG_PATTERN_FIELD_NUMBER: _ClassVar[int]
    VERSION_JOIN_FIELD_NUMBER: _ClassVar[int]
    VERSION_RESTRICTION_FIELD_NUMBER: _ClassVar[int]
    fixed_commit: str
    repo: str
    tag_filter_re: str
    tag_pattern: str
    version_join: str
    version_restriction: _containers.RepeatedCompositeFieldContainer[SemverRestriction]
    def __init__(self, repo: _Optional[str] = ..., tag_pattern: _Optional[str] = ..., version_restriction: _Optional[_Iterable[_Union[SemverRestriction, _Mapping]]] = ..., version_join: _Optional[str] = ..., tag_filter_re: _Optional[str] = ..., fixed_commit: _Optional[str] = ...) -> None: ...

class ScriptSource(_message.Message):
    __slots__ = ["name", "use_fetch_checkout_workflow", "verification_timeout"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    USE_FETCH_CHECKOUT_WORKFLOW_FIELD_NUMBER: _ClassVar[int]
    VERIFICATION_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    name: _containers.RepeatedScalarFieldContainer[str]
    use_fetch_checkout_workflow: bool
    verification_timeout: str
    def __init__(self, name: _Optional[_Iterable[str]] = ..., use_fetch_checkout_workflow: bool = ..., verification_timeout: _Optional[str] = ...) -> None: ...

class SemverRestriction(_message.Message):
    __slots__ = ["op", "val"]
    OP_FIELD_NUMBER: _ClassVar[int]
    VAL_FIELD_NUMBER: _ClassVar[int]
    op: Operator
    val: str
    def __init__(self, op: _Optional[_Union[Operator, str]] = ..., val: _Optional[str] = ...) -> None: ...

class Spec(_message.Message):
    __slots__ = ["create", "upload"]
    class Create(_message.Message):
        __slots__ = ["build", "experimental", "package", "platform_re", "source", "unsupported", "verify"]
        class Build(_message.Message):
            __slots__ = ["dep", "external_dep", "external_tool", "install", "no_docker_env", "no_toolchain", "tool"]
            DEP_FIELD_NUMBER: _ClassVar[int]
            EXTERNAL_DEP_FIELD_NUMBER: _ClassVar[int]
            EXTERNAL_TOOL_FIELD_NUMBER: _ClassVar[int]
            INSTALL_FIELD_NUMBER: _ClassVar[int]
            NO_DOCKER_ENV_FIELD_NUMBER: _ClassVar[int]
            NO_TOOLCHAIN_FIELD_NUMBER: _ClassVar[int]
            TOOL_FIELD_NUMBER: _ClassVar[int]
            dep: _containers.RepeatedScalarFieldContainer[str]
            external_dep: _containers.RepeatedScalarFieldContainer[str]
            external_tool: _containers.RepeatedScalarFieldContainer[str]
            install: _containers.RepeatedScalarFieldContainer[str]
            no_docker_env: bool
            no_toolchain: bool
            tool: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, install: _Optional[_Iterable[str]] = ..., tool: _Optional[_Iterable[str]] = ..., external_tool: _Optional[_Iterable[str]] = ..., dep: _Optional[_Iterable[str]] = ..., external_dep: _Optional[_Iterable[str]] = ..., no_docker_env: bool = ..., no_toolchain: bool = ...) -> None: ...
        class Package(_message.Message):
            __slots__ = ["additional_ref", "alter_version_re", "alter_version_replace", "disable_latest_ref", "install_mode", "version_file"]
            class InstallMode(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
                __slots__ = []
            ADDITIONAL_REF_FIELD_NUMBER: _ClassVar[int]
            ALTER_VERSION_REPLACE_FIELD_NUMBER: _ClassVar[int]
            ALTER_VERSION_RE_FIELD_NUMBER: _ClassVar[int]
            DISABLE_LATEST_REF_FIELD_NUMBER: _ClassVar[int]
            INSTALL_MODE_FIELD_NUMBER: _ClassVar[int]
            VERSION_FILE_FIELD_NUMBER: _ClassVar[int]
            additional_ref: _containers.RepeatedScalarFieldContainer[str]
            alter_version_re: str
            alter_version_replace: str
            copy: Spec.Create.Package.InstallMode
            disable_latest_ref: bool
            install_mode: Spec.Create.Package.InstallMode
            symlink: Spec.Create.Package.InstallMode
            version_file: str
            def __init__(self, install_mode: _Optional[_Union[Spec.Create.Package.InstallMode, str]] = ..., version_file: _Optional[str] = ..., alter_version_re: _Optional[str] = ..., alter_version_replace: _Optional[str] = ..., disable_latest_ref: bool = ..., additional_ref: _Optional[_Iterable[str]] = ...) -> None: ...
        class Source(_message.Message):
            __slots__ = ["cipd", "cpe_base_address", "git", "no_archive_prune", "patch_dir", "patch_version", "script", "subdir", "unpack_archive", "url"]
            CIPD_FIELD_NUMBER: _ClassVar[int]
            CPE_BASE_ADDRESS_FIELD_NUMBER: _ClassVar[int]
            GIT_FIELD_NUMBER: _ClassVar[int]
            NO_ARCHIVE_PRUNE_FIELD_NUMBER: _ClassVar[int]
            PATCH_DIR_FIELD_NUMBER: _ClassVar[int]
            PATCH_VERSION_FIELD_NUMBER: _ClassVar[int]
            SCRIPT_FIELD_NUMBER: _ClassVar[int]
            SUBDIR_FIELD_NUMBER: _ClassVar[int]
            UNPACK_ARCHIVE_FIELD_NUMBER: _ClassVar[int]
            URL_FIELD_NUMBER: _ClassVar[int]
            cipd: CipdSource
            cpe_base_address: str
            git: GitSource
            no_archive_prune: bool
            patch_dir: _containers.RepeatedScalarFieldContainer[str]
            patch_version: str
            script: ScriptSource
            subdir: str
            unpack_archive: bool
            url: UrlSource
            def __init__(self, git: _Optional[_Union[GitSource, _Mapping]] = ..., cipd: _Optional[_Union[CipdSource, _Mapping]] = ..., script: _Optional[_Union[ScriptSource, _Mapping]] = ..., url: _Optional[_Union[UrlSource, _Mapping]] = ..., subdir: _Optional[str] = ..., unpack_archive: bool = ..., no_archive_prune: bool = ..., patch_dir: _Optional[_Iterable[str]] = ..., patch_version: _Optional[str] = ..., cpe_base_address: _Optional[str] = ...) -> None: ...
        class Verify(_message.Message):
            __slots__ = ["test"]
            TEST_FIELD_NUMBER: _ClassVar[int]
            test: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, test: _Optional[_Iterable[str]] = ...) -> None: ...
        BUILD_FIELD_NUMBER: _ClassVar[int]
        EXPERIMENTAL_FIELD_NUMBER: _ClassVar[int]
        PACKAGE_FIELD_NUMBER: _ClassVar[int]
        PLATFORM_RE_FIELD_NUMBER: _ClassVar[int]
        SOURCE_FIELD_NUMBER: _ClassVar[int]
        UNSUPPORTED_FIELD_NUMBER: _ClassVar[int]
        VERIFY_FIELD_NUMBER: _ClassVar[int]
        build: Spec.Create.Build
        experimental: bool
        package: Spec.Create.Package
        platform_re: str
        source: Spec.Create.Source
        unsupported: bool
        verify: Spec.Create.Verify
        def __init__(self, platform_re: _Optional[str] = ..., experimental: bool = ..., unsupported: bool = ..., source: _Optional[_Union[Spec.Create.Source, _Mapping]] = ..., build: _Optional[_Union[Spec.Create.Build, _Mapping]] = ..., package: _Optional[_Union[Spec.Create.Package, _Mapping]] = ..., verify: _Optional[_Union[Spec.Create.Verify, _Mapping]] = ...) -> None: ...
    class Upload(_message.Message):
        __slots__ = ["pkg_name_override", "pkg_prefix", "universal"]
        PKG_NAME_OVERRIDE_FIELD_NUMBER: _ClassVar[int]
        PKG_PREFIX_FIELD_NUMBER: _ClassVar[int]
        UNIVERSAL_FIELD_NUMBER: _ClassVar[int]
        pkg_name_override: str
        pkg_prefix: str
        universal: bool
        def __init__(self, pkg_prefix: _Optional[str] = ..., universal: bool = ..., pkg_name_override: _Optional[str] = ...) -> None: ...
    CREATE_FIELD_NUMBER: _ClassVar[int]
    UPLOAD_FIELD_NUMBER: _ClassVar[int]
    create: _containers.RepeatedCompositeFieldContainer[Spec.Create]
    upload: Spec.Upload
    def __init__(self, create: _Optional[_Iterable[_Union[Spec.Create, _Mapping]]] = ..., upload: _Optional[_Union[Spec.Upload, _Mapping]] = ...) -> None: ...

class UrlSource(_message.Message):
    __slots__ = ["download_url", "extension", "version"]
    DOWNLOAD_URL_FIELD_NUMBER: _ClassVar[int]
    EXTENSION_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    download_url: str
    extension: str
    version: str
    def __init__(self, download_url: _Optional[str] = ..., version: _Optional[str] = ..., extension: _Optional[str] = ...) -> None: ...

class Operator(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
