from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Inputs(_message.Message):
    __slots__ = ["allowed_refs", "git_repo", "infra", "manifests", "project", "restrictions", "roll_into", "version_label_template"]
    class Project(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class GitRepo(_message.Message):
        __slots__ = ["go_version_file", "nodejs_version_file", "url"]
        GO_VERSION_FILE_FIELD_NUMBER: _ClassVar[int]
        NODEJS_VERSION_FILE_FIELD_NUMBER: _ClassVar[int]
        URL_FIELD_NUMBER: _ClassVar[int]
        go_version_file: str
        nodejs_version_file: str
        url: str
        def __init__(self, url: _Optional[str] = ..., go_version_file: _Optional[str] = ..., nodejs_version_file: _Optional[str] = ...) -> None: ...
    class Restrictions(_message.Message):
        __slots__ = ["build_steps", "storage", "targets"]
        BUILD_STEPS_FIELD_NUMBER: _ClassVar[int]
        STORAGE_FIELD_NUMBER: _ClassVar[int]
        TARGETS_FIELD_NUMBER: _ClassVar[int]
        build_steps: _containers.RepeatedScalarFieldContainer[str]
        storage: _containers.RepeatedScalarFieldContainer[str]
        targets: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, targets: _Optional[_Iterable[str]] = ..., build_steps: _Optional[_Iterable[str]] = ..., storage: _Optional[_Iterable[str]] = ...) -> None: ...
    class RollInto(_message.Message):
        __slots__ = ["commit", "repo_url", "tbr"]
        COMMIT_FIELD_NUMBER: _ClassVar[int]
        REPO_URL_FIELD_NUMBER: _ClassVar[int]
        TBR_FIELD_NUMBER: _ClassVar[int]
        commit: bool
        repo_url: str
        tbr: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, repo_url: _Optional[str] = ..., tbr: _Optional[_Iterable[str]] = ..., commit: bool = ...) -> None: ...
    ALLOWED_REFS_FIELD_NUMBER: _ClassVar[int]
    GIT_REPO_FIELD_NUMBER: _ClassVar[int]
    INFRA_FIELD_NUMBER: _ClassVar[int]
    MANIFESTS_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    PROJECT_GIT_REPO: Inputs.Project
    PROJECT_INFRA: Inputs.Project
    PROJECT_INFRA_INTERNAL: Inputs.Project
    PROJECT_UNDEFINED: Inputs.Project
    RESTRICTIONS_FIELD_NUMBER: _ClassVar[int]
    ROLL_INTO_FIELD_NUMBER: _ClassVar[int]
    VERSION_LABEL_TEMPLATE_FIELD_NUMBER: _ClassVar[int]
    allowed_refs: _containers.RepeatedScalarFieldContainer[str]
    git_repo: Inputs.GitRepo
    infra: str
    manifests: _containers.RepeatedScalarFieldContainer[str]
    project: Inputs.Project
    restrictions: Inputs.Restrictions
    roll_into: Inputs.RollInto
    version_label_template: str
    def __init__(self, project: _Optional[_Union[Inputs.Project, str]] = ..., git_repo: _Optional[_Union[Inputs.GitRepo, _Mapping]] = ..., infra: _Optional[str] = ..., manifests: _Optional[_Iterable[str]] = ..., roll_into: _Optional[_Union[Inputs.RollInto, _Mapping]] = ..., restrictions: _Optional[_Union[Inputs.Restrictions, _Mapping]] = ..., version_label_template: _Optional[str] = ..., allowed_refs: _Optional[_Iterable[str]] = ...) -> None: ...
