from PB.recipes.infra.windows_image_builder import sources as _sources_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

Binary: RegPropertyType
DESCRIPTOR: _descriptor.FileDescriptor
DWord: RegPropertyType
ExpandString: RegPropertyType
MultiString: RegPropertyType
None: RegPropertyType
QWord: RegPropertyType
String: RegPropertyType
Unknown: RegPropertyType

class Action(_message.Message):
    __slots__ = ["add_file", "add_windows_driver", "add_windows_package", "edit_offline_registry", "powershell_expr", "timeout"]
    ADD_FILE_FIELD_NUMBER: _ClassVar[int]
    ADD_WINDOWS_DRIVER_FIELD_NUMBER: _ClassVar[int]
    ADD_WINDOWS_PACKAGE_FIELD_NUMBER: _ClassVar[int]
    EDIT_OFFLINE_REGISTRY_FIELD_NUMBER: _ClassVar[int]
    POWERSHELL_EXPR_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    add_file: AddFile
    add_windows_driver: AddWindowsDriver
    add_windows_package: AddWindowsPackage
    edit_offline_registry: EditOfflineRegistry
    powershell_expr: PowershellExpr
    timeout: int
    def __init__(self, add_file: _Optional[_Union[AddFile, _Mapping]] = ..., add_windows_package: _Optional[_Union[AddWindowsPackage, _Mapping]] = ..., edit_offline_registry: _Optional[_Union[EditOfflineRegistry, _Mapping]] = ..., add_windows_driver: _Optional[_Union[AddWindowsDriver, _Mapping]] = ..., powershell_expr: _Optional[_Union[PowershellExpr, _Mapping]] = ..., timeout: _Optional[int] = ...) -> None: ...

class AddFile(_message.Message):
    __slots__ = ["dst", "name", "src"]
    DST_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SRC_FIELD_NUMBER: _ClassVar[int]
    dst: str
    name: str
    src: _sources_pb2.Src
    def __init__(self, name: _Optional[str] = ..., src: _Optional[_Union[_sources_pb2.Src, _Mapping]] = ..., dst: _Optional[str] = ...) -> None: ...

class AddWindowsDriver(_message.Message):
    __slots__ = ["args", "name", "src"]
    ARGS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SRC_FIELD_NUMBER: _ClassVar[int]
    args: _containers.RepeatedScalarFieldContainer[str]
    name: str
    src: _sources_pb2.Src
    def __init__(self, name: _Optional[str] = ..., src: _Optional[_Union[_sources_pb2.Src, _Mapping]] = ..., args: _Optional[_Iterable[str]] = ...) -> None: ...

class AddWindowsPackage(_message.Message):
    __slots__ = ["args", "name", "src"]
    ARGS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    SRC_FIELD_NUMBER: _ClassVar[int]
    args: _containers.RepeatedScalarFieldContainer[str]
    name: str
    src: _sources_pb2.Src
    def __init__(self, name: _Optional[str] = ..., src: _Optional[_Union[_sources_pb2.Src, _Mapping]] = ..., args: _Optional[_Iterable[str]] = ...) -> None: ...

class EditOfflineRegistry(_message.Message):
    __slots__ = ["name", "property_name", "property_type", "property_value", "reg_hive_file", "reg_key_path"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROPERTY_NAME_FIELD_NUMBER: _ClassVar[int]
    PROPERTY_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROPERTY_VALUE_FIELD_NUMBER: _ClassVar[int]
    REG_HIVE_FILE_FIELD_NUMBER: _ClassVar[int]
    REG_KEY_PATH_FIELD_NUMBER: _ClassVar[int]
    name: str
    property_name: str
    property_type: RegPropertyType
    property_value: str
    reg_hive_file: str
    reg_key_path: str
    def __init__(self, name: _Optional[str] = ..., reg_hive_file: _Optional[str] = ..., reg_key_path: _Optional[str] = ..., property_name: _Optional[str] = ..., property_value: _Optional[str] = ..., property_type: _Optional[_Union[RegPropertyType, str]] = ...) -> None: ...

class OfflineAction(_message.Message):
    __slots__ = ["actions", "name"]
    ACTIONS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    actions: _containers.RepeatedCompositeFieldContainer[Action]
    name: str
    def __init__(self, name: _Optional[str] = ..., actions: _Optional[_Iterable[_Union[Action, _Mapping]]] = ...) -> None: ...

class OnlineAction(_message.Message):
    __slots__ = ["actions", "name"]
    ACTIONS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    actions: _containers.RepeatedCompositeFieldContainer[Action]
    name: str
    def __init__(self, name: _Optional[str] = ..., actions: _Optional[_Iterable[_Union[Action, _Mapping]]] = ...) -> None: ...

class PowershellExpr(_message.Message):
    __slots__ = ["continue_ctx", "expr", "ignore_timeout", "logs", "name", "return_codes", "srcs"]
    class SrcsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _sources_pb2.Src
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_sources_pb2.Src, _Mapping]] = ...) -> None: ...
    CONTINUE_CTX_FIELD_NUMBER: _ClassVar[int]
    EXPR_FIELD_NUMBER: _ClassVar[int]
    IGNORE_TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    LOGS_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    RETURN_CODES_FIELD_NUMBER: _ClassVar[int]
    SRCS_FIELD_NUMBER: _ClassVar[int]
    continue_ctx: bool
    expr: str
    ignore_timeout: bool
    logs: _containers.RepeatedScalarFieldContainer[str]
    name: str
    return_codes: _containers.RepeatedScalarFieldContainer[int]
    srcs: _containers.MessageMap[str, _sources_pb2.Src]
    def __init__(self, name: _Optional[str] = ..., srcs: _Optional[_Mapping[str, _sources_pb2.Src]] = ..., continue_ctx: bool = ..., return_codes: _Optional[_Iterable[int]] = ..., logs: _Optional[_Iterable[str]] = ..., expr: _Optional[str] = ..., ignore_timeout: bool = ...) -> None: ...

class RegPropertyType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
