from google.protobuf import struct_pb2 as _struct_pb2
from PB.go.chromium.org.luci.buildbucket.proto import builder_common as _builder_common_pb2
from PB.go.chromium.org.luci.buildbucket.proto import common as _common_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

BUILD_BOUND: LifeTime
DESCRIPTOR: _descriptor.FileDescriptor
DETACHED: LifeTime

class Buildbucket(_message.Message):
    __slots__ = ["builder"]
    BUILDER_FIELD_NUMBER: _ClassVar[int]
    builder: _builder_common_pb2.BuilderID
    def __init__(self, builder: _Optional[_Union[_builder_common_pb2.BuilderID, _Mapping]] = ...) -> None: ...

class ChildBuild(_message.Message):
    __slots__ = ["buildbucket", "id", "life_time"]
    BUILDBUCKET_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    LIFE_TIME_FIELD_NUMBER: _ClassVar[int]
    buildbucket: Buildbucket
    id: str
    life_time: LifeTime
    def __init__(self, id: _Optional[str] = ..., life_time: _Optional[_Union[LifeTime, str]] = ..., buildbucket: _Optional[_Union[Buildbucket, _Mapping]] = ...) -> None: ...

class CollectChildren(_message.Message):
    __slots__ = ["child_build_step_ids"]
    CHILD_BUILD_STEP_IDS_FIELD_NUMBER: _ClassVar[int]
    child_build_step_ids: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, child_build_step_ids: _Optional[_Iterable[str]] = ...) -> None: ...

class FakeStep(_message.Message):
    __slots__ = ["canceled", "children", "duration_secs", "links", "logs", "set_properties", "status", "step_text", "tags", "timeout"]
    class LinksEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class LogsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    class TagsEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    CANCELED_FIELD_NUMBER: _ClassVar[int]
    CHILDREN_FIELD_NUMBER: _ClassVar[int]
    DURATION_SECS_FIELD_NUMBER: _ClassVar[int]
    LINKS_FIELD_NUMBER: _ClassVar[int]
    LOGS_FIELD_NUMBER: _ClassVar[int]
    SET_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STEP_TEXT_FIELD_NUMBER: _ClassVar[int]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    TIMEOUT_FIELD_NUMBER: _ClassVar[int]
    canceled: bool
    children: _containers.RepeatedCompositeFieldContainer[Step]
    duration_secs: int
    links: _containers.ScalarMap[str, str]
    logs: _containers.ScalarMap[str, str]
    set_properties: _struct_pb2.Struct
    status: _common_pb2.Status
    step_text: str
    tags: _containers.ScalarMap[str, str]
    timeout: bool
    def __init__(self, duration_secs: _Optional[int] = ..., step_text: _Optional[str] = ..., links: _Optional[_Mapping[str, str]] = ..., logs: _Optional[_Mapping[str, str]] = ..., status: _Optional[_Union[_common_pb2.Status, str]] = ..., canceled: bool = ..., timeout: bool = ..., set_properties: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., children: _Optional[_Iterable[_Union[Step, _Mapping]]] = ..., tags: _Optional[_Mapping[str, str]] = ...) -> None: ...

class InputProps(_message.Message):
    __slots__ = ["status", "steps"]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    STEPS_FIELD_NUMBER: _ClassVar[int]
    status: _common_pb2.Status
    steps: _containers.RepeatedCompositeFieldContainer[Step]
    def __init__(self, steps: _Optional[_Iterable[_Union[Step, _Mapping]]] = ..., status: _Optional[_Union[_common_pb2.Status, str]] = ...) -> None: ...

class Step(_message.Message):
    __slots__ = ["child_build", "collect_children", "fake_step", "name"]
    CHILD_BUILD_FIELD_NUMBER: _ClassVar[int]
    COLLECT_CHILDREN_FIELD_NUMBER: _ClassVar[int]
    FAKE_STEP_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    child_build: ChildBuild
    collect_children: CollectChildren
    fake_step: FakeStep
    name: str
    def __init__(self, name: _Optional[str] = ..., fake_step: _Optional[_Union[FakeStep, _Mapping]] = ..., child_build: _Optional[_Union[ChildBuild, _Mapping]] = ..., collect_children: _Optional[_Union[CollectChildren, _Mapping]] = ...) -> None: ...

class LifeTime(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
