from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Data(_message.Message):
    __slots__ = []
    class Status(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class Type(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    class ClangDetails(_message.Message):
        __slots__ = ["comp_dep_paths", "compilation_db", "platforms"]
        COMPILATION_DB_FIELD_NUMBER: _ClassVar[int]
        COMP_DEP_PATHS_FIELD_NUMBER: _ClassVar[int]
        PLATFORMS_FIELD_NUMBER: _ClassVar[int]
        comp_dep_paths: _containers.RepeatedScalarFieldContainer[str]
        compilation_db: str
        platforms: int
        def __init__(self, platforms: _Optional[int] = ..., compilation_db: _Optional[str] = ..., comp_dep_paths: _Optional[_Iterable[str]] = ...) -> None: ...
    class Comment(_message.Message):
        __slots__ = ["category", "end_char", "end_line", "id", "message", "path", "show_on_unchanged_lines", "start_char", "start_line", "suggestions"]
        CATEGORY_FIELD_NUMBER: _ClassVar[int]
        END_CHAR_FIELD_NUMBER: _ClassVar[int]
        END_LINE_FIELD_NUMBER: _ClassVar[int]
        ID_FIELD_NUMBER: _ClassVar[int]
        MESSAGE_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        SHOW_ON_UNCHANGED_LINES_FIELD_NUMBER: _ClassVar[int]
        START_CHAR_FIELD_NUMBER: _ClassVar[int]
        START_LINE_FIELD_NUMBER: _ClassVar[int]
        SUGGESTIONS_FIELD_NUMBER: _ClassVar[int]
        category: str
        end_char: int
        end_line: int
        id: str
        message: str
        path: str
        show_on_unchanged_lines: bool
        start_char: int
        start_line: int
        suggestions: _containers.RepeatedCompositeFieldContainer[Data.Suggestion]
        def __init__(self, id: _Optional[str] = ..., category: _Optional[str] = ..., message: _Optional[str] = ..., path: _Optional[str] = ..., start_line: _Optional[int] = ..., end_line: _Optional[int] = ..., start_char: _Optional[int] = ..., end_char: _Optional[int] = ..., suggestions: _Optional[_Iterable[_Union[Data.Suggestion, _Mapping]]] = ..., show_on_unchanged_lines: bool = ...) -> None: ...
    class File(_message.Message):
        __slots__ = ["is_binary", "path", "status"]
        IS_BINARY_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        STATUS_FIELD_NUMBER: _ClassVar[int]
        is_binary: bool
        path: str
        status: Data.Status
        def __init__(self, path: _Optional[str] = ..., is_binary: bool = ..., status: _Optional[_Union[Data.Status, str]] = ...) -> None: ...
    class Files(_message.Message):
        __slots__ = ["commit_message", "files", "platforms"]
        COMMIT_MESSAGE_FIELD_NUMBER: _ClassVar[int]
        FILES_FIELD_NUMBER: _ClassVar[int]
        PLATFORMS_FIELD_NUMBER: _ClassVar[int]
        commit_message: str
        files: _containers.RepeatedCompositeFieldContainer[Data.File]
        platforms: int
        def __init__(self, platforms: _Optional[int] = ..., files: _Optional[_Iterable[_Union[Data.File, _Mapping]]] = ..., commit_message: _Optional[str] = ...) -> None: ...
    class GitFileDetails(_message.Message):
        __slots__ = ["commit_message", "files", "platforms", "ref", "repository"]
        COMMIT_MESSAGE_FIELD_NUMBER: _ClassVar[int]
        FILES_FIELD_NUMBER: _ClassVar[int]
        PLATFORMS_FIELD_NUMBER: _ClassVar[int]
        REF_FIELD_NUMBER: _ClassVar[int]
        REPOSITORY_FIELD_NUMBER: _ClassVar[int]
        commit_message: str
        files: _containers.RepeatedCompositeFieldContainer[Data.File]
        platforms: int
        ref: str
        repository: str
        def __init__(self, platforms: _Optional[int] = ..., repository: _Optional[str] = ..., ref: _Optional[str] = ..., files: _Optional[_Iterable[_Union[Data.File, _Mapping]]] = ..., commit_message: _Optional[str] = ...) -> None: ...
    class Replacement(_message.Message):
        __slots__ = ["end_char", "end_line", "path", "replacement", "start_char", "start_line"]
        END_CHAR_FIELD_NUMBER: _ClassVar[int]
        END_LINE_FIELD_NUMBER: _ClassVar[int]
        PATH_FIELD_NUMBER: _ClassVar[int]
        REPLACEMENT_FIELD_NUMBER: _ClassVar[int]
        START_CHAR_FIELD_NUMBER: _ClassVar[int]
        START_LINE_FIELD_NUMBER: _ClassVar[int]
        end_char: int
        end_line: int
        path: str
        replacement: str
        start_char: int
        start_line: int
        def __init__(self, path: _Optional[str] = ..., replacement: _Optional[str] = ..., start_line: _Optional[int] = ..., end_line: _Optional[int] = ..., start_char: _Optional[int] = ..., end_char: _Optional[int] = ...) -> None: ...
    class Results(_message.Message):
        __slots__ = ["comments", "platforms"]
        COMMENTS_FIELD_NUMBER: _ClassVar[int]
        PLATFORMS_FIELD_NUMBER: _ClassVar[int]
        comments: _containers.RepeatedCompositeFieldContainer[Data.Comment]
        platforms: int
        def __init__(self, platforms: _Optional[int] = ..., comments: _Optional[_Iterable[_Union[Data.Comment, _Mapping]]] = ...) -> None: ...
    class Suggestion(_message.Message):
        __slots__ = ["description", "replacements"]
        DESCRIPTION_FIELD_NUMBER: _ClassVar[int]
        REPLACEMENTS_FIELD_NUMBER: _ClassVar[int]
        description: str
        replacements: _containers.RepeatedCompositeFieldContainer[Data.Replacement]
        def __init__(self, description: _Optional[str] = ..., replacements: _Optional[_Iterable[_Union[Data.Replacement, _Mapping]]] = ...) -> None: ...
    class TypeDetails(_message.Message):
        __slots__ = ["is_platform_specific", "type"]
        IS_PLATFORM_SPECIFIC_FIELD_NUMBER: _ClassVar[int]
        TYPE_FIELD_NUMBER: _ClassVar[int]
        is_platform_specific: bool
        type: Data.Type
        def __init__(self, type: _Optional[_Union[Data.Type, str]] = ..., is_platform_specific: bool = ...) -> None: ...
    ADDED: Data.Status
    CLANG_DETAILS: Data.Type
    COPIED: Data.Status
    DELETED: Data.Status
    FILES: Data.Type
    GIT_FILE_DETAILS: Data.Type
    MODIFIED: Data.Status
    NONE: Data.Type
    RENAMED: Data.Status
    RESULTS: Data.Type
    REWRITTEN: Data.Status
    def __init__(self) -> None: ...
