#!/bin/bash -ex
# Copyright 2024 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# Create a proxy GCE metadata server connected to the emulated metadata server
# via a domain socket mounted inside the sandbox.
socat="${1:?}"
shift

"$socat" TCP-LISTEN:40000,fork,reuseaddr "UNIX-CONNECT:${BAZEL_auth_socket_path:?}" &
# Inform Application Default Credentials (ADC) to query
# the proxy metadata server.
export GCE_METADATA_HOST='localhost:40000'
exec "$@"
