# Copyright 2018 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/buildsetlookup",
]


def RunSteps(api):
    api.buildsetlookup(
        step_name="test",
        builder="fuchsia/ci/core.64-release",
        buildset="commit/gitiles/fuchsia.googlesource.com/foo/+/e3127e0bd6d57da7a5959ee70eb0a396590e6d53",
        # Buildbucket SUCCESS status is 12.
        build_status=12,
        retries=1,
        interval=30,
    )


def GenTests(api):
    yield api.test("retry_into_success") + api.step_data("test.attempt 0", retcode=1)
    yield (
        api.test("retry_multi_failure", status="INFRA_FAILURE")
        + api.step_data("test.attempt 0", retcode=1)
        + api.step_data("test.attempt 1", retcode=1)
    )
