# Copyright 2019 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/buildbucket_util",
    "fuchsia/checkout",
    "recipe_engine/properties",
]


def RunSteps(api):
    checkout = api.checkout.fuchsia_with_options(
        manifest="flower",
        remote="https://fuchsia.googlesource.com/integration",
    )
    assert checkout.clang_toolchain_dir
    checkout.clang_toolchain_dir = ""
    assert checkout.gcc_toolchain_dir
    assert checkout.qemu_dir
    assert checkout.rust_toolchain_dir


def GenTests(api):
    yield api.buildbucket_util.test("default") + api.properties(
        **{
            "$fuchsia/checkout": {
                "clang_toolchain": {"cas_digest": "abc"},
                "gcc_toolchain": {"cas_digest": "def"},
                "qemu": {"cas_digest": "ghi"},
                "rust_toolchain": {"cipd_version": "git_revision:deadbeef"},
            }
        }
    )
