# Copyright 2022 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/cmake",
    "recipe_engine/path",
]


def RunSteps(api):
    api.cmake.build_with_ninja(
        src_dir=api.path.start_dir / "src",
        build_type="Release",
        cache=api.path.start_dir.joinpath("src", "Cache.cmake"),
        cache_entries=["CMAKE_INSTALL_PREFIX=/usr"],
        build_dir=api.path.start_dir / "build",
        install_dir=api.path.start_dir / "install",
    )


def GenTests(api):
    yield api.test("basic")
