# Copyright 2017 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/gitiles",
]


def RunSteps(api):
    url = "https://fuchsia.googlesource.com/fuchsia?format=TEXT"
    for ref in ("refs/heads/A", "refs/heads/B"):
        api.gitiles.log(url, ref, limit=10)

    data = api.gitiles.fetch(
        host="host.com",
        project="project",
        path="OWNERS",
        test_data=b"will be overridden",
    )
    assert data.decode() == "foobar"


def GenTests(api):
    yield (
        api.test("basic")
        + api.gitiles.log("gitiles log: refs/heads/A", "A")
        + api.gitiles.log(
            "gitiles log: refs/heads/B",
            "B",
            add_change_id=True,
            extra_footers={"Extra-Footer": "value"},
        )
        + api.gitiles.fetch("fetch", b"foobar")
    )
