# Copyright 2019 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/jsonutil",
    "recipe_engine/step",
]


def RunSteps(api):
    text = """
  [
    {
      "key": "value",
    },]
  """

    assert api.jsonutil.permissive_loads(text) == [{"key": "value"}]

    try:
        api.jsonutil.permissive_loads("[")
    except api.step.StepFailure:
        pass
    else:  # pragma: no cover
        assert False, "expected permissive_loads to raise StepFailure"

    assert api.jsonutil.retrieve_nested_field({"a": {"b": "c"}}, "b") == "c"
    assert api.jsonutil.retrieve_nested_field(["a", "b", {"c": "d"}], "c") == "d"
    assert api.jsonutil.retrieve_nested_field(["a", "b", {"c": "d"}], "d") is None


def GenTests(api):
    yield api.test("basic")
