# Copyright 2019 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/kubectl",
    "recipe_engine/raw_io",
    "recipe_engine/step",
]


def RunSteps(api):
    version = api.kubectl.version
    if version:
        api.step.empty("log version", step_text=version)


def GenTests(api):
    yield api.test("example")
    yield api.test("override_version") + api.override_step_data(
        "retrieve kubectl version", api.raw_io.stream_output_text("Foo: bar")
    )
