# Copyright 2018 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/macos_sdk",
    "recipe_engine/platform",
    "recipe_engine/raw_io",
    "recipe_engine/step",
]


def RunSteps(api):
    with api.macos_sdk(additional_sdks=[("sdk_version", "xcode_version")]):
        if api.platform.is_mac:
            assert api.macos_sdk.sdk_dir
            assert api.macos_sdk.sysroot
        api.step("gn", ["gn", "gen", "out/Release"])
        api.step("ninja", ["ninja", "-C", "out/Release"])


def GenTests(api):
    for platform in ("linux", "mac", "win"):
        yield api.test(platform, api.platform.name(platform))

    yield api.test(
        "mac_9",
        api.platform.name("mac"),
        api.step_data(
            "find macOS version",
            stdout=api.raw_io.output_text("9.0.0"),
        ),
        status="INFRA_FAILURE",
    )
