# Copyright 2022 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/nsjail",
    "recipe_engine/path",
    "recipe_engine/raw_io",
    "recipe_engine/step",
]


def RunSteps(api):
    assert api.nsjail.tool_metadata
    cmd = api.nsjail.sandboxed_cmd(
        ["/bin/bash"],
        env={"HOME": "$tmpdir"},
        symlinks={"/usr/bin/bash": "/usr/bin/sh"},
        ro_mounts=[
            str(api.path.cache_dir / "incremental"),
            "/dev/urandom",
            "/usr/bin/openssl",
            "/first/level/second",
            "/first/level",
        ],
        rw_mounts=[str(api.path.cache_dir)],
        use_linux_tools=True,
        use_luci_git=True,
    )
    api.step(
        "sandboxed step",
        cmd,
        ok_ret="any",
        timeout=60,
    )


def GenTests(api):
    yield api.test("default") + api.step_data(
        "find all git binaries",
        stdout=api.raw_io.output_text("/b/s/w/ir/cipd_bin_packages/bin/git"),
    )
