# Copyright 2018 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/platform_util",
    "recipe_engine/platform",
    "recipe_engine/step",
]


def RunSteps(api):
    platform = api.platform_util.platform("fuchsia-arm64")
    assert platform.is_fuchsia
    assert not platform.is_win
    assert not platform.is_linux
    assert not platform.is_mac
    assert api.platform_util.host.is_host
    assert platform != api.platform_util.host
    assert platform != "foo"
    assert platform != 1
    step_result = api.step.empty("platform things")
    step_result.presentation.logs["name"] = [platform.os]
    step_result.presentation.logs["arch"] = [platform.arch]
    step_result.presentation.logs["platform"] = [platform.platform]
    step_result.presentation.logs["triple"] = [platform.triple]
    step_result.presentation.logs["string"] = [str(platform)]


def GenTests(api):
    for platform in ("linux", "mac", "win"):
        yield api.test(platform) + api.platform.name(platform)
