# Copyright 2021 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/buildbucket_util",
    "fuchsia/repo",
    "recipe_engine/path",
]


def RunSteps(api):
    api.repo.checkout_from_build_input(
        remote="https://fuchsia.googlesource.com/manifest",
        path=api.path.start_dir,
    )
    api.repo.snapshot(
        step_name="get snapshot",
        path=api.path.start_dir,
    )


def GenTests(api):
    snapshot_data = api.repo.snapshot(
        step_name="get snapshot",
        projects=["foo/bar", "bar/baz"],
    )
    yield api.buildbucket_util.test("cq", tryjob=True) + snapshot_data
    yield api.buildbucket_util.test("ci", tryjob=False, repo="manifest") + snapshot_data
