# Copyright 2021 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

DEPS = [
    "fuchsia/submodule_update",
    "recipe_engine/json",
]


def RunSteps(api):
    api.submodule_update.integration_update(
        "integration update",
        {"foo": "bar"},
        no_commit=True,
    )


def GenTests(api):
    yield (
        api.test("basic")
        + api.step_data(
            "integration update",
            api.json.output({}),
        )
    )

    yield (
        api.test("failure", status="FAILURE")
        + api.step_data("integration update", retcode=1)
    )
