#!/usr/bin/env vpython3
# Copyright 2023 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# [VPYTHON:BEGIN]
# python_version: "3.8"
# wheel: <
#   name: "infra/python/wheels/toml-py3"
#   version: "version:0.10.2"
# >
# [VPYTHON:END]

import argparse
import json
import sys
import toml


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("file")
    args = parser.parse_args()

    if args.file == "-":
        print(json.dumps(toml.load(sys.stdin)))
    else:
        with open(args.file) as f:
            print(json.dumps(toml.load(f)))


if __name__ == "__main__":
    sys.exit(main())
