# Copyright 2020 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

from recipe_engine import recipe_test_api


class TreeStatusTestApi(recipe_test_api.RecipeTestApi):
    def get(self, **kwargs):
        step_name = kwargs.pop("step_name", "get current tree status")
        return self.step_data(step_name, self.status_step_data(**kwargs))

    def status_step_data(self, state="open", key=12345):
        return self.m.json.output_stream(
            {
                "general_state": state,
                "date": "2020-12-01 23:07:06.234",
                "username": "user@example.com",
                "key": key,
            }
        )
