#!/usr/bin/env vpython3
# Copyright 2018 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# [VPYTHON:BEGIN]
# python_version: "3.8"
# wheel <
#   name: "infra/python/wheels/pyyaml/${platform}_${py_python}_${py_abi}"
#   version: "version:5.4.1"
# >
# [VPYTHON:END]

import argparse
import json
import sys
import yaml


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("file")
    args = parser.parse_args()

    if args.file == "-":
        print(json.dumps(yaml.safe_load(sys.stdin)))
    else:
        with open(args.file) as f:
            print(json.dumps(yaml.safe_load(f)))


if __name__ == "__main__":
    sys.exit(main())
