#!/usr/bin/env vpython3
# Copyright 2023 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# [VPYTHON:BEGIN]
# python_version: "3.8"
# wheel <
#   name: "infra/python/wheels/pyyaml/${platform}_${py_python}_${py_abi}"
#   version: "version:5.4.1"
# >
# [VPYTHON:END]

import argparse
import json
import sys
import yaml


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("file")
    parser.add_argument("data")
    args = parser.parse_args()

    data = json.loads(args.data)
    with open(args.file, "w") as f:
        yaml.dump(data, f)


if __name__ == "__main__":
    sys.exit(main())
