# Copyright 2024 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.
"""Recipe for building Clang toolchain without any runtimes."""

from PB.recipes.fuchsia.contrib.clang import InputProperties

DEPS = [
    "fuchsia/git_checkout",
    "recipe_engine/buildbucket",
    "recipe_engine/platform",
    "recipe_engine/properties",
]

PROPERTIES = InputProperties


def RunSteps(api, props):
    api.git_checkout(props.repository, fallback_ref=props.revision)


def GenTests(api):
    yield (
        api.test("ci_linux_x64")
        + api.buildbucket.ci_build(
            project="fuchsia",
            bucket="ci",
            git_repo="https://fuchsia.googlesource.com/third_party/llvm-project",
            revision="a" * 40,
        )
        + api.platform.name("linux")
        + api.properties(
            repository="https://fuchsia.googlesource.com/third_party/llvm-project",
            revision="a" * 40,
        )
    )
