#!/usr/bin/env python3

# Copyright 2021 The Fuchsia Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

"""Look for files from a directory

Usage:
  python3 find_files.py DIR_NAME GLOB_PATTERN
"""

import argparse
import sys
import os.path
import glob


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("--dir", help="dir name")
    parser.add_argument("--pattern", help="glob pattern")
    args = parser.parse_args()
    if not args.dir or not args.pattern:
        print("Please specify the dir name and glob pattern")
        return 1
    pathname = os.path.join(args.dir, args.pattern)
    results_paths = glob.glob(pathname=pathname, recursive=True)
    for item in results_paths:
        print(item)
    return 0


if __name__ == "__main__":
    sys.exit(main())
