#!/usr/bin/env python3
# Copyright 2022 The LUCI Authors. All rights reserved.
# Use of this source code is governed under the Apache License, Version 2.0
# that can be found in the LICENSE file.

"""Simple script for resizing a file."""

import argparse
import sys


def main(args):
    parser = argparse.ArgumentParser(description="Resize a file")
    parser.add_argument("--file", help="Path to the file to resize", required=True)
    parser.add_argument(
        "--size-mb",
        help="Size in mebibytes to resize to",
        type=int,
        required=True,
    )
    args = parser.parse_args()

    with open(args.file, "ab") as f:
        f.truncate(args.size_mb * 1024 * 1024)


if __name__ == "__main__":
    sys.exit(main(sys.argv[1:]))
